#include <tree_sitter/parser.h>

#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"

#define LANGUAGE_VERSION 3
#define STATE_COUNT 1015
#define SYMBOL_COUNT 104
#define TOKEN_COUNT 69
#define EXTERNAL_TOKEN_COUNT 6
#define MAX_RENAME_SEQUENCE_LENGTH 5

enum {
  sym__simple_heredoc = 1,
  sym__heredoc_beginning = 2,
  sym__heredoc_middle = 3,
  sym__heredoc_end = 4,
  sym_file_descriptor = 5,
  sym__empty_value = 6,
  anon_sym_for = 7,
  anon_sym_in = 8,
  anon_sym_while = 9,
  anon_sym_do = 10,
  anon_sym_done = 11,
  anon_sym_if = 12,
  anon_sym_then = 13,
  anon_sym_fi = 14,
  anon_sym_elif = 15,
  anon_sym_else = 16,
  anon_sym_case = 17,
  anon_sym_esac = 18,
  anon_sym_RPAREN = 19,
  anon_sym_SEMI_SEMI = 20,
  anon_sym_function = 21,
  anon_sym_LPAREN = 22,
  anon_sym_LBRACE = 23,
  anon_sym_RBRACE = 24,
  anon_sym_PIPE = 25,
  anon_sym_PIPE_AMP = 26,
  anon_sym_AMP_AMP = 27,
  anon_sym_PIPE_PIPE = 28,
  anon_sym_LBRACK = 29,
  anon_sym_RBRACK = 30,
  anon_sym_LBRACK_LBRACK = 31,
  anon_sym_RBRACK_RBRACK = 32,
  anon_sym_COLON = 33,
  aux_sym_SLASH_BSLASHs_PLUS_SLASH = 34,
  anon_sym_EQ = 35,
  anon_sym_LT = 36,
  anon_sym_GT = 37,
  anon_sym_GT_GT = 38,
  anon_sym_AMP_GT = 39,
  anon_sym_AMP_GT_GT = 40,
  anon_sym_LT_AMP = 41,
  anon_sym_GT_AMP = 42,
  anon_sym_LT_LT = 43,
  anon_sym_LT_LT_DASH = 44,
  anon_sym_DQUOTE = 45,
  aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH = 46,
  sym_raw_string = 47,
  anon_sym_DOLLAR = 48,
  anon_sym_DOLLAR_LBRACE = 49,
  anon_sym_COLON_QMARK = 50,
  anon_sym_COLON_DASH = 51,
  anon_sym_DOLLAR_LPAREN = 52,
  anon_sym_BQUOTE = 53,
  sym_leading_word = 54,
  sym_word = 55,
  sym_comment = 56,
  sym_simple_variable_name = 57,
  anon_sym_STAR = 58,
  anon_sym_AT = 59,
  anon_sym_POUND = 60,
  anon_sym_QMARK = 61,
  anon_sym_DASH = 62,
  anon_sym_BANG = 63,
  anon_sym_0 = 64,
  anon_sym__ = 65,
  anon_sym_SEMI = 66,
  anon_sym_LF = 67,
  anon_sym_AMP = 68,
  sym_program = 69,
  sym__terminated_statement = 70,
  sym_for_statement = 71,
  sym_while_statement = 72,
  sym_do_group = 73,
  sym_if_statement = 74,
  sym_elif_clause = 75,
  sym_else_clause = 76,
  sym_case_statement = 77,
  sym_case_item = 78,
  sym_function_definition = 79,
  sym_compound_statement = 80,
  sym_subshell = 81,
  sym_pipeline = 82,
  sym_list = 83,
  sym_bracket_command = 84,
  sym_command = 85,
  sym_environment_variable_assignment = 86,
  sym_file_redirect = 87,
  sym_heredoc_redirect = 88,
  sym_heredoc = 89,
  sym_string = 90,
  sym_simple_expansion = 91,
  sym_expansion = 92,
  sym_command_substitution = 93,
  sym_process_substitution = 94,
  sym_special_variable_name = 95,
  aux_sym_program_repeat1 = 96,
  aux_sym_if_statement_repeat1 = 97,
  aux_sym_case_statement_repeat1 = 98,
  aux_sym_bracket_command_repeat1 = 99,
  aux_sym_command_repeat1 = 100,
  aux_sym_command_repeat2 = 101,
  aux_sym_heredoc_repeat1 = 102,
  aux_sym_string_repeat1 = 103,
  rename_sym_1 = 104,
  rename_sym_command_name = 105,
  rename_sym_variable_name = 106,
};

static const char *ts_symbol_names[] = {
  [sym__simple_heredoc] = "_simple_heredoc",
  [sym__heredoc_beginning] = "_heredoc_beginning",
  [sym__heredoc_middle] = "_heredoc_middle",
  [sym__heredoc_end] = "_heredoc_end",
  [sym_file_descriptor] = "file_descriptor",
  [sym__empty_value] = "_empty_value",
  [ts_builtin_sym_end] = "END",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_done] = "done",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_fi] = "fi",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_case] = "case",
  [anon_sym_esac] = "esac",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SEMI_SEMI] = ";;",
  [anon_sym_function] = "function",
  [anon_sym_LPAREN] = "(",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_PIPE] = "|",
  [anon_sym_PIPE_AMP] = "|&",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym_COLON] = ":",
  [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = "/\\s+/",
  [anon_sym_EQ] = "=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_GT] = "&>",
  [anon_sym_AMP_GT_GT] = "&>>",
  [anon_sym_LT_AMP] = "<&",
  [anon_sym_GT_AMP] = ">&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_LT_LT_DASH] = "<<-",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = "/[^\"$]+/",
  [sym_raw_string] = "raw_string",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_COLON_QMARK] = ":?",
  [anon_sym_COLON_DASH] = ":-",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_BQUOTE] = "`",
  [sym_leading_word] = "leading_word",
  [sym_word] = "word",
  [sym_comment] = "comment",
  [sym_simple_variable_name] = "simple_variable_name",
  [anon_sym_STAR] = "*",
  [anon_sym_AT] = "@",
  [anon_sym_POUND] = "#",
  [anon_sym_QMARK] = "?",
  [anon_sym_DASH] = "-",
  [anon_sym_BANG] = "!",
  [anon_sym_0] = "0",
  [anon_sym__] = "_",
  [anon_sym_SEMI] = ";",
  [anon_sym_LF] = "\n",
  [anon_sym_AMP] = "&",
  [sym_program] = "program",
  [sym__terminated_statement] = "_terminated_statement",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_group] = "do_group",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_case_statement] = "case_statement",
  [sym_case_item] = "case_item",
  [sym_function_definition] = "function_definition",
  [sym_compound_statement] = "compound_statement",
  [sym_subshell] = "subshell",
  [sym_pipeline] = "pipeline",
  [sym_list] = "list",
  [sym_bracket_command] = "bracket_command",
  [sym_command] = "command",
  [sym_environment_variable_assignment] = "environment_variable_assignment",
  [sym_file_redirect] = "file_redirect",
  [sym_heredoc_redirect] = "heredoc_redirect",
  [sym_heredoc] = "heredoc",
  [sym_string] = "string",
  [sym_simple_expansion] = "simple_expansion",
  [sym_expansion] = "expansion",
  [sym_command_substitution] = "command_substitution",
  [sym_process_substitution] = "process_substitution",
  [sym_special_variable_name] = "special_variable_name",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_bracket_command_repeat1] = "bracket_command_repeat1",
  [aux_sym_command_repeat1] = "command_repeat1",
  [aux_sym_command_repeat2] = "command_repeat2",
  [aux_sym_heredoc_repeat1] = "heredoc_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [rename_sym_1] = "",
  [rename_sym_command_name] = "command_name",
  [rename_sym_variable_name] = "variable_name",
};

static const TSSymbolMetadata ts_symbol_metadata[SYMBOL_COUNT] = {
  [sym__simple_heredoc] = {
    .visible = false,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym__heredoc_beginning] = {
    .visible = false,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym__heredoc_middle] = {
    .visible = false,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym__heredoc_end] = {
    .visible = false,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_file_descriptor] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym__empty_value] = {
    .visible = false,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_done] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_fi] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_esac] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_SEMI_SEMI] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_PIPE_AMP] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = {
    .visible = false,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_AMP_GT] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_AMP_GT_GT] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_LT_AMP] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_GT_AMP] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_LT_LT_DASH] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = {
    .visible = false,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [sym_raw_string] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_COLON_QMARK] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_COLON_DASH] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [sym_leading_word] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_word] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
    .structural = false,
    .extra = true,
  },
  [sym_simple_variable_name] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym__terminated_statement] = {
    .visible = false,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_do_group] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_case_item] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_pipeline] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_bracket_command] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_environment_variable_assignment] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_file_redirect] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_heredoc_redirect] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_heredoc] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_simple_expansion] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_expansion] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_command_substitution] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_process_substitution] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_special_variable_name] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [aux_sym_bracket_command_repeat1] = {
    .visible = false,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [aux_sym_command_repeat1] = {
    .visible = false,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [aux_sym_command_repeat2] = {
    .visible = false,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [aux_sym_heredoc_repeat1] = {
    .visible = false,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
    .structural = true,
    .extra = false,
  },
};

static TSSymbol ts_rename_sequences[13][MAX_RENAME_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = rename_sym_command_name,
  },
  [2] = {
    [0] = rename_sym_command_name,
  },
  [3] = {
    [1] = rename_sym_command_name,
  },
  [4] = {
    [1] = rename_sym_variable_name,
  },
  [5] = {
    [0] = rename_sym_command_name,
  },
  [6] = {
    [0] = rename_sym_variable_name,
  },
  [7] = {
    [1] = rename_sym_command_name,
  },
  [8] = {
    [1] = rename_sym_variable_name,
  },
  [9] = {
    [0] = rename_sym_command_name,
  },
  [10] = {
    [1] = rename_sym_command_name,
  },
  [11] = {
    [1] = rename_sym_command_name,
  },
  [12] = {
    [1] = rename_sym_variable_name,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '(')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(10);
      if (lookahead == '-')
        ADVANCE(11);
      if (lookahead == '0')
        ADVANCE(12);
      if (lookahead == ':')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(14);
      if (lookahead == '<')
        ADVANCE(15);
      if (lookahead == '=')
        ADVANCE(17);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        SKIP(24);
      if (lookahead == ']')
        ADVANCE(25);
      if (lookahead == '_')
        ADVANCE(27);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == 'c')
        ADVANCE(29);
      if (lookahead == 'd')
        ADVANCE(33);
      if (lookahead == 'e')
        ADVANCE(37);
      if (lookahead == 'f')
        ADVANCE(46);
      if (lookahead == 'i')
        ADVANCE(57);
      if (lookahead == 't')
        ADVANCE(60);
      if (lookahead == 'w')
        ADVANCE(64);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '|')
        ADVANCE(70);
      if (lookahead == '}')
        ADVANCE(72);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(5);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(5);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_0);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(16);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_LT_AMP);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_GT_AMP);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 24:
      if (lookahead == '\n')
        SKIP(0);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == ']')
        ADVANCE(26);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 29:
      if (lookahead == 'a')
        ADVANCE(30);
      END_STATE();
    case 30:
      if (lookahead == 's')
        ADVANCE(31);
      END_STATE();
    case 31:
      if (lookahead == 'e')
        ADVANCE(32);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 33:
      if (lookahead == 'o')
        ADVANCE(34);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'n')
        ADVANCE(35);
      END_STATE();
    case 35:
      if (lookahead == 'e')
        ADVANCE(36);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_done);
      END_STATE();
    case 37:
      if (lookahead == 'l')
        ADVANCE(38);
      if (lookahead == 's')
        ADVANCE(43);
      END_STATE();
    case 38:
      if (lookahead == 'i')
        ADVANCE(39);
      if (lookahead == 's')
        ADVANCE(41);
      END_STATE();
    case 39:
      if (lookahead == 'f')
        ADVANCE(40);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 41:
      if (lookahead == 'e')
        ADVANCE(42);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 43:
      if (lookahead == 'a')
        ADVANCE(44);
      END_STATE();
    case 44:
      if (lookahead == 'c')
        ADVANCE(45);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_esac);
      END_STATE();
    case 46:
      if (lookahead == 'i')
        ADVANCE(47);
      if (lookahead == 'o')
        ADVANCE(48);
      if (lookahead == 'u')
        ADVANCE(50);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_fi);
      END_STATE();
    case 48:
      if (lookahead == 'r')
        ADVANCE(49);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 50:
      if (lookahead == 'n')
        ADVANCE(51);
      END_STATE();
    case 51:
      if (lookahead == 'c')
        ADVANCE(52);
      END_STATE();
    case 52:
      if (lookahead == 't')
        ADVANCE(53);
      END_STATE();
    case 53:
      if (lookahead == 'i')
        ADVANCE(54);
      END_STATE();
    case 54:
      if (lookahead == 'o')
        ADVANCE(55);
      END_STATE();
    case 55:
      if (lookahead == 'n')
        ADVANCE(56);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 57:
      if (lookahead == 'f')
        ADVANCE(58);
      if (lookahead == 'n')
        ADVANCE(59);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 60:
      if (lookahead == 'h')
        ADVANCE(61);
      END_STATE();
    case 61:
      if (lookahead == 'e')
        ADVANCE(62);
      END_STATE();
    case 62:
      if (lookahead == 'n')
        ADVANCE(63);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 64:
      if (lookahead == 'h')
        ADVANCE(65);
      END_STATE();
    case 65:
      if (lookahead == 'i')
        ADVANCE(66);
      END_STATE();
    case 66:
      if (lookahead == 'l')
        ADVANCE(67);
      END_STATE();
    case 67:
      if (lookahead == 'e')
        ADVANCE(68);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(71);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 73:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(74);
      if (lookahead == '&')
        ADVANCE(77);
      if (lookahead == '\'')
        ADVANCE(80);
      if (lookahead == '(')
        ADVANCE(8);
      if (lookahead == ':')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(86);
      if (lookahead == '[')
        ADVANCE(89);
      if (lookahead == '\\')
        SKIP(91);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'f')
        ADVANCE(96);
      if (lookahead == 'i')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(73);
      if ((lookahead < '&' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == '(')
        ADVANCE(75);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == '>')
        ADVANCE(78);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '>' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_AMP_GT);
      if (lookahead == '>')
        ADVANCE(79);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '>' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_AMP_GT_GT);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == '\'')
        ADVANCE(81);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '\"' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ':' ||
          lookahead == ';' ||
          lookahead == '=' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(82);
      if (lookahead != 0)
        ADVANCE(80);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_raw_string);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 82:
      if (lookahead == '\'')
        ADVANCE(83);
      if (lookahead != 0)
        ADVANCE(82);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_raw_string);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(85);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_LT_AMP);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(87);
      if (lookahead == '>')
        ADVANCE(88);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '>' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_GT_AMP);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[')
        ADVANCE(90);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '[' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 91:
      if (lookahead == '\n')
        SKIP(73);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'a')
        ADVANCE(93);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 's')
        ADVANCE(94);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'e')
        ADVANCE(95);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_case);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'o')
        ADVANCE(97);
      if (lookahead == 'u')
        ADVANCE(99);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'r')
        ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'n')
        ADVANCE(100);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'c')
        ADVANCE(101);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 't')
        ADVANCE(102);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'i')
        ADVANCE(103);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'o')
        ADVANCE(104);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'n')
        ADVANCE(105);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_function);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'f')
        ADVANCE(107);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_if);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'h')
        ADVANCE(109);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'i')
        ADVANCE(110);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'l')
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'e')
        ADVANCE(112);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_while);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 113:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(114);
      if (lookahead == '<')
        ADVANCE(15);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(117);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(113);
      END_STATE();
    case 114:
      if (lookahead == '>')
        ADVANCE(115);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_AMP_GT);
      if (lookahead == '>')
        ADVANCE(116);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_AMP_GT_GT);
      END_STATE();
    case 117:
      if (lookahead == '\n')
        SKIP(113);
      END_STATE();
    case 118:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '\\')
        SKIP(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(118);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '&' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(120);
      END_STATE();
    case 119:
      if (lookahead == '\n')
        SKIP(118);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_word);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '&' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(120);
      END_STATE();
    case 121:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(74);
      if (lookahead == '&')
        ADVANCE(77);
      if (lookahead == '\'')
        ADVANCE(80);
      if (lookahead == '(')
        ADVANCE(8);
      if (lookahead == ':')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(86);
      if (lookahead == '[')
        ADVANCE(89);
      if (lookahead == '\\')
        SKIP(122);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'f')
        ADVANCE(96);
      if (lookahead == 'i')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(121);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 122:
      if (lookahead == '\n')
        SKIP(121);
      END_STATE();
    case 123:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(124);
      if (lookahead == '\'')
        ADVANCE(126);
      if (lookahead == '<')
        ADVANCE(128);
      if (lookahead == '>')
        ADVANCE(129);
      if (lookahead == '\\')
        SKIP(130);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(123);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(120);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(75);
      if (lookahead == '{')
        ADVANCE(125);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\'')
        ADVANCE(127);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          ('\"' <= lookahead && lookahead <= '$') ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead != 0)
        ADVANCE(126);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_raw_string);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '&' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(120);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 130:
      if (lookahead == '\n')
        SKIP(123);
      END_STATE();
    case 131:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '\\')
        SKIP(132);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(131);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 132:
      if (lookahead == '\n')
        SKIP(131);
      END_STATE();
    case 133:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(74);
      if (lookahead == '&')
        ADVANCE(77);
      if (lookahead == '\'')
        ADVANCE(80);
      if (lookahead == '(')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ':')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(86);
      if (lookahead == '[')
        ADVANCE(89);
      if (lookahead == '\\')
        SKIP(134);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'f')
        ADVANCE(96);
      if (lookahead == 'i')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(133);
      if (lookahead != 0 &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 134:
      if (lookahead == '\n')
        SKIP(133);
      END_STATE();
    case 135:
      if (lookahead == '\n')
        ADVANCE(136);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(138);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(145);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(137);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(136);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(137);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(136);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(137);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(139);
      if (lookahead == '>')
        ADVANCE(115);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == ';')
        ADVANCE(141);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_SEMI_SEMI);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(143);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '-')
        ADVANCE(144);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      END_STATE();
    case 145:
      if (lookahead == '\n')
        SKIP(135);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == '|')
        ADVANCE(71);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_PIPE_AMP);
      END_STATE();
    case 148:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(149);
      if (lookahead == '$')
        ADVANCE(124);
      if (lookahead == '\\')
        ADVANCE(151);
      if (lookahead == '`')
        ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(152);
      if (lookahead != 0)
        ADVANCE(150);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(150);
      if (lookahead == '\"' ||
          lookahead == '$')
        ADVANCE(5);
      if (lookahead != 0)
        ADVANCE(149);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$')
        ADVANCE(150);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(152);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$')
        ADVANCE(150);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '#')
        ADVANCE(149);
      if (lookahead == '\\')
        ADVANCE(151);
      if (lookahead == '`')
        ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(152);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(150);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$')
        ADVANCE(150);
      END_STATE();
    case 154:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(74);
      if (lookahead == '&')
        ADVANCE(77);
      if (lookahead == '\'')
        ADVANCE(80);
      if (lookahead == ':')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(86);
      if (lookahead == '\\')
        SKIP(155);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(154);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 155:
      if (lookahead == '\n')
        SKIP(154);
      END_STATE();
    case 156:
      if (lookahead == '\n')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(138);
      if (lookahead == '(')
        ADVANCE(8);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '=')
        ADVANCE(17);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(159);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(158);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(157);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(158);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(157);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(158);
      END_STATE();
    case 159:
      if (lookahead == '\n')
        SKIP(156);
      END_STATE();
    case 160:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '\\')
        SKIP(161);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(160);
      END_STATE();
    case 161:
      if (lookahead == '\n')
        SKIP(160);
      END_STATE();
    case 162:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(74);
      if (lookahead == '&')
        ADVANCE(77);
      if (lookahead == '\'')
        ADVANCE(80);
      if (lookahead == '(')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ':')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(163);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(86);
      if (lookahead == '[')
        ADVANCE(89);
      if (lookahead == '\\')
        SKIP(164);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(165);
      if (lookahead == 'e')
        ADVANCE(169);
      if (lookahead == 'f')
        ADVANCE(175);
      if (lookahead == 'i')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '}')
        ADVANCE(72);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(162);
      if ((lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 163:
      if (lookahead == ';')
        ADVANCE(141);
      END_STATE();
    case 164:
      if (lookahead == '\n')
        SKIP(162);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'o')
        ADVANCE(166);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'n')
        ADVANCE(167);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'e')
        ADVANCE(168);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_done);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'l')
        ADVANCE(170);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'i')
        ADVANCE(171);
      if (lookahead == 's')
        ADVANCE(173);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'f')
        ADVANCE(172);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_elif);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'e')
        ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'i')
        ADVANCE(176);
      if (lookahead == 'o')
        ADVANCE(97);
      if (lookahead == 'u')
        ADVANCE(99);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_fi);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 177:
      if (lookahead == '\n')
        ADVANCE(178);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(179);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '\\')
        SKIP(180);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(177);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(139);
      END_STATE();
    case 180:
      if (lookahead == '\n')
        SKIP(177);
      END_STATE();
    case 181:
      if (lookahead == '\n')
        ADVANCE(178);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(74);
      if (lookahead == '&')
        ADVANCE(182);
      if (lookahead == '\'')
        ADVANCE(80);
      if (lookahead == ':')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(86);
      if (lookahead == '\\')
        SKIP(184);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(181);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(183);
      if (lookahead == '>')
        ADVANCE(78);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '>' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 184:
      if (lookahead == '\n')
        SKIP(181);
      END_STATE();
    case 185:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '\\')
        SKIP(186);
      if (lookahead == 'i')
        ADVANCE(187);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(185);
      END_STATE();
    case 186:
      if (lookahead == '\n')
        SKIP(185);
      END_STATE();
    case 187:
      if (lookahead == 'n')
        ADVANCE(59);
      END_STATE();
    case 188:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '\\')
        SKIP(189);
      if (lookahead == 'd')
        ADVANCE(190);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(188);
      END_STATE();
    case 189:
      if (lookahead == '\n')
        SKIP(188);
      END_STATE();
    case 190:
      if (lookahead == 'o')
        ADVANCE(191);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 192:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '\\')
        SKIP(193);
      if (lookahead == 't')
        ADVANCE(60);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(192);
      END_STATE();
    case 193:
      if (lookahead == '\n')
        SKIP(192);
      END_STATE();
    case 194:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(8);
      if (lookahead == '\\')
        SKIP(195);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(194);
      END_STATE();
    case 195:
      if (lookahead == '\n')
        SKIP(194);
      END_STATE();
    case 196:
      if (lookahead == '\n')
        ADVANCE(178);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '\\')
        SKIP(197);
      if (lookahead == 'i')
        ADVANCE(187);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(196);
      END_STATE();
    case 197:
      if (lookahead == '\n')
        SKIP(196);
      END_STATE();
    case 198:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '*')
        ADVANCE(10);
      if (lookahead == '-')
        ADVANCE(11);
      if (lookahead == '0')
        ADVANCE(199);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '\\')
        SKIP(201);
      if (lookahead == '_')
        ADVANCE(202);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(198);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(200);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(200);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_simple_variable_name);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(200);
      END_STATE();
    case 201:
      if (lookahead == '\n')
        SKIP(198);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(200);
      END_STATE();
    case 203:
      if (lookahead == '!')
        ADVANCE(204);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(205);
      if (lookahead == '*')
        ADVANCE(206);
      if (lookahead == '-')
        ADVANCE(207);
      if (lookahead == '0')
        ADVANCE(208);
      if (lookahead == '?')
        ADVANCE(209);
      if (lookahead == '@')
        ADVANCE(210);
      if (lookahead == '\\')
        SKIP(211);
      if (lookahead == '_')
        ADVANCE(212);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(203);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '$') &&
          (lookahead < '(' || lookahead > '*') &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '_' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_0);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 211:
      if (lookahead == '\n')
        SKIP(203);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 213:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(124);
      if (lookahead == '\'')
        ADVANCE(126);
      if (lookahead == '<')
        ADVANCE(128);
      if (lookahead == '>')
        ADVANCE(129);
      if (lookahead == '\\')
        SKIP(214);
      if (lookahead == ']')
        ADVANCE(215);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(213);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(120);
      END_STATE();
    case 214:
      if (lookahead == '\n')
        SKIP(213);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == ']')
        ADVANCE(216);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '&' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '\\' &&
          lookahead != ']' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(120);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '&' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(120);
      END_STATE();
    case 217:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(124);
      if (lookahead == '\'')
        ADVANCE(126);
      if (lookahead == '<')
        ADVANCE(128);
      if (lookahead == '>')
        ADVANCE(129);
      if (lookahead == '\\')
        SKIP(218);
      if (lookahead == ']')
        ADVANCE(219);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(217);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(120);
      END_STATE();
    case 218:
      if (lookahead == '\n')
        SKIP(217);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '&' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(120);
      END_STATE();
    case 220:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(124);
      if (lookahead == '\'')
        ADVANCE(126);
      if (lookahead == '<')
        ADVANCE(128);
      if (lookahead == '>')
        ADVANCE(129);
      if (lookahead == '\\')
        SKIP(221);
      if (lookahead == ']')
        ADVANCE(222);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(220);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(120);
      END_STATE();
    case 221:
      if (lookahead == '\n')
        SKIP(220);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == ']')
        ADVANCE(216);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '&' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '\\' &&
          lookahead != ']' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(120);
      END_STATE();
    case 223:
      if (lookahead == '\n')
        ADVANCE(178);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(124);
      if (lookahead == '&')
        ADVANCE(138);
      if (lookahead == '\'')
        ADVANCE(126);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(224);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '|')
        ADVANCE(225);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(223);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(120);
      END_STATE();
    case 224:
      if (lookahead == '\n')
        SKIP(223);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == '|')
        ADVANCE(226);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(120);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '&' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(120);
      END_STATE();
    case 227:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '\\')
        SKIP(228);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(227);
      END_STATE();
    case 228:
      if (lookahead == '\n')
        SKIP(227);
      END_STATE();
    case 229:
      if (lookahead == '\n')
        ADVANCE(178);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(138);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(230);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(229);
      END_STATE();
    case 230:
      if (lookahead == '\n')
        SKIP(229);
      END_STATE();
    case 231:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(114);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(232);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(233);
      END_STATE();
    case 232:
      if (lookahead == '\n')
        SKIP(231);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(233);
      END_STATE();
    case 234:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(114);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '=')
        ADVANCE(17);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(235);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(236);
      END_STATE();
    case 235:
      if (lookahead == '\n')
        SKIP(234);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(236);
      END_STATE();
    case 237:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == '\\')
        SKIP(238);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(237);
      END_STATE();
    case 238:
      if (lookahead == '\n')
        SKIP(237);
      END_STATE();
    case 239:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(114);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(240);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(241);
      END_STATE();
    case 240:
      if (lookahead == '\n')
        SKIP(239);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(241);
      END_STATE();
    case 242:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(114);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '=')
        ADVANCE(17);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(243);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(244);
      END_STATE();
    case 243:
      if (lookahead == '\n')
        SKIP(242);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(244);
      END_STATE();
    case 245:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '\\')
        SKIP(246);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(245);
      END_STATE();
    case 246:
      if (lookahead == '\n')
        SKIP(245);
      END_STATE();
    case 247:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(74);
      if (lookahead == '&')
        ADVANCE(77);
      if (lookahead == '\'')
        ADVANCE(80);
      if (lookahead == '(')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ':')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(163);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(86);
      if (lookahead == '[')
        ADVANCE(89);
      if (lookahead == '\\')
        SKIP(248);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(249);
      if (lookahead == 'e')
        ADVANCE(169);
      if (lookahead == 'f')
        ADVANCE(175);
      if (lookahead == 'i')
        ADVANCE(106);
      if (lookahead == 't')
        ADVANCE(251);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '}')
        ADVANCE(72);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(247);
      if ((lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 248:
      if (lookahead == '\n')
        SKIP(247);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'o')
        ADVANCE(250);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'n')
        ADVANCE(167);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'h')
        ADVANCE(252);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'e')
        ADVANCE(253);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'n')
        ADVANCE(254);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_then);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 255:
      if (lookahead == '\n')
        ADVANCE(256);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(138);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '=')
        ADVANCE(17);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(258);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(257);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(256);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(257);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(256);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(257);
      END_STATE();
    case 258:
      if (lookahead == '\n')
        SKIP(255);
      END_STATE();
    case 259:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(74);
      if (lookahead == '&')
        ADVANCE(77);
      if (lookahead == '\'')
        ADVANCE(80);
      if (lookahead == '(')
        ADVANCE(8);
      if (lookahead == ':')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(86);
      if (lookahead == '[')
        ADVANCE(89);
      if (lookahead == '\\')
        SKIP(260);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(165);
      if (lookahead == 'f')
        ADVANCE(96);
      if (lookahead == 'i')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(259);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 260:
      if (lookahead == '\n')
        SKIP(259);
      END_STATE();
    case 261:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '\\')
        SKIP(262);
      if (lookahead == 'd')
        ADVANCE(190);
      if (lookahead == 't')
        ADVANCE(60);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(261);
      END_STATE();
    case 262:
      if (lookahead == '\n')
        SKIP(261);
      END_STATE();
    case 263:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(74);
      if (lookahead == '&')
        ADVANCE(77);
      if (lookahead == '\'')
        ADVANCE(80);
      if (lookahead == '(')
        ADVANCE(8);
      if (lookahead == ':')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(86);
      if (lookahead == '[')
        ADVANCE(89);
      if (lookahead == '\\')
        SKIP(264);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'e')
        ADVANCE(169);
      if (lookahead == 'f')
        ADVANCE(175);
      if (lookahead == 'i')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(263);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 264:
      if (lookahead == '\n')
        SKIP(263);
      END_STATE();
    case 265:
      if (lookahead == '\n')
        ADVANCE(178);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '\\')
        SKIP(266);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(265);
      END_STATE();
    case 266:
      if (lookahead == '\n')
        SKIP(265);
      END_STATE();
    case 267:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ':')
        ADVANCE(268);
      if (lookahead == '=')
        ADVANCE(17);
      if (lookahead == '\\')
        SKIP(271);
      if (lookahead == '}')
        ADVANCE(72);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(267);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(269);
      if (lookahead == '?')
        ADVANCE(270);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      END_STATE();
    case 271:
      if (lookahead == '\n')
        SKIP(267);
      END_STATE();
    case 272:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == ':')
        ADVANCE(268);
      if (lookahead == '=')
        ADVANCE(17);
      if (lookahead == '\\')
        SKIP(273);
      if (lookahead == '}')
        ADVANCE(72);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(272);
      END_STATE();
    case 273:
      if (lookahead == '\n')
        SKIP(272);
      END_STATE();
    case 274:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(124);
      if (lookahead == '\'')
        ADVANCE(126);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == '<')
        ADVANCE(128);
      if (lookahead == '>')
        ADVANCE(129);
      if (lookahead == '\\')
        SKIP(275);
      if (lookahead == ']')
        ADVANCE(215);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '}')
        ADVANCE(72);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(274);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{')
        ADVANCE(120);
      END_STATE();
    case 275:
      if (lookahead == '\n')
        SKIP(274);
      END_STATE();
    case 276:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(124);
      if (lookahead == '\'')
        ADVANCE(126);
      if (lookahead == '(')
        ADVANCE(8);
      if (lookahead == '<')
        ADVANCE(128);
      if (lookahead == '>')
        ADVANCE(129);
      if (lookahead == '\\')
        SKIP(277);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(276);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(120);
      END_STATE();
    case 277:
      if (lookahead == '\n')
        SKIP(276);
      END_STATE();
    case 278:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(279);
      if (lookahead == '\\')
        SKIP(280);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(278);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '{')
        ADVANCE(125);
      END_STATE();
    case 280:
      if (lookahead == '\n')
        SKIP(278);
      END_STATE();
    case 281:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(74);
      if (lookahead == '&')
        ADVANCE(282);
      if (lookahead == '\'')
        ADVANCE(80);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ':')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(86);
      if (lookahead == '\\')
        SKIP(283);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(281);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == '&')
        ADVANCE(183);
      if (lookahead == '>')
        ADVANCE(78);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '>' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 283:
      if (lookahead == '\n')
        SKIP(281);
      END_STATE();
    case 284:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(124);
      if (lookahead == '&')
        ADVANCE(114);
      if (lookahead == '\'')
        ADVANCE(126);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(285);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(284);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(120);
      END_STATE();
    case 285:
      if (lookahead == '\n')
        SKIP(284);
      END_STATE();
    case 286:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(287);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(288);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(286);
      END_STATE();
    case 287:
      if (lookahead == '&')
        ADVANCE(139);
      if (lookahead == '>')
        ADVANCE(115);
      END_STATE();
    case 288:
      if (lookahead == '\n')
        SKIP(286);
      END_STATE();
    case 289:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(114);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(290);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(289);
      END_STATE();
    case 290:
      if (lookahead == '\n')
        SKIP(289);
      END_STATE();
    case 291:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(287);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(292);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(293);
      END_STATE();
    case 292:
      if (lookahead == '\n')
        SKIP(291);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(293);
      END_STATE();
    case 294:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(124);
      if (lookahead == '&')
        ADVANCE(114);
      if (lookahead == '\'')
        ADVANCE(126);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(295);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(294);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(120);
      END_STATE();
    case 295:
      if (lookahead == '\n')
        SKIP(294);
      END_STATE();
    case 296:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '\\')
        SKIP(297);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(296);
      END_STATE();
    case 297:
      if (lookahead == '\n')
        SKIP(296);
      END_STATE();
    case 298:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(74);
      if (lookahead == '&')
        ADVANCE(77);
      if (lookahead == '\'')
        ADVANCE(80);
      if (lookahead == '(')
        ADVANCE(8);
      if (lookahead == ':')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(86);
      if (lookahead == '[')
        ADVANCE(89);
      if (lookahead == '\\')
        SKIP(299);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'f')
        ADVANCE(175);
      if (lookahead == 'i')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(298);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 299:
      if (lookahead == '\n')
        SKIP(298);
      END_STATE();
    case 300:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '\\')
        SKIP(301);
      if (lookahead == 'e')
        ADVANCE(302);
      if (lookahead == 'f')
        ADVANCE(303);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(300);
      END_STATE();
    case 301:
      if (lookahead == '\n')
        SKIP(300);
      END_STATE();
    case 302:
      if (lookahead == 'l')
        ADVANCE(38);
      END_STATE();
    case 303:
      if (lookahead == 'i')
        ADVANCE(47);
      END_STATE();
    case 304:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '\\')
        SKIP(305);
      if (lookahead == 'f')
        ADVANCE(303);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(304);
      END_STATE();
    case 305:
      if (lookahead == '\n')
        SKIP(304);
      END_STATE();
    case 306:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(287);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(307);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(308);
      END_STATE();
    case 307:
      if (lookahead == '\n')
        SKIP(306);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(308);
      END_STATE();
    case 309:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(287);
      if (lookahead == '(')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '=')
        ADVANCE(17);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(310);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(311);
      END_STATE();
    case 310:
      if (lookahead == '\n')
        SKIP(309);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(311);
      END_STATE();
    case 312:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(313);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == '\\')
        SKIP(314);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(312);
      END_STATE();
    case 313:
      if (lookahead == '&')
        ADVANCE(139);
      END_STATE();
    case 314:
      if (lookahead == '\n')
        SKIP(312);
      END_STATE();
    case 315:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(124);
      if (lookahead == '\'')
        ADVANCE(126);
      if (lookahead == '<')
        ADVANCE(128);
      if (lookahead == '>')
        ADVANCE(129);
      if (lookahead == '\\')
        SKIP(316);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == 'e')
        ADVANCE(317);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(315);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(120);
      END_STATE();
    case 316:
      if (lookahead == '\n')
        SKIP(315);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 's')
        ADVANCE(318);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '&' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(120);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'a')
        ADVANCE(319);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '&' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          lookahead != 'a' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(120);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'c')
        ADVANCE(320);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '&' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(120);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '&' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(120);
      END_STATE();
    case 321:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(124);
      if (lookahead == '&')
        ADVANCE(287);
      if (lookahead == '\'')
        ADVANCE(126);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(322);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '|')
        ADVANCE(225);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(321);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(120);
      END_STATE();
    case 322:
      if (lookahead == '\n')
        SKIP(321);
      END_STATE();
    case 323:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(74);
      if (lookahead == '&')
        ADVANCE(77);
      if (lookahead == '\'')
        ADVANCE(80);
      if (lookahead == '(')
        ADVANCE(8);
      if (lookahead == ':')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(86);
      if (lookahead == '[')
        ADVANCE(89);
      if (lookahead == '\\')
        SKIP(324);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'f')
        ADVANCE(96);
      if (lookahead == 'i')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '}')
        ADVANCE(72);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(323);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 324:
      if (lookahead == '\n')
        SKIP(323);
      END_STATE();
    case 325:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(287);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(326);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(325);
      END_STATE();
    case 326:
      if (lookahead == '\n')
        SKIP(325);
      END_STATE();
    case 327:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(287);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '=')
        ADVANCE(17);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(328);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(329);
      END_STATE();
    case 328:
      if (lookahead == '\n')
        SKIP(327);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(329);
      END_STATE();
    case 330:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '\\')
        SKIP(331);
      if (lookahead == '}')
        ADVANCE(72);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(330);
      END_STATE();
    case 331:
      if (lookahead == '\n')
        SKIP(330);
      END_STATE();
    case 332:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(74);
      if (lookahead == '&')
        ADVANCE(77);
      if (lookahead == '\'')
        ADVANCE(80);
      if (lookahead == '(')
        ADVANCE(8);
      if (lookahead == ':')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(163);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(86);
      if (lookahead == '[')
        ADVANCE(89);
      if (lookahead == '\\')
        SKIP(333);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'f')
        ADVANCE(96);
      if (lookahead == 'i')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(332);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 333:
      if (lookahead == '\n')
        SKIP(332);
      END_STATE();
    case 334:
      if (lookahead == '\n')
        ADVANCE(178);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(74);
      if (lookahead == '&')
        ADVANCE(335);
      if (lookahead == '\'')
        ADVANCE(80);
      if (lookahead == '(')
        ADVANCE(8);
      if (lookahead == ':')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(86);
      if (lookahead == '[')
        ADVANCE(89);
      if (lookahead == '\\')
        SKIP(336);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'f')
        ADVANCE(96);
      if (lookahead == 'i')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(334);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '>')
        ADVANCE(78);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '>' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 336:
      if (lookahead == '\n')
        SKIP(334);
      END_STATE();
    case 337:
      if (lookahead == '\n')
        ADVANCE(178);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(179);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '\\')
        SKIP(338);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(337);
      END_STATE();
    case 338:
      if (lookahead == '\n')
        SKIP(337);
      END_STATE();
    case 339:
      if (lookahead == '\n')
        ADVANCE(340);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(149);
      if (lookahead == '$')
        ADVANCE(398);
      if (lookahead == '&')
        ADVANCE(341);
      if (lookahead == '\'')
        ADVANCE(346);
      if (lookahead == '(')
        ADVANCE(352);
      if (lookahead == ')')
        ADVANCE(353);
      if (lookahead == ':')
        ADVANCE(354);
      if (lookahead == ';')
        ADVANCE(355);
      if (lookahead == '<')
        ADVANCE(357);
      if (lookahead == '=')
        ADVANCE(348);
      if (lookahead == '>')
        ADVANCE(361);
      if (lookahead == '[')
        ADVANCE(364);
      if (lookahead == '\\')
        ADVANCE(366);
      if (lookahead == ']')
        ADVANCE(368);
      if (lookahead == '`')
        ADVANCE(153);
      if (lookahead == 'c')
        ADVANCE(370);
      if (lookahead == 'f')
        ADVANCE(374);
      if (lookahead == 'i')
        ADVANCE(384);
      if (lookahead == 'w')
        ADVANCE(387);
      if (lookahead == '{')
        ADVANCE(392);
      if (lookahead == '|')
        ADVANCE(393);
      if (lookahead == '}')
        ADVANCE(396);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(397);
      if (lookahead != 0)
        ADVANCE(347);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(340);
      if (lookahead == '#')
        ADVANCE(149);
      if (lookahead == '&')
        ADVANCE(341);
      if (lookahead == '\'')
        ADVANCE(346);
      if (lookahead == '(')
        ADVANCE(352);
      if (lookahead == ')')
        ADVANCE(353);
      if (lookahead == ':')
        ADVANCE(354);
      if (lookahead == ';')
        ADVANCE(355);
      if (lookahead == '<')
        ADVANCE(357);
      if (lookahead == '=')
        ADVANCE(348);
      if (lookahead == '>')
        ADVANCE(361);
      if (lookahead == '[')
        ADVANCE(364);
      if (lookahead == '\\')
        ADVANCE(366);
      if (lookahead == ']')
        ADVANCE(368);
      if (lookahead == '`')
        ADVANCE(153);
      if (lookahead == 'c')
        ADVANCE(370);
      if (lookahead == 'f')
        ADVANCE(374);
      if (lookahead == 'i')
        ADVANCE(384);
      if (lookahead == 'w')
        ADVANCE(387);
      if (lookahead == '{')
        ADVANCE(392);
      if (lookahead == '|')
        ADVANCE(393);
      if (lookahead == '}')
        ADVANCE(396);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(397);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '&')
        ADVANCE(342);
      if (lookahead == '>')
        ADVANCE(344);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ':' ||
          lookahead == ';' ||
          lookahead == '=' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(343);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ':' ||
          lookahead == ';' ||
          lookahead == '=' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(343);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ':' ||
          lookahead == ';' ||
          lookahead == '=' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(343);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym_AMP_GT);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '>')
        ADVANCE(345);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ':' ||
          lookahead == ';' ||
          lookahead == '=' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(343);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_AMP_GT_GT);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ':' ||
          lookahead == ';' ||
          lookahead == '=' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(343);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\"')
        ADVANCE(82);
      if (lookahead == '$')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(347);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(349);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(351);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(350);
      if (lookahead != 0)
        ADVANCE(346);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '&' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(348);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\"')
        ADVANCE(82);
      if (lookahead == '$')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(343);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ':' ||
          lookahead == ';' ||
          lookahead == '=' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(350);
      if (lookahead != 0)
        ADVANCE(349);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\'')
        ADVANCE(150);
      if (lookahead == '\"' ||
          lookahead == '$')
        ADVANCE(82);
      if (lookahead != 0)
        ADVANCE(350);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\'')
        ADVANCE(348);
      if (lookahead == '\"' ||
          lookahead == '$')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(350);
      if (lookahead != 0)
        ADVANCE(351);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$')
        ADVANCE(150);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$')
        ADVANCE(150);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '&' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(348);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == ';')
        ADVANCE(356);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$')
        ADVANCE(150);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(anon_sym_SEMI_SEMI);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$')
        ADVANCE(150);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '&')
        ADVANCE(358);
      if (lookahead == '<')
        ADVANCE(359);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          (':' <= lookahead && lookahead <= '=') ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(343);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(anon_sym_LT_AMP);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ':' ||
          lookahead == ';' ||
          lookahead == '=' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(343);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '-')
        ADVANCE(360);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ':' ||
          lookahead == ';' ||
          lookahead == '=' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(343);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ':' ||
          lookahead == ';' ||
          lookahead == '=' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(343);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '&')
        ADVANCE(362);
      if (lookahead == '>')
        ADVANCE(363);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ':' ||
          lookahead == ';' ||
          lookahead == '=' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(343);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(anon_sym_GT_AMP);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ':' ||
          lookahead == ';' ||
          lookahead == '=' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(343);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ':' ||
          lookahead == ';' ||
          lookahead == '=' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(343);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '[')
        ADVANCE(365);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(367);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$')
        ADVANCE(150);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(340);
      if (lookahead == '#')
        ADVANCE(149);
      if (lookahead == '&')
        ADVANCE(341);
      if (lookahead == '\'')
        ADVANCE(346);
      if (lookahead == '(')
        ADVANCE(352);
      if (lookahead == ')')
        ADVANCE(353);
      if (lookahead == ':')
        ADVANCE(354);
      if (lookahead == ';')
        ADVANCE(355);
      if (lookahead == '<')
        ADVANCE(357);
      if (lookahead == '=')
        ADVANCE(348);
      if (lookahead == '>')
        ADVANCE(361);
      if (lookahead == '[')
        ADVANCE(364);
      if (lookahead == '\\')
        ADVANCE(366);
      if (lookahead == ']')
        ADVANCE(368);
      if (lookahead == '`')
        ADVANCE(153);
      if (lookahead == 'c')
        ADVANCE(370);
      if (lookahead == 'f')
        ADVANCE(374);
      if (lookahead == 'i')
        ADVANCE(384);
      if (lookahead == 'w')
        ADVANCE(387);
      if (lookahead == '{')
        ADVANCE(392);
      if (lookahead == '|')
        ADVANCE(393);
      if (lookahead == '}')
        ADVANCE(396);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(397);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == ']')
        ADVANCE(369);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == 'a')
        ADVANCE(371);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == 's')
        ADVANCE(372);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == 'e')
        ADVANCE(373);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(anon_sym_case);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == 'o')
        ADVANCE(375);
      if (lookahead == 'u')
        ADVANCE(377);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == 'r')
        ADVANCE(376);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == 'n')
        ADVANCE(378);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == 'c')
        ADVANCE(379);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == 't')
        ADVANCE(380);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == 'i')
        ADVANCE(381);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == 'o')
        ADVANCE(382);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == 'n')
        ADVANCE(383);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(anon_sym_function);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == 'f')
        ADVANCE(385);
      if (lookahead == 'n')
        ADVANCE(386);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(anon_sym_if);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == 'h')
        ADVANCE(388);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == 'i')
        ADVANCE(389);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == 'l')
        ADVANCE(390);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == 'e')
        ADVANCE(391);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(anon_sym_while);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$')
        ADVANCE(150);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(394);
      if (lookahead == '|')
        ADVANCE(395);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(348);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(anon_sym_PIPE_AMP);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$')
        ADVANCE(150);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '&' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(348);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$')
        ADVANCE(150);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(340);
      if (lookahead == '#')
        ADVANCE(149);
      if (lookahead == '&')
        ADVANCE(341);
      if (lookahead == '\'')
        ADVANCE(346);
      if (lookahead == '(')
        ADVANCE(352);
      if (lookahead == ')')
        ADVANCE(353);
      if (lookahead == ':')
        ADVANCE(354);
      if (lookahead == ';')
        ADVANCE(355);
      if (lookahead == '<')
        ADVANCE(357);
      if (lookahead == '=')
        ADVANCE(348);
      if (lookahead == '>')
        ADVANCE(361);
      if (lookahead == '[')
        ADVANCE(364);
      if (lookahead == '\\')
        ADVANCE(366);
      if (lookahead == ']')
        ADVANCE(368);
      if (lookahead == '`')
        ADVANCE(153);
      if (lookahead == 'c')
        ADVANCE(370);
      if (lookahead == 'f')
        ADVANCE(374);
      if (lookahead == 'i')
        ADVANCE(384);
      if (lookahead == 'w')
        ADVANCE(387);
      if (lookahead == '{')
        ADVANCE(392);
      if (lookahead == '|')
        ADVANCE(393);
      if (lookahead == '}')
        ADVANCE(396);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(397);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(75);
      if (lookahead == '{')
        ADVANCE(125);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 399:
      if (lookahead == '\n')
        ADVANCE(400);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(149);
      if (lookahead == '$')
        ADVANCE(398);
      if (lookahead == '&')
        ADVANCE(341);
      if (lookahead == '\'')
        ADVANCE(346);
      if (lookahead == ')')
        ADVANCE(353);
      if (lookahead == ':')
        ADVANCE(354);
      if (lookahead == ';')
        ADVANCE(355);
      if (lookahead == '<')
        ADVANCE(357);
      if (lookahead == '=')
        ADVANCE(348);
      if (lookahead == '>')
        ADVANCE(361);
      if (lookahead == '\\')
        ADVANCE(401);
      if (lookahead == ']')
        ADVANCE(368);
      if (lookahead == '`')
        ADVANCE(153);
      if (lookahead == 'i')
        ADVANCE(403);
      if (lookahead == '|')
        ADVANCE(393);
      if (lookahead == '}')
        ADVANCE(396);
      if (lookahead == '(' ||
          lookahead == '{')
        ADVANCE(150);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(402);
      if (lookahead != 0)
        ADVANCE(347);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(400);
      if (lookahead == '#')
        ADVANCE(149);
      if (lookahead == '&')
        ADVANCE(341);
      if (lookahead == '\'')
        ADVANCE(346);
      if (lookahead == ')')
        ADVANCE(353);
      if (lookahead == ':')
        ADVANCE(354);
      if (lookahead == ';')
        ADVANCE(355);
      if (lookahead == '<')
        ADVANCE(357);
      if (lookahead == '=')
        ADVANCE(348);
      if (lookahead == '>')
        ADVANCE(361);
      if (lookahead == '\\')
        ADVANCE(401);
      if (lookahead == ']')
        ADVANCE(368);
      if (lookahead == '`')
        ADVANCE(153);
      if (lookahead == 'i')
        ADVANCE(403);
      if (lookahead == '|')
        ADVANCE(393);
      if (lookahead == '}')
        ADVANCE(396);
      if (lookahead == '(' ||
          lookahead == '{')
        ADVANCE(150);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(402);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(402);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$')
        ADVANCE(150);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(400);
      if (lookahead == '#')
        ADVANCE(149);
      if (lookahead == '&')
        ADVANCE(341);
      if (lookahead == '\'')
        ADVANCE(346);
      if (lookahead == ')')
        ADVANCE(353);
      if (lookahead == ':')
        ADVANCE(354);
      if (lookahead == ';')
        ADVANCE(355);
      if (lookahead == '<')
        ADVANCE(357);
      if (lookahead == '=')
        ADVANCE(348);
      if (lookahead == '>')
        ADVANCE(361);
      if (lookahead == '\\')
        ADVANCE(401);
      if (lookahead == ']')
        ADVANCE(368);
      if (lookahead == '`')
        ADVANCE(153);
      if (lookahead == 'i')
        ADVANCE(403);
      if (lookahead == '|')
        ADVANCE(393);
      if (lookahead == '}')
        ADVANCE(396);
      if (lookahead == '(' ||
          lookahead == '{')
        ADVANCE(150);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(402);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == 'n')
        ADVANCE(386);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 404:
      if (lookahead == '\n')
        ADVANCE(405);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(124);
      if (lookahead == '&')
        ADVANCE(138);
      if (lookahead == '\'')
        ADVANCE(126);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(407);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '|')
        ADVANCE(225);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(406);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(120);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(405);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(406);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(405);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(406);
      END_STATE();
    case 407:
      if (lookahead == '\n')
        SKIP(404);
      END_STATE();
    case 408:
      if (lookahead == '\n')
        ADVANCE(409);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(149);
      if (lookahead == '$')
        ADVANCE(398);
      if (lookahead == '&')
        ADVANCE(341);
      if (lookahead == '\'')
        ADVANCE(346);
      if (lookahead == ')')
        ADVANCE(353);
      if (lookahead == ':')
        ADVANCE(354);
      if (lookahead == ';')
        ADVANCE(355);
      if (lookahead == '<')
        ADVANCE(357);
      if (lookahead == '=')
        ADVANCE(348);
      if (lookahead == '>')
        ADVANCE(361);
      if (lookahead == '\\')
        ADVANCE(410);
      if (lookahead == ']')
        ADVANCE(368);
      if (lookahead == '`')
        ADVANCE(153);
      if (lookahead == 'i')
        ADVANCE(403);
      if (lookahead == '|')
        ADVANCE(393);
      if (lookahead == '}')
        ADVANCE(396);
      if (lookahead == '(' ||
          lookahead == '{')
        ADVANCE(150);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(412);
      if (lookahead != 0)
        ADVANCE(347);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(409);
      if (lookahead == '#')
        ADVANCE(149);
      if (lookahead == '&')
        ADVANCE(341);
      if (lookahead == '\'')
        ADVANCE(346);
      if (lookahead == ')')
        ADVANCE(353);
      if (lookahead == ':')
        ADVANCE(354);
      if (lookahead == ';')
        ADVANCE(355);
      if (lookahead == '<')
        ADVANCE(357);
      if (lookahead == '=')
        ADVANCE(348);
      if (lookahead == '>')
        ADVANCE(361);
      if (lookahead == '\\')
        ADVANCE(410);
      if (lookahead == ']')
        ADVANCE(368);
      if (lookahead == '`')
        ADVANCE(153);
      if (lookahead == 'i')
        ADVANCE(403);
      if (lookahead == '|')
        ADVANCE(393);
      if (lookahead == '}')
        ADVANCE(396);
      if (lookahead == '(' ||
          lookahead == '{')
        ADVANCE(150);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(412);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(411);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$')
        ADVANCE(150);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(409);
      if (lookahead == '#')
        ADVANCE(149);
      if (lookahead == '&')
        ADVANCE(341);
      if (lookahead == '\'')
        ADVANCE(346);
      if (lookahead == ')')
        ADVANCE(353);
      if (lookahead == ':')
        ADVANCE(354);
      if (lookahead == ';')
        ADVANCE(355);
      if (lookahead == '<')
        ADVANCE(357);
      if (lookahead == '=')
        ADVANCE(348);
      if (lookahead == '>')
        ADVANCE(361);
      if (lookahead == '\\')
        ADVANCE(410);
      if (lookahead == ']')
        ADVANCE(368);
      if (lookahead == '`')
        ADVANCE(153);
      if (lookahead == 'i')
        ADVANCE(403);
      if (lookahead == '|')
        ADVANCE(393);
      if (lookahead == '}')
        ADVANCE(396);
      if (lookahead == '(' ||
          lookahead == '{')
        ADVANCE(150);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(412);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(409);
      if (lookahead == '#')
        ADVANCE(149);
      if (lookahead == '&')
        ADVANCE(341);
      if (lookahead == '\'')
        ADVANCE(346);
      if (lookahead == ')')
        ADVANCE(353);
      if (lookahead == ':')
        ADVANCE(354);
      if (lookahead == ';')
        ADVANCE(355);
      if (lookahead == '<')
        ADVANCE(357);
      if (lookahead == '=')
        ADVANCE(348);
      if (lookahead == '>')
        ADVANCE(361);
      if (lookahead == '\\')
        ADVANCE(410);
      if (lookahead == ']')
        ADVANCE(368);
      if (lookahead == '`')
        ADVANCE(153);
      if (lookahead == 'i')
        ADVANCE(403);
      if (lookahead == '|')
        ADVANCE(393);
      if (lookahead == '}')
        ADVANCE(396);
      if (lookahead == '(' ||
          lookahead == '{')
        ADVANCE(150);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(412);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 413:
      if (lookahead == '\n')
        ADVANCE(414);
      if (lookahead == '!')
        ADVANCE(415);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(416);
      if (lookahead == '$')
        ADVANCE(398);
      if (lookahead == '&')
        ADVANCE(341);
      if (lookahead == '\'')
        ADVANCE(346);
      if (lookahead == ')')
        ADVANCE(353);
      if (lookahead == '*')
        ADVANCE(417);
      if (lookahead == '-')
        ADVANCE(418);
      if (lookahead == '0')
        ADVANCE(419);
      if (lookahead == ':')
        ADVANCE(421);
      if (lookahead == ';')
        ADVANCE(355);
      if (lookahead == '<')
        ADVANCE(357);
      if (lookahead == '=')
        ADVANCE(424);
      if (lookahead == '>')
        ADVANCE(361);
      if (lookahead == '?')
        ADVANCE(425);
      if (lookahead == '@')
        ADVANCE(426);
      if (lookahead == '\\')
        ADVANCE(427);
      if (lookahead == ']')
        ADVANCE(368);
      if (lookahead == '_')
        ADVANCE(429);
      if (lookahead == '`')
        ADVANCE(153);
      if (lookahead == 'i')
        ADVANCE(430);
      if (lookahead == '|')
        ADVANCE(393);
      if (lookahead == '}')
        ADVANCE(396);
      if (lookahead == '(' ||
          lookahead == '{')
        ADVANCE(150);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(428);
      if (('1' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(420);
      if (lookahead != 0)
        ADVANCE(347);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(414);
      if (lookahead == '!')
        ADVANCE(415);
      if (lookahead == '#')
        ADVANCE(416);
      if (lookahead == '&')
        ADVANCE(341);
      if (lookahead == '\'')
        ADVANCE(346);
      if (lookahead == ')')
        ADVANCE(353);
      if (lookahead == '*')
        ADVANCE(417);
      if (lookahead == '-')
        ADVANCE(418);
      if (lookahead == '0')
        ADVANCE(419);
      if (lookahead == ':')
        ADVANCE(421);
      if (lookahead == ';')
        ADVANCE(355);
      if (lookahead == '<')
        ADVANCE(357);
      if (lookahead == '=')
        ADVANCE(424);
      if (lookahead == '>')
        ADVANCE(361);
      if (lookahead == '?')
        ADVANCE(425);
      if (lookahead == '@')
        ADVANCE(426);
      if (lookahead == '\\')
        ADVANCE(427);
      if (lookahead == ']')
        ADVANCE(368);
      if (lookahead == '_')
        ADVANCE(429);
      if (lookahead == '`')
        ADVANCE(153);
      if (lookahead == 'i')
        ADVANCE(430);
      if (lookahead == '|')
        ADVANCE(393);
      if (lookahead == '}')
        ADVANCE(396);
      if (lookahead == '(' ||
          lookahead == '{')
        ADVANCE(150);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(428);
      if (('1' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(420);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == '\n')
        ADVANCE(150);
      if (lookahead == '\"' ||
          lookahead == '$')
        ADVANCE(5);
      if (lookahead != 0)
        ADVANCE(149);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(anon_sym_0);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(420);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(420);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(422);
      if (lookahead == '?')
        ADVANCE(423);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '&' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(348);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '&' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(348);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '&' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(348);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '&' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(348);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(428);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$')
        ADVANCE(150);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(414);
      if (lookahead == '!')
        ADVANCE(415);
      if (lookahead == '#')
        ADVANCE(416);
      if (lookahead == '&')
        ADVANCE(341);
      if (lookahead == '\'')
        ADVANCE(346);
      if (lookahead == ')')
        ADVANCE(353);
      if (lookahead == '*')
        ADVANCE(417);
      if (lookahead == '-')
        ADVANCE(418);
      if (lookahead == '0')
        ADVANCE(419);
      if (lookahead == ':')
        ADVANCE(421);
      if (lookahead == ';')
        ADVANCE(355);
      if (lookahead == '<')
        ADVANCE(357);
      if (lookahead == '=')
        ADVANCE(424);
      if (lookahead == '>')
        ADVANCE(361);
      if (lookahead == '?')
        ADVANCE(425);
      if (lookahead == '@')
        ADVANCE(426);
      if (lookahead == '\\')
        ADVANCE(427);
      if (lookahead == ']')
        ADVANCE(368);
      if (lookahead == '_')
        ADVANCE(429);
      if (lookahead == '`')
        ADVANCE(153);
      if (lookahead == 'i')
        ADVANCE(430);
      if (lookahead == '|')
        ADVANCE(393);
      if (lookahead == '}')
        ADVANCE(396);
      if (lookahead == '(' ||
          lookahead == '{')
        ADVANCE(150);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(428);
      if (('1' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(420);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(420);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == 'n')
        ADVANCE(431);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(420);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == '$')
        ADVANCE(76);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>')
        ADVANCE(343);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(150);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(420);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 432:
      if (lookahead == '\n')
        ADVANCE(433);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(149);
      if (lookahead == '$')
        ADVANCE(398);
      if (lookahead == '&')
        ADVANCE(341);
      if (lookahead == '\'')
        ADVANCE(346);
      if (lookahead == ')')
        ADVANCE(353);
      if (lookahead == ':')
        ADVANCE(421);
      if (lookahead == ';')
        ADVANCE(355);
      if (lookahead == '<')
        ADVANCE(357);
      if (lookahead == '=')
        ADVANCE(424);
      if (lookahead == '>')
        ADVANCE(361);
      if (lookahead == '\\')
        ADVANCE(434);
      if (lookahead == ']')
        ADVANCE(368);
      if (lookahead == '`')
        ADVANCE(153);
      if (lookahead == 'i')
        ADVANCE(403);
      if (lookahead == '|')
        ADVANCE(393);
      if (lookahead == '}')
        ADVANCE(396);
      if (lookahead == '(' ||
          lookahead == '{')
        ADVANCE(150);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(435);
      if (lookahead != 0)
        ADVANCE(347);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(433);
      if (lookahead == '#')
        ADVANCE(149);
      if (lookahead == '&')
        ADVANCE(341);
      if (lookahead == '\'')
        ADVANCE(346);
      if (lookahead == ')')
        ADVANCE(353);
      if (lookahead == ':')
        ADVANCE(421);
      if (lookahead == ';')
        ADVANCE(355);
      if (lookahead == '<')
        ADVANCE(357);
      if (lookahead == '=')
        ADVANCE(424);
      if (lookahead == '>')
        ADVANCE(361);
      if (lookahead == '\\')
        ADVANCE(434);
      if (lookahead == ']')
        ADVANCE(368);
      if (lookahead == '`')
        ADVANCE(153);
      if (lookahead == 'i')
        ADVANCE(403);
      if (lookahead == '|')
        ADVANCE(393);
      if (lookahead == '}')
        ADVANCE(396);
      if (lookahead == '(' ||
          lookahead == '{')
        ADVANCE(150);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(435);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(435);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$')
        ADVANCE(150);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(433);
      if (lookahead == '#')
        ADVANCE(149);
      if (lookahead == '&')
        ADVANCE(341);
      if (lookahead == '\'')
        ADVANCE(346);
      if (lookahead == ')')
        ADVANCE(353);
      if (lookahead == ':')
        ADVANCE(421);
      if (lookahead == ';')
        ADVANCE(355);
      if (lookahead == '<')
        ADVANCE(357);
      if (lookahead == '=')
        ADVANCE(424);
      if (lookahead == '>')
        ADVANCE(361);
      if (lookahead == '\\')
        ADVANCE(434);
      if (lookahead == ']')
        ADVANCE(368);
      if (lookahead == '`')
        ADVANCE(153);
      if (lookahead == 'i')
        ADVANCE(403);
      if (lookahead == '|')
        ADVANCE(393);
      if (lookahead == '}')
        ADVANCE(396);
      if (lookahead == '(' ||
          lookahead == '{')
        ADVANCE(150);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(435);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$'))
        ADVANCE(347);
      END_STATE();
    case 436:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(398);
      if (lookahead == '&')
        ADVANCE(77);
      if (lookahead == '\'')
        ADVANCE(437);
      if (lookahead == '(')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ':')
        ADVANCE(440);
      if (lookahead == ';')
        ADVANCE(163);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(86);
      if (lookahead == '[')
        ADVANCE(441);
      if (lookahead == '\\')
        SKIP(443);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == 'c')
        ADVANCE(444);
      if (lookahead == 'd')
        ADVANCE(448);
      if (lookahead == 'e')
        ADVANCE(452);
      if (lookahead == 'f')
        ADVANCE(461);
      if (lookahead == 'i')
        ADVANCE(472);
      if (lookahead == 't')
        ADVANCE(475);
      if (lookahead == 'w')
        ADVANCE(479);
      if (lookahead == '}')
        ADVANCE(72);
      if (lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(436);
      if ((lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == '\'')
        ADVANCE(438);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(126);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(80);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '\"' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '\\' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(82);
      if (lookahead != 0)
        ADVANCE(437);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(sym_raw_string);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '&' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(120);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[')
        ADVANCE(442);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '[' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 443:
      if (lookahead == '\n')
        SKIP(436);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'a')
        ADVANCE(445);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 's')
        ADVANCE(446);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'e')
        ADVANCE(447);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(anon_sym_case);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'o')
        ADVANCE(449);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'n')
        ADVANCE(450);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'e')
        ADVANCE(451);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(anon_sym_done);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'l')
        ADVANCE(453);
      if (lookahead == 's')
        ADVANCE(458);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'i')
        ADVANCE(454);
      if (lookahead == 's')
        ADVANCE(456);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'f')
        ADVANCE(455);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym_elif);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'e')
        ADVANCE(457);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'a')
        ADVANCE(459);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'c')
        ADVANCE(460);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'i')
        ADVANCE(462);
      if (lookahead == 'o')
        ADVANCE(463);
      if (lookahead == 'u')
        ADVANCE(465);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_fi);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'r')
        ADVANCE(464);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'n')
        ADVANCE(466);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'c')
        ADVANCE(467);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 't')
        ADVANCE(468);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'i')
        ADVANCE(469);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'o')
        ADVANCE(470);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'n')
        ADVANCE(471);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_function);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'f')
        ADVANCE(473);
      if (lookahead == 'n')
        ADVANCE(474);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_if);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'h')
        ADVANCE(476);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'e')
        ADVANCE(477);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'n')
        ADVANCE(478);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(anon_sym_then);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'h')
        ADVANCE(480);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'i')
        ADVANCE(481);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'l')
        ADVANCE(482);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'e')
        ADVANCE(483);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(anon_sym_while);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 484:
      if (lookahead == '\n')
        ADVANCE(178);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(138);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(485);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(484);
      END_STATE();
    case 485:
      if (lookahead == '\n')
        SKIP(484);
      END_STATE();
    case 486:
      if (lookahead == '\n')
        ADVANCE(178);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(74);
      if (lookahead == '&')
        ADVANCE(182);
      if (lookahead == '\'')
        ADVANCE(80);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ':')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(86);
      if (lookahead == '\\')
        SKIP(487);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(486);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 487:
      if (lookahead == '\n')
        SKIP(486);
      END_STATE();
    case 488:
      if (lookahead == '\n')
        ADVANCE(178);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(179);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '\\')
        SKIP(489);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(488);
      END_STATE();
    case 489:
      if (lookahead == '\n')
        SKIP(488);
      END_STATE();
    case 490:
      if (lookahead == '\n')
        ADVANCE(178);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(74);
      if (lookahead == '&')
        ADVANCE(182);
      if (lookahead == '\'')
        ADVANCE(80);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ':')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(491);
      if (lookahead == '>')
        ADVANCE(86);
      if (lookahead == '\\')
        SKIP(494);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(490);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(85);
      if (lookahead == '<')
        ADVANCE(492);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '=') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '-')
        ADVANCE(493);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '\"' &&
          lookahead != '#' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ':' &&
          lookahead != ';' &&
          lookahead != '=' &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 494:
      if (lookahead == '\n')
        SKIP(490);
      END_STATE();
    case 495:
      if (lookahead == '\n')
        ADVANCE(496);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(398);
      if (lookahead == '&')
        ADVANCE(182);
      if (lookahead == '\'')
        ADVANCE(437);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ':')
        ADVANCE(440);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(491);
      if (lookahead == '=')
        ADVANCE(120);
      if (lookahead == '>')
        ADVANCE(86);
      if (lookahead == '\\')
        SKIP(498);
      if (lookahead == ']')
        ADVANCE(499);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == 'i')
        ADVANCE(501);
      if (lookahead == '|')
        ADVANCE(225);
      if (lookahead == '}')
        ADVANCE(72);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(497);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(496);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(497);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(496);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(497);
      END_STATE();
    case 498:
      if (lookahead == '\n')
        SKIP(495);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == ']')
        ADVANCE(500);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(sym_leading_word);
      if (lookahead == 'n')
        ADVANCE(474);
      if (lookahead == ':' ||
          lookahead == '=' ||
          lookahead == '|')
        ADVANCE(120);
      if (lookahead == '$' ||
          lookahead == '&' ||
          ('<' <= lookahead && lookahead <= '>'))
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < ':' || lookahead > '>') &&
          lookahead != '\\' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 502:
      if (lookahead == '\n')
        ADVANCE(178);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(398);
      if (lookahead == '&')
        ADVANCE(182);
      if (lookahead == '\'')
        ADVANCE(437);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ':')
        ADVANCE(440);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(491);
      if (lookahead == '=')
        ADVANCE(120);
      if (lookahead == '>')
        ADVANCE(86);
      if (lookahead == '\\')
        SKIP(503);
      if (lookahead == ']')
        ADVANCE(499);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == 'i')
        ADVANCE(501);
      if (lookahead == '|')
        ADVANCE(225);
      if (lookahead == '}')
        ADVANCE(72);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(502);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(439);
      END_STATE();
    case 503:
      if (lookahead == '\n')
        SKIP(502);
      END_STATE();
    case 504:
      if (lookahead == '\n')
        ADVANCE(178);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(124);
      if (lookahead == '&')
        ADVANCE(138);
      if (lookahead == '\'')
        ADVANCE(126);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(505);
      if (lookahead == ']')
        ADVANCE(215);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '|')
        ADVANCE(225);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(504);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(120);
      END_STATE();
    case 505:
      if (lookahead == '\n')
        SKIP(504);
      END_STATE();
    case 506:
      if (lookahead == '\n')
        ADVANCE(178);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(179);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '\\')
        SKIP(507);
      if (lookahead == '{')
        ADVANCE(69);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(506);
      END_STATE();
    case 507:
      if (lookahead == '\n')
        SKIP(506);
      END_STATE();
    case 508:
      if (lookahead == '\n')
        ADVANCE(509);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(138);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(511);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(510);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(509);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(510);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(509);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(510);
      END_STATE();
    case 511:
      if (lookahead == '\n')
        SKIP(508);
      END_STATE();
    case 512:
      if (lookahead == '\n')
        ADVANCE(513);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(138);
      if (lookahead == '(')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '=')
        ADVANCE(17);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(515);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(514);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(513);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(514);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(513);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(514);
      END_STATE();
    case 515:
      if (lookahead == '\n')
        SKIP(512);
      END_STATE();
    case 516:
      if (lookahead == '\n')
        ADVANCE(178);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(124);
      if (lookahead == '&')
        ADVANCE(138);
      if (lookahead == '\'')
        ADVANCE(126);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(517);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '|')
        ADVANCE(225);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(516);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(120);
      END_STATE();
    case 517:
      if (lookahead == '\n')
        SKIP(516);
      END_STATE();
    case 518:
      if (lookahead == '\n')
        ADVANCE(178);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(74);
      if (lookahead == '&')
        ADVANCE(182);
      if (lookahead == '\'')
        ADVANCE(80);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ':')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(86);
      if (lookahead == '\\')
        SKIP(519);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '}')
        ADVANCE(72);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(518);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(76);
      END_STATE();
    case 519:
      if (lookahead == '\n')
        SKIP(518);
      END_STATE();
    case 520:
      if (lookahead == '\n')
        ADVANCE(521);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(138);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(523);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(522);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(521);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(522);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(521);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(522);
      END_STATE();
    case 523:
      if (lookahead == '\n')
        SKIP(520);
      END_STATE();
    case 524:
      if (lookahead == '\n')
        ADVANCE(525);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(138);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '=')
        ADVANCE(17);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(527);
      if (lookahead == '`')
        ADVANCE(28);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(526);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(525);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(526);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(525);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(526);
      END_STATE();
    case 527:
      if (lookahead == '\n')
        SKIP(524);
      END_STATE();
    case 528:
      if (lookahead == '\n')
        ADVANCE(178);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(138);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(529);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(528);
      END_STATE();
    case 529:
      if (lookahead == '\n')
        SKIP(528);
      END_STATE();
    case 530:
      if (lookahead == '\n')
        ADVANCE(531);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(138);
      if (lookahead == ')')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(142);
      if (lookahead == '=')
        ADVANCE(17);
      if (lookahead == '>')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(533);
      if (lookahead == '|')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(532);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(531);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(532);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(531);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(532);
      END_STATE();
    case 533:
      if (lookahead == '\n')
        SKIP(530);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 73, .external_lex_state = 2},
  [2] = {.lex_state = 113},
  [3] = {.lex_state = 118},
  [4] = {.lex_state = 121, .external_lex_state = 2},
  [5] = {.lex_state = 121, .external_lex_state = 2},
  [6] = {.lex_state = 123},
  [7] = {.lex_state = 131},
  [8] = {.lex_state = 133, .external_lex_state = 2},
  [9] = {.lex_state = 123},
  [10] = {.lex_state = 123},
  [11] = {.lex_state = 135, .external_lex_state = 2},
  [12] = {.lex_state = 123},
  [13] = {.lex_state = 148},
  [14] = {.lex_state = 154, .external_lex_state = 2},
  [15] = {.lex_state = 154, .external_lex_state = 2},
  [16] = {.lex_state = 156, .external_lex_state = 2},
  [17] = {.lex_state = 160},
  [18] = {.lex_state = 162, .external_lex_state = 2},
  [19] = {.lex_state = 177},
  [20] = {.lex_state = 181, .external_lex_state = 2},
  [21] = {.lex_state = 154, .external_lex_state = 2},
  [22] = {.lex_state = 73, .external_lex_state = 2},
  [23] = {.lex_state = 154, .external_lex_state = 2},
  [24] = {.lex_state = 123},
  [25] = {.lex_state = 185},
  [26] = {.lex_state = 188},
  [27] = {.lex_state = 177},
  [28] = {.lex_state = 181, .external_lex_state = 2},
  [29] = {.lex_state = 192},
  [30] = {.lex_state = 194},
  [31] = {.lex_state = 148},
  [32] = {.lex_state = 196},
  [33] = {.lex_state = 198},
  [34] = {.lex_state = 203},
  [35] = {.lex_state = 154, .external_lex_state = 2},
  [36] = {.lex_state = 154, .external_lex_state = 2},
  [37] = {.lex_state = 194},
  [38] = {.lex_state = 177},
  [39] = {.lex_state = 133, .external_lex_state = 2},
  [40] = {.lex_state = 194},
  [41] = {.lex_state = 148},
  [42] = {.lex_state = 213},
  [43] = {.lex_state = 198},
  [44] = {.lex_state = 203},
  [45] = {.lex_state = 154, .external_lex_state = 2},
  [46] = {.lex_state = 154, .external_lex_state = 2},
  [47] = {.lex_state = 217},
  [48] = {.lex_state = 220},
  [49] = {.lex_state = 113},
  [50] = {.lex_state = 223, .external_lex_state = 2},
  [51] = {.lex_state = 123},
  [52] = {.lex_state = 227, .external_lex_state = 3},
  [53] = {.lex_state = 229, .external_lex_state = 2},
  [54] = {.lex_state = 229, .external_lex_state = 2},
  [55] = {.lex_state = 194},
  [56] = {.lex_state = 148},
  [57] = {.lex_state = 154, .external_lex_state = 2},
  [58] = {.lex_state = 198},
  [59] = {.lex_state = 203},
  [60] = {.lex_state = 154, .external_lex_state = 2},
  [61] = {.lex_state = 154, .external_lex_state = 2},
  [62] = {.lex_state = 135, .external_lex_state = 2},
  [63] = {.lex_state = 148},
  [64] = {.lex_state = 198},
  [65] = {.lex_state = 203},
  [66] = {.lex_state = 154, .external_lex_state = 2},
  [67] = {.lex_state = 154, .external_lex_state = 2},
  [68] = {.lex_state = 148},
  [69] = {.lex_state = 231, .external_lex_state = 2},
  [70] = {.lex_state = 148},
  [71] = {.lex_state = 154, .external_lex_state = 2},
  [72] = {.lex_state = 154, .external_lex_state = 2},
  [73] = {.lex_state = 234, .external_lex_state = 2},
  [74] = {.lex_state = 237},
  [75] = {.lex_state = 154, .external_lex_state = 2},
  [76] = {.lex_state = 239, .external_lex_state = 2},
  [77] = {.lex_state = 242, .external_lex_state = 2},
  [78] = {.lex_state = 245},
  [79] = {.lex_state = 154, .external_lex_state = 2},
  [80] = {.lex_state = 237},
  [81] = {.lex_state = 223, .external_lex_state = 2},
  [82] = {.lex_state = 123, .external_lex_state = 4},
  [83] = {.lex_state = 229, .external_lex_state = 2},
  [84] = {.lex_state = 247, .external_lex_state = 2},
  [85] = {.lex_state = 121, .external_lex_state = 2},
  [86] = {.lex_state = 121, .external_lex_state = 2},
  [87] = {.lex_state = 162, .external_lex_state = 2},
  [88] = {.lex_state = 135, .external_lex_state = 2},
  [89] = {.lex_state = 255, .external_lex_state = 2},
  [90] = {.lex_state = 154, .external_lex_state = 2},
  [91] = {.lex_state = 154, .external_lex_state = 2},
  [92] = {.lex_state = 121, .external_lex_state = 2},
  [93] = {.lex_state = 259, .external_lex_state = 2},
  [94] = {.lex_state = 177},
  [95] = {.lex_state = 261},
  [96] = {.lex_state = 263, .external_lex_state = 2},
  [97] = {.lex_state = 121, .external_lex_state = 2},
  [98] = {.lex_state = 196},
  [99] = {.lex_state = 148},
  [100] = {.lex_state = 265},
  [101] = {.lex_state = 185},
  [102] = {.lex_state = 196},
  [103] = {.lex_state = 196},
  [104] = {.lex_state = 196},
  [105] = {.lex_state = 267},
  [106] = {.lex_state = 272},
  [107] = {.lex_state = 272},
  [108] = {.lex_state = 237},
  [109] = {.lex_state = 245},
  [110] = {.lex_state = 237},
  [111] = {.lex_state = 177},
  [112] = {.lex_state = 121, .external_lex_state = 2},
  [113] = {.lex_state = 274},
  [114] = {.lex_state = 148},
  [115] = {.lex_state = 213},
  [116] = {.lex_state = 274},
  [117] = {.lex_state = 274},
  [118] = {.lex_state = 272},
  [119] = {.lex_state = 272},
  [120] = {.lex_state = 237},
  [121] = {.lex_state = 245},
  [122] = {.lex_state = 177},
  [123] = {.lex_state = 213},
  [124] = {.lex_state = 123},
  [125] = {.lex_state = 276},
  [126] = {.lex_state = 148},
  [127] = {.lex_state = 223, .external_lex_state = 2},
  [128] = {.lex_state = 198},
  [129] = {.lex_state = 203},
  [130] = {.lex_state = 154, .external_lex_state = 2},
  [131] = {.lex_state = 154, .external_lex_state = 2},
  [132] = {.lex_state = 223, .external_lex_state = 2},
  [133] = {.lex_state = 229, .external_lex_state = 2},
  [134] = {.lex_state = 194},
  [135] = {.lex_state = 148},
  [136] = {.lex_state = 229, .external_lex_state = 2},
  [137] = {.lex_state = 198},
  [138] = {.lex_state = 203},
  [139] = {.lex_state = 154, .external_lex_state = 2},
  [140] = {.lex_state = 154, .external_lex_state = 2},
  [141] = {.lex_state = 229, .external_lex_state = 2},
  [142] = {.lex_state = 278, .external_lex_state = 5},
  [143] = {.lex_state = 229, .external_lex_state = 2},
  [144] = {.lex_state = 229, .external_lex_state = 2},
  [145] = {.lex_state = 121, .external_lex_state = 2},
  [146] = {.lex_state = 281, .external_lex_state = 2},
  [147] = {.lex_state = 148},
  [148] = {.lex_state = 281, .external_lex_state = 2},
  [149] = {.lex_state = 281, .external_lex_state = 2},
  [150] = {.lex_state = 281, .external_lex_state = 2},
  [151] = {.lex_state = 272},
  [152] = {.lex_state = 272},
  [153] = {.lex_state = 237},
  [154] = {.lex_state = 245},
  [155] = {.lex_state = 148},
  [156] = {.lex_state = 148},
  [157] = {.lex_state = 148},
  [158] = {.lex_state = 272},
  [159] = {.lex_state = 272},
  [160] = {.lex_state = 237},
  [161] = {.lex_state = 245},
  [162] = {.lex_state = 135, .external_lex_state = 2},
  [163] = {.lex_state = 148},
  [164] = {.lex_state = 113},
  [165] = {.lex_state = 284, .external_lex_state = 2},
  [166] = {.lex_state = 123},
  [167] = {.lex_state = 227, .external_lex_state = 3},
  [168] = {.lex_state = 286, .external_lex_state = 2},
  [169] = {.lex_state = 289, .external_lex_state = 2},
  [170] = {.lex_state = 291, .external_lex_state = 2},
  [171] = {.lex_state = 148},
  [172] = {.lex_state = 237},
  [173] = {.lex_state = 245},
  [174] = {.lex_state = 284, .external_lex_state = 2},
  [175] = {.lex_state = 123, .external_lex_state = 4},
  [176] = {.lex_state = 289, .external_lex_state = 2},
  [177] = {.lex_state = 135, .external_lex_state = 2},
  [178] = {.lex_state = 231, .external_lex_state = 2},
  [179] = {.lex_state = 234, .external_lex_state = 2},
  [180] = {.lex_state = 294, .external_lex_state = 2},
  [181] = {.lex_state = 294, .external_lex_state = 2},
  [182] = {.lex_state = 239, .external_lex_state = 2},
  [183] = {.lex_state = 242, .external_lex_state = 2},
  [184] = {.lex_state = 296},
  [185] = {.lex_state = 223, .external_lex_state = 2},
  [186] = {.lex_state = 229, .external_lex_state = 2},
  [187] = {.lex_state = 181, .external_lex_state = 2},
  [188] = {.lex_state = 194},
  [189] = {.lex_state = 148},
  [190] = {.lex_state = 198},
  [191] = {.lex_state = 203},
  [192] = {.lex_state = 154, .external_lex_state = 2},
  [193] = {.lex_state = 154, .external_lex_state = 2},
  [194] = {.lex_state = 177},
  [195] = {.lex_state = 181, .external_lex_state = 2},
  [196] = {.lex_state = 177},
  [197] = {.lex_state = 181, .external_lex_state = 2},
  [198] = {.lex_state = 223, .external_lex_state = 2},
  [199] = {.lex_state = 223, .external_lex_state = 2},
  [200] = {.lex_state = 229, .external_lex_state = 2},
  [201] = {.lex_state = 188},
  [202] = {.lex_state = 177},
  [203] = {.lex_state = 259, .external_lex_state = 2},
  [204] = {.lex_state = 177},
  [205] = {.lex_state = 121, .external_lex_state = 2},
  [206] = {.lex_state = 298, .external_lex_state = 2},
  [207] = {.lex_state = 300},
  [208] = {.lex_state = 304},
  [209] = {.lex_state = 263, .external_lex_state = 2},
  [210] = {.lex_state = 300},
  [211] = {.lex_state = 118},
  [212] = {.lex_state = 121, .external_lex_state = 2},
  [213] = {.lex_state = 121, .external_lex_state = 2},
  [214] = {.lex_state = 123},
  [215] = {.lex_state = 131},
  [216] = {.lex_state = 133, .external_lex_state = 2},
  [217] = {.lex_state = 123},
  [218] = {.lex_state = 123},
  [219] = {.lex_state = 306, .external_lex_state = 2},
  [220] = {.lex_state = 309, .external_lex_state = 2},
  [221] = {.lex_state = 312},
  [222] = {.lex_state = 281, .external_lex_state = 2},
  [223] = {.lex_state = 154, .external_lex_state = 2},
  [224] = {.lex_state = 196},
  [225] = {.lex_state = 315},
  [226] = {.lex_state = 265},
  [227] = {.lex_state = 196},
  [228] = {.lex_state = 123},
  [229] = {.lex_state = 196},
  [230] = {.lex_state = 123},
  [231] = {.lex_state = 196},
  [232] = {.lex_state = 296},
  [233] = {.lex_state = 312},
  [234] = {.lex_state = 281, .external_lex_state = 2},
  [235] = {.lex_state = 274},
  [236] = {.lex_state = 274},
  [237] = {.lex_state = 123},
  [238] = {.lex_state = 274},
  [239] = {.lex_state = 123},
  [240] = {.lex_state = 274},
  [241] = {.lex_state = 229, .external_lex_state = 2},
  [242] = {.lex_state = 121, .external_lex_state = 2},
  [243] = {.lex_state = 223, .external_lex_state = 2},
  [244] = {.lex_state = 148},
  [245] = {.lex_state = 223, .external_lex_state = 2},
  [246] = {.lex_state = 223, .external_lex_state = 2},
  [247] = {.lex_state = 223, .external_lex_state = 2},
  [248] = {.lex_state = 272},
  [249] = {.lex_state = 272},
  [250] = {.lex_state = 237},
  [251] = {.lex_state = 245},
  [252] = {.lex_state = 223, .external_lex_state = 2},
  [253] = {.lex_state = 229, .external_lex_state = 2},
  [254] = {.lex_state = 121, .external_lex_state = 2},
  [255] = {.lex_state = 229, .external_lex_state = 2},
  [256] = {.lex_state = 148},
  [257] = {.lex_state = 229, .external_lex_state = 2},
  [258] = {.lex_state = 229, .external_lex_state = 2},
  [259] = {.lex_state = 229, .external_lex_state = 2},
  [260] = {.lex_state = 272},
  [261] = {.lex_state = 272},
  [262] = {.lex_state = 237},
  [263] = {.lex_state = 245},
  [264] = {.lex_state = 278, .external_lex_state = 5},
  [265] = {.lex_state = 229, .external_lex_state = 2},
  [266] = {.lex_state = 198},
  [267] = {.lex_state = 203},
  [268] = {.lex_state = 278, .external_lex_state = 5},
  [269] = {.lex_state = 312},
  [270] = {.lex_state = 281, .external_lex_state = 2},
  [271] = {.lex_state = 281, .external_lex_state = 2},
  [272] = {.lex_state = 281, .external_lex_state = 2},
  [273] = {.lex_state = 123},
  [274] = {.lex_state = 281, .external_lex_state = 2},
  [275] = {.lex_state = 123},
  [276] = {.lex_state = 281, .external_lex_state = 2},
  [277] = {.lex_state = 148},
  [278] = {.lex_state = 123},
  [279] = {.lex_state = 148},
  [280] = {.lex_state = 123},
  [281] = {.lex_state = 148},
  [282] = {.lex_state = 123},
  [283] = {.lex_state = 276},
  [284] = {.lex_state = 148},
  [285] = {.lex_state = 321, .external_lex_state = 2},
  [286] = {.lex_state = 198},
  [287] = {.lex_state = 203},
  [288] = {.lex_state = 154, .external_lex_state = 2},
  [289] = {.lex_state = 154, .external_lex_state = 2},
  [290] = {.lex_state = 284, .external_lex_state = 2},
  [291] = {.lex_state = 289, .external_lex_state = 2},
  [292] = {.lex_state = 194},
  [293] = {.lex_state = 286, .external_lex_state = 2},
  [294] = {.lex_state = 286, .external_lex_state = 2},
  [295] = {.lex_state = 278, .external_lex_state = 5},
  [296] = {.lex_state = 286, .external_lex_state = 2},
  [297] = {.lex_state = 286, .external_lex_state = 2},
  [298] = {.lex_state = 291, .external_lex_state = 2},
  [299] = {.lex_state = 291, .external_lex_state = 2},
  [300] = {.lex_state = 284, .external_lex_state = 2},
  [301] = {.lex_state = 289, .external_lex_state = 2},
  [302] = {.lex_state = 281, .external_lex_state = 2},
  [303] = {.lex_state = 284, .external_lex_state = 2},
  [304] = {.lex_state = 284, .external_lex_state = 2},
  [305] = {.lex_state = 289, .external_lex_state = 2},
  [306] = {.lex_state = 294, .external_lex_state = 2},
  [307] = {.lex_state = 294, .external_lex_state = 2},
  [308] = {.lex_state = 294, .external_lex_state = 2},
  [309] = {.lex_state = 294, .external_lex_state = 2},
  [310] = {.lex_state = 323, .external_lex_state = 2},
  [311] = {.lex_state = 177},
  [312] = {.lex_state = 229, .external_lex_state = 2},
  [313] = {.lex_state = 121, .external_lex_state = 2},
  [314] = {.lex_state = 181, .external_lex_state = 2},
  [315] = {.lex_state = 148},
  [316] = {.lex_state = 181, .external_lex_state = 2},
  [317] = {.lex_state = 181, .external_lex_state = 2},
  [318] = {.lex_state = 181, .external_lex_state = 2},
  [319] = {.lex_state = 272},
  [320] = {.lex_state = 272},
  [321] = {.lex_state = 237},
  [322] = {.lex_state = 245},
  [323] = {.lex_state = 223, .external_lex_state = 2},
  [324] = {.lex_state = 223, .external_lex_state = 2},
  [325] = {.lex_state = 229, .external_lex_state = 2},
  [326] = {.lex_state = 177},
  [327] = {.lex_state = 177},
  [328] = {.lex_state = 192},
  [329] = {.lex_state = 298, .external_lex_state = 2},
  [330] = {.lex_state = 177},
  [331] = {.lex_state = 304},
  [332] = {.lex_state = 300},
  [333] = {.lex_state = 300},
  [334] = {.lex_state = 185},
  [335] = {.lex_state = 188},
  [336] = {.lex_state = 192},
  [337] = {.lex_state = 196},
  [338] = {.lex_state = 194},
  [339] = {.lex_state = 312},
  [340] = {.lex_state = 133, .external_lex_state = 2},
  [341] = {.lex_state = 217},
  [342] = {.lex_state = 220},
  [343] = {.lex_state = 113},
  [344] = {.lex_state = 321, .external_lex_state = 2},
  [345] = {.lex_state = 123},
  [346] = {.lex_state = 325, .external_lex_state = 2},
  [347] = {.lex_state = 237},
  [348] = {.lex_state = 321, .external_lex_state = 2},
  [349] = {.lex_state = 325, .external_lex_state = 2},
  [350] = {.lex_state = 196},
  [351] = {.lex_state = 121, .external_lex_state = 2},
  [352] = {.lex_state = 121, .external_lex_state = 2},
  [353] = {.lex_state = 306, .external_lex_state = 2},
  [354] = {.lex_state = 327, .external_lex_state = 2},
  [355] = {.lex_state = 177},
  [356] = {.lex_state = 237},
  [357] = {.lex_state = 198},
  [358] = {.lex_state = 315},
  [359] = {.lex_state = 315},
  [360] = {.lex_state = 315},
  [361] = {.lex_state = 330},
  [362] = {.lex_state = 330},
  [363] = {.lex_state = 177},
  [364] = {.lex_state = 274},
  [365] = {.lex_state = 330},
  [366] = {.lex_state = 330},
  [367] = {.lex_state = 312},
  [368] = {.lex_state = 281, .external_lex_state = 2},
  [369] = {.lex_state = 223, .external_lex_state = 2},
  [370] = {.lex_state = 223, .external_lex_state = 2},
  [371] = {.lex_state = 123},
  [372] = {.lex_state = 223, .external_lex_state = 2},
  [373] = {.lex_state = 123},
  [374] = {.lex_state = 223, .external_lex_state = 2},
  [375] = {.lex_state = 312},
  [376] = {.lex_state = 281, .external_lex_state = 2},
  [377] = {.lex_state = 229, .external_lex_state = 2},
  [378] = {.lex_state = 229, .external_lex_state = 2},
  [379] = {.lex_state = 123},
  [380] = {.lex_state = 229, .external_lex_state = 2},
  [381] = {.lex_state = 123},
  [382] = {.lex_state = 229, .external_lex_state = 2},
  [383] = {.lex_state = 278, .external_lex_state = 5},
  [384] = {.lex_state = 278, .external_lex_state = 5},
  [385] = {.lex_state = 278, .external_lex_state = 5},
  [386] = {.lex_state = 272},
  [387] = {.lex_state = 272},
  [388] = {.lex_state = 278, .external_lex_state = 5},
  [389] = {.lex_state = 229, .external_lex_state = 2},
  [390] = {.lex_state = 281, .external_lex_state = 2},
  [391] = {.lex_state = 330},
  [392] = {.lex_state = 330},
  [393] = {.lex_state = 330},
  [394] = {.lex_state = 330},
  [395] = {.lex_state = 286, .external_lex_state = 2},
  [396] = {.lex_state = 121, .external_lex_state = 2},
  [397] = {.lex_state = 321, .external_lex_state = 2},
  [398] = {.lex_state = 148},
  [399] = {.lex_state = 321, .external_lex_state = 2},
  [400] = {.lex_state = 321, .external_lex_state = 2},
  [401] = {.lex_state = 321, .external_lex_state = 2},
  [402] = {.lex_state = 272},
  [403] = {.lex_state = 272},
  [404] = {.lex_state = 237},
  [405] = {.lex_state = 245},
  [406] = {.lex_state = 321, .external_lex_state = 2},
  [407] = {.lex_state = 289, .external_lex_state = 2},
  [408] = {.lex_state = 286, .external_lex_state = 2},
  [409] = {.lex_state = 278, .external_lex_state = 5},
  [410] = {.lex_state = 289, .external_lex_state = 2},
  [411] = {.lex_state = 284, .external_lex_state = 2},
  [412] = {.lex_state = 284, .external_lex_state = 2},
  [413] = {.lex_state = 289, .external_lex_state = 2},
  [414] = {.lex_state = 294, .external_lex_state = 2},
  [415] = {.lex_state = 294, .external_lex_state = 2},
  [416] = {.lex_state = 177},
  [417] = {.lex_state = 323, .external_lex_state = 2},
  [418] = {.lex_state = 312},
  [419] = {.lex_state = 281, .external_lex_state = 2},
  [420] = {.lex_state = 181, .external_lex_state = 2},
  [421] = {.lex_state = 181, .external_lex_state = 2},
  [422] = {.lex_state = 123},
  [423] = {.lex_state = 181, .external_lex_state = 2},
  [424] = {.lex_state = 123},
  [425] = {.lex_state = 181, .external_lex_state = 2},
  [426] = {.lex_state = 229, .external_lex_state = 2},
  [427] = {.lex_state = 229, .external_lex_state = 2},
  [428] = {.lex_state = 263, .external_lex_state = 2},
  [429] = {.lex_state = 177},
  [430] = {.lex_state = 304},
  [431] = {.lex_state = 121, .external_lex_state = 2},
  [432] = {.lex_state = 259, .external_lex_state = 2},
  [433] = {.lex_state = 312},
  [434] = {.lex_state = 263, .external_lex_state = 2},
  [435] = {.lex_state = 265},
  [436] = {.lex_state = 185},
  [437] = {.lex_state = 237},
  [438] = {.lex_state = 312},
  [439] = {.lex_state = 312},
  [440] = {.lex_state = 123},
  [441] = {.lex_state = 276},
  [442] = {.lex_state = 321, .external_lex_state = 2},
  [443] = {.lex_state = 325, .external_lex_state = 2},
  [444] = {.lex_state = 194},
  [445] = {.lex_state = 148},
  [446] = {.lex_state = 198},
  [447] = {.lex_state = 203},
  [448] = {.lex_state = 154, .external_lex_state = 2},
  [449] = {.lex_state = 154, .external_lex_state = 2},
  [450] = {.lex_state = 296},
  [451] = {.lex_state = 321, .external_lex_state = 2},
  [452] = {.lex_state = 325, .external_lex_state = 2},
  [453] = {.lex_state = 312},
  [454] = {.lex_state = 281, .external_lex_state = 2},
  [455] = {.lex_state = 312},
  [456] = {.lex_state = 281, .external_lex_state = 2},
  [457] = {.lex_state = 321, .external_lex_state = 2},
  [458] = {.lex_state = 321, .external_lex_state = 2},
  [459] = {.lex_state = 325, .external_lex_state = 2},
  [460] = {.lex_state = 332, .external_lex_state = 2},
  [461] = {.lex_state = 177},
  [462] = {.lex_state = 315},
  [463] = {.lex_state = 315},
  [464] = {.lex_state = 196},
  [465] = {.lex_state = 196},
  [466] = {.lex_state = 274},
  [467] = {.lex_state = 274},
  [468] = {.lex_state = 223, .external_lex_state = 2},
  [469] = {.lex_state = 330},
  [470] = {.lex_state = 330},
  [471] = {.lex_state = 229, .external_lex_state = 2},
  [472] = {.lex_state = 330},
  [473] = {.lex_state = 330},
  [474] = {.lex_state = 278, .external_lex_state = 5},
  [475] = {.lex_state = 123},
  [476] = {.lex_state = 278, .external_lex_state = 5},
  [477] = {.lex_state = 123},
  [478] = {.lex_state = 281, .external_lex_state = 2},
  [479] = {.lex_state = 281, .external_lex_state = 2},
  [480] = {.lex_state = 148},
  [481] = {.lex_state = 148},
  [482] = {.lex_state = 312},
  [483] = {.lex_state = 281, .external_lex_state = 2},
  [484] = {.lex_state = 321, .external_lex_state = 2},
  [485] = {.lex_state = 321, .external_lex_state = 2},
  [486] = {.lex_state = 123},
  [487] = {.lex_state = 321, .external_lex_state = 2},
  [488] = {.lex_state = 123},
  [489] = {.lex_state = 321, .external_lex_state = 2},
  [490] = {.lex_state = 286, .external_lex_state = 2},
  [491] = {.lex_state = 289, .external_lex_state = 2},
  [492] = {.lex_state = 289, .external_lex_state = 2},
  [493] = {.lex_state = 177},
  [494] = {.lex_state = 181, .external_lex_state = 2},
  [495] = {.lex_state = 330},
  [496] = {.lex_state = 330},
  [497] = {.lex_state = 263, .external_lex_state = 2},
  [498] = {.lex_state = 177},
  [499] = {.lex_state = 188},
  [500] = {.lex_state = 312},
  [501] = {.lex_state = 259, .external_lex_state = 2},
  [502] = {.lex_state = 312},
  [503] = {.lex_state = 304},
  [504] = {.lex_state = 263, .external_lex_state = 2},
  [505] = {.lex_state = 300},
  [506] = {.lex_state = 315},
  [507] = {.lex_state = 265},
  [508] = {.lex_state = 296},
  [509] = {.lex_state = 325, .external_lex_state = 2},
  [510] = {.lex_state = 121, .external_lex_state = 2},
  [511] = {.lex_state = 325, .external_lex_state = 2},
  [512] = {.lex_state = 148},
  [513] = {.lex_state = 325, .external_lex_state = 2},
  [514] = {.lex_state = 325, .external_lex_state = 2},
  [515] = {.lex_state = 325, .external_lex_state = 2},
  [516] = {.lex_state = 272},
  [517] = {.lex_state = 272},
  [518] = {.lex_state = 237},
  [519] = {.lex_state = 245},
  [520] = {.lex_state = 323, .external_lex_state = 2},
  [521] = {.lex_state = 312},
  [522] = {.lex_state = 325, .external_lex_state = 2},
  [523] = {.lex_state = 321, .external_lex_state = 2},
  [524] = {.lex_state = 321, .external_lex_state = 2},
  [525] = {.lex_state = 325, .external_lex_state = 2},
  [526] = {.lex_state = 315},
  [527] = {.lex_state = 332, .external_lex_state = 2},
  [528] = {.lex_state = 177},
  [529] = {.lex_state = 223, .external_lex_state = 2},
  [530] = {.lex_state = 223, .external_lex_state = 2},
  [531] = {.lex_state = 229, .external_lex_state = 2},
  [532] = {.lex_state = 229, .external_lex_state = 2},
  [533] = {.lex_state = 330},
  [534] = {.lex_state = 330},
  [535] = {.lex_state = 321, .external_lex_state = 2},
  [536] = {.lex_state = 330},
  [537] = {.lex_state = 330},
  [538] = {.lex_state = 181, .external_lex_state = 2},
  [539] = {.lex_state = 181, .external_lex_state = 2},
  [540] = {.lex_state = 312},
  [541] = {.lex_state = 312},
  [542] = {.lex_state = 312},
  [543] = {.lex_state = 304},
  [544] = {.lex_state = 300},
  [545] = {.lex_state = 312},
  [546] = {.lex_state = 315},
  [547] = {.lex_state = 315},
  [548] = {.lex_state = 312},
  [549] = {.lex_state = 312},
  [550] = {.lex_state = 281, .external_lex_state = 2},
  [551] = {.lex_state = 325, .external_lex_state = 2},
  [552] = {.lex_state = 325, .external_lex_state = 2},
  [553] = {.lex_state = 123},
  [554] = {.lex_state = 325, .external_lex_state = 2},
  [555] = {.lex_state = 123},
  [556] = {.lex_state = 325, .external_lex_state = 2},
  [557] = {.lex_state = 312},
  [558] = {.lex_state = 323, .external_lex_state = 2},
  [559] = {.lex_state = 325, .external_lex_state = 2},
  [560] = {.lex_state = 325, .external_lex_state = 2},
  [561] = {.lex_state = 315},
  [562] = {.lex_state = 278, .external_lex_state = 5},
  [563] = {.lex_state = 278, .external_lex_state = 5},
  [564] = {.lex_state = 321, .external_lex_state = 2},
  [565] = {.lex_state = 321, .external_lex_state = 2},
  [566] = {.lex_state = 312},
  [567] = {.lex_state = 304},
  [568] = {.lex_state = 312},
  [569] = {.lex_state = 315},
  [570] = {.lex_state = 325, .external_lex_state = 2},
  [571] = {.lex_state = 330},
  [572] = {.lex_state = 330},
  [573] = {.lex_state = 312},
  [574] = {.lex_state = 312},
  [575] = {.lex_state = 312},
  [576] = {.lex_state = 325, .external_lex_state = 2},
  [577] = {.lex_state = 325, .external_lex_state = 2},
  [578] = {.lex_state = 118},
  [579] = {.lex_state = 334, .external_lex_state = 2},
  [580] = {.lex_state = 121, .external_lex_state = 2},
  [581] = {.lex_state = 259, .external_lex_state = 2},
  [582] = {.lex_state = 337},
  [583] = {.lex_state = 121, .external_lex_state = 2},
  [584] = {.lex_state = 263, .external_lex_state = 2},
  [585] = {.lex_state = 337},
  [586] = {.lex_state = 123},
  [587] = {.lex_state = 337},
  [588] = {.lex_state = 339, .external_lex_state = 2},
  [589] = {.lex_state = 131},
  [590] = {.lex_state = 133, .external_lex_state = 2},
  [591] = {.lex_state = 323, .external_lex_state = 2},
  [592] = {.lex_state = 399, .external_lex_state = 6},
  [593] = {.lex_state = 121, .external_lex_state = 2},
  [594] = {.lex_state = 121, .external_lex_state = 2},
  [595] = {.lex_state = 123},
  [596] = {.lex_state = 337},
  [597] = {.lex_state = 404, .external_lex_state = 2},
  [598] = {.lex_state = 123, .external_lex_state = 4},
  [599] = {.lex_state = 276},
  [600] = {.lex_state = 123},
  [601] = {.lex_state = 408, .external_lex_state = 2},
  [602] = {.lex_state = 413, .external_lex_state = 6},
  [603] = {.lex_state = 408, .external_lex_state = 2},
  [604] = {.lex_state = 432, .external_lex_state = 6},
  [605] = {.lex_state = 436, .external_lex_state = 2},
  [606] = {.lex_state = 484, .external_lex_state = 2},
  [607] = {.lex_state = 278, .external_lex_state = 5},
  [608] = {.lex_state = 278, .external_lex_state = 5},
  [609] = {.lex_state = 484, .external_lex_state = 2},
  [610] = {.lex_state = 113},
  [611] = {.lex_state = 486, .external_lex_state = 2},
  [612] = {.lex_state = 247, .external_lex_state = 2},
  [613] = {.lex_state = 337},
  [614] = {.lex_state = 337},
  [615] = {.lex_state = 300},
  [616] = {.lex_state = 304},
  [617] = {.lex_state = 315},
  [618] = {.lex_state = 337},
  [619] = {.lex_state = 488},
  [620] = {.lex_state = 486, .external_lex_state = 2},
  [621] = {.lex_state = 490, .external_lex_state = 2},
  [622] = {.lex_state = 484, .external_lex_state = 2},
  [623] = {.lex_state = 484, .external_lex_state = 2},
  [624] = {.lex_state = 495, .external_lex_state = 2},
  [625] = {.lex_state = 399, .external_lex_state = 6},
  [626] = {.lex_state = 408, .external_lex_state = 2},
  [627] = {.lex_state = 502, .external_lex_state = 2},
  [628] = {.lex_state = 432, .external_lex_state = 6},
  [629] = {.lex_state = 162, .external_lex_state = 2},
  [630] = {.lex_state = 300},
  [631] = {.lex_state = 315},
  [632] = {.lex_state = 504, .external_lex_state = 2},
  [633] = {.lex_state = 154, .external_lex_state = 2},
  [634] = {.lex_state = 484, .external_lex_state = 2},
  [635] = {.lex_state = 278, .external_lex_state = 5},
  [636] = {.lex_state = 148},
  [637] = {.lex_state = 185},
  [638] = {.lex_state = 315},
  [639] = {.lex_state = 188},
  [640] = {.lex_state = 188},
  [641] = {.lex_state = 337},
  [642] = {.lex_state = 259, .external_lex_state = 2},
  [643] = {.lex_state = 192},
  [644] = {.lex_state = 337},
  [645] = {.lex_state = 304},
  [646] = {.lex_state = 263, .external_lex_state = 2},
  [647] = {.lex_state = 300},
  [648] = {.lex_state = 196},
  [649] = {.lex_state = 194},
  [650] = {.lex_state = 506},
  [651] = {.lex_state = 133, .external_lex_state = 2},
  [652] = {.lex_state = 123},
  [653] = {.lex_state = 508, .external_lex_state = 2},
  [654] = {.lex_state = 148},
  [655] = {.lex_state = 154, .external_lex_state = 2},
  [656] = {.lex_state = 154, .external_lex_state = 2},
  [657] = {.lex_state = 512, .external_lex_state = 2},
  [658] = {.lex_state = 337},
  [659] = {.lex_state = 486, .external_lex_state = 2},
  [660] = {.lex_state = 133, .external_lex_state = 2},
  [661] = {.lex_state = 154, .external_lex_state = 2},
  [662] = {.lex_state = 337},
  [663] = {.lex_state = 323, .external_lex_state = 2},
  [664] = {.lex_state = 337},
  [665] = {.lex_state = 486, .external_lex_state = 2},
  [666] = {.lex_state = 337},
  [667] = {.lex_state = 486, .external_lex_state = 2},
  [668] = {.lex_state = 217},
  [669] = {.lex_state = 113},
  [670] = {.lex_state = 516, .external_lex_state = 2},
  [671] = {.lex_state = 276},
  [672] = {.lex_state = 123},
  [673] = {.lex_state = 227, .external_lex_state = 3},
  [674] = {.lex_state = 330},
  [675] = {.lex_state = 484, .external_lex_state = 2},
  [676] = {.lex_state = 484, .external_lex_state = 2},
  [677] = {.lex_state = 194},
  [678] = {.lex_state = 148},
  [679] = {.lex_state = 518, .external_lex_state = 2},
  [680] = {.lex_state = 198},
  [681] = {.lex_state = 203},
  [682] = {.lex_state = 154, .external_lex_state = 2},
  [683] = {.lex_state = 154, .external_lex_state = 2},
  [684] = {.lex_state = 121, .external_lex_state = 2},
  [685] = {.lex_state = 194},
  [686] = {.lex_state = 148},
  [687] = {.lex_state = 490, .external_lex_state = 2},
  [688] = {.lex_state = 198},
  [689] = {.lex_state = 203},
  [690] = {.lex_state = 154, .external_lex_state = 2},
  [691] = {.lex_state = 154, .external_lex_state = 2},
  [692] = {.lex_state = 495, .external_lex_state = 2},
  [693] = {.lex_state = 399, .external_lex_state = 6},
  [694] = {.lex_state = 399, .external_lex_state = 6},
  [695] = {.lex_state = 399, .external_lex_state = 6},
  [696] = {.lex_state = 245},
  [697] = {.lex_state = 265},
  [698] = {.lex_state = 337},
  [699] = {.lex_state = 484, .external_lex_state = 2},
  [700] = {.lex_state = 123},
  [701] = {.lex_state = 502, .external_lex_state = 2},
  [702] = {.lex_state = 337},
  [703] = {.lex_state = 408, .external_lex_state = 2},
  [704] = {.lex_state = 408, .external_lex_state = 2},
  [705] = {.lex_state = 265},
  [706] = {.lex_state = 185},
  [707] = {.lex_state = 399, .external_lex_state = 6},
  [708] = {.lex_state = 399, .external_lex_state = 6},
  [709] = {.lex_state = 123},
  [710] = {.lex_state = 337},
  [711] = {.lex_state = 337},
  [712] = {.lex_state = 337},
  [713] = {.lex_state = 337},
  [714] = {.lex_state = 304},
  [715] = {.lex_state = 300},
  [716] = {.lex_state = 337},
  [717] = {.lex_state = 304},
  [718] = {.lex_state = 337},
  [719] = {.lex_state = 276},
  [720] = {.lex_state = 148},
  [721] = {.lex_state = 504, .external_lex_state = 2},
  [722] = {.lex_state = 198},
  [723] = {.lex_state = 203},
  [724] = {.lex_state = 154, .external_lex_state = 2},
  [725] = {.lex_state = 154, .external_lex_state = 2},
  [726] = {.lex_state = 484, .external_lex_state = 2},
  [727] = {.lex_state = 520, .external_lex_state = 2},
  [728] = {.lex_state = 148},
  [729] = {.lex_state = 154, .external_lex_state = 2},
  [730] = {.lex_state = 154, .external_lex_state = 2},
  [731] = {.lex_state = 524, .external_lex_state = 2},
  [732] = {.lex_state = 484, .external_lex_state = 2},
  [733] = {.lex_state = 484, .external_lex_state = 2},
  [734] = {.lex_state = 495, .external_lex_state = 2},
  [735] = {.lex_state = 121, .external_lex_state = 2},
  [736] = {.lex_state = 337},
  [737] = {.lex_state = 337},
  [738] = {.lex_state = 263, .external_lex_state = 2},
  [739] = {.lex_state = 237},
  [740] = {.lex_state = 337},
  [741] = {.lex_state = 220},
  [742] = {.lex_state = 113},
  [743] = {.lex_state = 516, .external_lex_state = 2},
  [744] = {.lex_state = 123},
  [745] = {.lex_state = 227, .external_lex_state = 3},
  [746] = {.lex_state = 528, .external_lex_state = 2},
  [747] = {.lex_state = 528, .external_lex_state = 2},
  [748] = {.lex_state = 508, .external_lex_state = 2},
  [749] = {.lex_state = 148},
  [750] = {.lex_state = 237},
  [751] = {.lex_state = 245},
  [752] = {.lex_state = 237},
  [753] = {.lex_state = 516, .external_lex_state = 2},
  [754] = {.lex_state = 123, .external_lex_state = 4},
  [755] = {.lex_state = 528, .external_lex_state = 2},
  [756] = {.lex_state = 508, .external_lex_state = 2},
  [757] = {.lex_state = 530, .external_lex_state = 2},
  [758] = {.lex_state = 123},
  [759] = {.lex_state = 276},
  [760] = {.lex_state = 148},
  [761] = {.lex_state = 516, .external_lex_state = 2},
  [762] = {.lex_state = 198},
  [763] = {.lex_state = 203},
  [764] = {.lex_state = 154, .external_lex_state = 2},
  [765] = {.lex_state = 154, .external_lex_state = 2},
  [766] = {.lex_state = 516, .external_lex_state = 2},
  [767] = {.lex_state = 484, .external_lex_state = 2},
  [768] = {.lex_state = 194},
  [769] = {.lex_state = 148},
  [770] = {.lex_state = 484, .external_lex_state = 2},
  [771] = {.lex_state = 198},
  [772] = {.lex_state = 203},
  [773] = {.lex_state = 154, .external_lex_state = 2},
  [774] = {.lex_state = 154, .external_lex_state = 2},
  [775] = {.lex_state = 121, .external_lex_state = 2},
  [776] = {.lex_state = 518, .external_lex_state = 2},
  [777] = {.lex_state = 148},
  [778] = {.lex_state = 518, .external_lex_state = 2},
  [779] = {.lex_state = 518, .external_lex_state = 2},
  [780] = {.lex_state = 518, .external_lex_state = 2},
  [781] = {.lex_state = 272},
  [782] = {.lex_state = 272},
  [783] = {.lex_state = 237},
  [784] = {.lex_state = 245},
  [785] = {.lex_state = 312},
  [786] = {.lex_state = 281, .external_lex_state = 2},
  [787] = {.lex_state = 121, .external_lex_state = 2},
  [788] = {.lex_state = 490, .external_lex_state = 2},
  [789] = {.lex_state = 148},
  [790] = {.lex_state = 490, .external_lex_state = 2},
  [791] = {.lex_state = 490, .external_lex_state = 2},
  [792] = {.lex_state = 490, .external_lex_state = 2},
  [793] = {.lex_state = 272},
  [794] = {.lex_state = 272},
  [795] = {.lex_state = 237},
  [796] = {.lex_state = 245},
  [797] = {.lex_state = 315},
  [798] = {.lex_state = 490, .external_lex_state = 2},
  [799] = {.lex_state = 315},
  [800] = {.lex_state = 330},
  [801] = {.lex_state = 337},
  [802] = {.lex_state = 304},
  [803] = {.lex_state = 337},
  [804] = {.lex_state = 121, .external_lex_state = 2},
  [805] = {.lex_state = 504, .external_lex_state = 2},
  [806] = {.lex_state = 148},
  [807] = {.lex_state = 504, .external_lex_state = 2},
  [808] = {.lex_state = 504, .external_lex_state = 2},
  [809] = {.lex_state = 504, .external_lex_state = 2},
  [810] = {.lex_state = 272},
  [811] = {.lex_state = 272},
  [812] = {.lex_state = 237},
  [813] = {.lex_state = 245},
  [814] = {.lex_state = 516, .external_lex_state = 2},
  [815] = {.lex_state = 484, .external_lex_state = 2},
  [816] = {.lex_state = 520, .external_lex_state = 2},
  [817] = {.lex_state = 148},
  [818] = {.lex_state = 237},
  [819] = {.lex_state = 245},
  [820] = {.lex_state = 516, .external_lex_state = 2},
  [821] = {.lex_state = 484, .external_lex_state = 2},
  [822] = {.lex_state = 263, .external_lex_state = 2},
  [823] = {.lex_state = 296},
  [824] = {.lex_state = 123},
  [825] = {.lex_state = 276},
  [826] = {.lex_state = 516, .external_lex_state = 2},
  [827] = {.lex_state = 528, .external_lex_state = 2},
  [828] = {.lex_state = 194},
  [829] = {.lex_state = 148},
  [830] = {.lex_state = 528, .external_lex_state = 2},
  [831] = {.lex_state = 198},
  [832] = {.lex_state = 203},
  [833] = {.lex_state = 154, .external_lex_state = 2},
  [834] = {.lex_state = 154, .external_lex_state = 2},
  [835] = {.lex_state = 528, .external_lex_state = 2},
  [836] = {.lex_state = 278, .external_lex_state = 5},
  [837] = {.lex_state = 528, .external_lex_state = 2},
  [838] = {.lex_state = 528, .external_lex_state = 2},
  [839] = {.lex_state = 508, .external_lex_state = 2},
  [840] = {.lex_state = 508, .external_lex_state = 2},
  [841] = {.lex_state = 296},
  [842] = {.lex_state = 516, .external_lex_state = 2},
  [843] = {.lex_state = 528, .external_lex_state = 2},
  [844] = {.lex_state = 194},
  [845] = {.lex_state = 148},
  [846] = {.lex_state = 198},
  [847] = {.lex_state = 203},
  [848] = {.lex_state = 154, .external_lex_state = 2},
  [849] = {.lex_state = 154, .external_lex_state = 2},
  [850] = {.lex_state = 516, .external_lex_state = 2},
  [851] = {.lex_state = 516, .external_lex_state = 2},
  [852] = {.lex_state = 528, .external_lex_state = 2},
  [853] = {.lex_state = 484, .external_lex_state = 2},
  [854] = {.lex_state = 121, .external_lex_state = 2},
  [855] = {.lex_state = 516, .external_lex_state = 2},
  [856] = {.lex_state = 148},
  [857] = {.lex_state = 516, .external_lex_state = 2},
  [858] = {.lex_state = 516, .external_lex_state = 2},
  [859] = {.lex_state = 516, .external_lex_state = 2},
  [860] = {.lex_state = 272},
  [861] = {.lex_state = 272},
  [862] = {.lex_state = 237},
  [863] = {.lex_state = 245},
  [864] = {.lex_state = 516, .external_lex_state = 2},
  [865] = {.lex_state = 484, .external_lex_state = 2},
  [866] = {.lex_state = 121, .external_lex_state = 2},
  [867] = {.lex_state = 484, .external_lex_state = 2},
  [868] = {.lex_state = 148},
  [869] = {.lex_state = 484, .external_lex_state = 2},
  [870] = {.lex_state = 484, .external_lex_state = 2},
  [871] = {.lex_state = 484, .external_lex_state = 2},
  [872] = {.lex_state = 272},
  [873] = {.lex_state = 272},
  [874] = {.lex_state = 237},
  [875] = {.lex_state = 245},
  [876] = {.lex_state = 312},
  [877] = {.lex_state = 281, .external_lex_state = 2},
  [878] = {.lex_state = 518, .external_lex_state = 2},
  [879] = {.lex_state = 518, .external_lex_state = 2},
  [880] = {.lex_state = 123},
  [881] = {.lex_state = 518, .external_lex_state = 2},
  [882] = {.lex_state = 123},
  [883] = {.lex_state = 518, .external_lex_state = 2},
  [884] = {.lex_state = 312},
  [885] = {.lex_state = 281, .external_lex_state = 2},
  [886] = {.lex_state = 490, .external_lex_state = 2},
  [887] = {.lex_state = 490, .external_lex_state = 2},
  [888] = {.lex_state = 123},
  [889] = {.lex_state = 490, .external_lex_state = 2},
  [890] = {.lex_state = 123},
  [891] = {.lex_state = 490, .external_lex_state = 2},
  [892] = {.lex_state = 337},
  [893] = {.lex_state = 315},
  [894] = {.lex_state = 337},
  [895] = {.lex_state = 315},
  [896] = {.lex_state = 399, .external_lex_state = 6},
  [897] = {.lex_state = 337},
  [898] = {.lex_state = 312},
  [899] = {.lex_state = 281, .external_lex_state = 2},
  [900] = {.lex_state = 504, .external_lex_state = 2},
  [901] = {.lex_state = 504, .external_lex_state = 2},
  [902] = {.lex_state = 123},
  [903] = {.lex_state = 504, .external_lex_state = 2},
  [904] = {.lex_state = 123},
  [905] = {.lex_state = 504, .external_lex_state = 2},
  [906] = {.lex_state = 516, .external_lex_state = 2},
  [907] = {.lex_state = 484, .external_lex_state = 2},
  [908] = {.lex_state = 520, .external_lex_state = 2},
  [909] = {.lex_state = 520, .external_lex_state = 2},
  [910] = {.lex_state = 516, .external_lex_state = 2},
  [911] = {.lex_state = 484, .external_lex_state = 2},
  [912] = {.lex_state = 337},
  [913] = {.lex_state = 528, .external_lex_state = 2},
  [914] = {.lex_state = 528, .external_lex_state = 2},
  [915] = {.lex_state = 121, .external_lex_state = 2},
  [916] = {.lex_state = 528, .external_lex_state = 2},
  [917] = {.lex_state = 148},
  [918] = {.lex_state = 528, .external_lex_state = 2},
  [919] = {.lex_state = 528, .external_lex_state = 2},
  [920] = {.lex_state = 528, .external_lex_state = 2},
  [921] = {.lex_state = 272},
  [922] = {.lex_state = 272},
  [923] = {.lex_state = 237},
  [924] = {.lex_state = 245},
  [925] = {.lex_state = 528, .external_lex_state = 2},
  [926] = {.lex_state = 278, .external_lex_state = 5},
  [927] = {.lex_state = 337},
  [928] = {.lex_state = 528, .external_lex_state = 2},
  [929] = {.lex_state = 121, .external_lex_state = 2},
  [930] = {.lex_state = 486, .external_lex_state = 2},
  [931] = {.lex_state = 148},
  [932] = {.lex_state = 486, .external_lex_state = 2},
  [933] = {.lex_state = 486, .external_lex_state = 2},
  [934] = {.lex_state = 486, .external_lex_state = 2},
  [935] = {.lex_state = 272},
  [936] = {.lex_state = 272},
  [937] = {.lex_state = 237},
  [938] = {.lex_state = 245},
  [939] = {.lex_state = 516, .external_lex_state = 2},
  [940] = {.lex_state = 516, .external_lex_state = 2},
  [941] = {.lex_state = 528, .external_lex_state = 2},
  [942] = {.lex_state = 312},
  [943] = {.lex_state = 281, .external_lex_state = 2},
  [944] = {.lex_state = 516, .external_lex_state = 2},
  [945] = {.lex_state = 516, .external_lex_state = 2},
  [946] = {.lex_state = 123},
  [947] = {.lex_state = 516, .external_lex_state = 2},
  [948] = {.lex_state = 123},
  [949] = {.lex_state = 516, .external_lex_state = 2},
  [950] = {.lex_state = 312},
  [951] = {.lex_state = 281, .external_lex_state = 2},
  [952] = {.lex_state = 484, .external_lex_state = 2},
  [953] = {.lex_state = 484, .external_lex_state = 2},
  [954] = {.lex_state = 123},
  [955] = {.lex_state = 484, .external_lex_state = 2},
  [956] = {.lex_state = 123},
  [957] = {.lex_state = 484, .external_lex_state = 2},
  [958] = {.lex_state = 518, .external_lex_state = 2},
  [959] = {.lex_state = 330},
  [960] = {.lex_state = 330},
  [961] = {.lex_state = 490, .external_lex_state = 2},
  [962] = {.lex_state = 330},
  [963] = {.lex_state = 330},
  [964] = {.lex_state = 337},
  [965] = {.lex_state = 504, .external_lex_state = 2},
  [966] = {.lex_state = 330},
  [967] = {.lex_state = 330},
  [968] = {.lex_state = 484, .external_lex_state = 2},
  [969] = {.lex_state = 484, .external_lex_state = 2},
  [970] = {.lex_state = 312},
  [971] = {.lex_state = 281, .external_lex_state = 2},
  [972] = {.lex_state = 528, .external_lex_state = 2},
  [973] = {.lex_state = 528, .external_lex_state = 2},
  [974] = {.lex_state = 123},
  [975] = {.lex_state = 528, .external_lex_state = 2},
  [976] = {.lex_state = 123},
  [977] = {.lex_state = 528, .external_lex_state = 2},
  [978] = {.lex_state = 528, .external_lex_state = 2},
  [979] = {.lex_state = 312},
  [980] = {.lex_state = 281, .external_lex_state = 2},
  [981] = {.lex_state = 486, .external_lex_state = 2},
  [982] = {.lex_state = 486, .external_lex_state = 2},
  [983] = {.lex_state = 123},
  [984] = {.lex_state = 486, .external_lex_state = 2},
  [985] = {.lex_state = 123},
  [986] = {.lex_state = 486, .external_lex_state = 2},
  [987] = {.lex_state = 528, .external_lex_state = 2},
  [988] = {.lex_state = 528, .external_lex_state = 2},
  [989] = {.lex_state = 516, .external_lex_state = 2},
  [990] = {.lex_state = 330},
  [991] = {.lex_state = 330},
  [992] = {.lex_state = 484, .external_lex_state = 2},
  [993] = {.lex_state = 330},
  [994] = {.lex_state = 330},
  [995] = {.lex_state = 518, .external_lex_state = 2},
  [996] = {.lex_state = 518, .external_lex_state = 2},
  [997] = {.lex_state = 490, .external_lex_state = 2},
  [998] = {.lex_state = 490, .external_lex_state = 2},
  [999] = {.lex_state = 504, .external_lex_state = 2},
  [1000] = {.lex_state = 504, .external_lex_state = 2},
  [1001] = {.lex_state = 528, .external_lex_state = 2},
  [1002] = {.lex_state = 330},
  [1003] = {.lex_state = 330},
  [1004] = {.lex_state = 486, .external_lex_state = 2},
  [1005] = {.lex_state = 330},
  [1006] = {.lex_state = 330},
  [1007] = {.lex_state = 516, .external_lex_state = 2},
  [1008] = {.lex_state = 516, .external_lex_state = 2},
  [1009] = {.lex_state = 484, .external_lex_state = 2},
  [1010] = {.lex_state = 484, .external_lex_state = 2},
  [1011] = {.lex_state = 528, .external_lex_state = 2},
  [1012] = {.lex_state = 528, .external_lex_state = 2},
  [1013] = {.lex_state = 486, .external_lex_state = 2},
  [1014] = {.lex_state = 486, .external_lex_state = 2},
};

enum {
  ts_external_token__simple_heredoc,
  ts_external_token__heredoc_beginning,
  ts_external_token__heredoc_middle,
  ts_external_token__heredoc_end,
  ts_external_token_file_descriptor,
  ts_external_token__empty_value,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__simple_heredoc] = sym__simple_heredoc,
  [ts_external_token__heredoc_beginning] = sym__heredoc_beginning,
  [ts_external_token__heredoc_middle] = sym__heredoc_middle,
  [ts_external_token__heredoc_end] = sym__heredoc_end,
  [ts_external_token_file_descriptor] = sym_file_descriptor,
  [ts_external_token__empty_value] = sym__empty_value,
};

static bool ts_external_scanner_states[7][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__simple_heredoc] = true,
    [ts_external_token__heredoc_beginning] = true,
    [ts_external_token__heredoc_middle] = true,
    [ts_external_token__heredoc_end] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__empty_value] = true,
  },
  [2] = {
    [ts_external_token_file_descriptor] = true,
  },
  [3] = {
    [ts_external_token__simple_heredoc] = true,
    [ts_external_token__heredoc_beginning] = true,
  },
  [4] = {
    [ts_external_token__empty_value] = true,
  },
  [5] = {
    [ts_external_token__heredoc_middle] = true,
    [ts_external_token__heredoc_end] = true,
  },
  [6] = {
    [ts_external_token__heredoc_middle] = true,
    [ts_external_token__heredoc_end] = true,
    [ts_external_token_file_descriptor] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_program] = STATE(17),
    [sym__terminated_statement] = STATE(612),
    [sym_for_statement] = STATE(613),
    [sym_while_statement] = STATE(613),
    [sym_do_group] = STATE(614),
    [sym_if_statement] = STATE(613),
    [sym_elif_clause] = STATE(615),
    [sym_else_clause] = STATE(616),
    [sym_case_statement] = STATE(613),
    [sym_case_item] = STATE(617),
    [sym_function_definition] = STATE(613),
    [sym_compound_statement] = STATE(618),
    [sym_subshell] = STATE(613),
    [sym_pipeline] = STATE(613),
    [sym_list] = STATE(613),
    [sym_bracket_command] = STATE(613),
    [sym_command] = STATE(619),
    [sym_environment_variable_assignment] = STATE(620),
    [sym_file_redirect] = STATE(621),
    [sym_heredoc_redirect] = STATE(622),
    [sym_heredoc] = STATE(623),
    [sym_string] = STATE(624),
    [sym_simple_expansion] = STATE(625),
    [sym_expansion] = STATE(625),
    [sym_command_substitution] = STATE(626),
    [sym_process_substitution] = STATE(627),
    [sym_special_variable_name] = STATE(628),
    [aux_sym_program_repeat1] = STATE(629),
    [aux_sym_if_statement_repeat1] = STATE(630),
    [aux_sym_case_statement_repeat1] = STATE(631),
    [aux_sym_bracket_command_repeat1] = STATE(632),
    [aux_sym_command_repeat1] = STATE(633),
    [aux_sym_command_repeat2] = STATE(634),
    [aux_sym_heredoc_repeat1] = STATE(635),
    [aux_sym_string_repeat1] = STATE(636),
    [sym__simple_heredoc] = ACTIONS(1),
    [sym__heredoc_beginning] = ACTIONS(3),
    [sym__heredoc_middle] = ACTIONS(5),
    [sym__heredoc_end] = ACTIONS(7),
    [sym_file_descriptor] = ACTIONS(9),
    [sym__empty_value] = ACTIONS(11),
    [ts_builtin_sym_end] = ACTIONS(13),
    [anon_sym_for] = ACTIONS(15),
    [anon_sym_in] = ACTIONS(17),
    [anon_sym_while] = ACTIONS(19),
    [anon_sym_do] = ACTIONS(21),
    [anon_sym_done] = ACTIONS(23),
    [anon_sym_if] = ACTIONS(25),
    [anon_sym_then] = ACTIONS(27),
    [anon_sym_fi] = ACTIONS(29),
    [anon_sym_elif] = ACTIONS(31),
    [anon_sym_else] = ACTIONS(33),
    [anon_sym_case] = ACTIONS(35),
    [anon_sym_esac] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(39),
    [anon_sym_function] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(47),
    [anon_sym_PIPE] = ACTIONS(49),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_RBRACK] = ACTIONS(55),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(57),
    [anon_sym_COLON] = ACTIONS(59),
    [anon_sym_EQ] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_GT] = ACTIONS(63),
    [anon_sym_GT_GT] = ACTIONS(65),
    [anon_sym_LT_AMP] = ACTIONS(65),
    [anon_sym_GT_AMP] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_DOLLAR] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
    [anon_sym_STAR] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_POUND] = ACTIONS(77),
    [anon_sym_QMARK] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_0] = ACTIONS(75),
    [anon_sym__] = ACTIONS(75),
    [anon_sym_SEMI] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(79),
  },
  [1] = {
    [sym_program] = STATE(17),
    [sym__terminated_statement] = STATE(18),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_program_repeat1] = STATE(22),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [ts_builtin_sym_end] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [2] = {
    [anon_sym_LT] = ACTIONS(117),
    [anon_sym_GT] = ACTIONS(117),
    [anon_sym_GT_GT] = ACTIONS(119),
    [anon_sym_AMP_GT] = ACTIONS(117),
    [anon_sym_AMP_GT_GT] = ACTIONS(119),
    [anon_sym_LT_AMP] = ACTIONS(119),
    [anon_sym_GT_AMP] = ACTIONS(119),
    [sym_comment] = ACTIONS(115),
  },
  [3] = {
    [sym_word] = ACTIONS(121),
    [sym_comment] = ACTIONS(115),
  },
  [4] = {
    [sym__terminated_statement] = STATE(26),
    [sym_for_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_function_definition] = STATE(27),
    [sym_subshell] = STATE(27),
    [sym_pipeline] = STATE(27),
    [sym_list] = STATE(27),
    [sym_bracket_command] = STATE(27),
    [sym_command] = STATE(27),
    [sym_environment_variable_assignment] = STATE(28),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [5] = {
    [sym__terminated_statement] = STATE(29),
    [sym_for_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_function_definition] = STATE(27),
    [sym_subshell] = STATE(27),
    [sym_pipeline] = STATE(27),
    [sym_list] = STATE(27),
    [sym_bracket_command] = STATE(27),
    [sym_command] = STATE(27),
    [sym_environment_variable_assignment] = STATE(28),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [6] = {
    [sym_string] = STATE(32),
    [sym_simple_expansion] = STATE(32),
    [sym_expansion] = STATE(32),
    [sym_command_substitution] = STATE(32),
    [sym_process_substitution] = STATE(32),
    [anon_sym_LT] = ACTIONS(123),
    [anon_sym_GT] = ACTIONS(123),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [sym_raw_string] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(131),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(133),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_word] = ACTIONS(137),
    [sym_comment] = ACTIONS(115),
  },
  [7] = {
    [sym_leading_word] = ACTIONS(139),
    [sym_comment] = ACTIONS(115),
  },
  [8] = {
    [sym__terminated_statement] = STATE(18),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_program_repeat1] = STATE(39),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_RPAREN] = ACTIONS(141),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [9] = {
    [sym_string] = STATE(42),
    [sym_simple_expansion] = STATE(42),
    [sym_expansion] = STATE(42),
    [sym_command_substitution] = STATE(42),
    [sym_process_substitution] = STATE(42),
    [aux_sym_bracket_command_repeat1] = STATE(47),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(147),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(157),
    [sym_comment] = ACTIONS(115),
  },
  [10] = {
    [sym_string] = STATE(42),
    [sym_simple_expansion] = STATE(42),
    [sym_expansion] = STATE(42),
    [sym_command_substitution] = STATE(42),
    [sym_process_substitution] = STATE(42),
    [aux_sym_bracket_command_repeat1] = STATE(48),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(147),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(157),
    [sym_comment] = ACTIONS(115),
  },
  [11] = {
    [sym_file_redirect] = STATE(53),
    [sym_heredoc_redirect] = STATE(53),
    [aux_sym_command_repeat2] = STATE(54),
    [sym_file_descriptor] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_PIPE_AMP] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(161),
    [anon_sym_PIPE_PIPE] = ACTIONS(161),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_LT_LT_DASH] = ACTIONS(167),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_LF] = ACTIONS(161),
    [anon_sym_AMP] = ACTIONS(161),
  },
  [12] = {
    [sym_string] = STATE(57),
    [sym_simple_expansion] = STATE(57),
    [sym_expansion] = STATE(57),
    [sym_command_substitution] = STATE(57),
    [sym_process_substitution] = STATE(57),
    [anon_sym_LT] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(171),
    [sym_raw_string] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(175),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(177),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [sym_word] = ACTIONS(183),
    [sym_comment] = ACTIONS(115),
  },
  [13] = {
    [sym_simple_expansion] = STATE(63),
    [sym_expansion] = STATE(63),
    [sym_command_substitution] = STATE(63),
    [aux_sym_string_repeat1] = STATE(68),
    [anon_sym_DQUOTE] = ACTIONS(185),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [14] = {
    [sym_command] = STATE(74),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(75),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(207),
    [sym_comment] = ACTIONS(115),
  },
  [15] = {
    [sym_command] = STATE(78),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_command_repeat1] = STATE(79),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(213),
    [sym_comment] = ACTIONS(115),
  },
  [16] = {
    [sym_file_redirect] = STATE(53),
    [sym_heredoc_redirect] = STATE(53),
    [aux_sym_command_repeat2] = STATE(83),
    [sym_file_descriptor] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(215),
    [anon_sym_LPAREN] = ACTIONS(217),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_PIPE_AMP] = ACTIONS(215),
    [anon_sym_AMP_AMP] = ACTIONS(215),
    [anon_sym_PIPE_PIPE] = ACTIONS(215),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(219),
    [anon_sym_EQ] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_LT_LT_DASH] = ACTIONS(167),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(215),
    [anon_sym_LF] = ACTIONS(215),
    [anon_sym_AMP] = ACTIONS(215),
  },
  [17] = {
    [ts_builtin_sym_end] = ACTIONS(223),
    [sym_comment] = ACTIONS(115),
  },
  [18] = {
    [sym_file_descriptor] = ACTIONS(225),
    [ts_builtin_sym_end] = ACTIONS(225),
    [anon_sym_for] = ACTIONS(227),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_done] = ACTIONS(227),
    [anon_sym_if] = ACTIONS(227),
    [anon_sym_fi] = ACTIONS(227),
    [anon_sym_elif] = ACTIONS(227),
    [anon_sym_else] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(227),
    [anon_sym_RPAREN] = ACTIONS(225),
    [anon_sym_SEMI_SEMI] = ACTIONS(225),
    [anon_sym_function] = ACTIONS(227),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_RBRACE] = ACTIONS(225),
    [anon_sym_LBRACK] = ACTIONS(227),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(227),
    [anon_sym_GT] = ACTIONS(227),
    [anon_sym_GT_GT] = ACTIONS(227),
    [anon_sym_AMP_GT] = ACTIONS(227),
    [anon_sym_AMP_GT_GT] = ACTIONS(227),
    [anon_sym_LT_AMP] = ACTIONS(227),
    [anon_sym_GT_AMP] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(225),
    [sym_raw_string] = ACTIONS(227),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_leading_word] = ACTIONS(229),
    [sym_comment] = ACTIONS(115),
  },
  [19] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(233),
    [anon_sym_PIPE_AMP] = ACTIONS(233),
    [anon_sym_AMP_AMP] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(231),
    [anon_sym_LF] = ACTIONS(231),
    [anon_sym_AMP] = ACTIONS(231),
  },
  [20] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_SEMI_SEMI] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(233),
    [anon_sym_PIPE_AMP] = ACTIONS(233),
    [anon_sym_AMP_AMP] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(235),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_LT] = ACTIONS(239),
    [anon_sym_GT] = ACTIONS(239),
    [anon_sym_GT_GT] = ACTIONS(239),
    [anon_sym_AMP_GT] = ACTIONS(239),
    [anon_sym_AMP_GT_GT] = ACTIONS(239),
    [anon_sym_LT_AMP] = ACTIONS(239),
    [anon_sym_GT_AMP] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [sym_raw_string] = ACTIONS(239),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(231),
    [anon_sym_LF] = ACTIONS(231),
    [anon_sym_AMP] = ACTIONS(231),
  },
  [21] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(241),
    [anon_sym_GT] = ACTIONS(241),
    [anon_sym_GT_GT] = ACTIONS(241),
    [anon_sym_AMP_GT] = ACTIONS(241),
    [anon_sym_AMP_GT_GT] = ACTIONS(241),
    [anon_sym_LT_AMP] = ACTIONS(241),
    [anon_sym_GT_AMP] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_raw_string] = ACTIONS(241),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(115),
  },
  [22] = {
    [sym__terminated_statement] = STATE(87),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [ts_builtin_sym_end] = ACTIONS(243),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [23] = {
    [sym_environment_variable_assignment] = STATE(90),
    [sym_file_redirect] = STATE(90),
    [sym_string] = STATE(88),
    [sym_command_substitution] = STATE(88),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(245),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(249),
    [sym_comment] = ACTIONS(115),
  },
  [24] = {
    [sym_string] = STATE(91),
    [sym_simple_expansion] = STATE(91),
    [sym_expansion] = STATE(91),
    [sym_command_substitution] = STATE(91),
    [sym_process_substitution] = STATE(91),
    [anon_sym_LT] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(171),
    [sym_raw_string] = ACTIONS(251),
    [anon_sym_DOLLAR] = ACTIONS(175),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(177),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [sym_word] = ACTIONS(253),
    [sym_comment] = ACTIONS(115),
  },
  [25] = {
    [anon_sym_in] = ACTIONS(255),
    [sym_comment] = ACTIONS(115),
  },
  [26] = {
    [sym_do_group] = STATE(94),
    [anon_sym_do] = ACTIONS(257),
    [sym_comment] = ACTIONS(115),
  },
  [27] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE] = ACTIONS(233),
    [anon_sym_PIPE_AMP] = ACTIONS(233),
    [anon_sym_AMP_AMP] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(259),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(259),
  },
  [28] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE] = ACTIONS(233),
    [anon_sym_PIPE_AMP] = ACTIONS(233),
    [anon_sym_AMP_AMP] = ACTIONS(235),
    [anon_sym_PIPE_PIPE] = ACTIONS(235),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_LT] = ACTIONS(239),
    [anon_sym_GT] = ACTIONS(239),
    [anon_sym_GT_GT] = ACTIONS(239),
    [anon_sym_AMP_GT] = ACTIONS(239),
    [anon_sym_AMP_GT_GT] = ACTIONS(239),
    [anon_sym_LT_AMP] = ACTIONS(239),
    [anon_sym_GT_AMP] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [sym_raw_string] = ACTIONS(239),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(259),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(259),
  },
  [29] = {
    [anon_sym_then] = ACTIONS(261),
    [sym_comment] = ACTIONS(115),
  },
  [30] = {
    [anon_sym_LPAREN] = ACTIONS(263),
    [sym_comment] = ACTIONS(115),
  },
  [31] = {
    [sym_simple_expansion] = STATE(63),
    [sym_expansion] = STATE(63),
    [sym_command_substitution] = STATE(63),
    [aux_sym_string_repeat1] = STATE(99),
    [anon_sym_DQUOTE] = ACTIONS(265),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [32] = {
    [anon_sym_in] = ACTIONS(267),
    [anon_sym_SEMI_SEMI] = ACTIONS(269),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(269),
    [anon_sym_LF] = ACTIONS(269),
    [anon_sym_AMP] = ACTIONS(269),
  },
  [33] = {
    [sym_special_variable_name] = STATE(104),
    [anon_sym_DOLLAR] = ACTIONS(271),
    [sym_comment] = ACTIONS(73),
    [sym_simple_variable_name] = ACTIONS(273),
    [anon_sym_STAR] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(271),
    [anon_sym_POUND] = ACTIONS(275),
    [anon_sym_QMARK] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(271),
    [anon_sym_0] = ACTIONS(275),
    [anon_sym__] = ACTIONS(275),
  },
  [34] = {
    [sym_special_variable_name] = STATE(107),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_leading_word] = ACTIONS(279),
    [sym_comment] = ACTIONS(73),
    [anon_sym_STAR] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_POUND] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(277),
    [anon_sym_0] = ACTIONS(277),
    [anon_sym__] = ACTIONS(277),
  },
  [35] = {
    [sym_command] = STATE(108),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(75),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(207),
    [sym_comment] = ACTIONS(115),
  },
  [36] = {
    [sym_command] = STATE(109),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_command_repeat1] = STATE(79),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(213),
    [sym_comment] = ACTIONS(115),
  },
  [37] = {
    [anon_sym_LPAREN] = ACTIONS(281),
    [sym_comment] = ACTIONS(115),
  },
  [38] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(283),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_PIPE_AMP] = ACTIONS(283),
    [anon_sym_AMP_AMP] = ACTIONS(283),
    [anon_sym_PIPE_PIPE] = ACTIONS(283),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(283),
    [anon_sym_LF] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(283),
  },
  [39] = {
    [sym__terminated_statement] = STATE(87),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_RPAREN] = ACTIONS(285),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [40] = {
    [anon_sym_LPAREN] = ACTIONS(287),
    [sym_comment] = ACTIONS(115),
  },
  [41] = {
    [sym_simple_expansion] = STATE(63),
    [sym_expansion] = STATE(63),
    [sym_command_substitution] = STATE(63),
    [aux_sym_string_repeat1] = STATE(114),
    [anon_sym_DQUOTE] = ACTIONS(289),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [42] = {
    [anon_sym_RBRACK] = ACTIONS(291),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(291),
    [anon_sym_LT] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(293),
    [anon_sym_DQUOTE] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [anon_sym_BQUOTE] = ACTIONS(293),
    [sym_word] = ACTIONS(295),
    [sym_comment] = ACTIONS(115),
  },
  [43] = {
    [sym_special_variable_name] = STATE(117),
    [anon_sym_DOLLAR] = ACTIONS(297),
    [sym_comment] = ACTIONS(73),
    [sym_simple_variable_name] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(297),
    [anon_sym_POUND] = ACTIONS(301),
    [anon_sym_QMARK] = ACTIONS(297),
    [anon_sym_DASH] = ACTIONS(297),
    [anon_sym_BANG] = ACTIONS(297),
    [anon_sym_0] = ACTIONS(301),
    [anon_sym__] = ACTIONS(301),
  },
  [44] = {
    [sym_special_variable_name] = STATE(119),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_leading_word] = ACTIONS(303),
    [sym_comment] = ACTIONS(73),
    [anon_sym_STAR] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_POUND] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(277),
    [anon_sym_0] = ACTIONS(277),
    [anon_sym__] = ACTIONS(277),
  },
  [45] = {
    [sym_command] = STATE(120),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(75),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(207),
    [sym_comment] = ACTIONS(115),
  },
  [46] = {
    [sym_command] = STATE(121),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_command_repeat1] = STATE(79),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(213),
    [sym_comment] = ACTIONS(115),
  },
  [47] = {
    [sym_string] = STATE(123),
    [sym_simple_expansion] = STATE(123),
    [sym_expansion] = STATE(123),
    [sym_command_substitution] = STATE(123),
    [sym_process_substitution] = STATE(123),
    [anon_sym_RBRACK] = ACTIONS(305),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(309),
    [sym_comment] = ACTIONS(115),
  },
  [48] = {
    [sym_string] = STATE(123),
    [sym_simple_expansion] = STATE(123),
    [sym_expansion] = STATE(123),
    [sym_command_substitution] = STATE(123),
    [sym_process_substitution] = STATE(123),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(305),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(309),
    [sym_comment] = ACTIONS(115),
  },
  [49] = {
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_GT] = ACTIONS(311),
    [anon_sym_GT_GT] = ACTIONS(313),
    [anon_sym_AMP_GT] = ACTIONS(311),
    [anon_sym_AMP_GT_GT] = ACTIONS(313),
    [anon_sym_LT_AMP] = ACTIONS(313),
    [anon_sym_GT_AMP] = ACTIONS(313),
    [sym_comment] = ACTIONS(115),
  },
  [50] = {
    [sym_file_redirect] = STATE(53),
    [sym_heredoc_redirect] = STATE(53),
    [sym_string] = STATE(127),
    [sym_simple_expansion] = STATE(127),
    [sym_expansion] = STATE(127),
    [sym_command_substitution] = STATE(127),
    [sym_process_substitution] = STATE(127),
    [aux_sym_bracket_command_repeat1] = STATE(132),
    [aux_sym_command_repeat2] = STATE(133),
    [sym_file_descriptor] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(315),
    [anon_sym_PIPE] = ACTIONS(315),
    [anon_sym_PIPE_AMP] = ACTIONS(315),
    [anon_sym_AMP_AMP] = ACTIONS(315),
    [anon_sym_PIPE_PIPE] = ACTIONS(315),
    [anon_sym_LT] = ACTIONS(317),
    [anon_sym_GT] = ACTIONS(317),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_LT_LT_DASH] = ACTIONS(167),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(327),
    [anon_sym_BQUOTE] = ACTIONS(329),
    [sym_word] = ACTIONS(321),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(315),
    [anon_sym_LF] = ACTIONS(315),
    [anon_sym_AMP] = ACTIONS(315),
  },
  [51] = {
    [sym_string] = STATE(136),
    [sym_simple_expansion] = STATE(136),
    [sym_expansion] = STATE(136),
    [sym_command_substitution] = STATE(136),
    [sym_process_substitution] = STATE(136),
    [anon_sym_LT] = ACTIONS(331),
    [anon_sym_GT] = ACTIONS(331),
    [anon_sym_DQUOTE] = ACTIONS(333),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(341),
    [anon_sym_BQUOTE] = ACTIONS(343),
    [sym_word] = ACTIONS(345),
    [sym_comment] = ACTIONS(115),
  },
  [52] = {
    [sym_heredoc] = STATE(143),
    [sym__simple_heredoc] = ACTIONS(347),
    [sym__heredoc_beginning] = ACTIONS(349),
    [sym_comment] = ACTIONS(115),
  },
  [53] = {
    [sym_file_descriptor] = ACTIONS(351),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_LT] = ACTIONS(353),
    [anon_sym_GT] = ACTIONS(353),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(353),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(353),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(353),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(353),
  },
  [54] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [sym_file_descriptor] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_PIPE_AMP] = ACTIONS(355),
    [anon_sym_AMP_AMP] = ACTIONS(355),
    [anon_sym_PIPE_PIPE] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_LT_LT_DASH] = ACTIONS(167),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(355),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [55] = {
    [anon_sym_LPAREN] = ACTIONS(357),
    [sym_comment] = ACTIONS(115),
  },
  [56] = {
    [sym_simple_expansion] = STATE(63),
    [sym_expansion] = STATE(63),
    [sym_command_substitution] = STATE(63),
    [aux_sym_string_repeat1] = STATE(147),
    [anon_sym_DQUOTE] = ACTIONS(359),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [57] = {
    [sym_file_descriptor] = ACTIONS(361),
    [anon_sym_COLON] = ACTIONS(361),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_AMP_GT] = ACTIONS(363),
    [anon_sym_AMP_GT_GT] = ACTIONS(363),
    [anon_sym_LT_AMP] = ACTIONS(363),
    [anon_sym_GT_AMP] = ACTIONS(363),
    [anon_sym_DQUOTE] = ACTIONS(361),
    [sym_raw_string] = ACTIONS(363),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(361),
    [sym_leading_word] = ACTIONS(365),
    [sym_comment] = ACTIONS(115),
  },
  [58] = {
    [sym_special_variable_name] = STATE(150),
    [anon_sym_DOLLAR] = ACTIONS(367),
    [sym_comment] = ACTIONS(73),
    [sym_simple_variable_name] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(367),
    [anon_sym_AT] = ACTIONS(367),
    [anon_sym_POUND] = ACTIONS(371),
    [anon_sym_QMARK] = ACTIONS(367),
    [anon_sym_DASH] = ACTIONS(367),
    [anon_sym_BANG] = ACTIONS(367),
    [anon_sym_0] = ACTIONS(371),
    [anon_sym__] = ACTIONS(371),
  },
  [59] = {
    [sym_special_variable_name] = STATE(152),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_leading_word] = ACTIONS(373),
    [sym_comment] = ACTIONS(73),
    [anon_sym_STAR] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_POUND] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(277),
    [anon_sym_0] = ACTIONS(277),
    [anon_sym__] = ACTIONS(277),
  },
  [60] = {
    [sym_command] = STATE(153),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(75),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(207),
    [sym_comment] = ACTIONS(115),
  },
  [61] = {
    [sym_command] = STATE(154),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_command_repeat1] = STATE(79),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(213),
    [sym_comment] = ACTIONS(115),
  },
  [62] = {
    [sym_file_descriptor] = ACTIONS(375),
    [anon_sym_SEMI_SEMI] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_PIPE_AMP] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_AMP_GT] = ACTIONS(377),
    [anon_sym_AMP_GT_GT] = ACTIONS(377),
    [anon_sym_LT_AMP] = ACTIONS(377),
    [anon_sym_GT_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(377),
    [anon_sym_LF] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
  },
  [63] = {
    [anon_sym_DQUOTE] = ACTIONS(379),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(379),
    [anon_sym_DOLLAR] = ACTIONS(379),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(379),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(379),
    [anon_sym_BQUOTE] = ACTIONS(381),
    [sym_comment] = ACTIONS(73),
  },
  [64] = {
    [sym_special_variable_name] = STATE(157),
    [anon_sym_DOLLAR] = ACTIONS(383),
    [sym_comment] = ACTIONS(73),
    [sym_simple_variable_name] = ACTIONS(385),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_AT] = ACTIONS(383),
    [anon_sym_POUND] = ACTIONS(387),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_DASH] = ACTIONS(383),
    [anon_sym_BANG] = ACTIONS(383),
    [anon_sym_0] = ACTIONS(387),
    [anon_sym__] = ACTIONS(387),
  },
  [65] = {
    [sym_special_variable_name] = STATE(159),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_leading_word] = ACTIONS(389),
    [sym_comment] = ACTIONS(73),
    [anon_sym_STAR] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_POUND] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(277),
    [anon_sym_0] = ACTIONS(277),
    [anon_sym__] = ACTIONS(277),
  },
  [66] = {
    [sym_command] = STATE(160),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(75),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(207),
    [sym_comment] = ACTIONS(115),
  },
  [67] = {
    [sym_command] = STATE(161),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_command_repeat1] = STATE(79),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(213),
    [sym_comment] = ACTIONS(115),
  },
  [68] = {
    [sym_simple_expansion] = STATE(163),
    [sym_expansion] = STATE(163),
    [sym_command_substitution] = STATE(163),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [69] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [aux_sym_command_repeat2] = STATE(169),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(161),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_GT] = ACTIONS(399),
    [anon_sym_AMP_GT] = ACTIONS(399),
    [anon_sym_AMP_GT_GT] = ACTIONS(399),
    [anon_sym_LT_AMP] = ACTIONS(399),
    [anon_sym_GT_AMP] = ACTIONS(399),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [sym_comment] = ACTIONS(73),
  },
  [70] = {
    [sym_simple_expansion] = STATE(63),
    [sym_expansion] = STATE(63),
    [sym_command_substitution] = STATE(63),
    [aux_sym_string_repeat1] = STATE(171),
    [anon_sym_DQUOTE] = ACTIONS(403),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [71] = {
    [sym_command] = STATE(172),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(75),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(207),
    [sym_comment] = ACTIONS(115),
  },
  [72] = {
    [sym_command] = STATE(173),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_command_repeat1] = STATE(79),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(213),
    [sym_comment] = ACTIONS(115),
  },
  [73] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [aux_sym_command_repeat2] = STATE(176),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(215),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_GT] = ACTIONS(399),
    [anon_sym_AMP_GT] = ACTIONS(399),
    [anon_sym_AMP_GT_GT] = ACTIONS(399),
    [anon_sym_LT_AMP] = ACTIONS(399),
    [anon_sym_GT_AMP] = ACTIONS(399),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [sym_comment] = ACTIONS(73),
  },
  [74] = {
    [anon_sym_RPAREN] = ACTIONS(409),
    [sym_comment] = ACTIONS(115),
  },
  [75] = {
    [sym_environment_variable_assignment] = STATE(90),
    [sym_file_redirect] = STATE(90),
    [sym_string] = STATE(178),
    [sym_command_substitution] = STATE(178),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(413),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(415),
    [sym_comment] = ACTIONS(115),
  },
  [76] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [aux_sym_command_repeat2] = STATE(169),
    [sym_file_descriptor] = ACTIONS(395),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(417),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_GT] = ACTIONS(399),
    [anon_sym_AMP_GT] = ACTIONS(399),
    [anon_sym_AMP_GT_GT] = ACTIONS(399),
    [anon_sym_LT_AMP] = ACTIONS(399),
    [anon_sym_GT_AMP] = ACTIONS(399),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(161),
    [sym_comment] = ACTIONS(73),
  },
  [77] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [aux_sym_command_repeat2] = STATE(176),
    [sym_file_descriptor] = ACTIONS(395),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_GT] = ACTIONS(399),
    [anon_sym_AMP_GT] = ACTIONS(399),
    [anon_sym_AMP_GT_GT] = ACTIONS(399),
    [anon_sym_LT_AMP] = ACTIONS(399),
    [anon_sym_GT_AMP] = ACTIONS(399),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(215),
    [sym_comment] = ACTIONS(73),
  },
  [78] = {
    [anon_sym_BQUOTE] = ACTIONS(409),
    [sym_comment] = ACTIONS(115),
  },
  [79] = {
    [sym_environment_variable_assignment] = STATE(90),
    [sym_file_redirect] = STATE(90),
    [sym_string] = STATE(182),
    [sym_command_substitution] = STATE(182),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(421),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(423),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(425),
    [sym_comment] = ACTIONS(115),
  },
  [80] = {
    [anon_sym_RPAREN] = ACTIONS(427),
    [sym_comment] = ACTIONS(115),
  },
  [81] = {
    [sym_file_redirect] = STATE(53),
    [sym_heredoc_redirect] = STATE(53),
    [sym_string] = STATE(127),
    [sym_simple_expansion] = STATE(127),
    [sym_expansion] = STATE(127),
    [sym_command_substitution] = STATE(127),
    [sym_process_substitution] = STATE(127),
    [aux_sym_bracket_command_repeat1] = STATE(185),
    [aux_sym_command_repeat2] = STATE(186),
    [sym_file_descriptor] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(429),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_PIPE_AMP] = ACTIONS(429),
    [anon_sym_AMP_AMP] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(317),
    [anon_sym_GT] = ACTIONS(317),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_LT_LT_DASH] = ACTIONS(167),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(327),
    [anon_sym_BQUOTE] = ACTIONS(329),
    [sym_word] = ACTIONS(321),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(429),
    [anon_sym_LF] = ACTIONS(429),
    [anon_sym_AMP] = ACTIONS(429),
  },
  [82] = {
    [sym_string] = STATE(187),
    [sym_simple_expansion] = STATE(187),
    [sym_expansion] = STATE(187),
    [sym_command_substitution] = STATE(187),
    [sym_process_substitution] = STATE(187),
    [sym__empty_value] = ACTIONS(431),
    [anon_sym_LT] = ACTIONS(433),
    [anon_sym_GT] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(437),
    [anon_sym_DOLLAR] = ACTIONS(439),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(441),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(443),
    [anon_sym_BQUOTE] = ACTIONS(445),
    [sym_word] = ACTIONS(447),
    [sym_comment] = ACTIONS(115),
  },
  [83] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [sym_file_descriptor] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_LT_LT_DASH] = ACTIONS(167),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_LF] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
  },
  [84] = {
    [sym_file_descriptor] = ACTIONS(451),
    [ts_builtin_sym_end] = ACTIONS(451),
    [anon_sym_for] = ACTIONS(453),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(453),
    [anon_sym_done] = ACTIONS(453),
    [anon_sym_if] = ACTIONS(453),
    [anon_sym_then] = ACTIONS(453),
    [anon_sym_fi] = ACTIONS(453),
    [anon_sym_elif] = ACTIONS(453),
    [anon_sym_else] = ACTIONS(453),
    [anon_sym_case] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(451),
    [anon_sym_SEMI_SEMI] = ACTIONS(451),
    [anon_sym_function] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RBRACE] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(451),
    [anon_sym_LT] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(453),
    [anon_sym_AMP_GT] = ACTIONS(453),
    [anon_sym_AMP_GT_GT] = ACTIONS(453),
    [anon_sym_LT_AMP] = ACTIONS(453),
    [anon_sym_GT_AMP] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(451),
    [sym_raw_string] = ACTIONS(453),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(451),
    [anon_sym_BQUOTE] = ACTIONS(451),
    [sym_leading_word] = ACTIONS(455),
    [sym_comment] = ACTIONS(115),
  },
  [85] = {
    [sym_for_statement] = STATE(194),
    [sym_while_statement] = STATE(194),
    [sym_if_statement] = STATE(194),
    [sym_case_statement] = STATE(194),
    [sym_function_definition] = STATE(194),
    [sym_subshell] = STATE(194),
    [sym_pipeline] = STATE(194),
    [sym_list] = STATE(194),
    [sym_bracket_command] = STATE(194),
    [sym_command] = STATE(194),
    [sym_environment_variable_assignment] = STATE(195),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [86] = {
    [sym_for_statement] = STATE(196),
    [sym_while_statement] = STATE(196),
    [sym_if_statement] = STATE(196),
    [sym_case_statement] = STATE(196),
    [sym_function_definition] = STATE(196),
    [sym_subshell] = STATE(196),
    [sym_pipeline] = STATE(196),
    [sym_list] = STATE(196),
    [sym_bracket_command] = STATE(196),
    [sym_command] = STATE(196),
    [sym_environment_variable_assignment] = STATE(197),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [87] = {
    [sym_file_descriptor] = ACTIONS(457),
    [ts_builtin_sym_end] = ACTIONS(457),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_done] = ACTIONS(459),
    [anon_sym_if] = ACTIONS(459),
    [anon_sym_fi] = ACTIONS(459),
    [anon_sym_elif] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(459),
    [anon_sym_case] = ACTIONS(459),
    [anon_sym_RPAREN] = ACTIONS(457),
    [anon_sym_SEMI_SEMI] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(459),
    [anon_sym_LPAREN] = ACTIONS(457),
    [anon_sym_RBRACE] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(459),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(459),
    [anon_sym_COLON] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(459),
    [anon_sym_GT_GT] = ACTIONS(459),
    [anon_sym_AMP_GT] = ACTIONS(459),
    [anon_sym_AMP_GT_GT] = ACTIONS(459),
    [anon_sym_LT_AMP] = ACTIONS(459),
    [anon_sym_GT_AMP] = ACTIONS(459),
    [anon_sym_DQUOTE] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(457),
    [anon_sym_BQUOTE] = ACTIONS(457),
    [sym_leading_word] = ACTIONS(461),
    [sym_comment] = ACTIONS(115),
  },
  [88] = {
    [sym_file_redirect] = STATE(53),
    [sym_heredoc_redirect] = STATE(53),
    [aux_sym_command_repeat2] = STATE(133),
    [sym_file_descriptor] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_PIPE_AMP] = ACTIONS(355),
    [anon_sym_AMP_AMP] = ACTIONS(355),
    [anon_sym_PIPE_PIPE] = ACTIONS(355),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_LT_LT_DASH] = ACTIONS(167),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(355),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [89] = {
    [sym_file_redirect] = STATE(53),
    [sym_heredoc_redirect] = STATE(53),
    [aux_sym_command_repeat2] = STATE(200),
    [sym_file_descriptor] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_PIPE_AMP] = ACTIONS(465),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE_PIPE] = ACTIONS(465),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(467),
    [anon_sym_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_LT_LT_DASH] = ACTIONS(167),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(465),
    [anon_sym_LF] = ACTIONS(465),
    [anon_sym_AMP] = ACTIONS(465),
  },
  [90] = {
    [sym_file_descriptor] = ACTIONS(469),
    [anon_sym_COLON] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_AMP_GT] = ACTIONS(471),
    [anon_sym_AMP_GT_GT] = ACTIONS(471),
    [anon_sym_LT_AMP] = ACTIONS(471),
    [anon_sym_GT_AMP] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(471),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [sym_leading_word] = ACTIONS(473),
    [sym_comment] = ACTIONS(115),
  },
  [91] = {
    [sym_file_descriptor] = ACTIONS(475),
    [anon_sym_COLON] = ACTIONS(475),
    [anon_sym_LT] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_AMP_GT] = ACTIONS(477),
    [anon_sym_AMP_GT_GT] = ACTIONS(477),
    [anon_sym_LT_AMP] = ACTIONS(477),
    [anon_sym_GT_AMP] = ACTIONS(477),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [sym_raw_string] = ACTIONS(477),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(475),
    [anon_sym_BQUOTE] = ACTIONS(475),
    [sym_leading_word] = ACTIONS(479),
    [sym_comment] = ACTIONS(115),
  },
  [92] = {
    [sym__terminated_statement] = STATE(201),
    [sym_for_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_function_definition] = STATE(27),
    [sym_subshell] = STATE(27),
    [sym_pipeline] = STATE(27),
    [sym_list] = STATE(27),
    [sym_bracket_command] = STATE(27),
    [sym_command] = STATE(27),
    [sym_environment_variable_assignment] = STATE(28),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [93] = {
    [sym__terminated_statement] = STATE(18),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_program_repeat1] = STATE(203),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_done] = ACTIONS(481),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [94] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(483),
    [anon_sym_PIPE_AMP] = ACTIONS(483),
    [anon_sym_AMP_AMP] = ACTIONS(483),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(483),
    [anon_sym_LF] = ACTIONS(483),
    [anon_sym_AMP] = ACTIONS(483),
  },
  [95] = {
    [anon_sym_do] = ACTIONS(451),
    [anon_sym_then] = ACTIONS(451),
    [sym_comment] = ACTIONS(115),
  },
  [96] = {
    [sym__terminated_statement] = STATE(18),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_elif_clause] = STATE(207),
    [sym_else_clause] = STATE(208),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_program_repeat1] = STATE(209),
    [aux_sym_if_statement_repeat1] = STATE(210),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_fi] = ACTIONS(485),
    [anon_sym_elif] = ACTIONS(487),
    [anon_sym_else] = ACTIONS(489),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [97] = {
    [sym_for_statement] = STATE(221),
    [sym_while_statement] = STATE(221),
    [sym_if_statement] = STATE(221),
    [sym_case_statement] = STATE(221),
    [sym_function_definition] = STATE(221),
    [sym_subshell] = STATE(221),
    [sym_pipeline] = STATE(221),
    [sym_list] = STATE(221),
    [sym_bracket_command] = STATE(221),
    [sym_command] = STATE(221),
    [sym_environment_variable_assignment] = STATE(222),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(219),
    [sym_command_substitution] = STATE(219),
    [aux_sym_command_repeat1] = STATE(223),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_if] = ACTIONS(495),
    [anon_sym_case] = ACTIONS(497),
    [anon_sym_function] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(505),
    [anon_sym_COLON] = ACTIONS(507),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(511),
    [sym_comment] = ACTIONS(115),
  },
  [98] = {
    [anon_sym_in] = ACTIONS(377),
    [anon_sym_SEMI_SEMI] = ACTIONS(377),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(377),
    [anon_sym_LF] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
  },
  [99] = {
    [sym_simple_expansion] = STATE(163),
    [sym_expansion] = STATE(163),
    [sym_command_substitution] = STATE(163),
    [anon_sym_DQUOTE] = ACTIONS(513),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [100] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(515),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(515),
    [anon_sym_LF] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
  },
  [101] = {
    [anon_sym_in] = ACTIONS(517),
    [sym_comment] = ACTIONS(115),
  },
  [102] = {
    [anon_sym_in] = ACTIONS(519),
    [anon_sym_SEMI_SEMI] = ACTIONS(519),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(519),
    [anon_sym_LF] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(519),
  },
  [103] = {
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_SEMI_SEMI] = ACTIONS(521),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(521),
    [anon_sym_LF] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
  },
  [104] = {
    [anon_sym_in] = ACTIONS(523),
    [anon_sym_SEMI_SEMI] = ACTIONS(523),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(523),
    [anon_sym_LF] = ACTIONS(523),
    [anon_sym_AMP] = ACTIONS(523),
  },
  [105] = {
    [anon_sym_RPAREN] = ACTIONS(525),
    [anon_sym_RBRACE] = ACTIONS(525),
    [anon_sym_COLON] = ACTIONS(527),
    [anon_sym_EQ] = ACTIONS(525),
    [anon_sym_COLON_QMARK] = ACTIONS(525),
    [anon_sym_COLON_DASH] = ACTIONS(525),
    [sym_comment] = ACTIONS(115),
  },
  [106] = {
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(533),
    [anon_sym_COLON_DASH] = ACTIONS(533),
    [sym_comment] = ACTIONS(115),
  },
  [107] = {
    [anon_sym_RBRACE] = ACTIONS(535),
    [anon_sym_COLON] = ACTIONS(537),
    [anon_sym_EQ] = ACTIONS(539),
    [anon_sym_COLON_QMARK] = ACTIONS(539),
    [anon_sym_COLON_DASH] = ACTIONS(539),
    [sym_comment] = ACTIONS(115),
  },
  [108] = {
    [anon_sym_RPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(115),
  },
  [109] = {
    [anon_sym_BQUOTE] = ACTIONS(541),
    [sym_comment] = ACTIONS(115),
  },
  [110] = {
    [anon_sym_RPAREN] = ACTIONS(543),
    [sym_comment] = ACTIONS(115),
  },
  [111] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(545),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(545),
    [anon_sym_LF] = ACTIONS(545),
    [anon_sym_AMP] = ACTIONS(545),
  },
  [112] = {
    [sym_for_statement] = STATE(233),
    [sym_while_statement] = STATE(233),
    [sym_if_statement] = STATE(233),
    [sym_case_statement] = STATE(233),
    [sym_function_definition] = STATE(233),
    [sym_subshell] = STATE(233),
    [sym_pipeline] = STATE(233),
    [sym_list] = STATE(233),
    [sym_bracket_command] = STATE(233),
    [sym_command] = STATE(233),
    [sym_environment_variable_assignment] = STATE(234),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(219),
    [sym_command_substitution] = STATE(219),
    [aux_sym_command_repeat1] = STATE(223),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_if] = ACTIONS(495),
    [anon_sym_case] = ACTIONS(497),
    [anon_sym_function] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(505),
    [anon_sym_COLON] = ACTIONS(507),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(511),
    [sym_comment] = ACTIONS(115),
  },
  [113] = {
    [anon_sym_RPAREN] = ACTIONS(375),
    [anon_sym_RBRACE] = ACTIONS(375),
    [anon_sym_RBRACK] = ACTIONS(547),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_DQUOTE] = ACTIONS(375),
    [sym_raw_string] = ACTIONS(547),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(375),
    [anon_sym_BQUOTE] = ACTIONS(375),
    [sym_word] = ACTIONS(377),
    [sym_comment] = ACTIONS(115),
  },
  [114] = {
    [sym_simple_expansion] = STATE(163),
    [sym_expansion] = STATE(163),
    [sym_command_substitution] = STATE(163),
    [anon_sym_DQUOTE] = ACTIONS(549),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [115] = {
    [anon_sym_RBRACK] = ACTIONS(527),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(525),
    [anon_sym_GT] = ACTIONS(525),
    [anon_sym_DQUOTE] = ACTIONS(525),
    [sym_raw_string] = ACTIONS(527),
    [anon_sym_DOLLAR] = ACTIONS(527),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(525),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(525),
    [anon_sym_BQUOTE] = ACTIONS(525),
    [sym_word] = ACTIONS(519),
    [sym_comment] = ACTIONS(115),
  },
  [116] = {
    [anon_sym_RPAREN] = ACTIONS(551),
    [anon_sym_RBRACE] = ACTIONS(551),
    [anon_sym_RBRACK] = ACTIONS(553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(553),
    [anon_sym_DOLLAR] = ACTIONS(553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [sym_word] = ACTIONS(521),
    [sym_comment] = ACTIONS(115),
  },
  [117] = {
    [anon_sym_RPAREN] = ACTIONS(555),
    [anon_sym_RBRACE] = ACTIONS(555),
    [anon_sym_RBRACK] = ACTIONS(557),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(557),
    [anon_sym_DOLLAR] = ACTIONS(557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [sym_word] = ACTIONS(523),
    [sym_comment] = ACTIONS(115),
  },
  [118] = {
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_COLON] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(563),
    [anon_sym_COLON_QMARK] = ACTIONS(563),
    [anon_sym_COLON_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(115),
  },
  [119] = {
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_COLON] = ACTIONS(567),
    [anon_sym_EQ] = ACTIONS(569),
    [anon_sym_COLON_QMARK] = ACTIONS(569),
    [anon_sym_COLON_DASH] = ACTIONS(569),
    [sym_comment] = ACTIONS(115),
  },
  [120] = {
    [anon_sym_RPAREN] = ACTIONS(571),
    [sym_comment] = ACTIONS(115),
  },
  [121] = {
    [anon_sym_BQUOTE] = ACTIONS(571),
    [sym_comment] = ACTIONS(115),
  },
  [122] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(573),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PIPE_AMP] = ACTIONS(573),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(573),
    [anon_sym_LF] = ACTIONS(573),
    [anon_sym_AMP] = ACTIONS(573),
  },
  [123] = {
    [anon_sym_RBRACK] = ACTIONS(575),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_DQUOTE] = ACTIONS(577),
    [sym_raw_string] = ACTIONS(575),
    [anon_sym_DOLLAR] = ACTIONS(575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(577),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(577),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_word] = ACTIONS(579),
    [sym_comment] = ACTIONS(115),
  },
  [124] = {
    [sym_string] = STATE(241),
    [sym_simple_expansion] = STATE(241),
    [sym_expansion] = STATE(241),
    [sym_command_substitution] = STATE(241),
    [sym_process_substitution] = STATE(241),
    [anon_sym_LT] = ACTIONS(331),
    [anon_sym_GT] = ACTIONS(331),
    [anon_sym_DQUOTE] = ACTIONS(333),
    [sym_raw_string] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(341),
    [anon_sym_BQUOTE] = ACTIONS(343),
    [sym_word] = ACTIONS(583),
    [sym_comment] = ACTIONS(115),
  },
  [125] = {
    [sym_string] = STATE(136),
    [sym_simple_expansion] = STATE(136),
    [sym_expansion] = STATE(136),
    [sym_command_substitution] = STATE(136),
    [sym_process_substitution] = STATE(136),
    [anon_sym_LPAREN] = ACTIONS(585),
    [anon_sym_LT] = ACTIONS(331),
    [anon_sym_GT] = ACTIONS(331),
    [anon_sym_DQUOTE] = ACTIONS(333),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(341),
    [anon_sym_BQUOTE] = ACTIONS(343),
    [sym_word] = ACTIONS(345),
    [sym_comment] = ACTIONS(115),
  },
  [126] = {
    [sym_simple_expansion] = STATE(63),
    [sym_expansion] = STATE(63),
    [sym_command_substitution] = STATE(63),
    [aux_sym_string_repeat1] = STATE(244),
    [anon_sym_DQUOTE] = ACTIONS(587),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [127] = {
    [sym_file_descriptor] = ACTIONS(293),
    [anon_sym_SEMI_SEMI] = ACTIONS(295),
    [anon_sym_PIPE] = ACTIONS(295),
    [anon_sym_PIPE_AMP] = ACTIONS(295),
    [anon_sym_AMP_AMP] = ACTIONS(295),
    [anon_sym_PIPE_PIPE] = ACTIONS(295),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_GT] = ACTIONS(295),
    [anon_sym_AMP_GT] = ACTIONS(295),
    [anon_sym_AMP_GT_GT] = ACTIONS(295),
    [anon_sym_LT_AMP] = ACTIONS(295),
    [anon_sym_GT_AMP] = ACTIONS(295),
    [anon_sym_LT_LT] = ACTIONS(295),
    [anon_sym_LT_LT_DASH] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(295),
    [sym_raw_string] = ACTIONS(295),
    [anon_sym_DOLLAR] = ACTIONS(295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(295),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [sym_word] = ACTIONS(295),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(295),
    [anon_sym_LF] = ACTIONS(295),
    [anon_sym_AMP] = ACTIONS(295),
  },
  [128] = {
    [sym_special_variable_name] = STATE(247),
    [anon_sym_DOLLAR] = ACTIONS(589),
    [sym_comment] = ACTIONS(73),
    [sym_simple_variable_name] = ACTIONS(591),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_AT] = ACTIONS(589),
    [anon_sym_POUND] = ACTIONS(593),
    [anon_sym_QMARK] = ACTIONS(589),
    [anon_sym_DASH] = ACTIONS(589),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_0] = ACTIONS(593),
    [anon_sym__] = ACTIONS(593),
  },
  [129] = {
    [sym_special_variable_name] = STATE(249),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_leading_word] = ACTIONS(595),
    [sym_comment] = ACTIONS(73),
    [anon_sym_STAR] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_POUND] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(277),
    [anon_sym_0] = ACTIONS(277),
    [anon_sym__] = ACTIONS(277),
  },
  [130] = {
    [sym_command] = STATE(250),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(75),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(207),
    [sym_comment] = ACTIONS(115),
  },
  [131] = {
    [sym_command] = STATE(251),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_command_repeat1] = STATE(79),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(213),
    [sym_comment] = ACTIONS(115),
  },
  [132] = {
    [sym_file_redirect] = STATE(53),
    [sym_heredoc_redirect] = STATE(53),
    [sym_string] = STATE(252),
    [sym_simple_expansion] = STATE(252),
    [sym_expansion] = STATE(252),
    [sym_command_substitution] = STATE(252),
    [sym_process_substitution] = STATE(252),
    [aux_sym_command_repeat2] = STATE(253),
    [sym_file_descriptor] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(597),
    [anon_sym_PIPE] = ACTIONS(597),
    [anon_sym_PIPE_AMP] = ACTIONS(597),
    [anon_sym_AMP_AMP] = ACTIONS(597),
    [anon_sym_PIPE_PIPE] = ACTIONS(597),
    [anon_sym_LT] = ACTIONS(317),
    [anon_sym_GT] = ACTIONS(317),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_LT_LT_DASH] = ACTIONS(167),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [sym_raw_string] = ACTIONS(599),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(327),
    [anon_sym_BQUOTE] = ACTIONS(329),
    [sym_word] = ACTIONS(599),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(597),
    [anon_sym_LF] = ACTIONS(597),
    [anon_sym_AMP] = ACTIONS(597),
  },
  [133] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [sym_file_descriptor] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(601),
    [anon_sym_PIPE] = ACTIONS(601),
    [anon_sym_PIPE_AMP] = ACTIONS(601),
    [anon_sym_AMP_AMP] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(601),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_LT_LT_DASH] = ACTIONS(167),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(601),
    [anon_sym_LF] = ACTIONS(601),
    [anon_sym_AMP] = ACTIONS(601),
  },
  [134] = {
    [anon_sym_LPAREN] = ACTIONS(603),
    [sym_comment] = ACTIONS(115),
  },
  [135] = {
    [sym_simple_expansion] = STATE(63),
    [sym_expansion] = STATE(63),
    [sym_command_substitution] = STATE(63),
    [aux_sym_string_repeat1] = STATE(256),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [136] = {
    [sym_file_descriptor] = ACTIONS(361),
    [anon_sym_SEMI_SEMI] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(365),
    [anon_sym_PIPE_AMP] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_LT] = ACTIONS(365),
    [anon_sym_GT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_AMP_GT] = ACTIONS(365),
    [anon_sym_AMP_GT_GT] = ACTIONS(365),
    [anon_sym_LT_AMP] = ACTIONS(365),
    [anon_sym_GT_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_LT_LT_DASH] = ACTIONS(365),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_LF] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(365),
  },
  [137] = {
    [sym_special_variable_name] = STATE(259),
    [anon_sym_DOLLAR] = ACTIONS(607),
    [sym_comment] = ACTIONS(73),
    [sym_simple_variable_name] = ACTIONS(609),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(607),
    [anon_sym_POUND] = ACTIONS(611),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_DASH] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_0] = ACTIONS(611),
    [anon_sym__] = ACTIONS(611),
  },
  [138] = {
    [sym_special_variable_name] = STATE(261),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_leading_word] = ACTIONS(613),
    [sym_comment] = ACTIONS(73),
    [anon_sym_STAR] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_POUND] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(277),
    [anon_sym_0] = ACTIONS(277),
    [anon_sym__] = ACTIONS(277),
  },
  [139] = {
    [sym_command] = STATE(262),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(75),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(207),
    [sym_comment] = ACTIONS(115),
  },
  [140] = {
    [sym_command] = STATE(263),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_command_repeat1] = STATE(79),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(213),
    [sym_comment] = ACTIONS(115),
  },
  [141] = {
    [sym_file_descriptor] = ACTIONS(615),
    [anon_sym_SEMI_SEMI] = ACTIONS(617),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_PIPE_AMP] = ACTIONS(617),
    [anon_sym_AMP_AMP] = ACTIONS(617),
    [anon_sym_PIPE_PIPE] = ACTIONS(617),
    [anon_sym_LT] = ACTIONS(617),
    [anon_sym_GT] = ACTIONS(617),
    [anon_sym_GT_GT] = ACTIONS(617),
    [anon_sym_AMP_GT] = ACTIONS(617),
    [anon_sym_AMP_GT_GT] = ACTIONS(617),
    [anon_sym_LT_AMP] = ACTIONS(617),
    [anon_sym_GT_AMP] = ACTIONS(617),
    [anon_sym_LT_LT] = ACTIONS(617),
    [anon_sym_LT_LT_DASH] = ACTIONS(617),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_LF] = ACTIONS(617),
    [anon_sym_AMP] = ACTIONS(617),
  },
  [142] = {
    [sym_simple_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [aux_sym_heredoc_repeat1] = STATE(268),
    [sym__heredoc_middle] = ACTIONS(619),
    [sym__heredoc_end] = ACTIONS(621),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(625),
    [sym_comment] = ACTIONS(115),
  },
  [143] = {
    [sym_file_descriptor] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(629),
    [anon_sym_PIPE] = ACTIONS(629),
    [anon_sym_PIPE_AMP] = ACTIONS(629),
    [anon_sym_AMP_AMP] = ACTIONS(629),
    [anon_sym_PIPE_PIPE] = ACTIONS(629),
    [anon_sym_LT] = ACTIONS(629),
    [anon_sym_GT] = ACTIONS(629),
    [anon_sym_GT_GT] = ACTIONS(629),
    [anon_sym_AMP_GT] = ACTIONS(629),
    [anon_sym_AMP_GT_GT] = ACTIONS(629),
    [anon_sym_LT_AMP] = ACTIONS(629),
    [anon_sym_GT_AMP] = ACTIONS(629),
    [anon_sym_LT_LT] = ACTIONS(629),
    [anon_sym_LT_LT_DASH] = ACTIONS(629),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym_LF] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
  },
  [144] = {
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_SEMI_SEMI] = ACTIONS(633),
    [anon_sym_PIPE] = ACTIONS(633),
    [anon_sym_PIPE_AMP] = ACTIONS(633),
    [anon_sym_AMP_AMP] = ACTIONS(633),
    [anon_sym_PIPE_PIPE] = ACTIONS(633),
    [anon_sym_LT] = ACTIONS(633),
    [anon_sym_GT] = ACTIONS(633),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_AMP_GT] = ACTIONS(633),
    [anon_sym_AMP_GT_GT] = ACTIONS(633),
    [anon_sym_LT_AMP] = ACTIONS(633),
    [anon_sym_GT_AMP] = ACTIONS(633),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_DASH] = ACTIONS(633),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(633),
    [anon_sym_LF] = ACTIONS(633),
    [anon_sym_AMP] = ACTIONS(633),
  },
  [145] = {
    [sym_for_statement] = STATE(269),
    [sym_while_statement] = STATE(269),
    [sym_if_statement] = STATE(269),
    [sym_case_statement] = STATE(269),
    [sym_function_definition] = STATE(269),
    [sym_subshell] = STATE(269),
    [sym_pipeline] = STATE(269),
    [sym_list] = STATE(269),
    [sym_bracket_command] = STATE(269),
    [sym_command] = STATE(269),
    [sym_environment_variable_assignment] = STATE(270),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(219),
    [sym_command_substitution] = STATE(219),
    [aux_sym_command_repeat1] = STATE(223),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_if] = ACTIONS(495),
    [anon_sym_case] = ACTIONS(497),
    [anon_sym_function] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(505),
    [anon_sym_COLON] = ACTIONS(507),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(511),
    [sym_comment] = ACTIONS(115),
  },
  [146] = {
    [sym_file_descriptor] = ACTIONS(375),
    [anon_sym_RPAREN] = ACTIONS(375),
    [anon_sym_PIPE] = ACTIONS(547),
    [anon_sym_PIPE_AMP] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(547),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_COLON] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(547),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(547),
    [anon_sym_LT_AMP] = ACTIONS(547),
    [anon_sym_GT_AMP] = ACTIONS(547),
    [anon_sym_DQUOTE] = ACTIONS(375),
    [sym_raw_string] = ACTIONS(547),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(375),
    [anon_sym_BQUOTE] = ACTIONS(375),
    [sym_leading_word] = ACTIONS(377),
    [sym_comment] = ACTIONS(115),
  },
  [147] = {
    [sym_simple_expansion] = STATE(163),
    [sym_expansion] = STATE(163),
    [sym_command_substitution] = STATE(163),
    [anon_sym_DQUOTE] = ACTIONS(635),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [148] = {
    [sym_file_descriptor] = ACTIONS(525),
    [anon_sym_RPAREN] = ACTIONS(525),
    [anon_sym_PIPE] = ACTIONS(527),
    [anon_sym_PIPE_AMP] = ACTIONS(525),
    [anon_sym_AMP_AMP] = ACTIONS(527),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [anon_sym_COLON] = ACTIONS(525),
    [anon_sym_LT] = ACTIONS(527),
    [anon_sym_GT] = ACTIONS(527),
    [anon_sym_GT_GT] = ACTIONS(527),
    [anon_sym_AMP_GT] = ACTIONS(527),
    [anon_sym_AMP_GT_GT] = ACTIONS(527),
    [anon_sym_LT_AMP] = ACTIONS(527),
    [anon_sym_GT_AMP] = ACTIONS(527),
    [anon_sym_DQUOTE] = ACTIONS(525),
    [sym_raw_string] = ACTIONS(527),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(525),
    [anon_sym_BQUOTE] = ACTIONS(525),
    [sym_leading_word] = ACTIONS(519),
    [sym_comment] = ACTIONS(115),
  },
  [149] = {
    [sym_file_descriptor] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(553),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
    [anon_sym_AMP_AMP] = ACTIONS(553),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [anon_sym_COLON] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(553),
    [anon_sym_GT_GT] = ACTIONS(553),
    [anon_sym_AMP_GT] = ACTIONS(553),
    [anon_sym_AMP_GT_GT] = ACTIONS(553),
    [anon_sym_LT_AMP] = ACTIONS(553),
    [anon_sym_GT_AMP] = ACTIONS(553),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(553),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [sym_leading_word] = ACTIONS(521),
    [sym_comment] = ACTIONS(115),
  },
  [150] = {
    [sym_file_descriptor] = ACTIONS(555),
    [anon_sym_RPAREN] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(557),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [anon_sym_COLON] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(557),
    [anon_sym_GT] = ACTIONS(557),
    [anon_sym_GT_GT] = ACTIONS(557),
    [anon_sym_AMP_GT] = ACTIONS(557),
    [anon_sym_AMP_GT_GT] = ACTIONS(557),
    [anon_sym_LT_AMP] = ACTIONS(557),
    [anon_sym_GT_AMP] = ACTIONS(557),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(557),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [sym_leading_word] = ACTIONS(523),
    [sym_comment] = ACTIONS(115),
  },
  [151] = {
    [anon_sym_RBRACE] = ACTIONS(637),
    [anon_sym_COLON] = ACTIONS(639),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_COLON_QMARK] = ACTIONS(641),
    [anon_sym_COLON_DASH] = ACTIONS(641),
    [sym_comment] = ACTIONS(115),
  },
  [152] = {
    [anon_sym_RBRACE] = ACTIONS(643),
    [anon_sym_COLON] = ACTIONS(645),
    [anon_sym_EQ] = ACTIONS(647),
    [anon_sym_COLON_QMARK] = ACTIONS(647),
    [anon_sym_COLON_DASH] = ACTIONS(647),
    [sym_comment] = ACTIONS(115),
  },
  [153] = {
    [anon_sym_RPAREN] = ACTIONS(649),
    [sym_comment] = ACTIONS(115),
  },
  [154] = {
    [anon_sym_BQUOTE] = ACTIONS(649),
    [sym_comment] = ACTIONS(115),
  },
  [155] = {
    [anon_sym_DQUOTE] = ACTIONS(519),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(519),
    [anon_sym_DOLLAR] = ACTIONS(519),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(519),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(519),
    [anon_sym_BQUOTE] = ACTIONS(527),
    [sym_comment] = ACTIONS(73),
  },
  [156] = {
    [anon_sym_DQUOTE] = ACTIONS(521),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(521),
    [anon_sym_DOLLAR] = ACTIONS(521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(521),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(521),
    [anon_sym_BQUOTE] = ACTIONS(553),
    [sym_comment] = ACTIONS(73),
  },
  [157] = {
    [anon_sym_DQUOTE] = ACTIONS(523),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(523),
    [anon_sym_DOLLAR] = ACTIONS(523),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(523),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(523),
    [anon_sym_BQUOTE] = ACTIONS(557),
    [sym_comment] = ACTIONS(73),
  },
  [158] = {
    [anon_sym_RBRACE] = ACTIONS(651),
    [anon_sym_COLON] = ACTIONS(653),
    [anon_sym_EQ] = ACTIONS(655),
    [anon_sym_COLON_QMARK] = ACTIONS(655),
    [anon_sym_COLON_DASH] = ACTIONS(655),
    [sym_comment] = ACTIONS(115),
  },
  [159] = {
    [anon_sym_RBRACE] = ACTIONS(657),
    [anon_sym_COLON] = ACTIONS(659),
    [anon_sym_EQ] = ACTIONS(661),
    [anon_sym_COLON_QMARK] = ACTIONS(661),
    [anon_sym_COLON_DASH] = ACTIONS(661),
    [sym_comment] = ACTIONS(115),
  },
  [160] = {
    [anon_sym_RPAREN] = ACTIONS(663),
    [sym_comment] = ACTIONS(115),
  },
  [161] = {
    [anon_sym_BQUOTE] = ACTIONS(663),
    [sym_comment] = ACTIONS(115),
  },
  [162] = {
    [sym_file_descriptor] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(667),
    [anon_sym_PIPE] = ACTIONS(667),
    [anon_sym_PIPE_AMP] = ACTIONS(667),
    [anon_sym_AMP_AMP] = ACTIONS(667),
    [anon_sym_PIPE_PIPE] = ACTIONS(667),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(667),
    [anon_sym_GT] = ACTIONS(667),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(667),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_LT_LT] = ACTIONS(667),
    [anon_sym_LT_LT_DASH] = ACTIONS(667),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_LF] = ACTIONS(667),
    [anon_sym_AMP] = ACTIONS(667),
  },
  [163] = {
    [anon_sym_DQUOTE] = ACTIONS(669),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(669),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(669),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(669),
    [anon_sym_BQUOTE] = ACTIONS(671),
    [sym_comment] = ACTIONS(73),
  },
  [164] = {
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(675),
    [anon_sym_AMP_GT] = ACTIONS(673),
    [anon_sym_AMP_GT_GT] = ACTIONS(675),
    [anon_sym_LT_AMP] = ACTIONS(675),
    [anon_sym_GT_AMP] = ACTIONS(675),
    [sym_comment] = ACTIONS(115),
  },
  [165] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(285),
    [sym_simple_expansion] = STATE(285),
    [sym_expansion] = STATE(285),
    [sym_command_substitution] = STATE(285),
    [sym_process_substitution] = STATE(285),
    [aux_sym_bracket_command_repeat1] = STATE(290),
    [aux_sym_command_repeat2] = STATE(291),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(691),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [sym_word] = ACTIONS(701),
    [sym_comment] = ACTIONS(115),
  },
  [166] = {
    [sym_string] = STATE(293),
    [sym_simple_expansion] = STATE(293),
    [sym_expansion] = STATE(293),
    [sym_command_substitution] = STATE(293),
    [sym_process_substitution] = STATE(293),
    [anon_sym_LT] = ACTIONS(703),
    [anon_sym_GT] = ACTIONS(703),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(705),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [sym_word] = ACTIONS(707),
    [sym_comment] = ACTIONS(115),
  },
  [167] = {
    [sym_heredoc] = STATE(296),
    [sym__simple_heredoc] = ACTIONS(709),
    [sym__heredoc_beginning] = ACTIONS(711),
    [sym_comment] = ACTIONS(115),
  },
  [168] = {
    [sym_file_descriptor] = ACTIONS(351),
    [anon_sym_RPAREN] = ACTIONS(351),
    [anon_sym_PIPE] = ACTIONS(713),
    [anon_sym_PIPE_AMP] = ACTIONS(351),
    [anon_sym_AMP_AMP] = ACTIONS(351),
    [anon_sym_PIPE_PIPE] = ACTIONS(351),
    [anon_sym_LT] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(713),
    [anon_sym_GT_GT] = ACTIONS(351),
    [anon_sym_AMP_GT] = ACTIONS(713),
    [anon_sym_AMP_GT_GT] = ACTIONS(351),
    [anon_sym_LT_AMP] = ACTIONS(351),
    [anon_sym_GT_AMP] = ACTIONS(351),
    [anon_sym_LT_LT] = ACTIONS(713),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(115),
  },
  [169] = {
    [sym_file_redirect] = STATE(297),
    [sym_heredoc_redirect] = STATE(297),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(683),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_BQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(115),
  },
  [170] = {
    [sym_file_descriptor] = ACTIONS(375),
    [anon_sym_RPAREN] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_PIPE_AMP] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_AMP_GT] = ACTIONS(377),
    [anon_sym_AMP_GT_GT] = ACTIONS(377),
    [anon_sym_LT_AMP] = ACTIONS(377),
    [anon_sym_GT_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(377),
    [sym_comment] = ACTIONS(73),
  },
  [171] = {
    [sym_simple_expansion] = STATE(163),
    [sym_expansion] = STATE(163),
    [sym_command_substitution] = STATE(163),
    [anon_sym_DQUOTE] = ACTIONS(717),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [172] = {
    [anon_sym_RPAREN] = ACTIONS(719),
    [sym_comment] = ACTIONS(115),
  },
  [173] = {
    [anon_sym_BQUOTE] = ACTIONS(719),
    [sym_comment] = ACTIONS(115),
  },
  [174] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(285),
    [sym_simple_expansion] = STATE(285),
    [sym_expansion] = STATE(285),
    [sym_command_substitution] = STATE(285),
    [sym_process_substitution] = STATE(285),
    [aux_sym_bracket_command_repeat1] = STATE(300),
    [aux_sym_command_repeat2] = STATE(301),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(691),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [sym_word] = ACTIONS(701),
    [sym_comment] = ACTIONS(115),
  },
  [175] = {
    [sym_string] = STATE(302),
    [sym_simple_expansion] = STATE(302),
    [sym_expansion] = STATE(302),
    [sym_command_substitution] = STATE(302),
    [sym_process_substitution] = STATE(302),
    [sym__empty_value] = ACTIONS(723),
    [anon_sym_LT] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(171),
    [sym_raw_string] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(175),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(177),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [sym_word] = ACTIONS(727),
    [sym_comment] = ACTIONS(115),
  },
  [176] = {
    [sym_file_redirect] = STATE(297),
    [sym_heredoc_redirect] = STATE(297),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(729),
    [anon_sym_LT] = ACTIONS(683),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_BQUOTE] = ACTIONS(729),
    [sym_comment] = ACTIONS(115),
  },
  [177] = {
    [sym_file_descriptor] = ACTIONS(731),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(733),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [178] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [aux_sym_command_repeat2] = STATE(291),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(355),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_GT] = ACTIONS(399),
    [anon_sym_AMP_GT] = ACTIONS(399),
    [anon_sym_AMP_GT_GT] = ACTIONS(399),
    [anon_sym_LT_AMP] = ACTIONS(399),
    [anon_sym_GT_AMP] = ACTIONS(399),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [sym_comment] = ACTIONS(73),
  },
  [179] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [aux_sym_command_repeat2] = STATE(305),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(465),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_GT] = ACTIONS(399),
    [anon_sym_AMP_GT] = ACTIONS(399),
    [anon_sym_AMP_GT_GT] = ACTIONS(399),
    [anon_sym_LT_AMP] = ACTIONS(399),
    [anon_sym_GT_AMP] = ACTIONS(399),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [sym_comment] = ACTIONS(73),
  },
  [180] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(285),
    [sym_simple_expansion] = STATE(285),
    [sym_expansion] = STATE(285),
    [sym_command_substitution] = STATE(285),
    [sym_process_substitution] = STATE(285),
    [aux_sym_bracket_command_repeat1] = STATE(306),
    [aux_sym_command_repeat2] = STATE(291),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(691),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(677),
    [sym_word] = ACTIONS(701),
    [sym_comment] = ACTIONS(115),
  },
  [181] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(285),
    [sym_simple_expansion] = STATE(285),
    [sym_expansion] = STATE(285),
    [sym_command_substitution] = STATE(285),
    [sym_process_substitution] = STATE(285),
    [aux_sym_bracket_command_repeat1] = STATE(307),
    [aux_sym_command_repeat2] = STATE(301),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(691),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(721),
    [sym_word] = ACTIONS(701),
    [sym_comment] = ACTIONS(115),
  },
  [182] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [aux_sym_command_repeat2] = STATE(291),
    [sym_file_descriptor] = ACTIONS(395),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(739),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_GT] = ACTIONS(399),
    [anon_sym_AMP_GT] = ACTIONS(399),
    [anon_sym_AMP_GT_GT] = ACTIONS(399),
    [anon_sym_LT_AMP] = ACTIONS(399),
    [anon_sym_GT_AMP] = ACTIONS(399),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(355),
    [sym_comment] = ACTIONS(73),
  },
  [183] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [aux_sym_command_repeat2] = STATE(305),
    [sym_file_descriptor] = ACTIONS(395),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_GT] = ACTIONS(399),
    [anon_sym_AMP_GT] = ACTIONS(399),
    [anon_sym_AMP_GT_GT] = ACTIONS(399),
    [anon_sym_LT_AMP] = ACTIONS(399),
    [anon_sym_GT_AMP] = ACTIONS(399),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(465),
    [sym_comment] = ACTIONS(73),
  },
  [184] = {
    [sym_compound_statement] = STATE(311),
    [anon_sym_LBRACE] = ACTIONS(743),
    [sym_comment] = ACTIONS(115),
  },
  [185] = {
    [sym_file_redirect] = STATE(53),
    [sym_heredoc_redirect] = STATE(53),
    [sym_string] = STATE(252),
    [sym_simple_expansion] = STATE(252),
    [sym_expansion] = STATE(252),
    [sym_command_substitution] = STATE(252),
    [sym_process_substitution] = STATE(252),
    [aux_sym_command_repeat2] = STATE(312),
    [sym_file_descriptor] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(745),
    [anon_sym_PIPE_AMP] = ACTIONS(745),
    [anon_sym_AMP_AMP] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(745),
    [anon_sym_LT] = ACTIONS(317),
    [anon_sym_GT] = ACTIONS(317),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_LT_LT_DASH] = ACTIONS(167),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [sym_raw_string] = ACTIONS(599),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(327),
    [anon_sym_BQUOTE] = ACTIONS(329),
    [sym_word] = ACTIONS(599),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_LF] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(745),
  },
  [186] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [sym_file_descriptor] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(747),
    [anon_sym_PIPE] = ACTIONS(747),
    [anon_sym_PIPE_AMP] = ACTIONS(747),
    [anon_sym_AMP_AMP] = ACTIONS(747),
    [anon_sym_PIPE_PIPE] = ACTIONS(747),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_LT_LT_DASH] = ACTIONS(167),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(747),
    [anon_sym_LF] = ACTIONS(747),
    [anon_sym_AMP] = ACTIONS(747),
  },
  [187] = {
    [sym_file_descriptor] = ACTIONS(749),
    [anon_sym_SEMI_SEMI] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_PIPE_AMP] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_LT] = ACTIONS(751),
    [anon_sym_GT] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_AMP_GT] = ACTIONS(751),
    [anon_sym_AMP_GT_GT] = ACTIONS(751),
    [anon_sym_LT_AMP] = ACTIONS(751),
    [anon_sym_GT_AMP] = ACTIONS(751),
    [anon_sym_DQUOTE] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(751),
    [anon_sym_BQUOTE] = ACTIONS(751),
    [sym_leading_word] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_LF] = ACTIONS(751),
    [anon_sym_AMP] = ACTIONS(751),
  },
  [188] = {
    [anon_sym_LPAREN] = ACTIONS(753),
    [sym_comment] = ACTIONS(115),
  },
  [189] = {
    [sym_simple_expansion] = STATE(63),
    [sym_expansion] = STATE(63),
    [sym_command_substitution] = STATE(63),
    [aux_sym_string_repeat1] = STATE(315),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [190] = {
    [sym_special_variable_name] = STATE(318),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [sym_comment] = ACTIONS(73),
    [sym_simple_variable_name] = ACTIONS(759),
    [anon_sym_STAR] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [anon_sym_POUND] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [anon_sym_BANG] = ACTIONS(757),
    [anon_sym_0] = ACTIONS(761),
    [anon_sym__] = ACTIONS(761),
  },
  [191] = {
    [sym_special_variable_name] = STATE(320),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_leading_word] = ACTIONS(763),
    [sym_comment] = ACTIONS(73),
    [anon_sym_STAR] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_POUND] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(277),
    [anon_sym_0] = ACTIONS(277),
    [anon_sym__] = ACTIONS(277),
  },
  [192] = {
    [sym_command] = STATE(321),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(75),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(207),
    [sym_comment] = ACTIONS(115),
  },
  [193] = {
    [sym_command] = STATE(322),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_command_repeat1] = STATE(79),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(213),
    [sym_comment] = ACTIONS(115),
  },
  [194] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(765),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(765),
  },
  [195] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(765),
    [anon_sym_AMP_AMP] = ACTIONS(765),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_LT] = ACTIONS(239),
    [anon_sym_GT] = ACTIONS(239),
    [anon_sym_GT_GT] = ACTIONS(239),
    [anon_sym_AMP_GT] = ACTIONS(239),
    [anon_sym_AMP_GT_GT] = ACTIONS(239),
    [anon_sym_LT_AMP] = ACTIONS(239),
    [anon_sym_GT_AMP] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [sym_raw_string] = ACTIONS(239),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(765),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(765),
  },
  [196] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(233),
    [anon_sym_PIPE_AMP] = ACTIONS(233),
    [anon_sym_AMP_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(767),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [197] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_SEMI_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(233),
    [anon_sym_PIPE_AMP] = ACTIONS(233),
    [anon_sym_AMP_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_LT] = ACTIONS(239),
    [anon_sym_GT] = ACTIONS(239),
    [anon_sym_GT_GT] = ACTIONS(239),
    [anon_sym_AMP_GT] = ACTIONS(239),
    [anon_sym_AMP_GT_GT] = ACTIONS(239),
    [anon_sym_LT_AMP] = ACTIONS(239),
    [anon_sym_GT_AMP] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [sym_raw_string] = ACTIONS(239),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [198] = {
    [sym_file_redirect] = STATE(53),
    [sym_heredoc_redirect] = STATE(53),
    [sym_string] = STATE(127),
    [sym_simple_expansion] = STATE(127),
    [sym_expansion] = STATE(127),
    [sym_command_substitution] = STATE(127),
    [sym_process_substitution] = STATE(127),
    [aux_sym_bracket_command_repeat1] = STATE(323),
    [aux_sym_command_repeat2] = STATE(253),
    [sym_file_descriptor] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(597),
    [anon_sym_PIPE] = ACTIONS(597),
    [anon_sym_PIPE_AMP] = ACTIONS(597),
    [anon_sym_AMP_AMP] = ACTIONS(597),
    [anon_sym_PIPE_PIPE] = ACTIONS(597),
    [anon_sym_LT] = ACTIONS(317),
    [anon_sym_GT] = ACTIONS(317),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_LT_LT_DASH] = ACTIONS(167),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(327),
    [anon_sym_BQUOTE] = ACTIONS(329),
    [sym_word] = ACTIONS(321),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(597),
    [anon_sym_LF] = ACTIONS(597),
    [anon_sym_AMP] = ACTIONS(597),
  },
  [199] = {
    [sym_file_redirect] = STATE(53),
    [sym_heredoc_redirect] = STATE(53),
    [sym_string] = STATE(127),
    [sym_simple_expansion] = STATE(127),
    [sym_expansion] = STATE(127),
    [sym_command_substitution] = STATE(127),
    [sym_process_substitution] = STATE(127),
    [aux_sym_bracket_command_repeat1] = STATE(324),
    [aux_sym_command_repeat2] = STATE(325),
    [sym_file_descriptor] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_PIPE_AMP] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_LT] = ACTIONS(317),
    [anon_sym_GT] = ACTIONS(317),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_LT_LT_DASH] = ACTIONS(167),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(327),
    [anon_sym_BQUOTE] = ACTIONS(329),
    [sym_word] = ACTIONS(321),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(769),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
  },
  [200] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [sym_file_descriptor] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(771),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_PIPE_AMP] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_LT_LT_DASH] = ACTIONS(167),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(771),
    [anon_sym_LF] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
  },
  [201] = {
    [sym_do_group] = STATE(326),
    [anon_sym_do] = ACTIONS(257),
    [sym_comment] = ACTIONS(115),
  },
  [202] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(773),
    [anon_sym_PIPE_AMP] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(773),
    [anon_sym_LF] = ACTIONS(773),
    [anon_sym_AMP] = ACTIONS(773),
  },
  [203] = {
    [sym__terminated_statement] = STATE(87),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_done] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [204] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_PIPE_AMP] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_LF] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(777),
  },
  [205] = {
    [sym__terminated_statement] = STATE(328),
    [sym_for_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_function_definition] = STATE(27),
    [sym_subshell] = STATE(27),
    [sym_pipeline] = STATE(27),
    [sym_list] = STATE(27),
    [sym_bracket_command] = STATE(27),
    [sym_command] = STATE(27),
    [sym_environment_variable_assignment] = STATE(28),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [206] = {
    [sym__terminated_statement] = STATE(18),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_program_repeat1] = STATE(329),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_fi] = ACTIONS(779),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [207] = {
    [anon_sym_fi] = ACTIONS(781),
    [anon_sym_elif] = ACTIONS(781),
    [anon_sym_else] = ACTIONS(781),
    [sym_comment] = ACTIONS(115),
  },
  [208] = {
    [anon_sym_fi] = ACTIONS(783),
    [sym_comment] = ACTIONS(115),
  },
  [209] = {
    [sym__terminated_statement] = STATE(87),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_elif_clause] = STATE(207),
    [sym_else_clause] = STATE(331),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_if_statement_repeat1] = STATE(332),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_fi] = ACTIONS(785),
    [anon_sym_elif] = ACTIONS(487),
    [anon_sym_else] = ACTIONS(489),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [210] = {
    [sym_elif_clause] = STATE(333),
    [sym_else_clause] = STATE(331),
    [anon_sym_fi] = ACTIONS(783),
    [anon_sym_elif] = ACTIONS(787),
    [anon_sym_else] = ACTIONS(789),
    [sym_comment] = ACTIONS(115),
  },
  [211] = {
    [sym_word] = ACTIONS(791),
    [sym_comment] = ACTIONS(115),
  },
  [212] = {
    [sym__terminated_statement] = STATE(335),
    [sym_for_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_function_definition] = STATE(27),
    [sym_subshell] = STATE(27),
    [sym_pipeline] = STATE(27),
    [sym_list] = STATE(27),
    [sym_bracket_command] = STATE(27),
    [sym_command] = STATE(27),
    [sym_environment_variable_assignment] = STATE(28),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [213] = {
    [sym__terminated_statement] = STATE(336),
    [sym_for_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_function_definition] = STATE(27),
    [sym_subshell] = STATE(27),
    [sym_pipeline] = STATE(27),
    [sym_list] = STATE(27),
    [sym_bracket_command] = STATE(27),
    [sym_command] = STATE(27),
    [sym_environment_variable_assignment] = STATE(28),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [214] = {
    [sym_string] = STATE(337),
    [sym_simple_expansion] = STATE(337),
    [sym_expansion] = STATE(337),
    [sym_command_substitution] = STATE(337),
    [sym_process_substitution] = STATE(337),
    [anon_sym_LT] = ACTIONS(123),
    [anon_sym_GT] = ACTIONS(123),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [sym_raw_string] = ACTIONS(793),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(131),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(133),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_word] = ACTIONS(795),
    [sym_comment] = ACTIONS(115),
  },
  [215] = {
    [sym_leading_word] = ACTIONS(797),
    [sym_comment] = ACTIONS(115),
  },
  [216] = {
    [sym__terminated_statement] = STATE(18),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_program_repeat1] = STATE(340),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_RPAREN] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [217] = {
    [sym_string] = STATE(42),
    [sym_simple_expansion] = STATE(42),
    [sym_expansion] = STATE(42),
    [sym_command_substitution] = STATE(42),
    [sym_process_substitution] = STATE(42),
    [aux_sym_bracket_command_repeat1] = STATE(341),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(147),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(157),
    [sym_comment] = ACTIONS(115),
  },
  [218] = {
    [sym_string] = STATE(42),
    [sym_simple_expansion] = STATE(42),
    [sym_expansion] = STATE(42),
    [sym_command_substitution] = STATE(42),
    [sym_process_substitution] = STATE(42),
    [aux_sym_bracket_command_repeat1] = STATE(342),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(147),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(157),
    [sym_comment] = ACTIONS(115),
  },
  [219] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [aux_sym_command_repeat2] = STATE(346),
    [sym_file_descriptor] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_PIPE_AMP] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(161),
    [anon_sym_PIPE_PIPE] = ACTIONS(161),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(803),
    [anon_sym_LT] = ACTIONS(805),
    [anon_sym_GT] = ACTIONS(805),
    [anon_sym_GT_GT] = ACTIONS(805),
    [anon_sym_AMP_GT] = ACTIONS(805),
    [anon_sym_AMP_GT_GT] = ACTIONS(805),
    [anon_sym_LT_AMP] = ACTIONS(805),
    [anon_sym_GT_AMP] = ACTIONS(805),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [sym_comment] = ACTIONS(73),
  },
  [220] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [aux_sym_command_repeat2] = STATE(349),
    [sym_file_descriptor] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_PIPE_AMP] = ACTIONS(215),
    [anon_sym_AMP_AMP] = ACTIONS(215),
    [anon_sym_PIPE_PIPE] = ACTIONS(215),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(809),
    [anon_sym_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(805),
    [anon_sym_GT] = ACTIONS(805),
    [anon_sym_GT_GT] = ACTIONS(805),
    [anon_sym_AMP_GT] = ACTIONS(805),
    [anon_sym_AMP_GT_GT] = ACTIONS(805),
    [anon_sym_LT_AMP] = ACTIONS(805),
    [anon_sym_GT_AMP] = ACTIONS(805),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [sym_comment] = ACTIONS(73),
  },
  [221] = {
    [anon_sym_RPAREN] = ACTIONS(811),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [sym_comment] = ACTIONS(115),
  },
  [222] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(811),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(819),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(241),
    [anon_sym_GT] = ACTIONS(241),
    [anon_sym_GT_GT] = ACTIONS(241),
    [anon_sym_AMP_GT] = ACTIONS(241),
    [anon_sym_AMP_GT_GT] = ACTIONS(241),
    [anon_sym_LT_AMP] = ACTIONS(241),
    [anon_sym_GT_AMP] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_raw_string] = ACTIONS(241),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(115),
  },
  [223] = {
    [sym_environment_variable_assignment] = STATE(90),
    [sym_file_redirect] = STATE(90),
    [sym_string] = STATE(353),
    [sym_command_substitution] = STATE(353),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(823),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(825),
    [sym_comment] = ACTIONS(115),
  },
  [224] = {
    [anon_sym_in] = ACTIONS(667),
    [anon_sym_SEMI_SEMI] = ACTIONS(667),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_LF] = ACTIONS(667),
    [anon_sym_AMP] = ACTIONS(667),
  },
  [225] = {
    [sym_case_item] = STATE(358),
    [sym_string] = STATE(356),
    [sym_simple_expansion] = STATE(356),
    [sym_expansion] = STATE(356),
    [sym_command_substitution] = STATE(356),
    [sym_process_substitution] = STATE(356),
    [aux_sym_case_statement_repeat1] = STATE(359),
    [anon_sym_esac] = ACTIONS(827),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(829),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(833),
    [sym_comment] = ACTIONS(115),
  },
  [226] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(835),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(835),
    [anon_sym_LF] = ACTIONS(835),
    [anon_sym_AMP] = ACTIONS(835),
  },
  [227] = {
    [anon_sym_in] = ACTIONS(837),
    [anon_sym_SEMI_SEMI] = ACTIONS(837),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_LF] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(837),
  },
  [228] = {
    [sym_string] = STATE(361),
    [sym_simple_expansion] = STATE(361),
    [sym_expansion] = STATE(361),
    [sym_command_substitution] = STATE(361),
    [sym_process_substitution] = STATE(361),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(839),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(841),
    [sym_comment] = ACTIONS(115),
  },
  [229] = {
    [anon_sym_in] = ACTIONS(843),
    [anon_sym_SEMI_SEMI] = ACTIONS(843),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(843),
    [anon_sym_LF] = ACTIONS(843),
    [anon_sym_AMP] = ACTIONS(843),
  },
  [230] = {
    [sym_string] = STATE(362),
    [sym_simple_expansion] = STATE(362),
    [sym_expansion] = STATE(362),
    [sym_command_substitution] = STATE(362),
    [sym_process_substitution] = STATE(362),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(845),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(847),
    [sym_comment] = ACTIONS(115),
  },
  [231] = {
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [232] = {
    [sym_compound_statement] = STATE(363),
    [anon_sym_LBRACE] = ACTIONS(743),
    [sym_comment] = ACTIONS(115),
  },
  [233] = {
    [anon_sym_RPAREN] = ACTIONS(849),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [sym_comment] = ACTIONS(115),
  },
  [234] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(849),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(819),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(241),
    [anon_sym_GT] = ACTIONS(241),
    [anon_sym_GT_GT] = ACTIONS(241),
    [anon_sym_AMP_GT] = ACTIONS(241),
    [anon_sym_AMP_GT_GT] = ACTIONS(241),
    [anon_sym_LT_AMP] = ACTIONS(241),
    [anon_sym_GT_AMP] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_raw_string] = ACTIONS(241),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(115),
  },
  [235] = {
    [anon_sym_RPAREN] = ACTIONS(665),
    [anon_sym_RBRACE] = ACTIONS(665),
    [anon_sym_RBRACK] = ACTIONS(851),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(851),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_DQUOTE] = ACTIONS(665),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_DOLLAR] = ACTIONS(851),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(665),
    [anon_sym_BQUOTE] = ACTIONS(665),
    [sym_word] = ACTIONS(667),
    [sym_comment] = ACTIONS(115),
  },
  [236] = {
    [anon_sym_RPAREN] = ACTIONS(853),
    [anon_sym_RBRACE] = ACTIONS(853),
    [anon_sym_RBRACK] = ACTIONS(855),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(855),
    [anon_sym_LT] = ACTIONS(853),
    [anon_sym_GT] = ACTIONS(853),
    [anon_sym_DQUOTE] = ACTIONS(853),
    [sym_raw_string] = ACTIONS(855),
    [anon_sym_DOLLAR] = ACTIONS(855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(853),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(853),
    [anon_sym_BQUOTE] = ACTIONS(853),
    [sym_word] = ACTIONS(837),
    [sym_comment] = ACTIONS(115),
  },
  [237] = {
    [sym_string] = STATE(365),
    [sym_simple_expansion] = STATE(365),
    [sym_expansion] = STATE(365),
    [sym_command_substitution] = STATE(365),
    [sym_process_substitution] = STATE(365),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(859),
    [sym_comment] = ACTIONS(115),
  },
  [238] = {
    [anon_sym_RPAREN] = ACTIONS(861),
    [anon_sym_RBRACE] = ACTIONS(861),
    [anon_sym_RBRACK] = ACTIONS(863),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(863),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(863),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [sym_word] = ACTIONS(843),
    [sym_comment] = ACTIONS(115),
  },
  [239] = {
    [sym_string] = STATE(366),
    [sym_simple_expansion] = STATE(366),
    [sym_expansion] = STATE(366),
    [sym_command_substitution] = STATE(366),
    [sym_process_substitution] = STATE(366),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(867),
    [sym_comment] = ACTIONS(115),
  },
  [240] = {
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_RBRACE] = ACTIONS(731),
    [anon_sym_RBRACK] = ACTIONS(869),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(869),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [sym_raw_string] = ACTIONS(869),
    [anon_sym_DOLLAR] = ACTIONS(869),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [sym_word] = ACTIONS(733),
    [sym_comment] = ACTIONS(115),
  },
  [241] = {
    [sym_file_descriptor] = ACTIONS(475),
    [anon_sym_SEMI_SEMI] = ACTIONS(479),
    [anon_sym_PIPE] = ACTIONS(479),
    [anon_sym_PIPE_AMP] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(479),
    [anon_sym_AMP_GT] = ACTIONS(479),
    [anon_sym_AMP_GT_GT] = ACTIONS(479),
    [anon_sym_LT_AMP] = ACTIONS(479),
    [anon_sym_GT_AMP] = ACTIONS(479),
    [anon_sym_LT_LT] = ACTIONS(479),
    [anon_sym_LT_LT_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_LF] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(479),
  },
  [242] = {
    [sym_for_statement] = STATE(367),
    [sym_while_statement] = STATE(367),
    [sym_if_statement] = STATE(367),
    [sym_case_statement] = STATE(367),
    [sym_function_definition] = STATE(367),
    [sym_subshell] = STATE(367),
    [sym_pipeline] = STATE(367),
    [sym_list] = STATE(367),
    [sym_bracket_command] = STATE(367),
    [sym_command] = STATE(367),
    [sym_environment_variable_assignment] = STATE(368),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(219),
    [sym_command_substitution] = STATE(219),
    [aux_sym_command_repeat1] = STATE(223),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_if] = ACTIONS(495),
    [anon_sym_case] = ACTIONS(497),
    [anon_sym_function] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(505),
    [anon_sym_COLON] = ACTIONS(507),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(511),
    [sym_comment] = ACTIONS(115),
  },
  [243] = {
    [sym_file_descriptor] = ACTIONS(375),
    [anon_sym_SEMI_SEMI] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_PIPE_AMP] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_AMP_GT] = ACTIONS(377),
    [anon_sym_AMP_GT_GT] = ACTIONS(377),
    [anon_sym_LT_AMP] = ACTIONS(377),
    [anon_sym_GT_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_DQUOTE] = ACTIONS(377),
    [sym_raw_string] = ACTIONS(377),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(377),
    [sym_word] = ACTIONS(377),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(377),
    [anon_sym_LF] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
  },
  [244] = {
    [sym_simple_expansion] = STATE(163),
    [sym_expansion] = STATE(163),
    [sym_command_substitution] = STATE(163),
    [anon_sym_DQUOTE] = ACTIONS(871),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [245] = {
    [sym_file_descriptor] = ACTIONS(525),
    [anon_sym_SEMI_SEMI] = ACTIONS(519),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_PIPE_AMP] = ACTIONS(519),
    [anon_sym_AMP_AMP] = ACTIONS(519),
    [anon_sym_PIPE_PIPE] = ACTIONS(519),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_GT] = ACTIONS(519),
    [anon_sym_AMP_GT] = ACTIONS(519),
    [anon_sym_AMP_GT_GT] = ACTIONS(519),
    [anon_sym_LT_AMP] = ACTIONS(519),
    [anon_sym_GT_AMP] = ACTIONS(519),
    [anon_sym_LT_LT] = ACTIONS(519),
    [anon_sym_LT_LT_DASH] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(519),
    [sym_raw_string] = ACTIONS(519),
    [anon_sym_DOLLAR] = ACTIONS(519),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(519),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(519),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [sym_word] = ACTIONS(519),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(519),
    [anon_sym_LF] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(519),
  },
  [246] = {
    [sym_file_descriptor] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PIPE_AMP] = ACTIONS(521),
    [anon_sym_AMP_AMP] = ACTIONS(521),
    [anon_sym_PIPE_PIPE] = ACTIONS(521),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_AMP_GT] = ACTIONS(521),
    [anon_sym_AMP_GT_GT] = ACTIONS(521),
    [anon_sym_LT_AMP] = ACTIONS(521),
    [anon_sym_GT_AMP] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_LT_LT_DASH] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(521),
    [sym_raw_string] = ACTIONS(521),
    [anon_sym_DOLLAR] = ACTIONS(521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(521),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(521),
    [anon_sym_BQUOTE] = ACTIONS(521),
    [sym_word] = ACTIONS(521),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(521),
    [anon_sym_LF] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
  },
  [247] = {
    [sym_file_descriptor] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(523),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(523),
    [anon_sym_PIPE_PIPE] = ACTIONS(523),
    [anon_sym_LT] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(523),
    [anon_sym_GT_GT] = ACTIONS(523),
    [anon_sym_AMP_GT] = ACTIONS(523),
    [anon_sym_AMP_GT_GT] = ACTIONS(523),
    [anon_sym_LT_AMP] = ACTIONS(523),
    [anon_sym_GT_AMP] = ACTIONS(523),
    [anon_sym_LT_LT] = ACTIONS(523),
    [anon_sym_LT_LT_DASH] = ACTIONS(523),
    [anon_sym_DQUOTE] = ACTIONS(523),
    [sym_raw_string] = ACTIONS(523),
    [anon_sym_DOLLAR] = ACTIONS(523),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(523),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(523),
    [anon_sym_BQUOTE] = ACTIONS(523),
    [sym_word] = ACTIONS(523),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(523),
    [anon_sym_LF] = ACTIONS(523),
    [anon_sym_AMP] = ACTIONS(523),
  },
  [248] = {
    [anon_sym_RBRACE] = ACTIONS(873),
    [anon_sym_COLON] = ACTIONS(875),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_COLON_QMARK] = ACTIONS(877),
    [anon_sym_COLON_DASH] = ACTIONS(877),
    [sym_comment] = ACTIONS(115),
  },
  [249] = {
    [anon_sym_RBRACE] = ACTIONS(879),
    [anon_sym_COLON] = ACTIONS(881),
    [anon_sym_EQ] = ACTIONS(883),
    [anon_sym_COLON_QMARK] = ACTIONS(883),
    [anon_sym_COLON_DASH] = ACTIONS(883),
    [sym_comment] = ACTIONS(115),
  },
  [250] = {
    [anon_sym_RPAREN] = ACTIONS(885),
    [sym_comment] = ACTIONS(115),
  },
  [251] = {
    [anon_sym_BQUOTE] = ACTIONS(885),
    [sym_comment] = ACTIONS(115),
  },
  [252] = {
    [sym_file_descriptor] = ACTIONS(577),
    [anon_sym_SEMI_SEMI] = ACTIONS(579),
    [anon_sym_PIPE] = ACTIONS(579),
    [anon_sym_PIPE_AMP] = ACTIONS(579),
    [anon_sym_AMP_AMP] = ACTIONS(579),
    [anon_sym_PIPE_PIPE] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(579),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_AMP_GT] = ACTIONS(579),
    [anon_sym_AMP_GT_GT] = ACTIONS(579),
    [anon_sym_LT_AMP] = ACTIONS(579),
    [anon_sym_GT_AMP] = ACTIONS(579),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_DASH] = ACTIONS(579),
    [anon_sym_DQUOTE] = ACTIONS(579),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_DOLLAR] = ACTIONS(579),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(579),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(579),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_word] = ACTIONS(579),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(579),
    [anon_sym_LF] = ACTIONS(579),
    [anon_sym_AMP] = ACTIONS(579),
  },
  [253] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [sym_file_descriptor] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(887),
    [anon_sym_PIPE_AMP] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_LT_LT_DASH] = ACTIONS(167),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_LF] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(887),
  },
  [254] = {
    [sym_for_statement] = STATE(375),
    [sym_while_statement] = STATE(375),
    [sym_if_statement] = STATE(375),
    [sym_case_statement] = STATE(375),
    [sym_function_definition] = STATE(375),
    [sym_subshell] = STATE(375),
    [sym_pipeline] = STATE(375),
    [sym_list] = STATE(375),
    [sym_bracket_command] = STATE(375),
    [sym_command] = STATE(375),
    [sym_environment_variable_assignment] = STATE(376),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(219),
    [sym_command_substitution] = STATE(219),
    [aux_sym_command_repeat1] = STATE(223),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_if] = ACTIONS(495),
    [anon_sym_case] = ACTIONS(497),
    [anon_sym_function] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(505),
    [anon_sym_COLON] = ACTIONS(507),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(511),
    [sym_comment] = ACTIONS(115),
  },
  [255] = {
    [sym_file_descriptor] = ACTIONS(375),
    [anon_sym_SEMI_SEMI] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_PIPE_AMP] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_AMP_GT] = ACTIONS(377),
    [anon_sym_AMP_GT_GT] = ACTIONS(377),
    [anon_sym_LT_AMP] = ACTIONS(377),
    [anon_sym_GT_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(377),
    [anon_sym_LF] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
  },
  [256] = {
    [sym_simple_expansion] = STATE(163),
    [sym_expansion] = STATE(163),
    [sym_command_substitution] = STATE(163),
    [anon_sym_DQUOTE] = ACTIONS(889),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [257] = {
    [sym_file_descriptor] = ACTIONS(525),
    [anon_sym_SEMI_SEMI] = ACTIONS(519),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_PIPE_AMP] = ACTIONS(519),
    [anon_sym_AMP_AMP] = ACTIONS(519),
    [anon_sym_PIPE_PIPE] = ACTIONS(519),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_GT] = ACTIONS(519),
    [anon_sym_AMP_GT] = ACTIONS(519),
    [anon_sym_AMP_GT_GT] = ACTIONS(519),
    [anon_sym_LT_AMP] = ACTIONS(519),
    [anon_sym_GT_AMP] = ACTIONS(519),
    [anon_sym_LT_LT] = ACTIONS(519),
    [anon_sym_LT_LT_DASH] = ACTIONS(519),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(519),
    [anon_sym_LF] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(519),
  },
  [258] = {
    [sym_file_descriptor] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PIPE_AMP] = ACTIONS(521),
    [anon_sym_AMP_AMP] = ACTIONS(521),
    [anon_sym_PIPE_PIPE] = ACTIONS(521),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_AMP_GT] = ACTIONS(521),
    [anon_sym_AMP_GT_GT] = ACTIONS(521),
    [anon_sym_LT_AMP] = ACTIONS(521),
    [anon_sym_GT_AMP] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_LT_LT_DASH] = ACTIONS(521),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(521),
    [anon_sym_LF] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
  },
  [259] = {
    [sym_file_descriptor] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(523),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(523),
    [anon_sym_PIPE_PIPE] = ACTIONS(523),
    [anon_sym_LT] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(523),
    [anon_sym_GT_GT] = ACTIONS(523),
    [anon_sym_AMP_GT] = ACTIONS(523),
    [anon_sym_AMP_GT_GT] = ACTIONS(523),
    [anon_sym_LT_AMP] = ACTIONS(523),
    [anon_sym_GT_AMP] = ACTIONS(523),
    [anon_sym_LT_LT] = ACTIONS(523),
    [anon_sym_LT_LT_DASH] = ACTIONS(523),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(523),
    [anon_sym_LF] = ACTIONS(523),
    [anon_sym_AMP] = ACTIONS(523),
  },
  [260] = {
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_COLON] = ACTIONS(893),
    [anon_sym_EQ] = ACTIONS(895),
    [anon_sym_COLON_QMARK] = ACTIONS(895),
    [anon_sym_COLON_DASH] = ACTIONS(895),
    [sym_comment] = ACTIONS(115),
  },
  [261] = {
    [anon_sym_RBRACE] = ACTIONS(897),
    [anon_sym_COLON] = ACTIONS(899),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_COLON_QMARK] = ACTIONS(901),
    [anon_sym_COLON_DASH] = ACTIONS(901),
    [sym_comment] = ACTIONS(115),
  },
  [262] = {
    [anon_sym_RPAREN] = ACTIONS(903),
    [sym_comment] = ACTIONS(115),
  },
  [263] = {
    [anon_sym_BQUOTE] = ACTIONS(903),
    [sym_comment] = ACTIONS(115),
  },
  [264] = {
    [sym__heredoc_middle] = ACTIONS(905),
    [sym__heredoc_end] = ACTIONS(905),
    [anon_sym_DOLLAR] = ACTIONS(907),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(905),
    [sym_comment] = ACTIONS(115),
  },
  [265] = {
    [sym_file_descriptor] = ACTIONS(909),
    [anon_sym_SEMI_SEMI] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_PIPE_AMP] = ACTIONS(911),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(911),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_GT] = ACTIONS(911),
    [anon_sym_AMP_GT] = ACTIONS(911),
    [anon_sym_AMP_GT_GT] = ACTIONS(911),
    [anon_sym_LT_AMP] = ACTIONS(911),
    [anon_sym_GT_AMP] = ACTIONS(911),
    [anon_sym_LT_LT] = ACTIONS(911),
    [anon_sym_LT_LT_DASH] = ACTIONS(911),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_LF] = ACTIONS(911),
    [anon_sym_AMP] = ACTIONS(911),
  },
  [266] = {
    [sym_special_variable_name] = STATE(385),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(73),
    [sym_simple_variable_name] = ACTIONS(915),
    [anon_sym_STAR] = ACTIONS(913),
    [anon_sym_AT] = ACTIONS(913),
    [anon_sym_POUND] = ACTIONS(917),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_BANG] = ACTIONS(913),
    [anon_sym_0] = ACTIONS(917),
    [anon_sym__] = ACTIONS(917),
  },
  [267] = {
    [sym_special_variable_name] = STATE(387),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_leading_word] = ACTIONS(919),
    [sym_comment] = ACTIONS(73),
    [anon_sym_STAR] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_POUND] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(277),
    [anon_sym_0] = ACTIONS(277),
    [anon_sym__] = ACTIONS(277),
  },
  [268] = {
    [sym_simple_expansion] = STATE(388),
    [sym_expansion] = STATE(388),
    [sym__heredoc_middle] = ACTIONS(921),
    [sym__heredoc_end] = ACTIONS(923),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(625),
    [sym_comment] = ACTIONS(115),
  },
  [269] = {
    [anon_sym_RPAREN] = ACTIONS(925),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [sym_comment] = ACTIONS(115),
  },
  [270] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(925),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(819),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(241),
    [anon_sym_GT] = ACTIONS(241),
    [anon_sym_GT_GT] = ACTIONS(241),
    [anon_sym_AMP_GT] = ACTIONS(241),
    [anon_sym_AMP_GT_GT] = ACTIONS(241),
    [anon_sym_LT_AMP] = ACTIONS(241),
    [anon_sym_GT_AMP] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_raw_string] = ACTIONS(241),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(115),
  },
  [271] = {
    [sym_file_descriptor] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(665),
    [anon_sym_PIPE] = ACTIONS(851),
    [anon_sym_PIPE_AMP] = ACTIONS(665),
    [anon_sym_AMP_AMP] = ACTIONS(851),
    [anon_sym_PIPE_PIPE] = ACTIONS(665),
    [anon_sym_COLON] = ACTIONS(665),
    [anon_sym_LT] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(851),
    [anon_sym_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_GT] = ACTIONS(851),
    [anon_sym_AMP_GT_GT] = ACTIONS(851),
    [anon_sym_LT_AMP] = ACTIONS(851),
    [anon_sym_GT_AMP] = ACTIONS(851),
    [anon_sym_DQUOTE] = ACTIONS(665),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(665),
    [anon_sym_BQUOTE] = ACTIONS(665),
    [sym_leading_word] = ACTIONS(667),
    [sym_comment] = ACTIONS(115),
  },
  [272] = {
    [sym_file_descriptor] = ACTIONS(853),
    [anon_sym_RPAREN] = ACTIONS(853),
    [anon_sym_PIPE] = ACTIONS(855),
    [anon_sym_PIPE_AMP] = ACTIONS(853),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_PIPE_PIPE] = ACTIONS(853),
    [anon_sym_COLON] = ACTIONS(853),
    [anon_sym_LT] = ACTIONS(855),
    [anon_sym_GT] = ACTIONS(855),
    [anon_sym_GT_GT] = ACTIONS(855),
    [anon_sym_AMP_GT] = ACTIONS(855),
    [anon_sym_AMP_GT_GT] = ACTIONS(855),
    [anon_sym_LT_AMP] = ACTIONS(855),
    [anon_sym_GT_AMP] = ACTIONS(855),
    [anon_sym_DQUOTE] = ACTIONS(853),
    [sym_raw_string] = ACTIONS(855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(853),
    [anon_sym_BQUOTE] = ACTIONS(853),
    [sym_leading_word] = ACTIONS(837),
    [sym_comment] = ACTIONS(115),
  },
  [273] = {
    [sym_string] = STATE(391),
    [sym_simple_expansion] = STATE(391),
    [sym_expansion] = STATE(391),
    [sym_command_substitution] = STATE(391),
    [sym_process_substitution] = STATE(391),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(929),
    [sym_comment] = ACTIONS(115),
  },
  [274] = {
    [sym_file_descriptor] = ACTIONS(861),
    [anon_sym_RPAREN] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(863),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(863),
    [anon_sym_GT_GT] = ACTIONS(863),
    [anon_sym_AMP_GT] = ACTIONS(863),
    [anon_sym_AMP_GT_GT] = ACTIONS(863),
    [anon_sym_LT_AMP] = ACTIONS(863),
    [anon_sym_GT_AMP] = ACTIONS(863),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(863),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [sym_leading_word] = ACTIONS(843),
    [sym_comment] = ACTIONS(115),
  },
  [275] = {
    [sym_string] = STATE(392),
    [sym_simple_expansion] = STATE(392),
    [sym_expansion] = STATE(392),
    [sym_command_substitution] = STATE(392),
    [sym_process_substitution] = STATE(392),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(931),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(933),
    [sym_comment] = ACTIONS(115),
  },
  [276] = {
    [sym_file_descriptor] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(869),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_COLON] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(869),
    [anon_sym_GT] = ACTIONS(869),
    [anon_sym_GT_GT] = ACTIONS(869),
    [anon_sym_AMP_GT] = ACTIONS(869),
    [anon_sym_AMP_GT_GT] = ACTIONS(869),
    [anon_sym_LT_AMP] = ACTIONS(869),
    [anon_sym_GT_AMP] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [sym_raw_string] = ACTIONS(869),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [sym_leading_word] = ACTIONS(733),
    [sym_comment] = ACTIONS(115),
  },
  [277] = {
    [anon_sym_DQUOTE] = ACTIONS(837),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(837),
    [anon_sym_DOLLAR] = ACTIONS(837),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(837),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_comment] = ACTIONS(73),
  },
  [278] = {
    [sym_string] = STATE(393),
    [sym_simple_expansion] = STATE(393),
    [sym_expansion] = STATE(393),
    [sym_command_substitution] = STATE(393),
    [sym_process_substitution] = STATE(393),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(935),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(937),
    [sym_comment] = ACTIONS(115),
  },
  [279] = {
    [anon_sym_DQUOTE] = ACTIONS(843),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(843),
    [anon_sym_DOLLAR] = ACTIONS(843),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(843),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_comment] = ACTIONS(73),
  },
  [280] = {
    [sym_string] = STATE(394),
    [sym_simple_expansion] = STATE(394),
    [sym_expansion] = STATE(394),
    [sym_command_substitution] = STATE(394),
    [sym_process_substitution] = STATE(394),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(941),
    [sym_comment] = ACTIONS(115),
  },
  [281] = {
    [anon_sym_DQUOTE] = ACTIONS(733),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(869),
    [sym_comment] = ACTIONS(73),
  },
  [282] = {
    [sym_string] = STATE(395),
    [sym_simple_expansion] = STATE(395),
    [sym_expansion] = STATE(395),
    [sym_command_substitution] = STATE(395),
    [sym_process_substitution] = STATE(395),
    [anon_sym_LT] = ACTIONS(703),
    [anon_sym_GT] = ACTIONS(703),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(943),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [sym_word] = ACTIONS(945),
    [sym_comment] = ACTIONS(115),
  },
  [283] = {
    [sym_string] = STATE(293),
    [sym_simple_expansion] = STATE(293),
    [sym_expansion] = STATE(293),
    [sym_command_substitution] = STATE(293),
    [sym_process_substitution] = STATE(293),
    [anon_sym_LPAREN] = ACTIONS(947),
    [anon_sym_LT] = ACTIONS(703),
    [anon_sym_GT] = ACTIONS(703),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(705),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [sym_word] = ACTIONS(707),
    [sym_comment] = ACTIONS(115),
  },
  [284] = {
    [sym_simple_expansion] = STATE(63),
    [sym_expansion] = STATE(63),
    [sym_command_substitution] = STATE(63),
    [aux_sym_string_repeat1] = STATE(398),
    [anon_sym_DQUOTE] = ACTIONS(949),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [285] = {
    [sym_file_descriptor] = ACTIONS(293),
    [anon_sym_RPAREN] = ACTIONS(293),
    [anon_sym_PIPE] = ACTIONS(291),
    [anon_sym_PIPE_AMP] = ACTIONS(293),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_GT] = ACTIONS(293),
    [anon_sym_AMP_GT] = ACTIONS(291),
    [anon_sym_AMP_GT_GT] = ACTIONS(293),
    [anon_sym_LT_AMP] = ACTIONS(293),
    [anon_sym_GT_AMP] = ACTIONS(293),
    [anon_sym_LT_LT] = ACTIONS(291),
    [anon_sym_LT_LT_DASH] = ACTIONS(293),
    [anon_sym_DQUOTE] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_DOLLAR] = ACTIONS(291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [anon_sym_BQUOTE] = ACTIONS(293),
    [sym_word] = ACTIONS(295),
    [sym_comment] = ACTIONS(115),
  },
  [286] = {
    [sym_special_variable_name] = STATE(401),
    [anon_sym_DOLLAR] = ACTIONS(951),
    [sym_comment] = ACTIONS(73),
    [sym_simple_variable_name] = ACTIONS(953),
    [anon_sym_STAR] = ACTIONS(951),
    [anon_sym_AT] = ACTIONS(951),
    [anon_sym_POUND] = ACTIONS(955),
    [anon_sym_QMARK] = ACTIONS(951),
    [anon_sym_DASH] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(951),
    [anon_sym_0] = ACTIONS(955),
    [anon_sym__] = ACTIONS(955),
  },
  [287] = {
    [sym_special_variable_name] = STATE(403),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_leading_word] = ACTIONS(957),
    [sym_comment] = ACTIONS(73),
    [anon_sym_STAR] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_POUND] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(277),
    [anon_sym_0] = ACTIONS(277),
    [anon_sym__] = ACTIONS(277),
  },
  [288] = {
    [sym_command] = STATE(404),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(75),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(207),
    [sym_comment] = ACTIONS(115),
  },
  [289] = {
    [sym_command] = STATE(405),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_command_repeat1] = STATE(79),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(213),
    [sym_comment] = ACTIONS(115),
  },
  [290] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_command_repeat2] = STATE(407),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(959),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(961),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [sym_word] = ACTIONS(963),
    [sym_comment] = ACTIONS(115),
  },
  [291] = {
    [sym_file_redirect] = STATE(297),
    [sym_heredoc_redirect] = STATE(297),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(965),
    [anon_sym_LT] = ACTIONS(683),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_BQUOTE] = ACTIONS(965),
    [sym_comment] = ACTIONS(115),
  },
  [292] = {
    [anon_sym_LPAREN] = ACTIONS(947),
    [sym_comment] = ACTIONS(115),
  },
  [293] = {
    [sym_file_descriptor] = ACTIONS(361),
    [anon_sym_RPAREN] = ACTIONS(361),
    [anon_sym_PIPE] = ACTIONS(363),
    [anon_sym_PIPE_AMP] = ACTIONS(361),
    [anon_sym_AMP_AMP] = ACTIONS(361),
    [anon_sym_PIPE_PIPE] = ACTIONS(361),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_AMP_GT] = ACTIONS(363),
    [anon_sym_AMP_GT_GT] = ACTIONS(361),
    [anon_sym_LT_AMP] = ACTIONS(361),
    [anon_sym_GT_AMP] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_LT_LT_DASH] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(361),
    [sym_comment] = ACTIONS(115),
  },
  [294] = {
    [sym_file_descriptor] = ACTIONS(615),
    [anon_sym_RPAREN] = ACTIONS(615),
    [anon_sym_PIPE] = ACTIONS(967),
    [anon_sym_PIPE_AMP] = ACTIONS(615),
    [anon_sym_AMP_AMP] = ACTIONS(615),
    [anon_sym_PIPE_PIPE] = ACTIONS(615),
    [anon_sym_LT] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(967),
    [anon_sym_GT_GT] = ACTIONS(615),
    [anon_sym_AMP_GT] = ACTIONS(967),
    [anon_sym_AMP_GT_GT] = ACTIONS(615),
    [anon_sym_LT_AMP] = ACTIONS(615),
    [anon_sym_GT_AMP] = ACTIONS(615),
    [anon_sym_LT_LT] = ACTIONS(967),
    [anon_sym_LT_LT_DASH] = ACTIONS(615),
    [anon_sym_BQUOTE] = ACTIONS(615),
    [sym_comment] = ACTIONS(115),
  },
  [295] = {
    [sym_simple_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [aux_sym_heredoc_repeat1] = STATE(409),
    [sym__heredoc_middle] = ACTIONS(619),
    [sym__heredoc_end] = ACTIONS(969),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(625),
    [sym_comment] = ACTIONS(115),
  },
  [296] = {
    [sym_file_descriptor] = ACTIONS(627),
    [anon_sym_RPAREN] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(971),
    [anon_sym_GT] = ACTIONS(971),
    [anon_sym_GT_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(971),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(971),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [sym_comment] = ACTIONS(115),
  },
  [297] = {
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_RPAREN] = ACTIONS(631),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_PIPE_AMP] = ACTIONS(631),
    [anon_sym_AMP_AMP] = ACTIONS(631),
    [anon_sym_PIPE_PIPE] = ACTIONS(631),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(631),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(631),
    [anon_sym_LT_AMP] = ACTIONS(631),
    [anon_sym_GT_AMP] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(631),
    [anon_sym_BQUOTE] = ACTIONS(631),
    [sym_comment] = ACTIONS(115),
  },
  [298] = {
    [sym_file_descriptor] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_PIPE] = ACTIONS(667),
    [anon_sym_PIPE_AMP] = ACTIONS(667),
    [anon_sym_AMP_AMP] = ACTIONS(667),
    [anon_sym_PIPE_PIPE] = ACTIONS(667),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(667),
    [anon_sym_GT] = ACTIONS(667),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(667),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_LT_LT] = ACTIONS(667),
    [anon_sym_LT_LT_DASH] = ACTIONS(667),
    [anon_sym_BQUOTE] = ACTIONS(667),
    [sym_comment] = ACTIONS(73),
  },
  [299] = {
    [sym_file_descriptor] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(73),
  },
  [300] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_command_repeat2] = STATE(410),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(975),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(961),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [sym_word] = ACTIONS(963),
    [sym_comment] = ACTIONS(115),
  },
  [301] = {
    [sym_file_redirect] = STATE(297),
    [sym_heredoc_redirect] = STATE(297),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(683),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [sym_comment] = ACTIONS(115),
  },
  [302] = {
    [sym_file_descriptor] = ACTIONS(749),
    [anon_sym_RPAREN] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_PIPE_AMP] = ACTIONS(749),
    [anon_sym_AMP_AMP] = ACTIONS(979),
    [anon_sym_PIPE_PIPE] = ACTIONS(749),
    [anon_sym_COLON] = ACTIONS(749),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(979),
    [anon_sym_AMP_GT] = ACTIONS(979),
    [anon_sym_AMP_GT_GT] = ACTIONS(979),
    [anon_sym_LT_AMP] = ACTIONS(979),
    [anon_sym_GT_AMP] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [sym_raw_string] = ACTIONS(979),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(749),
    [anon_sym_BQUOTE] = ACTIONS(749),
    [sym_leading_word] = ACTIONS(751),
    [sym_comment] = ACTIONS(115),
  },
  [303] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(285),
    [sym_simple_expansion] = STATE(285),
    [sym_expansion] = STATE(285),
    [sym_command_substitution] = STATE(285),
    [sym_process_substitution] = STATE(285),
    [aux_sym_bracket_command_repeat1] = STATE(411),
    [aux_sym_command_repeat2] = STATE(407),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(959),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(691),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [sym_word] = ACTIONS(701),
    [sym_comment] = ACTIONS(115),
  },
  [304] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(285),
    [sym_simple_expansion] = STATE(285),
    [sym_expansion] = STATE(285),
    [sym_command_substitution] = STATE(285),
    [sym_process_substitution] = STATE(285),
    [aux_sym_bracket_command_repeat1] = STATE(412),
    [aux_sym_command_repeat2] = STATE(413),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(981),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(691),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [sym_word] = ACTIONS(701),
    [sym_comment] = ACTIONS(115),
  },
  [305] = {
    [sym_file_redirect] = STATE(297),
    [sym_heredoc_redirect] = STATE(297),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(983),
    [anon_sym_LT] = ACTIONS(683),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_BQUOTE] = ACTIONS(983),
    [sym_comment] = ACTIONS(115),
  },
  [306] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_command_repeat2] = STATE(407),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(961),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(959),
    [sym_word] = ACTIONS(963),
    [sym_comment] = ACTIONS(115),
  },
  [307] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_command_repeat2] = STATE(410),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(961),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(975),
    [sym_word] = ACTIONS(963),
    [sym_comment] = ACTIONS(115),
  },
  [308] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(285),
    [sym_simple_expansion] = STATE(285),
    [sym_expansion] = STATE(285),
    [sym_command_substitution] = STATE(285),
    [sym_process_substitution] = STATE(285),
    [aux_sym_bracket_command_repeat1] = STATE(414),
    [aux_sym_command_repeat2] = STATE(407),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(691),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(959),
    [sym_word] = ACTIONS(701),
    [sym_comment] = ACTIONS(115),
  },
  [309] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(285),
    [sym_simple_expansion] = STATE(285),
    [sym_expansion] = STATE(285),
    [sym_command_substitution] = STATE(285),
    [sym_process_substitution] = STATE(285),
    [aux_sym_bracket_command_repeat1] = STATE(415),
    [aux_sym_command_repeat2] = STATE(413),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(691),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(981),
    [sym_word] = ACTIONS(701),
    [sym_comment] = ACTIONS(115),
  },
  [310] = {
    [sym__terminated_statement] = STATE(18),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_program_repeat1] = STATE(417),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [311] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(987),
    [anon_sym_PIPE] = ACTIONS(987),
    [anon_sym_PIPE_AMP] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(987),
    [anon_sym_PIPE_PIPE] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_LF] = ACTIONS(987),
    [anon_sym_AMP] = ACTIONS(987),
  },
  [312] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [sym_file_descriptor] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(989),
    [anon_sym_PIPE] = ACTIONS(989),
    [anon_sym_PIPE_AMP] = ACTIONS(989),
    [anon_sym_AMP_AMP] = ACTIONS(989),
    [anon_sym_PIPE_PIPE] = ACTIONS(989),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_LT_LT_DASH] = ACTIONS(167),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(989),
    [anon_sym_LF] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(989),
  },
  [313] = {
    [sym_for_statement] = STATE(418),
    [sym_while_statement] = STATE(418),
    [sym_if_statement] = STATE(418),
    [sym_case_statement] = STATE(418),
    [sym_function_definition] = STATE(418),
    [sym_subshell] = STATE(418),
    [sym_pipeline] = STATE(418),
    [sym_list] = STATE(418),
    [sym_bracket_command] = STATE(418),
    [sym_command] = STATE(418),
    [sym_environment_variable_assignment] = STATE(419),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(219),
    [sym_command_substitution] = STATE(219),
    [aux_sym_command_repeat1] = STATE(223),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_if] = ACTIONS(495),
    [anon_sym_case] = ACTIONS(497),
    [anon_sym_function] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(505),
    [anon_sym_COLON] = ACTIONS(507),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(511),
    [sym_comment] = ACTIONS(115),
  },
  [314] = {
    [sym_file_descriptor] = ACTIONS(375),
    [anon_sym_SEMI_SEMI] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_PIPE_AMP] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_AMP_GT] = ACTIONS(377),
    [anon_sym_AMP_GT_GT] = ACTIONS(377),
    [anon_sym_LT_AMP] = ACTIONS(377),
    [anon_sym_GT_AMP] = ACTIONS(377),
    [anon_sym_DQUOTE] = ACTIONS(377),
    [sym_raw_string] = ACTIONS(377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(377),
    [sym_leading_word] = ACTIONS(377),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(377),
    [anon_sym_LF] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
  },
  [315] = {
    [sym_simple_expansion] = STATE(163),
    [sym_expansion] = STATE(163),
    [sym_command_substitution] = STATE(163),
    [anon_sym_DQUOTE] = ACTIONS(991),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [316] = {
    [sym_file_descriptor] = ACTIONS(525),
    [anon_sym_SEMI_SEMI] = ACTIONS(519),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_PIPE_AMP] = ACTIONS(519),
    [anon_sym_AMP_AMP] = ACTIONS(519),
    [anon_sym_PIPE_PIPE] = ACTIONS(519),
    [anon_sym_COLON] = ACTIONS(519),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_GT] = ACTIONS(519),
    [anon_sym_AMP_GT] = ACTIONS(519),
    [anon_sym_AMP_GT_GT] = ACTIONS(519),
    [anon_sym_LT_AMP] = ACTIONS(519),
    [anon_sym_GT_AMP] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(519),
    [sym_raw_string] = ACTIONS(519),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(519),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [sym_leading_word] = ACTIONS(519),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(519),
    [anon_sym_LF] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(519),
  },
  [317] = {
    [sym_file_descriptor] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PIPE_AMP] = ACTIONS(521),
    [anon_sym_AMP_AMP] = ACTIONS(521),
    [anon_sym_PIPE_PIPE] = ACTIONS(521),
    [anon_sym_COLON] = ACTIONS(521),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_AMP_GT] = ACTIONS(521),
    [anon_sym_AMP_GT_GT] = ACTIONS(521),
    [anon_sym_LT_AMP] = ACTIONS(521),
    [anon_sym_GT_AMP] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(521),
    [sym_raw_string] = ACTIONS(521),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(521),
    [anon_sym_BQUOTE] = ACTIONS(521),
    [sym_leading_word] = ACTIONS(521),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(521),
    [anon_sym_LF] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
  },
  [318] = {
    [sym_file_descriptor] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(523),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(523),
    [anon_sym_PIPE_PIPE] = ACTIONS(523),
    [anon_sym_COLON] = ACTIONS(523),
    [anon_sym_LT] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(523),
    [anon_sym_GT_GT] = ACTIONS(523),
    [anon_sym_AMP_GT] = ACTIONS(523),
    [anon_sym_AMP_GT_GT] = ACTIONS(523),
    [anon_sym_LT_AMP] = ACTIONS(523),
    [anon_sym_GT_AMP] = ACTIONS(523),
    [anon_sym_DQUOTE] = ACTIONS(523),
    [sym_raw_string] = ACTIONS(523),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(523),
    [anon_sym_BQUOTE] = ACTIONS(523),
    [sym_leading_word] = ACTIONS(523),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(523),
    [anon_sym_LF] = ACTIONS(523),
    [anon_sym_AMP] = ACTIONS(523),
  },
  [319] = {
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_COLON] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(997),
    [anon_sym_COLON_QMARK] = ACTIONS(997),
    [anon_sym_COLON_DASH] = ACTIONS(997),
    [sym_comment] = ACTIONS(115),
  },
  [320] = {
    [anon_sym_RBRACE] = ACTIONS(999),
    [anon_sym_COLON] = ACTIONS(1001),
    [anon_sym_EQ] = ACTIONS(1003),
    [anon_sym_COLON_QMARK] = ACTIONS(1003),
    [anon_sym_COLON_DASH] = ACTIONS(1003),
    [sym_comment] = ACTIONS(115),
  },
  [321] = {
    [anon_sym_RPAREN] = ACTIONS(1005),
    [sym_comment] = ACTIONS(115),
  },
  [322] = {
    [anon_sym_BQUOTE] = ACTIONS(1005),
    [sym_comment] = ACTIONS(115),
  },
  [323] = {
    [sym_file_redirect] = STATE(53),
    [sym_heredoc_redirect] = STATE(53),
    [sym_string] = STATE(252),
    [sym_simple_expansion] = STATE(252),
    [sym_expansion] = STATE(252),
    [sym_command_substitution] = STATE(252),
    [sym_process_substitution] = STATE(252),
    [aux_sym_command_repeat2] = STATE(426),
    [sym_file_descriptor] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_PIPE_AMP] = ACTIONS(1007),
    [anon_sym_AMP_AMP] = ACTIONS(1007),
    [anon_sym_PIPE_PIPE] = ACTIONS(1007),
    [anon_sym_LT] = ACTIONS(317),
    [anon_sym_GT] = ACTIONS(317),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_LT_LT_DASH] = ACTIONS(167),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [sym_raw_string] = ACTIONS(599),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(327),
    [anon_sym_BQUOTE] = ACTIONS(329),
    [sym_word] = ACTIONS(599),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1007),
    [anon_sym_LF] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
  },
  [324] = {
    [sym_file_redirect] = STATE(53),
    [sym_heredoc_redirect] = STATE(53),
    [sym_string] = STATE(252),
    [sym_simple_expansion] = STATE(252),
    [sym_expansion] = STATE(252),
    [sym_command_substitution] = STATE(252),
    [sym_process_substitution] = STATE(252),
    [aux_sym_command_repeat2] = STATE(427),
    [sym_file_descriptor] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(1009),
    [anon_sym_PIPE] = ACTIONS(1009),
    [anon_sym_PIPE_AMP] = ACTIONS(1009),
    [anon_sym_AMP_AMP] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE] = ACTIONS(1009),
    [anon_sym_LT] = ACTIONS(317),
    [anon_sym_GT] = ACTIONS(317),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_LT_LT_DASH] = ACTIONS(167),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [sym_raw_string] = ACTIONS(599),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(327),
    [anon_sym_BQUOTE] = ACTIONS(329),
    [sym_word] = ACTIONS(599),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1009),
    [anon_sym_LF] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1009),
  },
  [325] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [sym_file_descriptor] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_LT_LT_DASH] = ACTIONS(167),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1011),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1011),
  },
  [326] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_PIPE_AMP] = ACTIONS(1013),
    [anon_sym_AMP_AMP] = ACTIONS(1013),
    [anon_sym_PIPE_PIPE] = ACTIONS(1013),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_LF] = ACTIONS(1013),
    [anon_sym_AMP] = ACTIONS(1013),
  },
  [327] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1015),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_PIPE_AMP] = ACTIONS(1015),
    [anon_sym_AMP_AMP] = ACTIONS(1015),
    [anon_sym_PIPE_PIPE] = ACTIONS(1015),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1015),
    [anon_sym_LF] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1015),
  },
  [328] = {
    [anon_sym_then] = ACTIONS(1017),
    [sym_comment] = ACTIONS(115),
  },
  [329] = {
    [sym__terminated_statement] = STATE(87),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_fi] = ACTIONS(1019),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [330] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1021),
    [anon_sym_PIPE_AMP] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(1021),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1021),
    [anon_sym_LF] = ACTIONS(1021),
    [anon_sym_AMP] = ACTIONS(1021),
  },
  [331] = {
    [anon_sym_fi] = ACTIONS(1023),
    [sym_comment] = ACTIONS(115),
  },
  [332] = {
    [sym_elif_clause] = STATE(333),
    [sym_else_clause] = STATE(430),
    [anon_sym_fi] = ACTIONS(1023),
    [anon_sym_elif] = ACTIONS(787),
    [anon_sym_else] = ACTIONS(789),
    [sym_comment] = ACTIONS(115),
  },
  [333] = {
    [anon_sym_fi] = ACTIONS(1025),
    [anon_sym_elif] = ACTIONS(1025),
    [anon_sym_else] = ACTIONS(1025),
    [sym_comment] = ACTIONS(115),
  },
  [334] = {
    [anon_sym_in] = ACTIONS(1027),
    [sym_comment] = ACTIONS(115),
  },
  [335] = {
    [sym_do_group] = STATE(433),
    [anon_sym_do] = ACTIONS(1029),
    [sym_comment] = ACTIONS(115),
  },
  [336] = {
    [anon_sym_then] = ACTIONS(1031),
    [sym_comment] = ACTIONS(115),
  },
  [337] = {
    [anon_sym_in] = ACTIONS(1033),
    [anon_sym_SEMI_SEMI] = ACTIONS(1035),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1035),
    [anon_sym_LF] = ACTIONS(1035),
    [anon_sym_AMP] = ACTIONS(1035),
  },
  [338] = {
    [anon_sym_LPAREN] = ACTIONS(1037),
    [sym_comment] = ACTIONS(115),
  },
  [339] = {
    [anon_sym_RPAREN] = ACTIONS(1039),
    [anon_sym_PIPE] = ACTIONS(1041),
    [anon_sym_PIPE_AMP] = ACTIONS(1039),
    [anon_sym_AMP_AMP] = ACTIONS(1039),
    [anon_sym_PIPE_PIPE] = ACTIONS(1039),
    [sym_comment] = ACTIONS(115),
  },
  [340] = {
    [sym__terminated_statement] = STATE(87),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_RPAREN] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [341] = {
    [sym_string] = STATE(123),
    [sym_simple_expansion] = STATE(123),
    [sym_expansion] = STATE(123),
    [sym_command_substitution] = STATE(123),
    [sym_process_substitution] = STATE(123),
    [anon_sym_RBRACK] = ACTIONS(1045),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(309),
    [sym_comment] = ACTIONS(115),
  },
  [342] = {
    [sym_string] = STATE(123),
    [sym_simple_expansion] = STATE(123),
    [sym_expansion] = STATE(123),
    [sym_command_substitution] = STATE(123),
    [sym_process_substitution] = STATE(123),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1045),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(309),
    [sym_comment] = ACTIONS(115),
  },
  [343] = {
    [anon_sym_LT] = ACTIONS(1047),
    [anon_sym_GT] = ACTIONS(1047),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_AMP_GT] = ACTIONS(1047),
    [anon_sym_AMP_GT_GT] = ACTIONS(1049),
    [anon_sym_LT_AMP] = ACTIONS(1049),
    [anon_sym_GT_AMP] = ACTIONS(1049),
    [sym_comment] = ACTIONS(115),
  },
  [344] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(285),
    [sym_simple_expansion] = STATE(285),
    [sym_expansion] = STATE(285),
    [sym_command_substitution] = STATE(285),
    [sym_process_substitution] = STATE(285),
    [aux_sym_bracket_command_repeat1] = STATE(442),
    [aux_sym_command_repeat2] = STATE(443),
    [sym_file_descriptor] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_PIPE] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(677),
    [anon_sym_AMP_AMP] = ACTIONS(677),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT_GT] = ACTIONS(1055),
    [anon_sym_LT_AMP] = ACTIONS(1055),
    [anon_sym_GT_AMP] = ACTIONS(1055),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(691),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [sym_word] = ACTIONS(701),
    [sym_comment] = ACTIONS(115),
  },
  [345] = {
    [sym_string] = STATE(293),
    [sym_simple_expansion] = STATE(293),
    [sym_expansion] = STATE(293),
    [sym_command_substitution] = STATE(293),
    [sym_process_substitution] = STATE(293),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(705),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1067),
    [anon_sym_BQUOTE] = ACTIONS(1069),
    [sym_word] = ACTIONS(707),
    [sym_comment] = ACTIONS(115),
  },
  [346] = {
    [sym_file_redirect] = STATE(297),
    [sym_heredoc_redirect] = STATE(297),
    [sym_file_descriptor] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(715),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1057),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT_GT] = ACTIONS(1055),
    [anon_sym_LT_AMP] = ACTIONS(1055),
    [anon_sym_GT_AMP] = ACTIONS(1055),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [sym_comment] = ACTIONS(115),
  },
  [347] = {
    [anon_sym_RPAREN] = ACTIONS(1073),
    [sym_comment] = ACTIONS(115),
  },
  [348] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(285),
    [sym_simple_expansion] = STATE(285),
    [sym_expansion] = STATE(285),
    [sym_command_substitution] = STATE(285),
    [sym_process_substitution] = STATE(285),
    [aux_sym_bracket_command_repeat1] = STATE(451),
    [aux_sym_command_repeat2] = STATE(452),
    [sym_file_descriptor] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(721),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_PIPE_AMP] = ACTIONS(721),
    [anon_sym_AMP_AMP] = ACTIONS(721),
    [anon_sym_PIPE_PIPE] = ACTIONS(1075),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT_GT] = ACTIONS(1055),
    [anon_sym_LT_AMP] = ACTIONS(1055),
    [anon_sym_GT_AMP] = ACTIONS(1055),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(691),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [sym_word] = ACTIONS(701),
    [sym_comment] = ACTIONS(115),
  },
  [349] = {
    [sym_file_redirect] = STATE(297),
    [sym_heredoc_redirect] = STATE(297),
    [sym_file_descriptor] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(729),
    [anon_sym_PIPE] = ACTIONS(1077),
    [anon_sym_PIPE_AMP] = ACTIONS(729),
    [anon_sym_AMP_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(729),
    [anon_sym_LT] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1057),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT_GT] = ACTIONS(1055),
    [anon_sym_LT_AMP] = ACTIONS(1055),
    [anon_sym_GT_AMP] = ACTIONS(1055),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [sym_comment] = ACTIONS(115),
  },
  [350] = {
    [anon_sym_in] = ACTIONS(1079),
    [anon_sym_SEMI_SEMI] = ACTIONS(1079),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1079),
    [anon_sym_LF] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
  },
  [351] = {
    [sym_for_statement] = STATE(453),
    [sym_while_statement] = STATE(453),
    [sym_if_statement] = STATE(453),
    [sym_case_statement] = STATE(453),
    [sym_function_definition] = STATE(453),
    [sym_subshell] = STATE(453),
    [sym_pipeline] = STATE(453),
    [sym_list] = STATE(453),
    [sym_bracket_command] = STATE(453),
    [sym_command] = STATE(453),
    [sym_environment_variable_assignment] = STATE(454),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(219),
    [sym_command_substitution] = STATE(219),
    [aux_sym_command_repeat1] = STATE(223),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_if] = ACTIONS(495),
    [anon_sym_case] = ACTIONS(497),
    [anon_sym_function] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(505),
    [anon_sym_COLON] = ACTIONS(507),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(511),
    [sym_comment] = ACTIONS(115),
  },
  [352] = {
    [sym_for_statement] = STATE(455),
    [sym_while_statement] = STATE(455),
    [sym_if_statement] = STATE(455),
    [sym_case_statement] = STATE(455),
    [sym_function_definition] = STATE(455),
    [sym_subshell] = STATE(455),
    [sym_pipeline] = STATE(455),
    [sym_list] = STATE(455),
    [sym_bracket_command] = STATE(455),
    [sym_command] = STATE(455),
    [sym_environment_variable_assignment] = STATE(456),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(219),
    [sym_command_substitution] = STATE(219),
    [aux_sym_command_repeat1] = STATE(223),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_if] = ACTIONS(495),
    [anon_sym_case] = ACTIONS(497),
    [anon_sym_function] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(505),
    [anon_sym_COLON] = ACTIONS(507),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(511),
    [sym_comment] = ACTIONS(115),
  },
  [353] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [aux_sym_command_repeat2] = STATE(443),
    [sym_file_descriptor] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_PIPE_AMP] = ACTIONS(355),
    [anon_sym_AMP_AMP] = ACTIONS(355),
    [anon_sym_PIPE_PIPE] = ACTIONS(355),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(805),
    [anon_sym_GT] = ACTIONS(805),
    [anon_sym_GT_GT] = ACTIONS(805),
    [anon_sym_AMP_GT] = ACTIONS(805),
    [anon_sym_AMP_GT_GT] = ACTIONS(805),
    [anon_sym_LT_AMP] = ACTIONS(805),
    [anon_sym_GT_AMP] = ACTIONS(805),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [sym_comment] = ACTIONS(73),
  },
  [354] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [aux_sym_command_repeat2] = STATE(459),
    [sym_file_descriptor] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_PIPE_AMP] = ACTIONS(465),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE_PIPE] = ACTIONS(465),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(1083),
    [anon_sym_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(805),
    [anon_sym_GT] = ACTIONS(805),
    [anon_sym_GT_GT] = ACTIONS(805),
    [anon_sym_AMP_GT] = ACTIONS(805),
    [anon_sym_AMP_GT_GT] = ACTIONS(805),
    [anon_sym_LT_AMP] = ACTIONS(805),
    [anon_sym_GT_AMP] = ACTIONS(805),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [sym_comment] = ACTIONS(73),
  },
  [355] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1085),
    [anon_sym_LF] = ACTIONS(1085),
    [anon_sym_AMP] = ACTIONS(1085),
  },
  [356] = {
    [anon_sym_RPAREN] = ACTIONS(1087),
    [sym_comment] = ACTIONS(115),
  },
  [357] = {
    [sym_special_variable_name] = STATE(117),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [sym_comment] = ACTIONS(73),
    [sym_simple_variable_name] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_AT] = ACTIONS(1089),
    [anon_sym_POUND] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_DASH] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_0] = ACTIONS(277),
    [anon_sym__] = ACTIONS(277),
  },
  [358] = {
    [anon_sym_esac] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [sym_word] = ACTIONS(1095),
    [sym_comment] = ACTIONS(115),
  },
  [359] = {
    [sym_case_item] = STATE(462),
    [sym_string] = STATE(356),
    [sym_simple_expansion] = STATE(356),
    [sym_expansion] = STATE(356),
    [sym_command_substitution] = STATE(356),
    [sym_process_substitution] = STATE(356),
    [anon_sym_esac] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(829),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(833),
    [sym_comment] = ACTIONS(115),
  },
  [360] = {
    [sym_case_item] = STATE(358),
    [sym_string] = STATE(356),
    [sym_simple_expansion] = STATE(356),
    [sym_expansion] = STATE(356),
    [sym_command_substitution] = STATE(356),
    [sym_process_substitution] = STATE(356),
    [aux_sym_case_statement_repeat1] = STATE(463),
    [anon_sym_esac] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(829),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(833),
    [sym_comment] = ACTIONS(115),
  },
  [361] = {
    [anon_sym_RBRACE] = ACTIONS(1099),
    [sym_comment] = ACTIONS(115),
  },
  [362] = {
    [anon_sym_RBRACE] = ACTIONS(1101),
    [sym_comment] = ACTIONS(115),
  },
  [363] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_PIPE_AMP] = ACTIONS(1103),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [364] = {
    [anon_sym_RPAREN] = ACTIONS(1105),
    [anon_sym_RBRACE] = ACTIONS(1105),
    [anon_sym_RBRACK] = ACTIONS(1107),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [sym_word] = ACTIONS(1079),
    [sym_comment] = ACTIONS(115),
  },
  [365] = {
    [anon_sym_RBRACE] = ACTIONS(1109),
    [sym_comment] = ACTIONS(115),
  },
  [366] = {
    [anon_sym_RBRACE] = ACTIONS(1111),
    [sym_comment] = ACTIONS(115),
  },
  [367] = {
    [anon_sym_RPAREN] = ACTIONS(1113),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [sym_comment] = ACTIONS(115),
  },
  [368] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(1113),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(819),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(241),
    [anon_sym_GT] = ACTIONS(241),
    [anon_sym_GT_GT] = ACTIONS(241),
    [anon_sym_AMP_GT] = ACTIONS(241),
    [anon_sym_AMP_GT_GT] = ACTIONS(241),
    [anon_sym_LT_AMP] = ACTIONS(241),
    [anon_sym_GT_AMP] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_raw_string] = ACTIONS(241),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(115),
  },
  [369] = {
    [sym_file_descriptor] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(667),
    [anon_sym_PIPE] = ACTIONS(667),
    [anon_sym_PIPE_AMP] = ACTIONS(667),
    [anon_sym_AMP_AMP] = ACTIONS(667),
    [anon_sym_PIPE_PIPE] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(667),
    [anon_sym_GT] = ACTIONS(667),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(667),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_LT_LT] = ACTIONS(667),
    [anon_sym_LT_LT_DASH] = ACTIONS(667),
    [anon_sym_DQUOTE] = ACTIONS(667),
    [sym_raw_string] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(667),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(667),
    [anon_sym_BQUOTE] = ACTIONS(667),
    [sym_word] = ACTIONS(667),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_LF] = ACTIONS(667),
    [anon_sym_AMP] = ACTIONS(667),
  },
  [370] = {
    [sym_file_descriptor] = ACTIONS(853),
    [anon_sym_SEMI_SEMI] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_PIPE_AMP] = ACTIONS(837),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_AMP_GT] = ACTIONS(837),
    [anon_sym_AMP_GT_GT] = ACTIONS(837),
    [anon_sym_LT_AMP] = ACTIONS(837),
    [anon_sym_GT_AMP] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_LT_LT_DASH] = ACTIONS(837),
    [anon_sym_DQUOTE] = ACTIONS(837),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_DOLLAR] = ACTIONS(837),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(837),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [sym_word] = ACTIONS(837),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_LF] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(837),
  },
  [371] = {
    [sym_string] = STATE(469),
    [sym_simple_expansion] = STATE(469),
    [sym_expansion] = STATE(469),
    [sym_command_substitution] = STATE(469),
    [sym_process_substitution] = STATE(469),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(1117),
    [sym_comment] = ACTIONS(115),
  },
  [372] = {
    [sym_file_descriptor] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(843),
    [anon_sym_PIPE] = ACTIONS(843),
    [anon_sym_PIPE_AMP] = ACTIONS(843),
    [anon_sym_AMP_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_GT] = ACTIONS(843),
    [anon_sym_AMP_GT] = ACTIONS(843),
    [anon_sym_AMP_GT_GT] = ACTIONS(843),
    [anon_sym_LT_AMP] = ACTIONS(843),
    [anon_sym_GT_AMP] = ACTIONS(843),
    [anon_sym_LT_LT] = ACTIONS(843),
    [anon_sym_LT_LT_DASH] = ACTIONS(843),
    [anon_sym_DQUOTE] = ACTIONS(843),
    [sym_raw_string] = ACTIONS(843),
    [anon_sym_DOLLAR] = ACTIONS(843),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(843),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(843),
    [sym_word] = ACTIONS(843),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(843),
    [anon_sym_LF] = ACTIONS(843),
    [anon_sym_AMP] = ACTIONS(843),
  },
  [373] = {
    [sym_string] = STATE(470),
    [sym_simple_expansion] = STATE(470),
    [sym_expansion] = STATE(470),
    [sym_command_substitution] = STATE(470),
    [sym_process_substitution] = STATE(470),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(1121),
    [sym_comment] = ACTIONS(115),
  },
  [374] = {
    [sym_file_descriptor] = ACTIONS(731),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [sym_word] = ACTIONS(733),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [375] = {
    [anon_sym_RPAREN] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [sym_comment] = ACTIONS(115),
  },
  [376] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(819),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(241),
    [anon_sym_GT] = ACTIONS(241),
    [anon_sym_GT_GT] = ACTIONS(241),
    [anon_sym_AMP_GT] = ACTIONS(241),
    [anon_sym_AMP_GT_GT] = ACTIONS(241),
    [anon_sym_LT_AMP] = ACTIONS(241),
    [anon_sym_GT_AMP] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_raw_string] = ACTIONS(241),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(115),
  },
  [377] = {
    [sym_file_descriptor] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(667),
    [anon_sym_PIPE] = ACTIONS(667),
    [anon_sym_PIPE_AMP] = ACTIONS(667),
    [anon_sym_AMP_AMP] = ACTIONS(667),
    [anon_sym_PIPE_PIPE] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(667),
    [anon_sym_GT] = ACTIONS(667),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(667),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_LT_LT] = ACTIONS(667),
    [anon_sym_LT_LT_DASH] = ACTIONS(667),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_LF] = ACTIONS(667),
    [anon_sym_AMP] = ACTIONS(667),
  },
  [378] = {
    [sym_file_descriptor] = ACTIONS(853),
    [anon_sym_SEMI_SEMI] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_PIPE_AMP] = ACTIONS(837),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_AMP_GT] = ACTIONS(837),
    [anon_sym_AMP_GT_GT] = ACTIONS(837),
    [anon_sym_LT_AMP] = ACTIONS(837),
    [anon_sym_GT_AMP] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_LT_LT_DASH] = ACTIONS(837),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_LF] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(837),
  },
  [379] = {
    [sym_string] = STATE(472),
    [sym_simple_expansion] = STATE(472),
    [sym_expansion] = STATE(472),
    [sym_command_substitution] = STATE(472),
    [sym_process_substitution] = STATE(472),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(1125),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(1127),
    [sym_comment] = ACTIONS(115),
  },
  [380] = {
    [sym_file_descriptor] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(843),
    [anon_sym_PIPE] = ACTIONS(843),
    [anon_sym_PIPE_AMP] = ACTIONS(843),
    [anon_sym_AMP_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_GT] = ACTIONS(843),
    [anon_sym_AMP_GT] = ACTIONS(843),
    [anon_sym_AMP_GT_GT] = ACTIONS(843),
    [anon_sym_LT_AMP] = ACTIONS(843),
    [anon_sym_GT_AMP] = ACTIONS(843),
    [anon_sym_LT_LT] = ACTIONS(843),
    [anon_sym_LT_LT_DASH] = ACTIONS(843),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(843),
    [anon_sym_LF] = ACTIONS(843),
    [anon_sym_AMP] = ACTIONS(843),
  },
  [381] = {
    [sym_string] = STATE(473),
    [sym_simple_expansion] = STATE(473),
    [sym_expansion] = STATE(473),
    [sym_command_substitution] = STATE(473),
    [sym_process_substitution] = STATE(473),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(1129),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(1131),
    [sym_comment] = ACTIONS(115),
  },
  [382] = {
    [sym_file_descriptor] = ACTIONS(731),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(733),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [383] = {
    [sym__heredoc_middle] = ACTIONS(525),
    [sym__heredoc_end] = ACTIONS(525),
    [anon_sym_DOLLAR] = ACTIONS(527),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(525),
    [sym_comment] = ACTIONS(115),
  },
  [384] = {
    [sym__heredoc_middle] = ACTIONS(551),
    [sym__heredoc_end] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [sym_comment] = ACTIONS(115),
  },
  [385] = {
    [sym__heredoc_middle] = ACTIONS(555),
    [sym__heredoc_end] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [sym_comment] = ACTIONS(115),
  },
  [386] = {
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_COLON] = ACTIONS(1135),
    [anon_sym_EQ] = ACTIONS(1137),
    [anon_sym_COLON_QMARK] = ACTIONS(1137),
    [anon_sym_COLON_DASH] = ACTIONS(1137),
    [sym_comment] = ACTIONS(115),
  },
  [387] = {
    [anon_sym_RBRACE] = ACTIONS(1139),
    [anon_sym_COLON] = ACTIONS(1141),
    [anon_sym_EQ] = ACTIONS(1143),
    [anon_sym_COLON_QMARK] = ACTIONS(1143),
    [anon_sym_COLON_DASH] = ACTIONS(1143),
    [sym_comment] = ACTIONS(115),
  },
  [388] = {
    [sym__heredoc_middle] = ACTIONS(1145),
    [sym__heredoc_end] = ACTIONS(1145),
    [anon_sym_DOLLAR] = ACTIONS(1147),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1145),
    [sym_comment] = ACTIONS(115),
  },
  [389] = {
    [sym_file_descriptor] = ACTIONS(1149),
    [anon_sym_SEMI_SEMI] = ACTIONS(1151),
    [anon_sym_PIPE] = ACTIONS(1151),
    [anon_sym_PIPE_AMP] = ACTIONS(1151),
    [anon_sym_AMP_AMP] = ACTIONS(1151),
    [anon_sym_PIPE_PIPE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(1151),
    [anon_sym_GT] = ACTIONS(1151),
    [anon_sym_GT_GT] = ACTIONS(1151),
    [anon_sym_AMP_GT] = ACTIONS(1151),
    [anon_sym_AMP_GT_GT] = ACTIONS(1151),
    [anon_sym_LT_AMP] = ACTIONS(1151),
    [anon_sym_GT_AMP] = ACTIONS(1151),
    [anon_sym_LT_LT] = ACTIONS(1151),
    [anon_sym_LT_LT_DASH] = ACTIONS(1151),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1151),
    [anon_sym_LF] = ACTIONS(1151),
    [anon_sym_AMP] = ACTIONS(1151),
  },
  [390] = {
    [sym_file_descriptor] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_COLON] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_AMP] = ACTIONS(1107),
    [anon_sym_GT_AMP] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [sym_leading_word] = ACTIONS(1079),
    [sym_comment] = ACTIONS(115),
  },
  [391] = {
    [anon_sym_RBRACE] = ACTIONS(1153),
    [sym_comment] = ACTIONS(115),
  },
  [392] = {
    [anon_sym_RBRACE] = ACTIONS(1155),
    [sym_comment] = ACTIONS(115),
  },
  [393] = {
    [anon_sym_RBRACE] = ACTIONS(1157),
    [sym_comment] = ACTIONS(115),
  },
  [394] = {
    [anon_sym_RBRACE] = ACTIONS(1159),
    [sym_comment] = ACTIONS(115),
  },
  [395] = {
    [sym_file_descriptor] = ACTIONS(475),
    [anon_sym_RPAREN] = ACTIONS(475),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_PIPE_AMP] = ACTIONS(475),
    [anon_sym_AMP_AMP] = ACTIONS(475),
    [anon_sym_PIPE_PIPE] = ACTIONS(475),
    [anon_sym_LT] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(475),
    [anon_sym_AMP_GT] = ACTIONS(477),
    [anon_sym_AMP_GT_GT] = ACTIONS(475),
    [anon_sym_LT_AMP] = ACTIONS(475),
    [anon_sym_GT_AMP] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_DASH] = ACTIONS(475),
    [anon_sym_BQUOTE] = ACTIONS(475),
    [sym_comment] = ACTIONS(115),
  },
  [396] = {
    [sym_for_statement] = STATE(482),
    [sym_while_statement] = STATE(482),
    [sym_if_statement] = STATE(482),
    [sym_case_statement] = STATE(482),
    [sym_function_definition] = STATE(482),
    [sym_subshell] = STATE(482),
    [sym_pipeline] = STATE(482),
    [sym_list] = STATE(482),
    [sym_bracket_command] = STATE(482),
    [sym_command] = STATE(482),
    [sym_environment_variable_assignment] = STATE(483),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(219),
    [sym_command_substitution] = STATE(219),
    [aux_sym_command_repeat1] = STATE(223),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_if] = ACTIONS(495),
    [anon_sym_case] = ACTIONS(497),
    [anon_sym_function] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(505),
    [anon_sym_COLON] = ACTIONS(507),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(511),
    [sym_comment] = ACTIONS(115),
  },
  [397] = {
    [sym_file_descriptor] = ACTIONS(375),
    [anon_sym_RPAREN] = ACTIONS(375),
    [anon_sym_PIPE] = ACTIONS(547),
    [anon_sym_PIPE_AMP] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(375),
    [anon_sym_LT_AMP] = ACTIONS(375),
    [anon_sym_GT_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(547),
    [anon_sym_LT_LT_DASH] = ACTIONS(375),
    [anon_sym_DQUOTE] = ACTIONS(375),
    [sym_raw_string] = ACTIONS(547),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(375),
    [anon_sym_BQUOTE] = ACTIONS(375),
    [sym_word] = ACTIONS(377),
    [sym_comment] = ACTIONS(115),
  },
  [398] = {
    [sym_simple_expansion] = STATE(163),
    [sym_expansion] = STATE(163),
    [sym_command_substitution] = STATE(163),
    [anon_sym_DQUOTE] = ACTIONS(1161),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [399] = {
    [sym_file_descriptor] = ACTIONS(525),
    [anon_sym_RPAREN] = ACTIONS(525),
    [anon_sym_PIPE] = ACTIONS(527),
    [anon_sym_PIPE_AMP] = ACTIONS(525),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(527),
    [anon_sym_GT] = ACTIONS(527),
    [anon_sym_GT_GT] = ACTIONS(525),
    [anon_sym_AMP_GT] = ACTIONS(527),
    [anon_sym_AMP_GT_GT] = ACTIONS(525),
    [anon_sym_LT_AMP] = ACTIONS(525),
    [anon_sym_GT_AMP] = ACTIONS(525),
    [anon_sym_LT_LT] = ACTIONS(527),
    [anon_sym_LT_LT_DASH] = ACTIONS(525),
    [anon_sym_DQUOTE] = ACTIONS(525),
    [sym_raw_string] = ACTIONS(527),
    [anon_sym_DOLLAR] = ACTIONS(527),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(525),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(525),
    [anon_sym_BQUOTE] = ACTIONS(525),
    [sym_word] = ACTIONS(519),
    [sym_comment] = ACTIONS(115),
  },
  [400] = {
    [sym_file_descriptor] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(553),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(553),
    [anon_sym_GT_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(553),
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(553),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(553),
    [anon_sym_DOLLAR] = ACTIONS(553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [sym_word] = ACTIONS(521),
    [sym_comment] = ACTIONS(115),
  },
  [401] = {
    [sym_file_descriptor] = ACTIONS(555),
    [anon_sym_RPAREN] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(557),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(557),
    [anon_sym_GT] = ACTIONS(557),
    [anon_sym_GT_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(557),
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(557),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(557),
    [anon_sym_DOLLAR] = ACTIONS(557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [sym_word] = ACTIONS(523),
    [sym_comment] = ACTIONS(115),
  },
  [402] = {
    [anon_sym_RBRACE] = ACTIONS(1163),
    [anon_sym_COLON] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_COLON_QMARK] = ACTIONS(1167),
    [anon_sym_COLON_DASH] = ACTIONS(1167),
    [sym_comment] = ACTIONS(115),
  },
  [403] = {
    [anon_sym_RBRACE] = ACTIONS(1169),
    [anon_sym_COLON] = ACTIONS(1171),
    [anon_sym_EQ] = ACTIONS(1173),
    [anon_sym_COLON_QMARK] = ACTIONS(1173),
    [anon_sym_COLON_DASH] = ACTIONS(1173),
    [sym_comment] = ACTIONS(115),
  },
  [404] = {
    [anon_sym_RPAREN] = ACTIONS(1175),
    [sym_comment] = ACTIONS(115),
  },
  [405] = {
    [anon_sym_BQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(115),
  },
  [406] = {
    [sym_file_descriptor] = ACTIONS(577),
    [anon_sym_RPAREN] = ACTIONS(577),
    [anon_sym_PIPE] = ACTIONS(575),
    [anon_sym_PIPE_AMP] = ACTIONS(577),
    [anon_sym_AMP_AMP] = ACTIONS(577),
    [anon_sym_PIPE_PIPE] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_GT] = ACTIONS(575),
    [anon_sym_GT_GT] = ACTIONS(577),
    [anon_sym_AMP_GT] = ACTIONS(575),
    [anon_sym_AMP_GT_GT] = ACTIONS(577),
    [anon_sym_LT_AMP] = ACTIONS(577),
    [anon_sym_GT_AMP] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_LT_LT_DASH] = ACTIONS(577),
    [anon_sym_DQUOTE] = ACTIONS(577),
    [sym_raw_string] = ACTIONS(575),
    [anon_sym_DOLLAR] = ACTIONS(575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(577),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(577),
    [anon_sym_BQUOTE] = ACTIONS(577),
    [sym_word] = ACTIONS(579),
    [sym_comment] = ACTIONS(115),
  },
  [407] = {
    [sym_file_redirect] = STATE(297),
    [sym_heredoc_redirect] = STATE(297),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(1177),
    [anon_sym_LT] = ACTIONS(683),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_comment] = ACTIONS(115),
  },
  [408] = {
    [sym_file_descriptor] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_PIPE_AMP] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(1179),
    [anon_sym_GT] = ACTIONS(1179),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_AMP_GT] = ACTIONS(1179),
    [anon_sym_AMP_GT_GT] = ACTIONS(909),
    [anon_sym_LT_AMP] = ACTIONS(909),
    [anon_sym_GT_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(1179),
    [anon_sym_LT_LT_DASH] = ACTIONS(909),
    [anon_sym_BQUOTE] = ACTIONS(909),
    [sym_comment] = ACTIONS(115),
  },
  [409] = {
    [sym_simple_expansion] = STATE(388),
    [sym_expansion] = STATE(388),
    [sym__heredoc_middle] = ACTIONS(921),
    [sym__heredoc_end] = ACTIONS(1181),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(625),
    [sym_comment] = ACTIONS(115),
  },
  [410] = {
    [sym_file_redirect] = STATE(297),
    [sym_heredoc_redirect] = STATE(297),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(1183),
    [anon_sym_LT] = ACTIONS(683),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_BQUOTE] = ACTIONS(1183),
    [sym_comment] = ACTIONS(115),
  },
  [411] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_command_repeat2] = STATE(491),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(961),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [sym_word] = ACTIONS(963),
    [sym_comment] = ACTIONS(115),
  },
  [412] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_command_repeat2] = STATE(492),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(961),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [sym_word] = ACTIONS(963),
    [sym_comment] = ACTIONS(115),
  },
  [413] = {
    [sym_file_redirect] = STATE(297),
    [sym_heredoc_redirect] = STATE(297),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(1189),
    [anon_sym_LT] = ACTIONS(683),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_BQUOTE] = ACTIONS(1189),
    [sym_comment] = ACTIONS(115),
  },
  [414] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_command_repeat2] = STATE(491),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(961),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(1185),
    [sym_word] = ACTIONS(963),
    [sym_comment] = ACTIONS(115),
  },
  [415] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_command_repeat2] = STATE(492),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(961),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [sym_word] = ACTIONS(963),
    [sym_comment] = ACTIONS(115),
  },
  [416] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1191),
    [anon_sym_PIPE] = ACTIONS(1191),
    [anon_sym_PIPE_AMP] = ACTIONS(1191),
    [anon_sym_AMP_AMP] = ACTIONS(1191),
    [anon_sym_PIPE_PIPE] = ACTIONS(1191),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1191),
    [anon_sym_LF] = ACTIONS(1191),
    [anon_sym_AMP] = ACTIONS(1191),
  },
  [417] = {
    [sym__terminated_statement] = STATE(87),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [418] = {
    [anon_sym_RPAREN] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [sym_comment] = ACTIONS(115),
  },
  [419] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(819),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(241),
    [anon_sym_GT] = ACTIONS(241),
    [anon_sym_GT_GT] = ACTIONS(241),
    [anon_sym_AMP_GT] = ACTIONS(241),
    [anon_sym_AMP_GT_GT] = ACTIONS(241),
    [anon_sym_LT_AMP] = ACTIONS(241),
    [anon_sym_GT_AMP] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_raw_string] = ACTIONS(241),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(115),
  },
  [420] = {
    [sym_file_descriptor] = ACTIONS(665),
    [anon_sym_SEMI_SEMI] = ACTIONS(667),
    [anon_sym_PIPE] = ACTIONS(667),
    [anon_sym_PIPE_AMP] = ACTIONS(667),
    [anon_sym_AMP_AMP] = ACTIONS(667),
    [anon_sym_PIPE_PIPE] = ACTIONS(667),
    [anon_sym_COLON] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(667),
    [anon_sym_GT] = ACTIONS(667),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(667),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_DQUOTE] = ACTIONS(667),
    [sym_raw_string] = ACTIONS(667),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(667),
    [anon_sym_BQUOTE] = ACTIONS(667),
    [sym_leading_word] = ACTIONS(667),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_LF] = ACTIONS(667),
    [anon_sym_AMP] = ACTIONS(667),
  },
  [421] = {
    [sym_file_descriptor] = ACTIONS(853),
    [anon_sym_SEMI_SEMI] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_PIPE_AMP] = ACTIONS(837),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_COLON] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_AMP_GT] = ACTIONS(837),
    [anon_sym_AMP_GT_GT] = ACTIONS(837),
    [anon_sym_LT_AMP] = ACTIONS(837),
    [anon_sym_GT_AMP] = ACTIONS(837),
    [anon_sym_DQUOTE] = ACTIONS(837),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(837),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [sym_leading_word] = ACTIONS(837),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_LF] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(837),
  },
  [422] = {
    [sym_string] = STATE(495),
    [sym_simple_expansion] = STATE(495),
    [sym_expansion] = STATE(495),
    [sym_command_substitution] = STATE(495),
    [sym_process_substitution] = STATE(495),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(1197),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(1199),
    [sym_comment] = ACTIONS(115),
  },
  [423] = {
    [sym_file_descriptor] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(843),
    [anon_sym_PIPE] = ACTIONS(843),
    [anon_sym_PIPE_AMP] = ACTIONS(843),
    [anon_sym_AMP_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_GT] = ACTIONS(843),
    [anon_sym_AMP_GT] = ACTIONS(843),
    [anon_sym_AMP_GT_GT] = ACTIONS(843),
    [anon_sym_LT_AMP] = ACTIONS(843),
    [anon_sym_GT_AMP] = ACTIONS(843),
    [anon_sym_DQUOTE] = ACTIONS(843),
    [sym_raw_string] = ACTIONS(843),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(843),
    [sym_leading_word] = ACTIONS(843),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(843),
    [anon_sym_LF] = ACTIONS(843),
    [anon_sym_AMP] = ACTIONS(843),
  },
  [424] = {
    [sym_string] = STATE(496),
    [sym_simple_expansion] = STATE(496),
    [sym_expansion] = STATE(496),
    [sym_command_substitution] = STATE(496),
    [sym_process_substitution] = STATE(496),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(1201),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(1203),
    [sym_comment] = ACTIONS(115),
  },
  [425] = {
    [sym_file_descriptor] = ACTIONS(731),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [sym_leading_word] = ACTIONS(733),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [426] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [sym_file_descriptor] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(1205),
    [anon_sym_PIPE] = ACTIONS(1205),
    [anon_sym_PIPE_AMP] = ACTIONS(1205),
    [anon_sym_AMP_AMP] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_LT_LT_DASH] = ACTIONS(167),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1205),
    [anon_sym_LF] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1205),
  },
  [427] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [sym_file_descriptor] = ACTIONS(159),
    [anon_sym_SEMI_SEMI] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PIPE_AMP] = ACTIONS(1207),
    [anon_sym_AMP_AMP] = ACTIONS(1207),
    [anon_sym_PIPE_PIPE] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_LT_LT_DASH] = ACTIONS(167),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LF] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
  },
  [428] = {
    [sym__terminated_statement] = STATE(18),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_program_repeat1] = STATE(497),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_fi] = ACTIONS(1209),
    [anon_sym_elif] = ACTIONS(1209),
    [anon_sym_else] = ACTIONS(1209),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [429] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1211),
    [anon_sym_PIPE] = ACTIONS(1211),
    [anon_sym_PIPE_AMP] = ACTIONS(1211),
    [anon_sym_AMP_AMP] = ACTIONS(1211),
    [anon_sym_PIPE_PIPE] = ACTIONS(1211),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym_LF] = ACTIONS(1211),
    [anon_sym_AMP] = ACTIONS(1211),
  },
  [430] = {
    [anon_sym_fi] = ACTIONS(1213),
    [sym_comment] = ACTIONS(115),
  },
  [431] = {
    [sym__terminated_statement] = STATE(499),
    [sym_for_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_function_definition] = STATE(27),
    [sym_subshell] = STATE(27),
    [sym_pipeline] = STATE(27),
    [sym_list] = STATE(27),
    [sym_bracket_command] = STATE(27),
    [sym_command] = STATE(27),
    [sym_environment_variable_assignment] = STATE(28),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [432] = {
    [sym__terminated_statement] = STATE(18),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_program_repeat1] = STATE(501),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_done] = ACTIONS(1215),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [433] = {
    [anon_sym_RPAREN] = ACTIONS(1217),
    [anon_sym_PIPE] = ACTIONS(1219),
    [anon_sym_PIPE_AMP] = ACTIONS(1217),
    [anon_sym_AMP_AMP] = ACTIONS(1217),
    [anon_sym_PIPE_PIPE] = ACTIONS(1217),
    [sym_comment] = ACTIONS(115),
  },
  [434] = {
    [sym__terminated_statement] = STATE(18),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_elif_clause] = STATE(207),
    [sym_else_clause] = STATE(503),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_program_repeat1] = STATE(504),
    [aux_sym_if_statement_repeat1] = STATE(505),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_fi] = ACTIONS(1221),
    [anon_sym_elif] = ACTIONS(487),
    [anon_sym_else] = ACTIONS(489),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [435] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1223),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LF] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1223),
  },
  [436] = {
    [anon_sym_in] = ACTIONS(1225),
    [sym_comment] = ACTIONS(115),
  },
  [437] = {
    [anon_sym_RPAREN] = ACTIONS(1227),
    [sym_comment] = ACTIONS(115),
  },
  [438] = {
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_PIPE_AMP] = ACTIONS(1229),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [sym_comment] = ACTIONS(115),
  },
  [439] = {
    [anon_sym_RPAREN] = ACTIONS(1233),
    [anon_sym_PIPE] = ACTIONS(1235),
    [anon_sym_PIPE_AMP] = ACTIONS(1233),
    [anon_sym_AMP_AMP] = ACTIONS(1233),
    [anon_sym_PIPE_PIPE] = ACTIONS(1233),
    [sym_comment] = ACTIONS(115),
  },
  [440] = {
    [sym_string] = STATE(395),
    [sym_simple_expansion] = STATE(395),
    [sym_expansion] = STATE(395),
    [sym_command_substitution] = STATE(395),
    [sym_process_substitution] = STATE(395),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(943),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1067),
    [anon_sym_BQUOTE] = ACTIONS(1069),
    [sym_word] = ACTIONS(945),
    [sym_comment] = ACTIONS(115),
  },
  [441] = {
    [sym_string] = STATE(293),
    [sym_simple_expansion] = STATE(293),
    [sym_expansion] = STATE(293),
    [sym_command_substitution] = STATE(293),
    [sym_process_substitution] = STATE(293),
    [anon_sym_LPAREN] = ACTIONS(947),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(705),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1067),
    [anon_sym_BQUOTE] = ACTIONS(1069),
    [sym_word] = ACTIONS(707),
    [sym_comment] = ACTIONS(115),
  },
  [442] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_command_repeat2] = STATE(509),
    [sym_file_descriptor] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(1237),
    [anon_sym_PIPE_AMP] = ACTIONS(959),
    [anon_sym_AMP_AMP] = ACTIONS(959),
    [anon_sym_PIPE_PIPE] = ACTIONS(1237),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT_GT] = ACTIONS(1055),
    [anon_sym_LT_AMP] = ACTIONS(1055),
    [anon_sym_GT_AMP] = ACTIONS(1055),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(961),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [sym_word] = ACTIONS(963),
    [sym_comment] = ACTIONS(115),
  },
  [443] = {
    [sym_file_redirect] = STATE(297),
    [sym_heredoc_redirect] = STATE(297),
    [sym_file_descriptor] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(1239),
    [anon_sym_PIPE_AMP] = ACTIONS(965),
    [anon_sym_AMP_AMP] = ACTIONS(965),
    [anon_sym_PIPE_PIPE] = ACTIONS(965),
    [anon_sym_LT] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1057),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT_GT] = ACTIONS(1055),
    [anon_sym_LT_AMP] = ACTIONS(1055),
    [anon_sym_GT_AMP] = ACTIONS(1055),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [sym_comment] = ACTIONS(115),
  },
  [444] = {
    [anon_sym_LPAREN] = ACTIONS(1241),
    [sym_comment] = ACTIONS(115),
  },
  [445] = {
    [sym_simple_expansion] = STATE(63),
    [sym_expansion] = STATE(63),
    [sym_command_substitution] = STATE(63),
    [aux_sym_string_repeat1] = STATE(512),
    [anon_sym_DQUOTE] = ACTIONS(1243),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [446] = {
    [sym_special_variable_name] = STATE(515),
    [anon_sym_DOLLAR] = ACTIONS(1245),
    [sym_comment] = ACTIONS(73),
    [sym_simple_variable_name] = ACTIONS(1247),
    [anon_sym_STAR] = ACTIONS(1245),
    [anon_sym_AT] = ACTIONS(1245),
    [anon_sym_POUND] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1245),
    [anon_sym_BANG] = ACTIONS(1245),
    [anon_sym_0] = ACTIONS(1249),
    [anon_sym__] = ACTIONS(1249),
  },
  [447] = {
    [sym_special_variable_name] = STATE(517),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_leading_word] = ACTIONS(1251),
    [sym_comment] = ACTIONS(73),
    [anon_sym_STAR] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_POUND] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(277),
    [anon_sym_0] = ACTIONS(277),
    [anon_sym__] = ACTIONS(277),
  },
  [448] = {
    [sym_command] = STATE(518),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(75),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(207),
    [sym_comment] = ACTIONS(115),
  },
  [449] = {
    [sym_command] = STATE(519),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_command_repeat1] = STATE(79),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(213),
    [sym_comment] = ACTIONS(115),
  },
  [450] = {
    [sym_compound_statement] = STATE(521),
    [anon_sym_LBRACE] = ACTIONS(1253),
    [sym_comment] = ACTIONS(115),
  },
  [451] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_command_repeat2] = STATE(522),
    [sym_file_descriptor] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_PIPE_AMP] = ACTIONS(975),
    [anon_sym_AMP_AMP] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT_GT] = ACTIONS(1055),
    [anon_sym_LT_AMP] = ACTIONS(1055),
    [anon_sym_GT_AMP] = ACTIONS(1055),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(961),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [sym_word] = ACTIONS(963),
    [sym_comment] = ACTIONS(115),
  },
  [452] = {
    [sym_file_redirect] = STATE(297),
    [sym_heredoc_redirect] = STATE(297),
    [sym_file_descriptor] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1057),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT_GT] = ACTIONS(1055),
    [anon_sym_LT_AMP] = ACTIONS(1055),
    [anon_sym_GT_AMP] = ACTIONS(1055),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [sym_comment] = ACTIONS(115),
  },
  [453] = {
    [anon_sym_RPAREN] = ACTIONS(1259),
    [anon_sym_PIPE] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1259),
    [anon_sym_AMP_AMP] = ACTIONS(1259),
    [anon_sym_PIPE_PIPE] = ACTIONS(1259),
    [sym_comment] = ACTIONS(115),
  },
  [454] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(1259),
    [anon_sym_PIPE] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1259),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1259),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(241),
    [anon_sym_GT] = ACTIONS(241),
    [anon_sym_GT_GT] = ACTIONS(241),
    [anon_sym_AMP_GT] = ACTIONS(241),
    [anon_sym_AMP_GT_GT] = ACTIONS(241),
    [anon_sym_LT_AMP] = ACTIONS(241),
    [anon_sym_GT_AMP] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_raw_string] = ACTIONS(241),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(115),
  },
  [455] = {
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [sym_comment] = ACTIONS(115),
  },
  [456] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(241),
    [anon_sym_GT] = ACTIONS(241),
    [anon_sym_GT_GT] = ACTIONS(241),
    [anon_sym_AMP_GT] = ACTIONS(241),
    [anon_sym_AMP_GT_GT] = ACTIONS(241),
    [anon_sym_LT_AMP] = ACTIONS(241),
    [anon_sym_GT_AMP] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_raw_string] = ACTIONS(241),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(115),
  },
  [457] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(285),
    [sym_simple_expansion] = STATE(285),
    [sym_expansion] = STATE(285),
    [sym_command_substitution] = STATE(285),
    [sym_process_substitution] = STATE(285),
    [aux_sym_bracket_command_repeat1] = STATE(523),
    [aux_sym_command_repeat2] = STATE(509),
    [sym_file_descriptor] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(1237),
    [anon_sym_PIPE_AMP] = ACTIONS(959),
    [anon_sym_AMP_AMP] = ACTIONS(959),
    [anon_sym_PIPE_PIPE] = ACTIONS(1237),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT_GT] = ACTIONS(1055),
    [anon_sym_LT_AMP] = ACTIONS(1055),
    [anon_sym_GT_AMP] = ACTIONS(1055),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(691),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [sym_word] = ACTIONS(701),
    [sym_comment] = ACTIONS(115),
  },
  [458] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(285),
    [sym_simple_expansion] = STATE(285),
    [sym_expansion] = STATE(285),
    [sym_command_substitution] = STATE(285),
    [sym_process_substitution] = STATE(285),
    [aux_sym_bracket_command_repeat1] = STATE(524),
    [aux_sym_command_repeat2] = STATE(525),
    [sym_file_descriptor] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(981),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(981),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT_GT] = ACTIONS(1055),
    [anon_sym_LT_AMP] = ACTIONS(1055),
    [anon_sym_GT_AMP] = ACTIONS(1055),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(691),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [sym_word] = ACTIONS(701),
    [sym_comment] = ACTIONS(115),
  },
  [459] = {
    [sym_file_redirect] = STATE(297),
    [sym_heredoc_redirect] = STATE(297),
    [sym_file_descriptor] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(983),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_PIPE_AMP] = ACTIONS(983),
    [anon_sym_AMP_AMP] = ACTIONS(983),
    [anon_sym_PIPE_PIPE] = ACTIONS(983),
    [anon_sym_LT] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1057),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT_GT] = ACTIONS(1055),
    [anon_sym_LT_AMP] = ACTIONS(1055),
    [anon_sym_GT_AMP] = ACTIONS(1055),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [sym_comment] = ACTIONS(115),
  },
  [460] = {
    [sym__terminated_statement] = STATE(18),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_program_repeat1] = STATE(527),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [461] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1273),
    [anon_sym_PIPE_AMP] = ACTIONS(1273),
    [anon_sym_AMP_AMP] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE] = ACTIONS(1273),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(1273),
  },
  [462] = {
    [anon_sym_esac] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1277),
    [anon_sym_GT] = ACTIONS(1277),
    [anon_sym_DQUOTE] = ACTIONS(1277),
    [sym_raw_string] = ACTIONS(1275),
    [anon_sym_DOLLAR] = ACTIONS(1275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1277),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1277),
    [anon_sym_BQUOTE] = ACTIONS(1277),
    [sym_word] = ACTIONS(1279),
    [sym_comment] = ACTIONS(115),
  },
  [463] = {
    [sym_case_item] = STATE(462),
    [sym_string] = STATE(356),
    [sym_simple_expansion] = STATE(356),
    [sym_expansion] = STATE(356),
    [sym_command_substitution] = STATE(356),
    [sym_process_substitution] = STATE(356),
    [anon_sym_esac] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(829),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(833),
    [sym_comment] = ACTIONS(115),
  },
  [464] = {
    [anon_sym_in] = ACTIONS(1283),
    [anon_sym_SEMI_SEMI] = ACTIONS(1283),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_LF] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1283),
  },
  [465] = {
    [anon_sym_in] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [466] = {
    [anon_sym_RPAREN] = ACTIONS(1287),
    [anon_sym_RBRACE] = ACTIONS(1287),
    [anon_sym_RBRACK] = ACTIONS(1289),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1287),
    [anon_sym_GT] = ACTIONS(1287),
    [anon_sym_DQUOTE] = ACTIONS(1287),
    [sym_raw_string] = ACTIONS(1289),
    [anon_sym_DOLLAR] = ACTIONS(1289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1287),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1287),
    [anon_sym_BQUOTE] = ACTIONS(1287),
    [sym_word] = ACTIONS(1283),
    [sym_comment] = ACTIONS(115),
  },
  [467] = {
    [anon_sym_RPAREN] = ACTIONS(1291),
    [anon_sym_RBRACE] = ACTIONS(1291),
    [anon_sym_RBRACK] = ACTIONS(1293),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1291),
    [anon_sym_GT] = ACTIONS(1291),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [sym_raw_string] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1293),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1291),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1291),
    [anon_sym_BQUOTE] = ACTIONS(1291),
    [sym_word] = ACTIONS(1285),
    [sym_comment] = ACTIONS(115),
  },
  [468] = {
    [sym_file_descriptor] = ACTIONS(1105),
    [anon_sym_SEMI_SEMI] = ACTIONS(1079),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PIPE_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1079),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT_GT] = ACTIONS(1079),
    [anon_sym_LT_AMP] = ACTIONS(1079),
    [anon_sym_GT_AMP] = ACTIONS(1079),
    [anon_sym_LT_LT] = ACTIONS(1079),
    [anon_sym_LT_LT_DASH] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(1079),
    [sym_raw_string] = ACTIONS(1079),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1079),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1079),
    [anon_sym_BQUOTE] = ACTIONS(1079),
    [sym_word] = ACTIONS(1079),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1079),
    [anon_sym_LF] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
  },
  [469] = {
    [anon_sym_RBRACE] = ACTIONS(1295),
    [sym_comment] = ACTIONS(115),
  },
  [470] = {
    [anon_sym_RBRACE] = ACTIONS(1297),
    [sym_comment] = ACTIONS(115),
  },
  [471] = {
    [sym_file_descriptor] = ACTIONS(1105),
    [anon_sym_SEMI_SEMI] = ACTIONS(1079),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PIPE_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1079),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT_GT] = ACTIONS(1079),
    [anon_sym_LT_AMP] = ACTIONS(1079),
    [anon_sym_GT_AMP] = ACTIONS(1079),
    [anon_sym_LT_LT] = ACTIONS(1079),
    [anon_sym_LT_LT_DASH] = ACTIONS(1079),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1079),
    [anon_sym_LF] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
  },
  [472] = {
    [anon_sym_RBRACE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(115),
  },
  [473] = {
    [anon_sym_RBRACE] = ACTIONS(1301),
    [sym_comment] = ACTIONS(115),
  },
  [474] = {
    [sym__heredoc_middle] = ACTIONS(853),
    [sym__heredoc_end] = ACTIONS(853),
    [anon_sym_DOLLAR] = ACTIONS(855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(853),
    [sym_comment] = ACTIONS(115),
  },
  [475] = {
    [sym_string] = STATE(533),
    [sym_simple_expansion] = STATE(533),
    [sym_expansion] = STATE(533),
    [sym_command_substitution] = STATE(533),
    [sym_process_substitution] = STATE(533),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(1303),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(1305),
    [sym_comment] = ACTIONS(115),
  },
  [476] = {
    [sym__heredoc_middle] = ACTIONS(861),
    [sym__heredoc_end] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [sym_comment] = ACTIONS(115),
  },
  [477] = {
    [sym_string] = STATE(534),
    [sym_simple_expansion] = STATE(534),
    [sym_expansion] = STATE(534),
    [sym_command_substitution] = STATE(534),
    [sym_process_substitution] = STATE(534),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(1307),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(1309),
    [sym_comment] = ACTIONS(115),
  },
  [478] = {
    [sym_file_descriptor] = ACTIONS(1287),
    [anon_sym_RPAREN] = ACTIONS(1287),
    [anon_sym_PIPE] = ACTIONS(1289),
    [anon_sym_PIPE_AMP] = ACTIONS(1287),
    [anon_sym_AMP_AMP] = ACTIONS(1289),
    [anon_sym_PIPE_PIPE] = ACTIONS(1287),
    [anon_sym_COLON] = ACTIONS(1287),
    [anon_sym_LT] = ACTIONS(1289),
    [anon_sym_GT] = ACTIONS(1289),
    [anon_sym_GT_GT] = ACTIONS(1289),
    [anon_sym_AMP_GT] = ACTIONS(1289),
    [anon_sym_AMP_GT_GT] = ACTIONS(1289),
    [anon_sym_LT_AMP] = ACTIONS(1289),
    [anon_sym_GT_AMP] = ACTIONS(1289),
    [anon_sym_DQUOTE] = ACTIONS(1287),
    [sym_raw_string] = ACTIONS(1289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1287),
    [anon_sym_BQUOTE] = ACTIONS(1287),
    [sym_leading_word] = ACTIONS(1283),
    [sym_comment] = ACTIONS(115),
  },
  [479] = {
    [sym_file_descriptor] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1291),
    [anon_sym_PIPE] = ACTIONS(1293),
    [anon_sym_PIPE_AMP] = ACTIONS(1291),
    [anon_sym_AMP_AMP] = ACTIONS(1293),
    [anon_sym_PIPE_PIPE] = ACTIONS(1291),
    [anon_sym_COLON] = ACTIONS(1291),
    [anon_sym_LT] = ACTIONS(1293),
    [anon_sym_GT] = ACTIONS(1293),
    [anon_sym_GT_GT] = ACTIONS(1293),
    [anon_sym_AMP_GT] = ACTIONS(1293),
    [anon_sym_AMP_GT_GT] = ACTIONS(1293),
    [anon_sym_LT_AMP] = ACTIONS(1293),
    [anon_sym_GT_AMP] = ACTIONS(1293),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [sym_raw_string] = ACTIONS(1293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1291),
    [anon_sym_BQUOTE] = ACTIONS(1291),
    [sym_leading_word] = ACTIONS(1285),
    [sym_comment] = ACTIONS(115),
  },
  [480] = {
    [anon_sym_DQUOTE] = ACTIONS(1283),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1283),
    [anon_sym_DOLLAR] = ACTIONS(1283),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1283),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_BQUOTE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(73),
  },
  [481] = {
    [anon_sym_DQUOTE] = ACTIONS(1285),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(1285),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1293),
    [sym_comment] = ACTIONS(73),
  },
  [482] = {
    [anon_sym_RPAREN] = ACTIONS(1311),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [sym_comment] = ACTIONS(115),
  },
  [483] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(1311),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(819),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(241),
    [anon_sym_GT] = ACTIONS(241),
    [anon_sym_GT_GT] = ACTIONS(241),
    [anon_sym_AMP_GT] = ACTIONS(241),
    [anon_sym_AMP_GT_GT] = ACTIONS(241),
    [anon_sym_LT_AMP] = ACTIONS(241),
    [anon_sym_GT_AMP] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_raw_string] = ACTIONS(241),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(115),
  },
  [484] = {
    [sym_file_descriptor] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(665),
    [anon_sym_PIPE] = ACTIONS(851),
    [anon_sym_PIPE_AMP] = ACTIONS(665),
    [anon_sym_AMP_AMP] = ACTIONS(665),
    [anon_sym_PIPE_PIPE] = ACTIONS(851),
    [anon_sym_LT] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(851),
    [anon_sym_GT_GT] = ACTIONS(665),
    [anon_sym_AMP_GT] = ACTIONS(851),
    [anon_sym_AMP_GT_GT] = ACTIONS(665),
    [anon_sym_LT_AMP] = ACTIONS(665),
    [anon_sym_GT_AMP] = ACTIONS(665),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_LT_LT_DASH] = ACTIONS(665),
    [anon_sym_DQUOTE] = ACTIONS(665),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_DOLLAR] = ACTIONS(851),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(665),
    [anon_sym_BQUOTE] = ACTIONS(665),
    [sym_word] = ACTIONS(667),
    [sym_comment] = ACTIONS(115),
  },
  [485] = {
    [sym_file_descriptor] = ACTIONS(853),
    [anon_sym_RPAREN] = ACTIONS(853),
    [anon_sym_PIPE] = ACTIONS(855),
    [anon_sym_PIPE_AMP] = ACTIONS(853),
    [anon_sym_AMP_AMP] = ACTIONS(853),
    [anon_sym_PIPE_PIPE] = ACTIONS(855),
    [anon_sym_LT] = ACTIONS(855),
    [anon_sym_GT] = ACTIONS(855),
    [anon_sym_GT_GT] = ACTIONS(853),
    [anon_sym_AMP_GT] = ACTIONS(855),
    [anon_sym_AMP_GT_GT] = ACTIONS(853),
    [anon_sym_LT_AMP] = ACTIONS(853),
    [anon_sym_GT_AMP] = ACTIONS(853),
    [anon_sym_LT_LT] = ACTIONS(855),
    [anon_sym_LT_LT_DASH] = ACTIONS(853),
    [anon_sym_DQUOTE] = ACTIONS(853),
    [sym_raw_string] = ACTIONS(855),
    [anon_sym_DOLLAR] = ACTIONS(855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(853),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(853),
    [anon_sym_BQUOTE] = ACTIONS(853),
    [sym_word] = ACTIONS(837),
    [sym_comment] = ACTIONS(115),
  },
  [486] = {
    [sym_string] = STATE(536),
    [sym_simple_expansion] = STATE(536),
    [sym_expansion] = STATE(536),
    [sym_command_substitution] = STATE(536),
    [sym_process_substitution] = STATE(536),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(1313),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(1315),
    [sym_comment] = ACTIONS(115),
  },
  [487] = {
    [sym_file_descriptor] = ACTIONS(861),
    [anon_sym_RPAREN] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(863),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(863),
    [anon_sym_LT] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(863),
    [anon_sym_GT_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(863),
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(863),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(863),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [sym_word] = ACTIONS(843),
    [sym_comment] = ACTIONS(115),
  },
  [488] = {
    [sym_string] = STATE(537),
    [sym_simple_expansion] = STATE(537),
    [sym_expansion] = STATE(537),
    [sym_command_substitution] = STATE(537),
    [sym_process_substitution] = STATE(537),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(1317),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(1319),
    [sym_comment] = ACTIONS(115),
  },
  [489] = {
    [sym_file_descriptor] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(869),
    [anon_sym_LT] = ACTIONS(869),
    [anon_sym_GT] = ACTIONS(869),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(869),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(869),
    [anon_sym_LT_LT_DASH] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(731),
    [sym_raw_string] = ACTIONS(869),
    [anon_sym_DOLLAR] = ACTIONS(869),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [sym_word] = ACTIONS(733),
    [sym_comment] = ACTIONS(115),
  },
  [490] = {
    [sym_file_descriptor] = ACTIONS(1149),
    [anon_sym_RPAREN] = ACTIONS(1149),
    [anon_sym_PIPE] = ACTIONS(1321),
    [anon_sym_PIPE_AMP] = ACTIONS(1149),
    [anon_sym_AMP_AMP] = ACTIONS(1149),
    [anon_sym_PIPE_PIPE] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(1321),
    [anon_sym_GT] = ACTIONS(1321),
    [anon_sym_GT_GT] = ACTIONS(1149),
    [anon_sym_AMP_GT] = ACTIONS(1321),
    [anon_sym_AMP_GT_GT] = ACTIONS(1149),
    [anon_sym_LT_AMP] = ACTIONS(1149),
    [anon_sym_GT_AMP] = ACTIONS(1149),
    [anon_sym_LT_LT] = ACTIONS(1321),
    [anon_sym_LT_LT_DASH] = ACTIONS(1149),
    [anon_sym_BQUOTE] = ACTIONS(1149),
    [sym_comment] = ACTIONS(115),
  },
  [491] = {
    [sym_file_redirect] = STATE(297),
    [sym_heredoc_redirect] = STATE(297),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(1323),
    [anon_sym_LT] = ACTIONS(683),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_BQUOTE] = ACTIONS(1323),
    [sym_comment] = ACTIONS(115),
  },
  [492] = {
    [sym_file_redirect] = STATE(297),
    [sym_heredoc_redirect] = STATE(297),
    [sym_file_descriptor] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(1325),
    [anon_sym_LT] = ACTIONS(683),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_AMP_GT] = ACTIONS(683),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_BQUOTE] = ACTIONS(1325),
    [sym_comment] = ACTIONS(115),
  },
  [493] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_PIPE_AMP] = ACTIONS(1327),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1327),
    [anon_sym_LF] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
  },
  [494] = {
    [sym_file_descriptor] = ACTIONS(1105),
    [anon_sym_SEMI_SEMI] = ACTIONS(1079),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PIPE_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1079),
    [anon_sym_COLON] = ACTIONS(1079),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT_GT] = ACTIONS(1079),
    [anon_sym_LT_AMP] = ACTIONS(1079),
    [anon_sym_GT_AMP] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(1079),
    [sym_raw_string] = ACTIONS(1079),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1079),
    [anon_sym_BQUOTE] = ACTIONS(1079),
    [sym_leading_word] = ACTIONS(1079),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1079),
    [anon_sym_LF] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
  },
  [495] = {
    [anon_sym_RBRACE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(115),
  },
  [496] = {
    [anon_sym_RBRACE] = ACTIONS(1331),
    [sym_comment] = ACTIONS(115),
  },
  [497] = {
    [sym__terminated_statement] = STATE(87),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_fi] = ACTIONS(1333),
    [anon_sym_elif] = ACTIONS(1333),
    [anon_sym_else] = ACTIONS(1333),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [498] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1335),
    [anon_sym_PIPE] = ACTIONS(1335),
    [anon_sym_PIPE_AMP] = ACTIONS(1335),
    [anon_sym_AMP_AMP] = ACTIONS(1335),
    [anon_sym_PIPE_PIPE] = ACTIONS(1335),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym_LF] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1335),
  },
  [499] = {
    [sym_do_group] = STATE(540),
    [anon_sym_do] = ACTIONS(1029),
    [sym_comment] = ACTIONS(115),
  },
  [500] = {
    [anon_sym_RPAREN] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(1339),
    [anon_sym_PIPE_AMP] = ACTIONS(1337),
    [anon_sym_AMP_AMP] = ACTIONS(1337),
    [anon_sym_PIPE_PIPE] = ACTIONS(1337),
    [sym_comment] = ACTIONS(115),
  },
  [501] = {
    [sym__terminated_statement] = STATE(87),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_done] = ACTIONS(1341),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [502] = {
    [anon_sym_RPAREN] = ACTIONS(1343),
    [anon_sym_PIPE] = ACTIONS(1345),
    [anon_sym_PIPE_AMP] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1343),
    [anon_sym_PIPE_PIPE] = ACTIONS(1343),
    [sym_comment] = ACTIONS(115),
  },
  [503] = {
    [anon_sym_fi] = ACTIONS(1347),
    [sym_comment] = ACTIONS(115),
  },
  [504] = {
    [sym__terminated_statement] = STATE(87),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_elif_clause] = STATE(207),
    [sym_else_clause] = STATE(543),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_if_statement_repeat1] = STATE(544),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_fi] = ACTIONS(1349),
    [anon_sym_elif] = ACTIONS(487),
    [anon_sym_else] = ACTIONS(489),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [505] = {
    [sym_elif_clause] = STATE(333),
    [sym_else_clause] = STATE(543),
    [anon_sym_fi] = ACTIONS(1347),
    [anon_sym_elif] = ACTIONS(787),
    [anon_sym_else] = ACTIONS(789),
    [sym_comment] = ACTIONS(115),
  },
  [506] = {
    [sym_case_item] = STATE(358),
    [sym_string] = STATE(356),
    [sym_simple_expansion] = STATE(356),
    [sym_expansion] = STATE(356),
    [sym_command_substitution] = STATE(356),
    [sym_process_substitution] = STATE(356),
    [aux_sym_case_statement_repeat1] = STATE(546),
    [anon_sym_esac] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(829),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(833),
    [sym_comment] = ACTIONS(115),
  },
  [507] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1353),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1353),
    [anon_sym_LF] = ACTIONS(1353),
    [anon_sym_AMP] = ACTIONS(1353),
  },
  [508] = {
    [sym_compound_statement] = STATE(548),
    [anon_sym_LBRACE] = ACTIONS(1253),
    [sym_comment] = ACTIONS(115),
  },
  [509] = {
    [sym_file_redirect] = STATE(297),
    [sym_heredoc_redirect] = STATE(297),
    [sym_file_descriptor] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1355),
    [anon_sym_PIPE_AMP] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1177),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_LT] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1057),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT_GT] = ACTIONS(1055),
    [anon_sym_LT_AMP] = ACTIONS(1055),
    [anon_sym_GT_AMP] = ACTIONS(1055),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [sym_comment] = ACTIONS(115),
  },
  [510] = {
    [sym_for_statement] = STATE(549),
    [sym_while_statement] = STATE(549),
    [sym_if_statement] = STATE(549),
    [sym_case_statement] = STATE(549),
    [sym_function_definition] = STATE(549),
    [sym_subshell] = STATE(549),
    [sym_pipeline] = STATE(549),
    [sym_list] = STATE(549),
    [sym_bracket_command] = STATE(549),
    [sym_command] = STATE(549),
    [sym_environment_variable_assignment] = STATE(550),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(219),
    [sym_command_substitution] = STATE(219),
    [aux_sym_command_repeat1] = STATE(223),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_if] = ACTIONS(495),
    [anon_sym_case] = ACTIONS(497),
    [anon_sym_function] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(505),
    [anon_sym_COLON] = ACTIONS(507),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(511),
    [sym_comment] = ACTIONS(115),
  },
  [511] = {
    [sym_file_descriptor] = ACTIONS(375),
    [anon_sym_RPAREN] = ACTIONS(375),
    [anon_sym_PIPE] = ACTIONS(547),
    [anon_sym_PIPE_AMP] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(375),
    [anon_sym_LT_AMP] = ACTIONS(375),
    [anon_sym_GT_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(547),
    [anon_sym_LT_LT_DASH] = ACTIONS(375),
    [sym_comment] = ACTIONS(115),
  },
  [512] = {
    [sym_simple_expansion] = STATE(163),
    [sym_expansion] = STATE(163),
    [sym_command_substitution] = STATE(163),
    [anon_sym_DQUOTE] = ACTIONS(1357),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [513] = {
    [sym_file_descriptor] = ACTIONS(525),
    [anon_sym_RPAREN] = ACTIONS(525),
    [anon_sym_PIPE] = ACTIONS(527),
    [anon_sym_PIPE_AMP] = ACTIONS(525),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [anon_sym_LT] = ACTIONS(527),
    [anon_sym_GT] = ACTIONS(527),
    [anon_sym_GT_GT] = ACTIONS(525),
    [anon_sym_AMP_GT] = ACTIONS(527),
    [anon_sym_AMP_GT_GT] = ACTIONS(525),
    [anon_sym_LT_AMP] = ACTIONS(525),
    [anon_sym_GT_AMP] = ACTIONS(525),
    [anon_sym_LT_LT] = ACTIONS(527),
    [anon_sym_LT_LT_DASH] = ACTIONS(525),
    [sym_comment] = ACTIONS(115),
  },
  [514] = {
    [sym_file_descriptor] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(553),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(553),
    [anon_sym_GT_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(553),
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(553),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [sym_comment] = ACTIONS(115),
  },
  [515] = {
    [sym_file_descriptor] = ACTIONS(555),
    [anon_sym_RPAREN] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(557),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(557),
    [anon_sym_GT] = ACTIONS(557),
    [anon_sym_GT_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(557),
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(557),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [sym_comment] = ACTIONS(115),
  },
  [516] = {
    [anon_sym_RBRACE] = ACTIONS(1359),
    [anon_sym_COLON] = ACTIONS(1361),
    [anon_sym_EQ] = ACTIONS(1363),
    [anon_sym_COLON_QMARK] = ACTIONS(1363),
    [anon_sym_COLON_DASH] = ACTIONS(1363),
    [sym_comment] = ACTIONS(115),
  },
  [517] = {
    [anon_sym_RBRACE] = ACTIONS(1365),
    [anon_sym_COLON] = ACTIONS(1367),
    [anon_sym_EQ] = ACTIONS(1369),
    [anon_sym_COLON_QMARK] = ACTIONS(1369),
    [anon_sym_COLON_DASH] = ACTIONS(1369),
    [sym_comment] = ACTIONS(115),
  },
  [518] = {
    [anon_sym_RPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(115),
  },
  [519] = {
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [sym_comment] = ACTIONS(115),
  },
  [520] = {
    [sym__terminated_statement] = STATE(18),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_program_repeat1] = STATE(558),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(1373),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [521] = {
    [anon_sym_RPAREN] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1377),
    [anon_sym_PIPE_AMP] = ACTIONS(1375),
    [anon_sym_AMP_AMP] = ACTIONS(1375),
    [anon_sym_PIPE_PIPE] = ACTIONS(1375),
    [sym_comment] = ACTIONS(115),
  },
  [522] = {
    [sym_file_redirect] = STATE(297),
    [sym_heredoc_redirect] = STATE(297),
    [sym_file_descriptor] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(1183),
    [anon_sym_PIPE] = ACTIONS(1379),
    [anon_sym_PIPE_AMP] = ACTIONS(1183),
    [anon_sym_AMP_AMP] = ACTIONS(1183),
    [anon_sym_PIPE_PIPE] = ACTIONS(1183),
    [anon_sym_LT] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1057),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT_GT] = ACTIONS(1055),
    [anon_sym_LT_AMP] = ACTIONS(1055),
    [anon_sym_GT_AMP] = ACTIONS(1055),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [sym_comment] = ACTIONS(115),
  },
  [523] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_command_repeat2] = STATE(559),
    [sym_file_descriptor] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(1185),
    [anon_sym_PIPE] = ACTIONS(1381),
    [anon_sym_PIPE_AMP] = ACTIONS(1185),
    [anon_sym_AMP_AMP] = ACTIONS(1185),
    [anon_sym_PIPE_PIPE] = ACTIONS(1381),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT_GT] = ACTIONS(1055),
    [anon_sym_LT_AMP] = ACTIONS(1055),
    [anon_sym_GT_AMP] = ACTIONS(1055),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(961),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [sym_word] = ACTIONS(963),
    [sym_comment] = ACTIONS(115),
  },
  [524] = {
    [sym_file_redirect] = STATE(168),
    [sym_heredoc_redirect] = STATE(168),
    [sym_string] = STATE(406),
    [sym_simple_expansion] = STATE(406),
    [sym_expansion] = STATE(406),
    [sym_command_substitution] = STATE(406),
    [sym_process_substitution] = STATE(406),
    [aux_sym_command_repeat2] = STATE(560),
    [sym_file_descriptor] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1383),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1383),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT_GT] = ACTIONS(1055),
    [anon_sym_LT_AMP] = ACTIONS(1055),
    [anon_sym_GT_AMP] = ACTIONS(1055),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [sym_raw_string] = ACTIONS(961),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(699),
    [sym_word] = ACTIONS(963),
    [sym_comment] = ACTIONS(115),
  },
  [525] = {
    [sym_file_redirect] = STATE(297),
    [sym_heredoc_redirect] = STATE(297),
    [sym_file_descriptor] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(1189),
    [anon_sym_PIPE] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1189),
    [anon_sym_AMP_AMP] = ACTIONS(1189),
    [anon_sym_PIPE_PIPE] = ACTIONS(1189),
    [anon_sym_LT] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1057),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT_GT] = ACTIONS(1055),
    [anon_sym_LT_AMP] = ACTIONS(1055),
    [anon_sym_GT_AMP] = ACTIONS(1055),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [sym_comment] = ACTIONS(115),
  },
  [526] = {
    [anon_sym_esac] = ACTIONS(1387),
    [anon_sym_LT] = ACTIONS(1389),
    [anon_sym_GT] = ACTIONS(1389),
    [anon_sym_DQUOTE] = ACTIONS(1389),
    [sym_raw_string] = ACTIONS(1387),
    [anon_sym_DOLLAR] = ACTIONS(1387),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1389),
    [anon_sym_BQUOTE] = ACTIONS(1389),
    [sym_word] = ACTIONS(1391),
    [sym_comment] = ACTIONS(115),
  },
  [527] = {
    [sym__terminated_statement] = STATE(87),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_SEMI_SEMI] = ACTIONS(1393),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [528] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1395),
    [anon_sym_PIPE] = ACTIONS(1395),
    [anon_sym_PIPE_AMP] = ACTIONS(1395),
    [anon_sym_AMP_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1395),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1395),
    [anon_sym_LF] = ACTIONS(1395),
    [anon_sym_AMP] = ACTIONS(1395),
  },
  [529] = {
    [sym_file_descriptor] = ACTIONS(1287),
    [anon_sym_SEMI_SEMI] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1283),
    [anon_sym_PIPE_AMP] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE] = ACTIONS(1283),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(1283),
    [anon_sym_GT_GT] = ACTIONS(1283),
    [anon_sym_AMP_GT] = ACTIONS(1283),
    [anon_sym_AMP_GT_GT] = ACTIONS(1283),
    [anon_sym_LT_AMP] = ACTIONS(1283),
    [anon_sym_GT_AMP] = ACTIONS(1283),
    [anon_sym_LT_LT] = ACTIONS(1283),
    [anon_sym_LT_LT_DASH] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(1283),
    [sym_raw_string] = ACTIONS(1283),
    [anon_sym_DOLLAR] = ACTIONS(1283),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1283),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_BQUOTE] = ACTIONS(1283),
    [sym_word] = ACTIONS(1283),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_LF] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1283),
  },
  [530] = {
    [sym_file_descriptor] = ACTIONS(1291),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(1285),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [sym_word] = ACTIONS(1285),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [531] = {
    [sym_file_descriptor] = ACTIONS(1287),
    [anon_sym_SEMI_SEMI] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1283),
    [anon_sym_PIPE_AMP] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE] = ACTIONS(1283),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(1283),
    [anon_sym_GT_GT] = ACTIONS(1283),
    [anon_sym_AMP_GT] = ACTIONS(1283),
    [anon_sym_AMP_GT_GT] = ACTIONS(1283),
    [anon_sym_LT_AMP] = ACTIONS(1283),
    [anon_sym_GT_AMP] = ACTIONS(1283),
    [anon_sym_LT_LT] = ACTIONS(1283),
    [anon_sym_LT_LT_DASH] = ACTIONS(1283),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_LF] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1283),
  },
  [532] = {
    [sym_file_descriptor] = ACTIONS(1291),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [533] = {
    [anon_sym_RBRACE] = ACTIONS(1397),
    [sym_comment] = ACTIONS(115),
  },
  [534] = {
    [anon_sym_RBRACE] = ACTIONS(1399),
    [sym_comment] = ACTIONS(115),
  },
  [535] = {
    [sym_file_descriptor] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [sym_raw_string] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [sym_word] = ACTIONS(1079),
    [sym_comment] = ACTIONS(115),
  },
  [536] = {
    [anon_sym_RBRACE] = ACTIONS(1401),
    [sym_comment] = ACTIONS(115),
  },
  [537] = {
    [anon_sym_RBRACE] = ACTIONS(1403),
    [sym_comment] = ACTIONS(115),
  },
  [538] = {
    [sym_file_descriptor] = ACTIONS(1287),
    [anon_sym_SEMI_SEMI] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1283),
    [anon_sym_PIPE_AMP] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE] = ACTIONS(1283),
    [anon_sym_COLON] = ACTIONS(1283),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(1283),
    [anon_sym_GT_GT] = ACTIONS(1283),
    [anon_sym_AMP_GT] = ACTIONS(1283),
    [anon_sym_AMP_GT_GT] = ACTIONS(1283),
    [anon_sym_LT_AMP] = ACTIONS(1283),
    [anon_sym_GT_AMP] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(1283),
    [sym_raw_string] = ACTIONS(1283),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_BQUOTE] = ACTIONS(1283),
    [sym_leading_word] = ACTIONS(1283),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_LF] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1283),
  },
  [539] = {
    [sym_file_descriptor] = ACTIONS(1291),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_COLON] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [sym_leading_word] = ACTIONS(1285),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [540] = {
    [anon_sym_RPAREN] = ACTIONS(1405),
    [anon_sym_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE_AMP] = ACTIONS(1405),
    [anon_sym_AMP_AMP] = ACTIONS(1405),
    [anon_sym_PIPE_PIPE] = ACTIONS(1405),
    [sym_comment] = ACTIONS(115),
  },
  [541] = {
    [anon_sym_RPAREN] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_PIPE_AMP] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [sym_comment] = ACTIONS(115),
  },
  [542] = {
    [anon_sym_RPAREN] = ACTIONS(1413),
    [anon_sym_PIPE] = ACTIONS(1415),
    [anon_sym_PIPE_AMP] = ACTIONS(1413),
    [anon_sym_AMP_AMP] = ACTIONS(1413),
    [anon_sym_PIPE_PIPE] = ACTIONS(1413),
    [sym_comment] = ACTIONS(115),
  },
  [543] = {
    [anon_sym_fi] = ACTIONS(1417),
    [sym_comment] = ACTIONS(115),
  },
  [544] = {
    [sym_elif_clause] = STATE(333),
    [sym_else_clause] = STATE(567),
    [anon_sym_fi] = ACTIONS(1417),
    [anon_sym_elif] = ACTIONS(787),
    [anon_sym_else] = ACTIONS(789),
    [sym_comment] = ACTIONS(115),
  },
  [545] = {
    [anon_sym_RPAREN] = ACTIONS(1419),
    [anon_sym_PIPE] = ACTIONS(1421),
    [anon_sym_PIPE_AMP] = ACTIONS(1419),
    [anon_sym_AMP_AMP] = ACTIONS(1419),
    [anon_sym_PIPE_PIPE] = ACTIONS(1419),
    [sym_comment] = ACTIONS(115),
  },
  [546] = {
    [sym_case_item] = STATE(462),
    [sym_string] = STATE(356),
    [sym_simple_expansion] = STATE(356),
    [sym_expansion] = STATE(356),
    [sym_command_substitution] = STATE(356),
    [sym_process_substitution] = STATE(356),
    [anon_sym_esac] = ACTIONS(1423),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(829),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(833),
    [sym_comment] = ACTIONS(115),
  },
  [547] = {
    [sym_case_item] = STATE(358),
    [sym_string] = STATE(356),
    [sym_simple_expansion] = STATE(356),
    [sym_expansion] = STATE(356),
    [sym_command_substitution] = STATE(356),
    [sym_process_substitution] = STATE(356),
    [aux_sym_case_statement_repeat1] = STATE(569),
    [anon_sym_esac] = ACTIONS(1423),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(829),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(833),
    [sym_comment] = ACTIONS(115),
  },
  [548] = {
    [anon_sym_RPAREN] = ACTIONS(1425),
    [anon_sym_PIPE] = ACTIONS(1427),
    [anon_sym_PIPE_AMP] = ACTIONS(1425),
    [anon_sym_AMP_AMP] = ACTIONS(1425),
    [anon_sym_PIPE_PIPE] = ACTIONS(1425),
    [sym_comment] = ACTIONS(115),
  },
  [549] = {
    [anon_sym_RPAREN] = ACTIONS(1429),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [sym_comment] = ACTIONS(115),
  },
  [550] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(1429),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(819),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(241),
    [anon_sym_GT] = ACTIONS(241),
    [anon_sym_GT_GT] = ACTIONS(241),
    [anon_sym_AMP_GT] = ACTIONS(241),
    [anon_sym_AMP_GT_GT] = ACTIONS(241),
    [anon_sym_LT_AMP] = ACTIONS(241),
    [anon_sym_GT_AMP] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_raw_string] = ACTIONS(241),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(115),
  },
  [551] = {
    [sym_file_descriptor] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(665),
    [anon_sym_PIPE] = ACTIONS(851),
    [anon_sym_PIPE_AMP] = ACTIONS(665),
    [anon_sym_AMP_AMP] = ACTIONS(665),
    [anon_sym_PIPE_PIPE] = ACTIONS(665),
    [anon_sym_LT] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(851),
    [anon_sym_GT_GT] = ACTIONS(665),
    [anon_sym_AMP_GT] = ACTIONS(851),
    [anon_sym_AMP_GT_GT] = ACTIONS(665),
    [anon_sym_LT_AMP] = ACTIONS(665),
    [anon_sym_GT_AMP] = ACTIONS(665),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_LT_LT_DASH] = ACTIONS(665),
    [sym_comment] = ACTIONS(115),
  },
  [552] = {
    [sym_file_descriptor] = ACTIONS(853),
    [anon_sym_RPAREN] = ACTIONS(853),
    [anon_sym_PIPE] = ACTIONS(855),
    [anon_sym_PIPE_AMP] = ACTIONS(853),
    [anon_sym_AMP_AMP] = ACTIONS(853),
    [anon_sym_PIPE_PIPE] = ACTIONS(853),
    [anon_sym_LT] = ACTIONS(855),
    [anon_sym_GT] = ACTIONS(855),
    [anon_sym_GT_GT] = ACTIONS(853),
    [anon_sym_AMP_GT] = ACTIONS(855),
    [anon_sym_AMP_GT_GT] = ACTIONS(853),
    [anon_sym_LT_AMP] = ACTIONS(853),
    [anon_sym_GT_AMP] = ACTIONS(853),
    [anon_sym_LT_LT] = ACTIONS(855),
    [anon_sym_LT_LT_DASH] = ACTIONS(853),
    [sym_comment] = ACTIONS(115),
  },
  [553] = {
    [sym_string] = STATE(571),
    [sym_simple_expansion] = STATE(571),
    [sym_expansion] = STATE(571),
    [sym_command_substitution] = STATE(571),
    [sym_process_substitution] = STATE(571),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(1431),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(1433),
    [sym_comment] = ACTIONS(115),
  },
  [554] = {
    [sym_file_descriptor] = ACTIONS(861),
    [anon_sym_RPAREN] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(863),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(863),
    [anon_sym_GT_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(863),
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(863),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [sym_comment] = ACTIONS(115),
  },
  [555] = {
    [sym_string] = STATE(572),
    [sym_simple_expansion] = STATE(572),
    [sym_expansion] = STATE(572),
    [sym_command_substitution] = STATE(572),
    [sym_process_substitution] = STATE(572),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(1435),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(1437),
    [sym_comment] = ACTIONS(115),
  },
  [556] = {
    [sym_file_descriptor] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PIPE_AMP] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(731),
    [anon_sym_PIPE_PIPE] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(869),
    [anon_sym_GT] = ACTIONS(869),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_AMP_GT] = ACTIONS(869),
    [anon_sym_AMP_GT_GT] = ACTIONS(731),
    [anon_sym_LT_AMP] = ACTIONS(731),
    [anon_sym_GT_AMP] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(869),
    [anon_sym_LT_LT_DASH] = ACTIONS(731),
    [sym_comment] = ACTIONS(115),
  },
  [557] = {
    [anon_sym_RPAREN] = ACTIONS(1439),
    [anon_sym_PIPE] = ACTIONS(1441),
    [anon_sym_PIPE_AMP] = ACTIONS(1439),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_PIPE_PIPE] = ACTIONS(1439),
    [sym_comment] = ACTIONS(115),
  },
  [558] = {
    [sym__terminated_statement] = STATE(87),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(1443),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [559] = {
    [sym_file_redirect] = STATE(297),
    [sym_heredoc_redirect] = STATE(297),
    [sym_file_descriptor] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(1323),
    [anon_sym_PIPE] = ACTIONS(1445),
    [anon_sym_PIPE_AMP] = ACTIONS(1323),
    [anon_sym_AMP_AMP] = ACTIONS(1323),
    [anon_sym_PIPE_PIPE] = ACTIONS(1323),
    [anon_sym_LT] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1057),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT_GT] = ACTIONS(1055),
    [anon_sym_LT_AMP] = ACTIONS(1055),
    [anon_sym_GT_AMP] = ACTIONS(1055),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [sym_comment] = ACTIONS(115),
  },
  [560] = {
    [sym_file_redirect] = STATE(297),
    [sym_heredoc_redirect] = STATE(297),
    [sym_file_descriptor] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(1325),
    [anon_sym_PIPE] = ACTIONS(1447),
    [anon_sym_PIPE_AMP] = ACTIONS(1325),
    [anon_sym_AMP_AMP] = ACTIONS(1325),
    [anon_sym_PIPE_PIPE] = ACTIONS(1325),
    [anon_sym_LT] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1057),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_AMP_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT_GT] = ACTIONS(1055),
    [anon_sym_LT_AMP] = ACTIONS(1055),
    [anon_sym_GT_AMP] = ACTIONS(1055),
    [anon_sym_LT_LT] = ACTIONS(685),
    [anon_sym_LT_LT_DASH] = ACTIONS(687),
    [sym_comment] = ACTIONS(115),
  },
  [561] = {
    [anon_sym_esac] = ACTIONS(1449),
    [anon_sym_LT] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1451),
    [anon_sym_DQUOTE] = ACTIONS(1451),
    [sym_raw_string] = ACTIONS(1449),
    [anon_sym_DOLLAR] = ACTIONS(1449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1451),
    [anon_sym_BQUOTE] = ACTIONS(1451),
    [sym_word] = ACTIONS(1453),
    [sym_comment] = ACTIONS(115),
  },
  [562] = {
    [sym__heredoc_middle] = ACTIONS(1287),
    [sym__heredoc_end] = ACTIONS(1287),
    [anon_sym_DOLLAR] = ACTIONS(1289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1287),
    [sym_comment] = ACTIONS(115),
  },
  [563] = {
    [sym__heredoc_middle] = ACTIONS(1291),
    [sym__heredoc_end] = ACTIONS(1291),
    [anon_sym_DOLLAR] = ACTIONS(1293),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1291),
    [sym_comment] = ACTIONS(115),
  },
  [564] = {
    [sym_file_descriptor] = ACTIONS(1287),
    [anon_sym_RPAREN] = ACTIONS(1287),
    [anon_sym_PIPE] = ACTIONS(1289),
    [anon_sym_PIPE_AMP] = ACTIONS(1287),
    [anon_sym_AMP_AMP] = ACTIONS(1287),
    [anon_sym_PIPE_PIPE] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1289),
    [anon_sym_GT] = ACTIONS(1289),
    [anon_sym_GT_GT] = ACTIONS(1287),
    [anon_sym_AMP_GT] = ACTIONS(1289),
    [anon_sym_AMP_GT_GT] = ACTIONS(1287),
    [anon_sym_LT_AMP] = ACTIONS(1287),
    [anon_sym_GT_AMP] = ACTIONS(1287),
    [anon_sym_LT_LT] = ACTIONS(1289),
    [anon_sym_LT_LT_DASH] = ACTIONS(1287),
    [anon_sym_DQUOTE] = ACTIONS(1287),
    [sym_raw_string] = ACTIONS(1289),
    [anon_sym_DOLLAR] = ACTIONS(1289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1287),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1287),
    [anon_sym_BQUOTE] = ACTIONS(1287),
    [sym_word] = ACTIONS(1283),
    [sym_comment] = ACTIONS(115),
  },
  [565] = {
    [sym_file_descriptor] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1291),
    [anon_sym_PIPE] = ACTIONS(1293),
    [anon_sym_PIPE_AMP] = ACTIONS(1291),
    [anon_sym_AMP_AMP] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1293),
    [anon_sym_GT] = ACTIONS(1293),
    [anon_sym_GT_GT] = ACTIONS(1291),
    [anon_sym_AMP_GT] = ACTIONS(1293),
    [anon_sym_AMP_GT_GT] = ACTIONS(1291),
    [anon_sym_LT_AMP] = ACTIONS(1291),
    [anon_sym_GT_AMP] = ACTIONS(1291),
    [anon_sym_LT_LT] = ACTIONS(1293),
    [anon_sym_LT_LT_DASH] = ACTIONS(1291),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [sym_raw_string] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1293),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1291),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1291),
    [anon_sym_BQUOTE] = ACTIONS(1291),
    [sym_word] = ACTIONS(1285),
    [sym_comment] = ACTIONS(115),
  },
  [566] = {
    [anon_sym_RPAREN] = ACTIONS(1455),
    [anon_sym_PIPE] = ACTIONS(1457),
    [anon_sym_PIPE_AMP] = ACTIONS(1455),
    [anon_sym_AMP_AMP] = ACTIONS(1455),
    [anon_sym_PIPE_PIPE] = ACTIONS(1455),
    [sym_comment] = ACTIONS(115),
  },
  [567] = {
    [anon_sym_fi] = ACTIONS(1459),
    [sym_comment] = ACTIONS(115),
  },
  [568] = {
    [anon_sym_RPAREN] = ACTIONS(1461),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_PIPE_AMP] = ACTIONS(1461),
    [anon_sym_AMP_AMP] = ACTIONS(1461),
    [anon_sym_PIPE_PIPE] = ACTIONS(1461),
    [sym_comment] = ACTIONS(115),
  },
  [569] = {
    [sym_case_item] = STATE(462),
    [sym_string] = STATE(356),
    [sym_simple_expansion] = STATE(356),
    [sym_expansion] = STATE(356),
    [sym_command_substitution] = STATE(356),
    [sym_process_substitution] = STATE(356),
    [anon_sym_esac] = ACTIONS(1465),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(829),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(833),
    [sym_comment] = ACTIONS(115),
  },
  [570] = {
    [sym_file_descriptor] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [sym_comment] = ACTIONS(115),
  },
  [571] = {
    [anon_sym_RBRACE] = ACTIONS(1467),
    [sym_comment] = ACTIONS(115),
  },
  [572] = {
    [anon_sym_RBRACE] = ACTIONS(1469),
    [sym_comment] = ACTIONS(115),
  },
  [573] = {
    [anon_sym_RPAREN] = ACTIONS(1471),
    [anon_sym_PIPE] = ACTIONS(1473),
    [anon_sym_PIPE_AMP] = ACTIONS(1471),
    [anon_sym_AMP_AMP] = ACTIONS(1471),
    [anon_sym_PIPE_PIPE] = ACTIONS(1471),
    [sym_comment] = ACTIONS(115),
  },
  [574] = {
    [anon_sym_RPAREN] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(1477),
    [anon_sym_PIPE_AMP] = ACTIONS(1475),
    [anon_sym_AMP_AMP] = ACTIONS(1475),
    [anon_sym_PIPE_PIPE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(115),
  },
  [575] = {
    [anon_sym_RPAREN] = ACTIONS(1479),
    [anon_sym_PIPE] = ACTIONS(1481),
    [anon_sym_PIPE_AMP] = ACTIONS(1479),
    [anon_sym_AMP_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1479),
    [sym_comment] = ACTIONS(115),
  },
  [576] = {
    [sym_file_descriptor] = ACTIONS(1287),
    [anon_sym_RPAREN] = ACTIONS(1287),
    [anon_sym_PIPE] = ACTIONS(1289),
    [anon_sym_PIPE_AMP] = ACTIONS(1287),
    [anon_sym_AMP_AMP] = ACTIONS(1287),
    [anon_sym_PIPE_PIPE] = ACTIONS(1287),
    [anon_sym_LT] = ACTIONS(1289),
    [anon_sym_GT] = ACTIONS(1289),
    [anon_sym_GT_GT] = ACTIONS(1287),
    [anon_sym_AMP_GT] = ACTIONS(1289),
    [anon_sym_AMP_GT_GT] = ACTIONS(1287),
    [anon_sym_LT_AMP] = ACTIONS(1287),
    [anon_sym_GT_AMP] = ACTIONS(1287),
    [anon_sym_LT_LT] = ACTIONS(1289),
    [anon_sym_LT_LT_DASH] = ACTIONS(1287),
    [sym_comment] = ACTIONS(115),
  },
  [577] = {
    [sym_file_descriptor] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1291),
    [anon_sym_PIPE] = ACTIONS(1293),
    [anon_sym_PIPE_AMP] = ACTIONS(1291),
    [anon_sym_AMP_AMP] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE] = ACTIONS(1291),
    [anon_sym_LT] = ACTIONS(1293),
    [anon_sym_GT] = ACTIONS(1293),
    [anon_sym_GT_GT] = ACTIONS(1291),
    [anon_sym_AMP_GT] = ACTIONS(1293),
    [anon_sym_AMP_GT_GT] = ACTIONS(1291),
    [anon_sym_LT_AMP] = ACTIONS(1291),
    [anon_sym_GT_AMP] = ACTIONS(1291),
    [anon_sym_LT_LT] = ACTIONS(1293),
    [anon_sym_LT_LT_DASH] = ACTIONS(1291),
    [sym_comment] = ACTIONS(115),
  },
  [578] = {
    [sym_word] = ACTIONS(1483),
    [sym_comment] = ACTIONS(115),
  },
  [579] = {
    [sym__terminated_statement] = STATE(639),
    [sym_for_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_function_definition] = STATE(27),
    [sym_subshell] = STATE(27),
    [sym_pipeline] = STATE(27),
    [sym_list] = STATE(27),
    [sym_bracket_command] = STATE(27),
    [sym_command] = STATE(27),
    [sym_environment_variable_assignment] = STATE(28),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(1485),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_if] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(1491),
    [anon_sym_SEMI_SEMI] = ACTIONS(1493),
    [anon_sym_function] = ACTIONS(1495),
    [anon_sym_LPAREN] = ACTIONS(1497),
    [anon_sym_LBRACK] = ACTIONS(1499),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1501),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_LT] = ACTIONS(1505),
    [anon_sym_GT] = ACTIONS(1505),
    [anon_sym_GT_GT] = ACTIONS(1505),
    [anon_sym_AMP_GT] = ACTIONS(1505),
    [anon_sym_AMP_GT_GT] = ACTIONS(1505),
    [anon_sym_LT_AMP] = ACTIONS(1505),
    [anon_sym_GT_AMP] = ACTIONS(1505),
    [anon_sym_DQUOTE] = ACTIONS(1507),
    [sym_raw_string] = ACTIONS(1503),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1509),
    [anon_sym_BQUOTE] = ACTIONS(1511),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1493),
    [anon_sym_LF] = ACTIONS(1493),
    [anon_sym_AMP] = ACTIONS(1493),
  },
  [580] = {
    [sym__terminated_statement] = STATE(640),
    [sym_for_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_function_definition] = STATE(27),
    [sym_subshell] = STATE(27),
    [sym_pipeline] = STATE(27),
    [sym_list] = STATE(27),
    [sym_bracket_command] = STATE(27),
    [sym_command] = STATE(27),
    [sym_environment_variable_assignment] = STATE(28),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [581] = {
    [sym__terminated_statement] = STATE(18),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_program_repeat1] = STATE(642),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_done] = ACTIONS(1513),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [582] = {
    [anon_sym_RPAREN] = ACTIONS(1515),
    [anon_sym_SEMI_SEMI] = ACTIONS(1515),
    [anon_sym_PIPE] = ACTIONS(1515),
    [anon_sym_PIPE_AMP] = ACTIONS(1515),
    [anon_sym_AMP_AMP] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE] = ACTIONS(1515),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1515),
    [anon_sym_LF] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
  },
  [583] = {
    [sym__terminated_statement] = STATE(643),
    [sym_for_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_function_definition] = STATE(27),
    [sym_subshell] = STATE(27),
    [sym_pipeline] = STATE(27),
    [sym_list] = STATE(27),
    [sym_bracket_command] = STATE(27),
    [sym_command] = STATE(27),
    [sym_environment_variable_assignment] = STATE(28),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [584] = {
    [sym__terminated_statement] = STATE(18),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_elif_clause] = STATE(207),
    [sym_else_clause] = STATE(645),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_program_repeat1] = STATE(646),
    [aux_sym_if_statement_repeat1] = STATE(647),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_fi] = ACTIONS(1518),
    [anon_sym_elif] = ACTIONS(1521),
    [anon_sym_else] = ACTIONS(1524),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [585] = {
    [anon_sym_RPAREN] = ACTIONS(1527),
    [anon_sym_SEMI_SEMI] = ACTIONS(1527),
    [anon_sym_PIPE] = ACTIONS(1527),
    [anon_sym_PIPE_AMP] = ACTIONS(1527),
    [anon_sym_AMP_AMP] = ACTIONS(1527),
    [anon_sym_PIPE_PIPE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1527),
    [anon_sym_LF] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
  },
  [586] = {
    [sym_string] = STATE(648),
    [sym_simple_expansion] = STATE(648),
    [sym_expansion] = STATE(648),
    [sym_command_substitution] = STATE(648),
    [sym_process_substitution] = STATE(648),
    [anon_sym_LT] = ACTIONS(123),
    [anon_sym_GT] = ACTIONS(123),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [sym_raw_string] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(131),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(133),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_word] = ACTIONS(1534),
    [sym_comment] = ACTIONS(115),
  },
  [587] = {
    [anon_sym_RPAREN] = ACTIONS(1536),
    [anon_sym_SEMI_SEMI] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1536),
    [anon_sym_PIPE_AMP] = ACTIONS(1536),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE_PIPE] = ACTIONS(1536),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1536),
    [anon_sym_LF] = ACTIONS(1536),
    [anon_sym_AMP] = ACTIONS(1536),
  },
  [588] = {
    [sym__terminated_statement] = STATE(18),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_compound_statement] = STATE(618),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_program_repeat1] = STATE(527),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1485),
    [anon_sym_in] = ACTIONS(1544),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_if] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(1491),
    [anon_sym_RPAREN] = ACTIONS(1547),
    [anon_sym_SEMI_SEMI] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1495),
    [anon_sym_LPAREN] = ACTIONS(1497),
    [anon_sym_LBRACE] = ACTIONS(1558),
    [anon_sym_RBRACE] = ACTIONS(1544),
    [anon_sym_PIPE] = ACTIONS(1547),
    [anon_sym_PIPE_AMP] = ACTIONS(1547),
    [anon_sym_AMP_AMP] = ACTIONS(1547),
    [anon_sym_PIPE_PIPE] = ACTIONS(1547),
    [anon_sym_LBRACK] = ACTIONS(1499),
    [anon_sym_RBRACK] = ACTIONS(1544),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1501),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1560),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1564),
    [anon_sym_GT_GT] = ACTIONS(1564),
    [anon_sym_AMP_GT] = ACTIONS(1564),
    [anon_sym_AMP_GT_GT] = ACTIONS(1564),
    [anon_sym_LT_AMP] = ACTIONS(1564),
    [anon_sym_GT_AMP] = ACTIONS(1564),
    [anon_sym_LT_LT] = ACTIONS(1544),
    [anon_sym_LT_LT_DASH] = ACTIONS(1544),
    [anon_sym_DQUOTE] = ACTIONS(1568),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(1560),
    [anon_sym_DOLLAR] = ACTIONS(1544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1572),
    [anon_sym_BQUOTE] = ACTIONS(1576),
    [sym_leading_word] = ACTIONS(1580),
    [sym_word] = ACTIONS(1544),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1547),
    [anon_sym_LF] = ACTIONS(1547),
    [anon_sym_AMP] = ACTIONS(1547),
  },
  [589] = {
    [sym_leading_word] = ACTIONS(1584),
    [sym_comment] = ACTIONS(115),
  },
  [590] = {
    [sym__terminated_statement] = STATE(18),
    [sym_for_statement] = STATE(658),
    [sym_while_statement] = STATE(658),
    [sym_if_statement] = STATE(658),
    [sym_case_statement] = STATE(658),
    [sym_function_definition] = STATE(658),
    [sym_subshell] = STATE(658),
    [sym_pipeline] = STATE(658),
    [sym_list] = STATE(658),
    [sym_bracket_command] = STATE(658),
    [sym_command] = STATE(658),
    [sym_environment_variable_assignment] = STATE(659),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(653),
    [sym_command_substitution] = STATE(653),
    [aux_sym_program_repeat1] = STATE(660),
    [aux_sym_command_repeat1] = STATE(661),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(1586),
    [anon_sym_while] = ACTIONS(1588),
    [anon_sym_if] = ACTIONS(1590),
    [anon_sym_case] = ACTIONS(1592),
    [anon_sym_RPAREN] = ACTIONS(1594),
    [anon_sym_function] = ACTIONS(1596),
    [anon_sym_LPAREN] = ACTIONS(1598),
    [anon_sym_LBRACK] = ACTIONS(1600),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1602),
    [anon_sym_COLON] = ACTIONS(1604),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(1606),
    [sym_raw_string] = ACTIONS(1608),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1610),
    [anon_sym_BQUOTE] = ACTIONS(1612),
    [sym_leading_word] = ACTIONS(1614),
    [sym_comment] = ACTIONS(115),
  },
  [591] = {
    [sym__terminated_statement] = STATE(18),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_program_repeat1] = STATE(663),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [592] = {
    [sym__heredoc_middle] = ACTIONS(1618),
    [sym__heredoc_end] = ACTIONS(1618),
    [sym_file_descriptor] = ACTIONS(1618),
    [anon_sym_in] = ACTIONS(1623),
    [anon_sym_RPAREN] = ACTIONS(1628),
    [anon_sym_SEMI_SEMI] = ACTIONS(1628),
    [anon_sym_RBRACE] = ACTIONS(1623),
    [anon_sym_PIPE] = ACTIONS(1628),
    [anon_sym_PIPE_AMP] = ACTIONS(1628),
    [anon_sym_AMP_AMP] = ACTIONS(1628),
    [anon_sym_PIPE_PIPE] = ACTIONS(1628),
    [anon_sym_RBRACK] = ACTIONS(1623),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1623),
    [anon_sym_COLON] = ACTIONS(1623),
    [anon_sym_LT] = ACTIONS(1623),
    [anon_sym_GT] = ACTIONS(1623),
    [anon_sym_GT_GT] = ACTIONS(1623),
    [anon_sym_AMP_GT] = ACTIONS(1623),
    [anon_sym_AMP_GT_GT] = ACTIONS(1623),
    [anon_sym_LT_AMP] = ACTIONS(1623),
    [anon_sym_GT_AMP] = ACTIONS(1623),
    [anon_sym_LT_LT] = ACTIONS(1623),
    [anon_sym_LT_LT_DASH] = ACTIONS(1623),
    [anon_sym_DQUOTE] = ACTIONS(1623),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1623),
    [sym_raw_string] = ACTIONS(1623),
    [anon_sym_DOLLAR] = ACTIONS(1623),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1623),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1623),
    [anon_sym_BQUOTE] = ACTIONS(1623),
    [sym_leading_word] = ACTIONS(1623),
    [sym_word] = ACTIONS(1623),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1628),
    [anon_sym_LF] = ACTIONS(1628),
    [anon_sym_AMP] = ACTIONS(1628),
  },
  [593] = {
    [sym_for_statement] = STATE(664),
    [sym_while_statement] = STATE(664),
    [sym_if_statement] = STATE(664),
    [sym_case_statement] = STATE(664),
    [sym_function_definition] = STATE(664),
    [sym_subshell] = STATE(664),
    [sym_pipeline] = STATE(664),
    [sym_list] = STATE(664),
    [sym_bracket_command] = STATE(664),
    [sym_command] = STATE(664),
    [sym_environment_variable_assignment] = STATE(665),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(653),
    [sym_command_substitution] = STATE(653),
    [aux_sym_command_repeat1] = STATE(661),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(1586),
    [anon_sym_while] = ACTIONS(1588),
    [anon_sym_if] = ACTIONS(1590),
    [anon_sym_case] = ACTIONS(1592),
    [anon_sym_function] = ACTIONS(1596),
    [anon_sym_LPAREN] = ACTIONS(1598),
    [anon_sym_LBRACK] = ACTIONS(1600),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1602),
    [anon_sym_COLON] = ACTIONS(1604),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(1606),
    [sym_raw_string] = ACTIONS(1608),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1610),
    [anon_sym_BQUOTE] = ACTIONS(1612),
    [sym_leading_word] = ACTIONS(1614),
    [sym_comment] = ACTIONS(115),
  },
  [594] = {
    [sym_for_statement] = STATE(666),
    [sym_while_statement] = STATE(666),
    [sym_if_statement] = STATE(666),
    [sym_case_statement] = STATE(666),
    [sym_function_definition] = STATE(666),
    [sym_subshell] = STATE(666),
    [sym_pipeline] = STATE(666),
    [sym_list] = STATE(666),
    [sym_bracket_command] = STATE(666),
    [sym_command] = STATE(666),
    [sym_environment_variable_assignment] = STATE(667),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(653),
    [sym_command_substitution] = STATE(653),
    [aux_sym_command_repeat1] = STATE(661),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(1586),
    [anon_sym_while] = ACTIONS(1588),
    [anon_sym_if] = ACTIONS(1590),
    [anon_sym_case] = ACTIONS(1592),
    [anon_sym_function] = ACTIONS(1596),
    [anon_sym_LPAREN] = ACTIONS(1598),
    [anon_sym_LBRACK] = ACTIONS(1600),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1602),
    [anon_sym_COLON] = ACTIONS(1604),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(1606),
    [sym_raw_string] = ACTIONS(1608),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1610),
    [anon_sym_BQUOTE] = ACTIONS(1612),
    [sym_leading_word] = ACTIONS(1614),
    [sym_comment] = ACTIONS(115),
  },
  [595] = {
    [sym_string] = STATE(42),
    [sym_simple_expansion] = STATE(42),
    [sym_expansion] = STATE(42),
    [sym_command_substitution] = STATE(42),
    [sym_process_substitution] = STATE(42),
    [aux_sym_bracket_command_repeat1] = STATE(668),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(147),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(157),
    [sym_comment] = ACTIONS(115),
  },
  [596] = {
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_SEMI_SEMI] = ACTIONS(573),
    [anon_sym_PIPE] = ACTIONS(573),
    [anon_sym_PIPE_AMP] = ACTIONS(573),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(573),
    [anon_sym_LF] = ACTIONS(573),
    [anon_sym_AMP] = ACTIONS(573),
  },
  [597] = {
    [sym_file_redirect] = STATE(675),
    [sym_heredoc_redirect] = STATE(675),
    [sym_string] = STATE(674),
    [sym_simple_expansion] = STATE(674),
    [sym_expansion] = STATE(674),
    [sym_command_substitution] = STATE(674),
    [sym_process_substitution] = STATE(674),
    [aux_sym_command_repeat2] = STATE(676),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(1637),
    [anon_sym_SEMI_SEMI] = ACTIONS(1637),
    [anon_sym_PIPE] = ACTIONS(1637),
    [anon_sym_PIPE_AMP] = ACTIONS(1637),
    [anon_sym_AMP_AMP] = ACTIONS(1637),
    [anon_sym_PIPE_PIPE] = ACTIONS(1637),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(1640),
    [anon_sym_LT] = ACTIONS(1642),
    [anon_sym_GT] = ACTIONS(1642),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1646),
    [anon_sym_DQUOTE] = ACTIONS(1648),
    [sym_raw_string] = ACTIONS(1650),
    [anon_sym_DOLLAR] = ACTIONS(1652),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1654),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1656),
    [anon_sym_BQUOTE] = ACTIONS(1658),
    [sym_word] = ACTIONS(1650),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1637),
    [anon_sym_LF] = ACTIONS(1637),
    [anon_sym_AMP] = ACTIONS(1637),
  },
  [598] = {
    [sym_string] = STATE(679),
    [sym_simple_expansion] = STATE(679),
    [sym_expansion] = STATE(679),
    [sym_command_substitution] = STATE(679),
    [sym_process_substitution] = STATE(679),
    [sym__empty_value] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1664),
    [anon_sym_GT] = ACTIONS(1664),
    [anon_sym_DQUOTE] = ACTIONS(1666),
    [sym_raw_string] = ACTIONS(1668),
    [anon_sym_DOLLAR] = ACTIONS(1670),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1672),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1674),
    [anon_sym_BQUOTE] = ACTIONS(1676),
    [sym_word] = ACTIONS(1678),
    [sym_comment] = ACTIONS(115),
  },
  [599] = {
    [sym_string] = STATE(687),
    [sym_simple_expansion] = STATE(687),
    [sym_expansion] = STATE(687),
    [sym_command_substitution] = STATE(687),
    [sym_process_substitution] = STATE(687),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(1682),
    [anon_sym_DQUOTE] = ACTIONS(1684),
    [sym_raw_string] = ACTIONS(1686),
    [anon_sym_DOLLAR] = ACTIONS(1688),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1692),
    [anon_sym_BQUOTE] = ACTIONS(1694),
    [sym_word] = ACTIONS(1696),
    [sym_comment] = ACTIONS(115),
  },
  [600] = {
    [sym_string] = STATE(687),
    [sym_simple_expansion] = STATE(687),
    [sym_expansion] = STATE(687),
    [sym_command_substitution] = STATE(687),
    [sym_process_substitution] = STATE(687),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(1682),
    [anon_sym_DQUOTE] = ACTIONS(1684),
    [sym_raw_string] = ACTIONS(1686),
    [anon_sym_DOLLAR] = ACTIONS(1688),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1692),
    [anon_sym_BQUOTE] = ACTIONS(1694),
    [sym_word] = ACTIONS(1696),
    [sym_comment] = ACTIONS(115),
  },
  [601] = {
    [sym_simple_expansion] = STATE(63),
    [sym_expansion] = STATE(63),
    [sym_command_substitution] = STATE(63),
    [aux_sym_string_repeat1] = STATE(636),
    [sym_file_descriptor] = ACTIONS(1698),
    [anon_sym_in] = ACTIONS(1701),
    [anon_sym_RPAREN] = ACTIONS(1701),
    [anon_sym_SEMI_SEMI] = ACTIONS(1701),
    [anon_sym_RBRACE] = ACTIONS(1701),
    [anon_sym_PIPE] = ACTIONS(1701),
    [anon_sym_PIPE_AMP] = ACTIONS(1701),
    [anon_sym_AMP_AMP] = ACTIONS(1701),
    [anon_sym_PIPE_PIPE] = ACTIONS(1701),
    [anon_sym_RBRACK] = ACTIONS(1701),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1701),
    [anon_sym_COLON] = ACTIONS(1701),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1701),
    [anon_sym_GT] = ACTIONS(1701),
    [anon_sym_GT_GT] = ACTIONS(1701),
    [anon_sym_AMP_GT] = ACTIONS(1701),
    [anon_sym_AMP_GT_GT] = ACTIONS(1701),
    [anon_sym_LT_AMP] = ACTIONS(1701),
    [anon_sym_GT_AMP] = ACTIONS(1701),
    [anon_sym_LT_LT] = ACTIONS(1701),
    [anon_sym_LT_LT_DASH] = ACTIONS(1701),
    [anon_sym_DQUOTE] = ACTIONS(1704),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(1701),
    [anon_sym_DOLLAR] = ACTIONS(1708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1716),
    [anon_sym_BQUOTE] = ACTIONS(1720),
    [sym_leading_word] = ACTIONS(1701),
    [sym_word] = ACTIONS(1701),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1701),
    [anon_sym_LF] = ACTIONS(1701),
    [anon_sym_AMP] = ACTIONS(1701),
  },
  [602] = {
    [sym_special_variable_name] = STATE(695),
    [sym__heredoc_middle] = ACTIONS(525),
    [sym__heredoc_end] = ACTIONS(525),
    [sym_file_descriptor] = ACTIONS(525),
    [anon_sym_in] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(519),
    [anon_sym_SEMI_SEMI] = ACTIONS(519),
    [anon_sym_RBRACE] = ACTIONS(519),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_PIPE_AMP] = ACTIONS(519),
    [anon_sym_AMP_AMP] = ACTIONS(519),
    [anon_sym_PIPE_PIPE] = ACTIONS(519),
    [anon_sym_RBRACK] = ACTIONS(519),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(519),
    [anon_sym_COLON] = ACTIONS(519),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_GT] = ACTIONS(519),
    [anon_sym_AMP_GT] = ACTIONS(519),
    [anon_sym_AMP_GT_GT] = ACTIONS(519),
    [anon_sym_LT_AMP] = ACTIONS(519),
    [anon_sym_GT_AMP] = ACTIONS(519),
    [anon_sym_LT_LT] = ACTIONS(519),
    [anon_sym_LT_LT_DASH] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(519),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(519),
    [sym_raw_string] = ACTIONS(519),
    [anon_sym_DOLLAR] = ACTIONS(1724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(519),
    [anon_sym_COLON_QMARK] = ACTIONS(527),
    [anon_sym_COLON_DASH] = ACTIONS(527),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(519),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [sym_leading_word] = ACTIONS(519),
    [sym_word] = ACTIONS(519),
    [sym_comment] = ACTIONS(73),
    [sym_simple_variable_name] = ACTIONS(1727),
    [anon_sym_STAR] = ACTIONS(1729),
    [anon_sym_AT] = ACTIONS(1729),
    [anon_sym_POUND] = ACTIONS(1729),
    [anon_sym_QMARK] = ACTIONS(1729),
    [anon_sym_DASH] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_0] = ACTIONS(1729),
    [anon_sym__] = ACTIONS(1729),
    [anon_sym_SEMI] = ACTIONS(519),
    [anon_sym_LF] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(519),
  },
  [603] = {
    [sym_command] = STATE(696),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_command_repeat1] = STATE(79),
    [sym_file_descriptor] = ACTIONS(1731),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_RBRACK] = ACTIONS(733),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(1734),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(1737),
    [anon_sym_GT] = ACTIONS(1737),
    [anon_sym_GT_GT] = ACTIONS(1737),
    [anon_sym_AMP_GT] = ACTIONS(1737),
    [anon_sym_AMP_GT_GT] = ACTIONS(1737),
    [anon_sym_LT_AMP] = ACTIONS(1737),
    [anon_sym_GT_AMP] = ACTIONS(1737),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(1740),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(1734),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1743),
    [anon_sym_BQUOTE] = ACTIONS(1746),
    [sym_leading_word] = ACTIONS(1749),
    [sym_word] = ACTIONS(733),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [604] = {
    [sym__heredoc_middle] = ACTIONS(525),
    [sym__heredoc_end] = ACTIONS(525),
    [sym_file_descriptor] = ACTIONS(525),
    [anon_sym_in] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(519),
    [anon_sym_SEMI_SEMI] = ACTIONS(519),
    [anon_sym_RBRACE] = ACTIONS(519),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_PIPE_AMP] = ACTIONS(519),
    [anon_sym_AMP_AMP] = ACTIONS(519),
    [anon_sym_PIPE_PIPE] = ACTIONS(519),
    [anon_sym_RBRACK] = ACTIONS(519),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(519),
    [anon_sym_COLON] = ACTIONS(519),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_GT] = ACTIONS(519),
    [anon_sym_AMP_GT] = ACTIONS(519),
    [anon_sym_AMP_GT_GT] = ACTIONS(519),
    [anon_sym_LT_AMP] = ACTIONS(519),
    [anon_sym_GT_AMP] = ACTIONS(519),
    [anon_sym_LT_LT] = ACTIONS(519),
    [anon_sym_LT_LT_DASH] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(519),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(519),
    [sym_raw_string] = ACTIONS(519),
    [anon_sym_DOLLAR] = ACTIONS(519),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(519),
    [anon_sym_COLON_QMARK] = ACTIONS(527),
    [anon_sym_COLON_DASH] = ACTIONS(527),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(519),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [sym_leading_word] = ACTIONS(519),
    [sym_word] = ACTIONS(519),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(519),
    [anon_sym_LF] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(519),
  },
  [605] = {
    [sym_case_item] = STATE(358),
    [sym_string] = STATE(356),
    [sym_simple_expansion] = STATE(356),
    [sym_expansion] = STATE(356),
    [sym_command_substitution] = STATE(356),
    [sym_process_substitution] = STATE(356),
    [aux_sym_case_statement_repeat1] = STATE(631),
    [sym_file_descriptor] = ACTIONS(451),
    [ts_builtin_sym_end] = ACTIONS(451),
    [anon_sym_for] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(1752),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(453),
    [anon_sym_done] = ACTIONS(453),
    [anon_sym_if] = ACTIONS(453),
    [anon_sym_then] = ACTIONS(453),
    [anon_sym_fi] = ACTIONS(453),
    [anon_sym_elif] = ACTIONS(453),
    [anon_sym_else] = ACTIONS(453),
    [anon_sym_case] = ACTIONS(453),
    [anon_sym_esac] = ACTIONS(1754),
    [anon_sym_RPAREN] = ACTIONS(451),
    [anon_sym_SEMI_SEMI] = ACTIONS(451),
    [anon_sym_function] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RBRACE] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1756),
    [anon_sym_GT] = ACTIONS(1756),
    [anon_sym_GT_GT] = ACTIONS(453),
    [anon_sym_AMP_GT] = ACTIONS(453),
    [anon_sym_AMP_GT_GT] = ACTIONS(453),
    [anon_sym_LT_AMP] = ACTIONS(453),
    [anon_sym_GT_AMP] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(1759),
    [sym_raw_string] = ACTIONS(1762),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1765),
    [anon_sym_BQUOTE] = ACTIONS(1768),
    [sym_leading_word] = ACTIONS(455),
    [sym_word] = ACTIONS(833),
    [sym_comment] = ACTIONS(115),
  },
  [606] = {
    [sym_file_descriptor] = ACTIONS(615),
    [anon_sym_RPAREN] = ACTIONS(617),
    [anon_sym_SEMI_SEMI] = ACTIONS(617),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_PIPE_AMP] = ACTIONS(617),
    [anon_sym_AMP_AMP] = ACTIONS(617),
    [anon_sym_PIPE_PIPE] = ACTIONS(617),
    [anon_sym_LT] = ACTIONS(617),
    [anon_sym_GT] = ACTIONS(617),
    [anon_sym_GT_GT] = ACTIONS(617),
    [anon_sym_AMP_GT] = ACTIONS(617),
    [anon_sym_AMP_GT_GT] = ACTIONS(617),
    [anon_sym_LT_AMP] = ACTIONS(617),
    [anon_sym_GT_AMP] = ACTIONS(617),
    [anon_sym_LT_LT] = ACTIONS(617),
    [anon_sym_LT_LT_DASH] = ACTIONS(617),
    [anon_sym_BQUOTE] = ACTIONS(617),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_LF] = ACTIONS(617),
    [anon_sym_AMP] = ACTIONS(617),
  },
  [607] = {
    [sym_simple_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [aux_sym_heredoc_repeat1] = STATE(635),
    [sym__heredoc_middle] = ACTIONS(619),
    [sym__heredoc_end] = ACTIONS(1771),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(625),
    [sym_comment] = ACTIONS(115),
  },
  [608] = {
    [sym__heredoc_middle] = ACTIONS(1773),
    [sym__heredoc_end] = ACTIONS(1773),
    [anon_sym_DOLLAR] = ACTIONS(1776),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1773),
    [sym_comment] = ACTIONS(115),
  },
  [609] = {
    [sym_file_descriptor] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(1782),
    [anon_sym_SEMI_SEMI] = ACTIONS(1782),
    [anon_sym_PIPE] = ACTIONS(1782),
    [anon_sym_PIPE_AMP] = ACTIONS(1782),
    [anon_sym_AMP_AMP] = ACTIONS(1782),
    [anon_sym_PIPE_PIPE] = ACTIONS(1782),
    [anon_sym_LT] = ACTIONS(1782),
    [anon_sym_GT] = ACTIONS(1782),
    [anon_sym_GT_GT] = ACTIONS(1782),
    [anon_sym_AMP_GT] = ACTIONS(1782),
    [anon_sym_AMP_GT_GT] = ACTIONS(1782),
    [anon_sym_LT_AMP] = ACTIONS(1782),
    [anon_sym_GT_AMP] = ACTIONS(1782),
    [anon_sym_LT_LT] = ACTIONS(1782),
    [anon_sym_LT_LT_DASH] = ACTIONS(1782),
    [anon_sym_BQUOTE] = ACTIONS(1782),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1782),
    [anon_sym_LF] = ACTIONS(1782),
    [anon_sym_AMP] = ACTIONS(1782),
  },
  [610] = {
    [anon_sym_LT] = ACTIONS(1785),
    [anon_sym_GT] = ACTIONS(1785),
    [anon_sym_GT_GT] = ACTIONS(1787),
    [anon_sym_AMP_GT] = ACTIONS(1785),
    [anon_sym_AMP_GT_GT] = ACTIONS(1787),
    [anon_sym_LT_AMP] = ACTIONS(1787),
    [anon_sym_GT_AMP] = ACTIONS(1787),
    [sym_comment] = ACTIONS(115),
  },
  [611] = {
    [sym_file_descriptor] = ACTIONS(749),
    [anon_sym_RPAREN] = ACTIONS(751),
    [anon_sym_SEMI_SEMI] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_PIPE_AMP] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_LT] = ACTIONS(751),
    [anon_sym_GT] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_AMP_GT] = ACTIONS(751),
    [anon_sym_AMP_GT_GT] = ACTIONS(751),
    [anon_sym_LT_AMP] = ACTIONS(751),
    [anon_sym_GT_AMP] = ACTIONS(751),
    [anon_sym_DQUOTE] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(751),
    [anon_sym_BQUOTE] = ACTIONS(751),
    [sym_leading_word] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_LF] = ACTIONS(751),
    [anon_sym_AMP] = ACTIONS(751),
  },
  [612] = {
    [sym_do_group] = STATE(614),
    [sym_file_descriptor] = ACTIONS(1789),
    [ts_builtin_sym_end] = ACTIONS(1789),
    [anon_sym_for] = ACTIONS(1792),
    [anon_sym_while] = ACTIONS(1792),
    [anon_sym_do] = ACTIONS(1795),
    [anon_sym_done] = ACTIONS(1792),
    [anon_sym_if] = ACTIONS(1792),
    [anon_sym_then] = ACTIONS(1797),
    [anon_sym_fi] = ACTIONS(1792),
    [anon_sym_elif] = ACTIONS(1792),
    [anon_sym_else] = ACTIONS(1792),
    [anon_sym_case] = ACTIONS(1792),
    [anon_sym_RPAREN] = ACTIONS(1789),
    [anon_sym_SEMI_SEMI] = ACTIONS(1789),
    [anon_sym_function] = ACTIONS(1792),
    [anon_sym_LPAREN] = ACTIONS(1789),
    [anon_sym_RBRACE] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1792),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1792),
    [anon_sym_COLON] = ACTIONS(1789),
    [anon_sym_LT] = ACTIONS(1792),
    [anon_sym_GT] = ACTIONS(1792),
    [anon_sym_GT_GT] = ACTIONS(1792),
    [anon_sym_AMP_GT] = ACTIONS(1792),
    [anon_sym_AMP_GT_GT] = ACTIONS(1792),
    [anon_sym_LT_AMP] = ACTIONS(1792),
    [anon_sym_GT_AMP] = ACTIONS(1792),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [sym_raw_string] = ACTIONS(1792),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1789),
    [anon_sym_BQUOTE] = ACTIONS(1789),
    [sym_leading_word] = ACTIONS(1799),
    [sym_comment] = ACTIONS(115),
  },
  [613] = {
    [anon_sym_RPAREN] = ACTIONS(1802),
    [anon_sym_SEMI_SEMI] = ACTIONS(1806),
    [anon_sym_PIPE] = ACTIONS(1810),
    [anon_sym_PIPE_AMP] = ACTIONS(1810),
    [anon_sym_AMP_AMP] = ACTIONS(1814),
    [anon_sym_PIPE_PIPE] = ACTIONS(1814),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1806),
    [anon_sym_LF] = ACTIONS(1806),
    [anon_sym_AMP] = ACTIONS(1806),
  },
  [614] = {
    [anon_sym_RPAREN] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_LF] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1818),
  },
  [615] = {
    [anon_sym_fi] = ACTIONS(1821),
    [anon_sym_elif] = ACTIONS(1821),
    [anon_sym_else] = ACTIONS(1821),
    [sym_comment] = ACTIONS(115),
  },
  [616] = {
    [anon_sym_fi] = ACTIONS(1824),
    [sym_comment] = ACTIONS(115),
  },
  [617] = {
    [anon_sym_esac] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1829),
    [anon_sym_GT] = ACTIONS(1829),
    [anon_sym_DQUOTE] = ACTIONS(1829),
    [sym_raw_string] = ACTIONS(1826),
    [anon_sym_DOLLAR] = ACTIONS(1826),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1829),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1829),
    [anon_sym_BQUOTE] = ACTIONS(1829),
    [sym_word] = ACTIONS(1832),
    [sym_comment] = ACTIONS(115),
  },
  [618] = {
    [anon_sym_RPAREN] = ACTIONS(1835),
    [anon_sym_SEMI_SEMI] = ACTIONS(1835),
    [anon_sym_PIPE] = ACTIONS(1835),
    [anon_sym_PIPE_AMP] = ACTIONS(1835),
    [anon_sym_AMP_AMP] = ACTIONS(1835),
    [anon_sym_PIPE_PIPE] = ACTIONS(1835),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1835),
    [anon_sym_LF] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
  },
  [619] = {
    [anon_sym_RPAREN] = ACTIONS(1838),
    [anon_sym_SEMI_SEMI] = ACTIONS(1842),
    [anon_sym_PIPE] = ACTIONS(1846),
    [anon_sym_PIPE_AMP] = ACTIONS(1846),
    [anon_sym_AMP_AMP] = ACTIONS(1850),
    [anon_sym_PIPE_PIPE] = ACTIONS(1850),
    [anon_sym_BQUOTE] = ACTIONS(1854),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1842),
    [anon_sym_LF] = ACTIONS(1842),
    [anon_sym_AMP] = ACTIONS(1842),
  },
  [620] = {
    [sym_file_descriptor] = ACTIONS(1856),
    [anon_sym_RPAREN] = ACTIONS(1802),
    [anon_sym_SEMI_SEMI] = ACTIONS(1806),
    [anon_sym_PIPE] = ACTIONS(1810),
    [anon_sym_PIPE_AMP] = ACTIONS(1810),
    [anon_sym_AMP_AMP] = ACTIONS(1814),
    [anon_sym_PIPE_PIPE] = ACTIONS(1814),
    [anon_sym_COLON] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1859),
    [anon_sym_GT] = ACTIONS(1859),
    [anon_sym_GT_GT] = ACTIONS(1859),
    [anon_sym_AMP_GT] = ACTIONS(1859),
    [anon_sym_AMP_GT_GT] = ACTIONS(1859),
    [anon_sym_LT_AMP] = ACTIONS(1859),
    [anon_sym_GT_AMP] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_raw_string] = ACTIONS(1859),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1859),
    [anon_sym_BQUOTE] = ACTIONS(1859),
    [sym_leading_word] = ACTIONS(1859),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1806),
    [anon_sym_LF] = ACTIONS(1806),
    [anon_sym_AMP] = ACTIONS(1806),
  },
  [621] = {
    [sym_file_descriptor] = ACTIONS(1862),
    [anon_sym_RPAREN] = ACTIONS(1867),
    [anon_sym_SEMI_SEMI] = ACTIONS(1867),
    [anon_sym_PIPE] = ACTIONS(1867),
    [anon_sym_PIPE_AMP] = ACTIONS(1867),
    [anon_sym_AMP_AMP] = ACTIONS(1867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1867),
    [anon_sym_COLON] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1870),
    [anon_sym_GT] = ACTIONS(1870),
    [anon_sym_GT_GT] = ACTIONS(1870),
    [anon_sym_AMP_GT] = ACTIONS(1870),
    [anon_sym_AMP_GT_GT] = ACTIONS(1870),
    [anon_sym_LT_AMP] = ACTIONS(1870),
    [anon_sym_GT_AMP] = ACTIONS(1870),
    [anon_sym_LT_LT] = ACTIONS(1867),
    [anon_sym_LT_LT_DASH] = ACTIONS(1867),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_raw_string] = ACTIONS(1859),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1859),
    [anon_sym_BQUOTE] = ACTIONS(1870),
    [sym_leading_word] = ACTIONS(1859),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1867),
    [anon_sym_LF] = ACTIONS(1867),
    [anon_sym_AMP] = ACTIONS(1867),
  },
  [622] = {
    [sym_file_descriptor] = ACTIONS(1875),
    [anon_sym_RPAREN] = ACTIONS(1867),
    [anon_sym_SEMI_SEMI] = ACTIONS(1867),
    [anon_sym_PIPE] = ACTIONS(1867),
    [anon_sym_PIPE_AMP] = ACTIONS(1867),
    [anon_sym_AMP_AMP] = ACTIONS(1867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1867),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_GT] = ACTIONS(1867),
    [anon_sym_AMP_GT] = ACTIONS(1867),
    [anon_sym_AMP_GT_GT] = ACTIONS(1867),
    [anon_sym_LT_AMP] = ACTIONS(1867),
    [anon_sym_GT_AMP] = ACTIONS(1867),
    [anon_sym_LT_LT] = ACTIONS(1867),
    [anon_sym_LT_LT_DASH] = ACTIONS(1867),
    [anon_sym_BQUOTE] = ACTIONS(1867),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1867),
    [anon_sym_LF] = ACTIONS(1867),
    [anon_sym_AMP] = ACTIONS(1867),
  },
  [623] = {
    [sym_file_descriptor] = ACTIONS(627),
    [anon_sym_RPAREN] = ACTIONS(629),
    [anon_sym_SEMI_SEMI] = ACTIONS(629),
    [anon_sym_PIPE] = ACTIONS(629),
    [anon_sym_PIPE_AMP] = ACTIONS(629),
    [anon_sym_AMP_AMP] = ACTIONS(629),
    [anon_sym_PIPE_PIPE] = ACTIONS(629),
    [anon_sym_LT] = ACTIONS(629),
    [anon_sym_GT] = ACTIONS(629),
    [anon_sym_GT_GT] = ACTIONS(629),
    [anon_sym_AMP_GT] = ACTIONS(629),
    [anon_sym_AMP_GT_GT] = ACTIONS(629),
    [anon_sym_LT_AMP] = ACTIONS(629),
    [anon_sym_GT_AMP] = ACTIONS(629),
    [anon_sym_LT_LT] = ACTIONS(629),
    [anon_sym_LT_LT_DASH] = ACTIONS(629),
    [anon_sym_BQUOTE] = ACTIONS(629),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym_LF] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
  },
  [624] = {
    [sym_file_redirect] = STATE(675),
    [sym_heredoc_redirect] = STATE(675),
    [aux_sym_command_repeat2] = STATE(676),
    [sym_file_descriptor] = ACTIONS(1878),
    [anon_sym_in] = ACTIONS(1885),
    [anon_sym_RPAREN] = ACTIONS(1887),
    [anon_sym_SEMI_SEMI] = ACTIONS(1896),
    [anon_sym_RBRACE] = ACTIONS(1905),
    [anon_sym_PIPE] = ACTIONS(1907),
    [anon_sym_PIPE_AMP] = ACTIONS(1907),
    [anon_sym_AMP_AMP] = ACTIONS(1907),
    [anon_sym_PIPE_PIPE] = ACTIONS(1907),
    [anon_sym_RBRACK] = ACTIONS(1915),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1915),
    [anon_sym_COLON] = ACTIONS(1918),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(1640),
    [anon_sym_LT] = ACTIONS(1922),
    [anon_sym_GT] = ACTIONS(1922),
    [anon_sym_GT_GT] = ACTIONS(1922),
    [anon_sym_AMP_GT] = ACTIONS(1922),
    [anon_sym_AMP_GT_GT] = ACTIONS(1922),
    [anon_sym_LT_AMP] = ACTIONS(1922),
    [anon_sym_GT_AMP] = ACTIONS(1922),
    [anon_sym_LT_LT] = ACTIONS(1929),
    [anon_sym_LT_LT_DASH] = ACTIONS(1929),
    [anon_sym_DQUOTE] = ACTIONS(1935),
    [sym_raw_string] = ACTIONS(1935),
    [anon_sym_DOLLAR] = ACTIONS(1915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1935),
    [anon_sym_BQUOTE] = ACTIONS(1907),
    [sym_leading_word] = ACTIONS(1918),
    [sym_word] = ACTIONS(1915),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1896),
    [anon_sym_LF] = ACTIONS(1896),
    [anon_sym_AMP] = ACTIONS(1896),
  },
  [625] = {
    [sym__heredoc_middle] = ACTIONS(1773),
    [sym__heredoc_end] = ACTIONS(1773),
    [sym_file_descriptor] = ACTIONS(1941),
    [anon_sym_in] = ACTIONS(1885),
    [anon_sym_RPAREN] = ACTIONS(1947),
    [anon_sym_SEMI_SEMI] = ACTIONS(1954),
    [anon_sym_RBRACE] = ACTIONS(1905),
    [anon_sym_PIPE] = ACTIONS(1935),
    [anon_sym_PIPE_AMP] = ACTIONS(1935),
    [anon_sym_AMP_AMP] = ACTIONS(1935),
    [anon_sym_PIPE_PIPE] = ACTIONS(1935),
    [anon_sym_RBRACK] = ACTIONS(1915),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1915),
    [anon_sym_COLON] = ACTIONS(1918),
    [anon_sym_LT] = ACTIONS(1935),
    [anon_sym_GT] = ACTIONS(1935),
    [anon_sym_GT_GT] = ACTIONS(1935),
    [anon_sym_AMP_GT] = ACTIONS(1935),
    [anon_sym_AMP_GT_GT] = ACTIONS(1935),
    [anon_sym_LT_AMP] = ACTIONS(1935),
    [anon_sym_GT_AMP] = ACTIONS(1935),
    [anon_sym_LT_LT] = ACTIONS(1961),
    [anon_sym_LT_LT_DASH] = ACTIONS(1961),
    [anon_sym_DQUOTE] = ACTIONS(1966),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1974),
    [sym_raw_string] = ACTIONS(1935),
    [anon_sym_DOLLAR] = ACTIONS(1977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1966),
    [anon_sym_BQUOTE] = ACTIONS(1966),
    [sym_leading_word] = ACTIONS(1918),
    [sym_word] = ACTIONS(1915),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1954),
    [anon_sym_LF] = ACTIONS(1954),
    [anon_sym_AMP] = ACTIONS(1954),
  },
  [626] = {
    [sym_file_redirect] = STATE(675),
    [sym_heredoc_redirect] = STATE(675),
    [aux_sym_command_repeat2] = STATE(676),
    [sym_file_descriptor] = ACTIONS(1878),
    [anon_sym_in] = ACTIONS(1885),
    [anon_sym_RPAREN] = ACTIONS(1887),
    [anon_sym_SEMI_SEMI] = ACTIONS(1896),
    [anon_sym_RBRACE] = ACTIONS(1905),
    [anon_sym_PIPE] = ACTIONS(1907),
    [anon_sym_PIPE_AMP] = ACTIONS(1907),
    [anon_sym_AMP_AMP] = ACTIONS(1907),
    [anon_sym_PIPE_PIPE] = ACTIONS(1907),
    [anon_sym_RBRACK] = ACTIONS(1915),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1915),
    [anon_sym_COLON] = ACTIONS(1918),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(1640),
    [anon_sym_LT] = ACTIONS(1922),
    [anon_sym_GT] = ACTIONS(1922),
    [anon_sym_GT_GT] = ACTIONS(1922),
    [anon_sym_AMP_GT] = ACTIONS(1922),
    [anon_sym_AMP_GT_GT] = ACTIONS(1922),
    [anon_sym_LT_AMP] = ACTIONS(1922),
    [anon_sym_GT_AMP] = ACTIONS(1922),
    [anon_sym_LT_LT] = ACTIONS(1929),
    [anon_sym_LT_LT_DASH] = ACTIONS(1929),
    [anon_sym_DQUOTE] = ACTIONS(1966),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1974),
    [sym_raw_string] = ACTIONS(1935),
    [anon_sym_DOLLAR] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1966),
    [anon_sym_BQUOTE] = ACTIONS(1989),
    [sym_leading_word] = ACTIONS(1918),
    [sym_word] = ACTIONS(1915),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1896),
    [anon_sym_LF] = ACTIONS(1896),
    [anon_sym_AMP] = ACTIONS(1896),
  },
  [627] = {
    [sym_file_descriptor] = ACTIONS(1941),
    [anon_sym_in] = ACTIONS(1885),
    [anon_sym_RPAREN] = ACTIONS(1947),
    [anon_sym_SEMI_SEMI] = ACTIONS(1954),
    [anon_sym_RBRACE] = ACTIONS(1905),
    [anon_sym_PIPE] = ACTIONS(1935),
    [anon_sym_PIPE_AMP] = ACTIONS(1935),
    [anon_sym_AMP_AMP] = ACTIONS(1935),
    [anon_sym_PIPE_PIPE] = ACTIONS(1935),
    [anon_sym_RBRACK] = ACTIONS(1915),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1915),
    [anon_sym_COLON] = ACTIONS(1918),
    [anon_sym_LT] = ACTIONS(1935),
    [anon_sym_GT] = ACTIONS(1935),
    [anon_sym_GT_GT] = ACTIONS(1935),
    [anon_sym_AMP_GT] = ACTIONS(1935),
    [anon_sym_AMP_GT_GT] = ACTIONS(1935),
    [anon_sym_LT_AMP] = ACTIONS(1935),
    [anon_sym_GT_AMP] = ACTIONS(1935),
    [anon_sym_LT_LT] = ACTIONS(1961),
    [anon_sym_LT_LT_DASH] = ACTIONS(1961),
    [anon_sym_DQUOTE] = ACTIONS(1935),
    [sym_raw_string] = ACTIONS(1935),
    [anon_sym_DOLLAR] = ACTIONS(1915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1935),
    [anon_sym_BQUOTE] = ACTIONS(1935),
    [sym_leading_word] = ACTIONS(1918),
    [sym_word] = ACTIONS(1915),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1954),
    [anon_sym_LF] = ACTIONS(1954),
    [anon_sym_AMP] = ACTIONS(1954),
  },
  [628] = {
    [sym__heredoc_middle] = ACTIONS(555),
    [sym__heredoc_end] = ACTIONS(555),
    [sym_file_descriptor] = ACTIONS(555),
    [anon_sym_in] = ACTIONS(523),
    [anon_sym_RPAREN] = ACTIONS(523),
    [anon_sym_SEMI_SEMI] = ACTIONS(523),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(523),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(523),
    [anon_sym_PIPE_PIPE] = ACTIONS(523),
    [anon_sym_RBRACK] = ACTIONS(523),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(523),
    [anon_sym_COLON] = ACTIONS(2002),
    [anon_sym_EQ] = ACTIONS(2005),
    [anon_sym_LT] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(523),
    [anon_sym_GT_GT] = ACTIONS(523),
    [anon_sym_AMP_GT] = ACTIONS(523),
    [anon_sym_AMP_GT_GT] = ACTIONS(523),
    [anon_sym_LT_AMP] = ACTIONS(523),
    [anon_sym_GT_AMP] = ACTIONS(523),
    [anon_sym_LT_LT] = ACTIONS(523),
    [anon_sym_LT_LT_DASH] = ACTIONS(523),
    [anon_sym_DQUOTE] = ACTIONS(523),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(523),
    [sym_raw_string] = ACTIONS(523),
    [anon_sym_DOLLAR] = ACTIONS(523),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(523),
    [anon_sym_COLON_QMARK] = ACTIONS(2007),
    [anon_sym_COLON_DASH] = ACTIONS(2007),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(523),
    [anon_sym_BQUOTE] = ACTIONS(523),
    [sym_leading_word] = ACTIONS(523),
    [sym_word] = ACTIONS(523),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(523),
    [anon_sym_LF] = ACTIONS(523),
    [anon_sym_AMP] = ACTIONS(523),
  },
  [629] = {
    [sym__terminated_statement] = STATE(87),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_elif_clause] = STATE(207),
    [sym_else_clause] = STATE(714),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_if_statement_repeat1] = STATE(715),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [ts_builtin_sym_end] = ACTIONS(243),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_done] = ACTIONS(2009),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_fi] = ACTIONS(2011),
    [anon_sym_elif] = ACTIONS(2015),
    [anon_sym_else] = ACTIONS(2018),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_RPAREN] = ACTIONS(2021),
    [anon_sym_SEMI_SEMI] = ACTIONS(1393),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(2023),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [630] = {
    [sym_elif_clause] = STATE(333),
    [sym_else_clause] = STATE(717),
    [anon_sym_fi] = ACTIONS(2025),
    [anon_sym_elif] = ACTIONS(787),
    [anon_sym_else] = ACTIONS(789),
    [sym_comment] = ACTIONS(115),
  },
  [631] = {
    [sym_case_item] = STATE(462),
    [sym_string] = STATE(356),
    [sym_simple_expansion] = STATE(356),
    [sym_expansion] = STATE(356),
    [sym_command_substitution] = STATE(356),
    [sym_process_substitution] = STATE(356),
    [anon_sym_esac] = ACTIONS(2027),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(829),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(833),
    [sym_comment] = ACTIONS(115),
  },
  [632] = {
    [sym_file_redirect] = STATE(675),
    [sym_heredoc_redirect] = STATE(675),
    [sym_string] = STATE(721),
    [sym_simple_expansion] = STATE(721),
    [sym_expansion] = STATE(721),
    [sym_command_substitution] = STATE(721),
    [sym_process_substitution] = STATE(721),
    [aux_sym_command_repeat2] = STATE(726),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(2029),
    [anon_sym_SEMI_SEMI] = ACTIONS(2029),
    [anon_sym_PIPE] = ACTIONS(2029),
    [anon_sym_PIPE_AMP] = ACTIONS(2029),
    [anon_sym_AMP_AMP] = ACTIONS(2029),
    [anon_sym_PIPE_PIPE] = ACTIONS(2029),
    [anon_sym_RBRACK] = ACTIONS(2034),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2034),
    [anon_sym_LT] = ACTIONS(2036),
    [anon_sym_GT] = ACTIONS(2036),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1646),
    [anon_sym_DQUOTE] = ACTIONS(2038),
    [sym_raw_string] = ACTIONS(2040),
    [anon_sym_DOLLAR] = ACTIONS(2042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2046),
    [anon_sym_BQUOTE] = ACTIONS(2048),
    [sym_word] = ACTIONS(2040),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_LF] = ACTIONS(2029),
    [anon_sym_AMP] = ACTIONS(2029),
  },
  [633] = {
    [sym_environment_variable_assignment] = STATE(90),
    [sym_file_redirect] = STATE(90),
    [sym_string] = STATE(727),
    [sym_command_substitution] = STATE(727),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(2054),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(2056),
    [sym_raw_string] = ACTIONS(2058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2060),
    [anon_sym_BQUOTE] = ACTIONS(2062),
    [sym_leading_word] = ACTIONS(2064),
    [sym_comment] = ACTIONS(115),
  },
  [634] = {
    [sym_file_redirect] = STATE(732),
    [sym_heredoc_redirect] = STATE(732),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(2066),
    [anon_sym_SEMI_SEMI] = ACTIONS(2066),
    [anon_sym_PIPE] = ACTIONS(2066),
    [anon_sym_PIPE_AMP] = ACTIONS(2066),
    [anon_sym_AMP_AMP] = ACTIONS(2066),
    [anon_sym_PIPE_PIPE] = ACTIONS(2066),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1646),
    [anon_sym_BQUOTE] = ACTIONS(2066),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(2066),
    [anon_sym_LF] = ACTIONS(2066),
    [anon_sym_AMP] = ACTIONS(2066),
  },
  [635] = {
    [sym_simple_expansion] = STATE(388),
    [sym_expansion] = STATE(388),
    [sym__heredoc_middle] = ACTIONS(921),
    [sym__heredoc_end] = ACTIONS(2077),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(625),
    [sym_comment] = ACTIONS(115),
  },
  [636] = {
    [sym_simple_expansion] = STATE(163),
    [sym_expansion] = STATE(163),
    [sym_command_substitution] = STATE(163),
    [anon_sym_DQUOTE] = ACTIONS(2079),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [637] = {
    [anon_sym_in] = ACTIONS(2081),
    [sym_comment] = ACTIONS(115),
  },
  [638] = {
    [sym_case_item] = STATE(358),
    [sym_string] = STATE(356),
    [sym_simple_expansion] = STATE(356),
    [sym_expansion] = STATE(356),
    [sym_command_substitution] = STATE(356),
    [sym_process_substitution] = STATE(356),
    [aux_sym_case_statement_repeat1] = STATE(631),
    [anon_sym_esac] = ACTIONS(1754),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(829),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(833),
    [sym_comment] = ACTIONS(115),
  },
  [639] = {
    [sym_do_group] = STATE(736),
    [anon_sym_do] = ACTIONS(2083),
    [sym_comment] = ACTIONS(115),
  },
  [640] = {
    [sym_do_group] = STATE(737),
    [anon_sym_do] = ACTIONS(2083),
    [sym_comment] = ACTIONS(115),
  },
  [641] = {
    [anon_sym_RPAREN] = ACTIONS(773),
    [anon_sym_SEMI_SEMI] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(773),
    [anon_sym_PIPE_AMP] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(773),
    [anon_sym_LF] = ACTIONS(773),
    [anon_sym_AMP] = ACTIONS(773),
  },
  [642] = {
    [sym__terminated_statement] = STATE(87),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_done] = ACTIONS(2009),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [643] = {
    [anon_sym_then] = ACTIONS(2085),
    [sym_comment] = ACTIONS(115),
  },
  [644] = {
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_SEMI_SEMI] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_PIPE_AMP] = ACTIONS(777),
    [anon_sym_AMP_AMP] = ACTIONS(777),
    [anon_sym_PIPE_PIPE] = ACTIONS(777),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_LF] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(777),
  },
  [645] = {
    [anon_sym_fi] = ACTIONS(2087),
    [sym_comment] = ACTIONS(115),
  },
  [646] = {
    [sym__terminated_statement] = STATE(87),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_elif_clause] = STATE(207),
    [sym_else_clause] = STATE(714),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_if_statement_repeat1] = STATE(715),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_fi] = ACTIONS(2089),
    [anon_sym_elif] = ACTIONS(2015),
    [anon_sym_else] = ACTIONS(2018),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [647] = {
    [sym_elif_clause] = STATE(333),
    [sym_else_clause] = STATE(714),
    [anon_sym_fi] = ACTIONS(2087),
    [anon_sym_elif] = ACTIONS(787),
    [anon_sym_else] = ACTIONS(789),
    [sym_comment] = ACTIONS(115),
  },
  [648] = {
    [anon_sym_in] = ACTIONS(1885),
    [anon_sym_SEMI_SEMI] = ACTIONS(2092),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(2092),
    [anon_sym_LF] = ACTIONS(2092),
    [anon_sym_AMP] = ACTIONS(2092),
  },
  [649] = {
    [anon_sym_LPAREN] = ACTIONS(2094),
    [sym_comment] = ACTIONS(115),
  },
  [650] = {
    [sym_compound_statement] = STATE(618),
    [anon_sym_RPAREN] = ACTIONS(283),
    [anon_sym_SEMI_SEMI] = ACTIONS(283),
    [anon_sym_LBRACE] = ACTIONS(1558),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_PIPE_AMP] = ACTIONS(283),
    [anon_sym_AMP_AMP] = ACTIONS(283),
    [anon_sym_PIPE_PIPE] = ACTIONS(283),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(283),
    [anon_sym_LF] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(283),
  },
  [651] = {
    [sym__terminated_statement] = STATE(18),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_program_repeat1] = STATE(660),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_RPAREN] = ACTIONS(2096),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [652] = {
    [sym_string] = STATE(42),
    [sym_simple_expansion] = STATE(42),
    [sym_expansion] = STATE(42),
    [sym_command_substitution] = STATE(42),
    [sym_process_substitution] = STATE(42),
    [aux_sym_bracket_command_repeat1] = STATE(741),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(147),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(157),
    [sym_comment] = ACTIONS(115),
  },
  [653] = {
    [sym_file_redirect] = STATE(746),
    [sym_heredoc_redirect] = STATE(746),
    [aux_sym_command_repeat2] = STATE(747),
    [sym_file_descriptor] = ACTIONS(2098),
    [anon_sym_RPAREN] = ACTIONS(161),
    [anon_sym_SEMI_SEMI] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_PIPE_AMP] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(161),
    [anon_sym_PIPE_PIPE] = ACTIONS(161),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2100),
    [anon_sym_LT] = ACTIONS(2102),
    [anon_sym_GT] = ACTIONS(2102),
    [anon_sym_GT_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT_GT] = ACTIONS(2102),
    [anon_sym_LT_AMP] = ACTIONS(2102),
    [anon_sym_GT_AMP] = ACTIONS(2102),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2104),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_LF] = ACTIONS(161),
    [anon_sym_AMP] = ACTIONS(161),
  },
  [654] = {
    [sym_simple_expansion] = STATE(63),
    [sym_expansion] = STATE(63),
    [sym_command_substitution] = STATE(63),
    [aux_sym_string_repeat1] = STATE(749),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [655] = {
    [sym_command] = STATE(750),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(75),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(207),
    [sym_comment] = ACTIONS(115),
  },
  [656] = {
    [sym_command] = STATE(751),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_command_repeat1] = STATE(79),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(213),
    [sym_comment] = ACTIONS(115),
  },
  [657] = {
    [sym_file_redirect] = STATE(746),
    [sym_heredoc_redirect] = STATE(746),
    [aux_sym_command_repeat2] = STATE(755),
    [sym_file_descriptor] = ACTIONS(2098),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_SEMI_SEMI] = ACTIONS(215),
    [anon_sym_LPAREN] = ACTIONS(2108),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_PIPE_AMP] = ACTIONS(215),
    [anon_sym_AMP_AMP] = ACTIONS(215),
    [anon_sym_PIPE_PIPE] = ACTIONS(215),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2110),
    [anon_sym_EQ] = ACTIONS(2112),
    [anon_sym_LT] = ACTIONS(2102),
    [anon_sym_GT] = ACTIONS(2102),
    [anon_sym_GT_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT_GT] = ACTIONS(2102),
    [anon_sym_LT_AMP] = ACTIONS(2102),
    [anon_sym_GT_AMP] = ACTIONS(2102),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2104),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(215),
    [anon_sym_LF] = ACTIONS(215),
    [anon_sym_AMP] = ACTIONS(215),
  },
  [658] = {
    [anon_sym_RPAREN] = ACTIONS(2114),
    [anon_sym_SEMI_SEMI] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(2116),
    [anon_sym_PIPE_AMP] = ACTIONS(2116),
    [anon_sym_AMP_AMP] = ACTIONS(2118),
    [anon_sym_PIPE_PIPE] = ACTIONS(2118),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(231),
    [anon_sym_LF] = ACTIONS(231),
    [anon_sym_AMP] = ACTIONS(231),
  },
  [659] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(2114),
    [anon_sym_SEMI_SEMI] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(2116),
    [anon_sym_PIPE_AMP] = ACTIONS(2116),
    [anon_sym_AMP_AMP] = ACTIONS(2118),
    [anon_sym_PIPE_PIPE] = ACTIONS(2118),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_LT] = ACTIONS(239),
    [anon_sym_GT] = ACTIONS(239),
    [anon_sym_GT_GT] = ACTIONS(239),
    [anon_sym_AMP_GT] = ACTIONS(239),
    [anon_sym_AMP_GT_GT] = ACTIONS(239),
    [anon_sym_LT_AMP] = ACTIONS(239),
    [anon_sym_GT_AMP] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [sym_raw_string] = ACTIONS(239),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(231),
    [anon_sym_LF] = ACTIONS(231),
    [anon_sym_AMP] = ACTIONS(231),
  },
  [660] = {
    [sym__terminated_statement] = STATE(87),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_RPAREN] = ACTIONS(2021),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [661] = {
    [sym_environment_variable_assignment] = STATE(90),
    [sym_file_redirect] = STATE(90),
    [sym_string] = STATE(756),
    [sym_command_substitution] = STATE(756),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(2120),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(1606),
    [sym_raw_string] = ACTIONS(2122),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1610),
    [anon_sym_BQUOTE] = ACTIONS(1612),
    [sym_leading_word] = ACTIONS(2124),
    [sym_comment] = ACTIONS(115),
  },
  [662] = {
    [anon_sym_RPAREN] = ACTIONS(1191),
    [anon_sym_SEMI_SEMI] = ACTIONS(1191),
    [anon_sym_PIPE] = ACTIONS(1191),
    [anon_sym_PIPE_AMP] = ACTIONS(1191),
    [anon_sym_AMP_AMP] = ACTIONS(1191),
    [anon_sym_PIPE_PIPE] = ACTIONS(1191),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1191),
    [anon_sym_LF] = ACTIONS(1191),
    [anon_sym_AMP] = ACTIONS(1191),
  },
  [663] = {
    [sym__terminated_statement] = STATE(87),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(2023),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [664] = {
    [anon_sym_RPAREN] = ACTIONS(765),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(2126),
    [anon_sym_PIPE_AMP] = ACTIONS(2126),
    [anon_sym_AMP_AMP] = ACTIONS(2129),
    [anon_sym_PIPE_PIPE] = ACTIONS(2129),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(765),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(765),
  },
  [665] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(765),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(2126),
    [anon_sym_PIPE_AMP] = ACTIONS(2126),
    [anon_sym_AMP_AMP] = ACTIONS(2129),
    [anon_sym_PIPE_PIPE] = ACTIONS(2129),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_LT] = ACTIONS(239),
    [anon_sym_GT] = ACTIONS(239),
    [anon_sym_GT_GT] = ACTIONS(239),
    [anon_sym_AMP_GT] = ACTIONS(239),
    [anon_sym_AMP_GT_GT] = ACTIONS(239),
    [anon_sym_LT_AMP] = ACTIONS(239),
    [anon_sym_GT_AMP] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [sym_raw_string] = ACTIONS(239),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(765),
    [anon_sym_LF] = ACTIONS(765),
    [anon_sym_AMP] = ACTIONS(765),
  },
  [666] = {
    [anon_sym_RPAREN] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_PIPE_AMP] = ACTIONS(2132),
    [anon_sym_AMP_AMP] = ACTIONS(2135),
    [anon_sym_PIPE_PIPE] = ACTIONS(2135),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [667] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(767),
    [anon_sym_SEMI_SEMI] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_PIPE_AMP] = ACTIONS(2132),
    [anon_sym_AMP_AMP] = ACTIONS(2135),
    [anon_sym_PIPE_PIPE] = ACTIONS(2135),
    [anon_sym_COLON] = ACTIONS(239),
    [anon_sym_LT] = ACTIONS(239),
    [anon_sym_GT] = ACTIONS(239),
    [anon_sym_GT_GT] = ACTIONS(239),
    [anon_sym_AMP_GT] = ACTIONS(239),
    [anon_sym_AMP_GT_GT] = ACTIONS(239),
    [anon_sym_LT_AMP] = ACTIONS(239),
    [anon_sym_GT_AMP] = ACTIONS(239),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [sym_raw_string] = ACTIONS(239),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(767),
  },
  [668] = {
    [sym_string] = STATE(123),
    [sym_simple_expansion] = STATE(123),
    [sym_expansion] = STATE(123),
    [sym_command_substitution] = STATE(123),
    [sym_process_substitution] = STATE(123),
    [anon_sym_RBRACK] = ACTIONS(2138),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(309),
    [sym_comment] = ACTIONS(115),
  },
  [669] = {
    [anon_sym_LT] = ACTIONS(2140),
    [anon_sym_GT] = ACTIONS(2140),
    [anon_sym_GT_GT] = ACTIONS(2142),
    [anon_sym_AMP_GT] = ACTIONS(2140),
    [anon_sym_AMP_GT_GT] = ACTIONS(2142),
    [anon_sym_LT_AMP] = ACTIONS(2142),
    [anon_sym_GT_AMP] = ACTIONS(2142),
    [sym_comment] = ACTIONS(115),
  },
  [670] = {
    [sym_file_redirect] = STATE(675),
    [sym_heredoc_redirect] = STATE(675),
    [sym_string] = STATE(761),
    [sym_simple_expansion] = STATE(761),
    [sym_expansion] = STATE(761),
    [sym_command_substitution] = STATE(761),
    [sym_process_substitution] = STATE(761),
    [aux_sym_bracket_command_repeat1] = STATE(766),
    [aux_sym_command_repeat2] = STATE(767),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(2144),
    [anon_sym_SEMI_SEMI] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_PIPE_AMP] = ACTIONS(2144),
    [anon_sym_AMP_AMP] = ACTIONS(2144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2144),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1646),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [sym_raw_string] = ACTIONS(2151),
    [anon_sym_DOLLAR] = ACTIONS(2153),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2155),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2157),
    [anon_sym_BQUOTE] = ACTIONS(2159),
    [sym_word] = ACTIONS(2151),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(2144),
    [anon_sym_LF] = ACTIONS(2144),
    [anon_sym_AMP] = ACTIONS(2144),
  },
  [671] = {
    [sym_string] = STATE(770),
    [sym_simple_expansion] = STATE(770),
    [sym_expansion] = STATE(770),
    [sym_command_substitution] = STATE(770),
    [sym_process_substitution] = STATE(770),
    [anon_sym_LPAREN] = ACTIONS(287),
    [anon_sym_LT] = ACTIONS(2163),
    [anon_sym_GT] = ACTIONS(2163),
    [anon_sym_DQUOTE] = ACTIONS(2165),
    [sym_raw_string] = ACTIONS(2167),
    [anon_sym_DOLLAR] = ACTIONS(2169),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2171),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2173),
    [anon_sym_BQUOTE] = ACTIONS(2175),
    [sym_word] = ACTIONS(2177),
    [sym_comment] = ACTIONS(115),
  },
  [672] = {
    [sym_string] = STATE(770),
    [sym_simple_expansion] = STATE(770),
    [sym_expansion] = STATE(770),
    [sym_command_substitution] = STATE(770),
    [sym_process_substitution] = STATE(770),
    [anon_sym_LT] = ACTIONS(2163),
    [anon_sym_GT] = ACTIONS(2163),
    [anon_sym_DQUOTE] = ACTIONS(2165),
    [sym_raw_string] = ACTIONS(2167),
    [anon_sym_DOLLAR] = ACTIONS(2169),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2171),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2173),
    [anon_sym_BQUOTE] = ACTIONS(2175),
    [sym_word] = ACTIONS(2177),
    [sym_comment] = ACTIONS(115),
  },
  [673] = {
    [sym_heredoc] = STATE(623),
    [sym__simple_heredoc] = ACTIONS(2179),
    [sym__heredoc_beginning] = ACTIONS(2181),
    [sym_comment] = ACTIONS(115),
  },
  [674] = {
    [anon_sym_RBRACE] = ACTIONS(2183),
    [sym_comment] = ACTIONS(115),
  },
  [675] = {
    [sym_file_descriptor] = ACTIONS(351),
    [anon_sym_RPAREN] = ACTIONS(353),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_LT] = ACTIONS(353),
    [anon_sym_GT] = ACTIONS(353),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(353),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(353),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(353),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(353),
  },
  [676] = {
    [sym_file_redirect] = STATE(732),
    [sym_heredoc_redirect] = STATE(732),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(2185),
    [anon_sym_SEMI_SEMI] = ACTIONS(2185),
    [anon_sym_PIPE] = ACTIONS(2185),
    [anon_sym_PIPE_AMP] = ACTIONS(2185),
    [anon_sym_AMP_AMP] = ACTIONS(2185),
    [anon_sym_PIPE_PIPE] = ACTIONS(2185),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1646),
    [anon_sym_BQUOTE] = ACTIONS(2185),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(2185),
    [anon_sym_LF] = ACTIONS(2185),
    [anon_sym_AMP] = ACTIONS(2185),
  },
  [677] = {
    [anon_sym_LPAREN] = ACTIONS(2188),
    [sym_comment] = ACTIONS(115),
  },
  [678] = {
    [sym_simple_expansion] = STATE(63),
    [sym_expansion] = STATE(63),
    [sym_command_substitution] = STATE(63),
    [aux_sym_string_repeat1] = STATE(777),
    [anon_sym_DQUOTE] = ACTIONS(2190),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [679] = {
    [sym_file_descriptor] = ACTIONS(749),
    [anon_sym_RPAREN] = ACTIONS(751),
    [anon_sym_SEMI_SEMI] = ACTIONS(751),
    [anon_sym_RBRACE] = ACTIONS(1905),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_PIPE_AMP] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [anon_sym_COLON] = ACTIONS(751),
    [anon_sym_LT] = ACTIONS(751),
    [anon_sym_GT] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_AMP_GT] = ACTIONS(751),
    [anon_sym_AMP_GT_GT] = ACTIONS(751),
    [anon_sym_LT_AMP] = ACTIONS(751),
    [anon_sym_GT_AMP] = ACTIONS(751),
    [anon_sym_DQUOTE] = ACTIONS(751),
    [sym_raw_string] = ACTIONS(751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(751),
    [anon_sym_BQUOTE] = ACTIONS(751),
    [sym_leading_word] = ACTIONS(751),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_LF] = ACTIONS(751),
    [anon_sym_AMP] = ACTIONS(751),
  },
  [680] = {
    [sym_special_variable_name] = STATE(780),
    [anon_sym_DOLLAR] = ACTIONS(2192),
    [sym_comment] = ACTIONS(73),
    [sym_simple_variable_name] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_AT] = ACTIONS(2192),
    [anon_sym_POUND] = ACTIONS(2196),
    [anon_sym_QMARK] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2192),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_0] = ACTIONS(2196),
    [anon_sym__] = ACTIONS(2196),
  },
  [681] = {
    [sym_special_variable_name] = STATE(782),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_leading_word] = ACTIONS(2198),
    [sym_comment] = ACTIONS(73),
    [anon_sym_STAR] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_POUND] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(277),
    [anon_sym_0] = ACTIONS(277),
    [anon_sym__] = ACTIONS(277),
  },
  [682] = {
    [sym_command] = STATE(783),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(75),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(207),
    [sym_comment] = ACTIONS(115),
  },
  [683] = {
    [sym_command] = STATE(784),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_command_repeat1] = STATE(79),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(213),
    [sym_comment] = ACTIONS(115),
  },
  [684] = {
    [sym_for_statement] = STATE(785),
    [sym_while_statement] = STATE(785),
    [sym_if_statement] = STATE(785),
    [sym_case_statement] = STATE(785),
    [sym_function_definition] = STATE(785),
    [sym_subshell] = STATE(785),
    [sym_pipeline] = STATE(785),
    [sym_list] = STATE(785),
    [sym_bracket_command] = STATE(785),
    [sym_command] = STATE(785),
    [sym_environment_variable_assignment] = STATE(786),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(219),
    [sym_command_substitution] = STATE(219),
    [aux_sym_command_repeat1] = STATE(223),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_if] = ACTIONS(495),
    [anon_sym_case] = ACTIONS(497),
    [anon_sym_function] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(505),
    [anon_sym_COLON] = ACTIONS(507),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(511),
    [sym_comment] = ACTIONS(115),
  },
  [685] = {
    [anon_sym_LPAREN] = ACTIONS(2200),
    [sym_comment] = ACTIONS(115),
  },
  [686] = {
    [sym_simple_expansion] = STATE(63),
    [sym_expansion] = STATE(63),
    [sym_command_substitution] = STATE(63),
    [aux_sym_string_repeat1] = STATE(789),
    [anon_sym_DQUOTE] = ACTIONS(2202),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [687] = {
    [sym_file_descriptor] = ACTIONS(2204),
    [anon_sym_RPAREN] = ACTIONS(2207),
    [anon_sym_SEMI_SEMI] = ACTIONS(2207),
    [anon_sym_PIPE] = ACTIONS(2207),
    [anon_sym_PIPE_AMP] = ACTIONS(2207),
    [anon_sym_AMP_AMP] = ACTIONS(2207),
    [anon_sym_PIPE_PIPE] = ACTIONS(2207),
    [anon_sym_COLON] = ACTIONS(2207),
    [anon_sym_LT] = ACTIONS(2207),
    [anon_sym_GT] = ACTIONS(2207),
    [anon_sym_GT_GT] = ACTIONS(2207),
    [anon_sym_AMP_GT] = ACTIONS(2207),
    [anon_sym_AMP_GT_GT] = ACTIONS(2207),
    [anon_sym_LT_AMP] = ACTIONS(2207),
    [anon_sym_GT_AMP] = ACTIONS(2207),
    [anon_sym_LT_LT] = ACTIONS(2207),
    [anon_sym_LT_LT_DASH] = ACTIONS(2207),
    [anon_sym_DQUOTE] = ACTIONS(2207),
    [sym_raw_string] = ACTIONS(2207),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2207),
    [anon_sym_BQUOTE] = ACTIONS(2207),
    [sym_leading_word] = ACTIONS(2207),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(2207),
    [anon_sym_LF] = ACTIONS(2207),
    [anon_sym_AMP] = ACTIONS(2207),
  },
  [688] = {
    [sym_special_variable_name] = STATE(792),
    [anon_sym_DOLLAR] = ACTIONS(2210),
    [sym_comment] = ACTIONS(73),
    [sym_simple_variable_name] = ACTIONS(2212),
    [anon_sym_STAR] = ACTIONS(2210),
    [anon_sym_AT] = ACTIONS(2210),
    [anon_sym_POUND] = ACTIONS(2214),
    [anon_sym_QMARK] = ACTIONS(2210),
    [anon_sym_DASH] = ACTIONS(2210),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_0] = ACTIONS(2214),
    [anon_sym__] = ACTIONS(2214),
  },
  [689] = {
    [sym_special_variable_name] = STATE(794),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_leading_word] = ACTIONS(2216),
    [sym_comment] = ACTIONS(73),
    [anon_sym_STAR] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_POUND] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(277),
    [anon_sym_0] = ACTIONS(277),
    [anon_sym__] = ACTIONS(277),
  },
  [690] = {
    [sym_command] = STATE(795),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(75),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(207),
    [sym_comment] = ACTIONS(115),
  },
  [691] = {
    [sym_command] = STATE(796),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_command_repeat1] = STATE(79),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(213),
    [sym_comment] = ACTIONS(115),
  },
  [692] = {
    [sym_file_descriptor] = ACTIONS(375),
    [anon_sym_in] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(377),
    [anon_sym_SEMI_SEMI] = ACTIONS(377),
    [anon_sym_RBRACE] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_PIPE_AMP] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(377),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(377),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_AMP_GT] = ACTIONS(377),
    [anon_sym_AMP_GT_GT] = ACTIONS(377),
    [anon_sym_LT_AMP] = ACTIONS(377),
    [anon_sym_GT_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_DQUOTE] = ACTIONS(377),
    [sym_raw_string] = ACTIONS(377),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(377),
    [sym_leading_word] = ACTIONS(377),
    [sym_word] = ACTIONS(377),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(377),
    [anon_sym_LF] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
  },
  [693] = {
    [sym__heredoc_middle] = ACTIONS(525),
    [sym__heredoc_end] = ACTIONS(525),
    [sym_file_descriptor] = ACTIONS(525),
    [anon_sym_in] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(519),
    [anon_sym_SEMI_SEMI] = ACTIONS(519),
    [anon_sym_RBRACE] = ACTIONS(519),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_PIPE_AMP] = ACTIONS(519),
    [anon_sym_AMP_AMP] = ACTIONS(519),
    [anon_sym_PIPE_PIPE] = ACTIONS(519),
    [anon_sym_RBRACK] = ACTIONS(519),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(519),
    [anon_sym_COLON] = ACTIONS(519),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_GT] = ACTIONS(519),
    [anon_sym_AMP_GT] = ACTIONS(519),
    [anon_sym_AMP_GT_GT] = ACTIONS(519),
    [anon_sym_LT_AMP] = ACTIONS(519),
    [anon_sym_GT_AMP] = ACTIONS(519),
    [anon_sym_LT_LT] = ACTIONS(519),
    [anon_sym_LT_LT_DASH] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(519),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(519),
    [sym_raw_string] = ACTIONS(519),
    [anon_sym_DOLLAR] = ACTIONS(519),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(519),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(519),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [sym_leading_word] = ACTIONS(519),
    [sym_word] = ACTIONS(519),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(519),
    [anon_sym_LF] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(519),
  },
  [694] = {
    [sym__heredoc_middle] = ACTIONS(551),
    [sym__heredoc_end] = ACTIONS(551),
    [sym_file_descriptor] = ACTIONS(551),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_RPAREN] = ACTIONS(521),
    [anon_sym_SEMI_SEMI] = ACTIONS(521),
    [anon_sym_RBRACE] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PIPE_AMP] = ACTIONS(521),
    [anon_sym_AMP_AMP] = ACTIONS(521),
    [anon_sym_PIPE_PIPE] = ACTIONS(521),
    [anon_sym_RBRACK] = ACTIONS(521),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(521),
    [anon_sym_COLON] = ACTIONS(521),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_AMP_GT] = ACTIONS(521),
    [anon_sym_AMP_GT_GT] = ACTIONS(521),
    [anon_sym_LT_AMP] = ACTIONS(521),
    [anon_sym_GT_AMP] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_LT_LT_DASH] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(521),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(521),
    [sym_raw_string] = ACTIONS(521),
    [anon_sym_DOLLAR] = ACTIONS(521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(521),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(521),
    [anon_sym_BQUOTE] = ACTIONS(521),
    [sym_leading_word] = ACTIONS(521),
    [sym_word] = ACTIONS(521),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(521),
    [anon_sym_LF] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
  },
  [695] = {
    [sym__heredoc_middle] = ACTIONS(555),
    [sym__heredoc_end] = ACTIONS(555),
    [sym_file_descriptor] = ACTIONS(555),
    [anon_sym_in] = ACTIONS(523),
    [anon_sym_RPAREN] = ACTIONS(523),
    [anon_sym_SEMI_SEMI] = ACTIONS(523),
    [anon_sym_RBRACE] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(523),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(523),
    [anon_sym_PIPE_PIPE] = ACTIONS(523),
    [anon_sym_RBRACK] = ACTIONS(523),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(523),
    [anon_sym_COLON] = ACTIONS(523),
    [anon_sym_LT] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(523),
    [anon_sym_GT_GT] = ACTIONS(523),
    [anon_sym_AMP_GT] = ACTIONS(523),
    [anon_sym_AMP_GT_GT] = ACTIONS(523),
    [anon_sym_LT_AMP] = ACTIONS(523),
    [anon_sym_GT_AMP] = ACTIONS(523),
    [anon_sym_LT_LT] = ACTIONS(523),
    [anon_sym_LT_LT_DASH] = ACTIONS(523),
    [anon_sym_DQUOTE] = ACTIONS(523),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(523),
    [sym_raw_string] = ACTIONS(523),
    [anon_sym_DOLLAR] = ACTIONS(523),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(523),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(523),
    [anon_sym_BQUOTE] = ACTIONS(523),
    [sym_leading_word] = ACTIONS(523),
    [sym_word] = ACTIONS(523),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(523),
    [anon_sym_LF] = ACTIONS(523),
    [anon_sym_AMP] = ACTIONS(523),
  },
  [696] = {
    [anon_sym_BQUOTE] = ACTIONS(2218),
    [sym_comment] = ACTIONS(115),
  },
  [697] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2220),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(2220),
    [anon_sym_LF] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2220),
  },
  [698] = {
    [anon_sym_RPAREN] = ACTIONS(2222),
    [anon_sym_SEMI_SEMI] = ACTIONS(2222),
    [anon_sym_PIPE] = ACTIONS(2222),
    [anon_sym_PIPE_AMP] = ACTIONS(2222),
    [anon_sym_AMP_AMP] = ACTIONS(2222),
    [anon_sym_PIPE_PIPE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(2222),
    [anon_sym_LF] = ACTIONS(2222),
    [anon_sym_AMP] = ACTIONS(2222),
  },
  [699] = {
    [sym_file_descriptor] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(911),
    [anon_sym_SEMI_SEMI] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_PIPE_AMP] = ACTIONS(911),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(911),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_GT] = ACTIONS(911),
    [anon_sym_AMP_GT] = ACTIONS(911),
    [anon_sym_AMP_GT_GT] = ACTIONS(911),
    [anon_sym_LT_AMP] = ACTIONS(911),
    [anon_sym_GT_AMP] = ACTIONS(911),
    [anon_sym_LT_LT] = ACTIONS(911),
    [anon_sym_LT_LT_DASH] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(911),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_LF] = ACTIONS(911),
    [anon_sym_AMP] = ACTIONS(911),
  },
  [700] = {
    [sym_string] = STATE(798),
    [sym_simple_expansion] = STATE(798),
    [sym_expansion] = STATE(798),
    [sym_command_substitution] = STATE(798),
    [sym_process_substitution] = STATE(798),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(1682),
    [anon_sym_DQUOTE] = ACTIONS(1684),
    [sym_raw_string] = ACTIONS(2225),
    [anon_sym_DOLLAR] = ACTIONS(1688),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1692),
    [anon_sym_BQUOTE] = ACTIONS(1694),
    [sym_word] = ACTIONS(2227),
    [sym_comment] = ACTIONS(115),
  },
  [701] = {
    [sym_file_descriptor] = ACTIONS(1105),
    [anon_sym_in] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1079),
    [anon_sym_SEMI_SEMI] = ACTIONS(1079),
    [anon_sym_RBRACE] = ACTIONS(1079),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PIPE_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1079),
    [anon_sym_RBRACK] = ACTIONS(1079),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1079),
    [anon_sym_COLON] = ACTIONS(1079),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT_GT] = ACTIONS(1079),
    [anon_sym_LT_AMP] = ACTIONS(1079),
    [anon_sym_GT_AMP] = ACTIONS(1079),
    [anon_sym_LT_LT] = ACTIONS(1079),
    [anon_sym_LT_LT_DASH] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(1079),
    [sym_raw_string] = ACTIONS(1079),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1079),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1079),
    [anon_sym_BQUOTE] = ACTIONS(1079),
    [sym_leading_word] = ACTIONS(1079),
    [sym_word] = ACTIONS(1079),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1079),
    [anon_sym_LF] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
  },
  [702] = {
    [anon_sym_RPAREN] = ACTIONS(2229),
    [anon_sym_SEMI_SEMI] = ACTIONS(2229),
    [anon_sym_PIPE] = ACTIONS(2229),
    [anon_sym_PIPE_AMP] = ACTIONS(2229),
    [anon_sym_AMP_AMP] = ACTIONS(2229),
    [anon_sym_PIPE_PIPE] = ACTIONS(2229),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(2229),
    [anon_sym_LF] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2229),
  },
  [703] = {
    [sym_file_descriptor] = ACTIONS(2233),
    [anon_sym_in] = ACTIONS(1544),
    [anon_sym_RPAREN] = ACTIONS(1544),
    [anon_sym_SEMI_SEMI] = ACTIONS(1544),
    [anon_sym_RBRACE] = ACTIONS(1544),
    [anon_sym_PIPE] = ACTIONS(1544),
    [anon_sym_PIPE_AMP] = ACTIONS(1544),
    [anon_sym_AMP_AMP] = ACTIONS(1544),
    [anon_sym_PIPE_PIPE] = ACTIONS(1544),
    [anon_sym_RBRACK] = ACTIONS(1544),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1544),
    [anon_sym_COLON] = ACTIONS(1544),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_GT_GT] = ACTIONS(1544),
    [anon_sym_AMP_GT] = ACTIONS(1544),
    [anon_sym_AMP_GT_GT] = ACTIONS(1544),
    [anon_sym_LT_AMP] = ACTIONS(1544),
    [anon_sym_GT_AMP] = ACTIONS(1544),
    [anon_sym_LT_LT] = ACTIONS(1544),
    [anon_sym_LT_LT_DASH] = ACTIONS(1544),
    [anon_sym_DQUOTE] = ACTIONS(1544),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(1544),
    [anon_sym_DOLLAR] = ACTIONS(1544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1544),
    [anon_sym_BQUOTE] = ACTIONS(1544),
    [sym_leading_word] = ACTIONS(1544),
    [sym_word] = ACTIONS(1544),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1544),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_AMP] = ACTIONS(1544),
  },
  [704] = {
    [sym_file_descriptor] = ACTIONS(731),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_RBRACK] = ACTIONS(733),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(733),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [sym_leading_word] = ACTIONS(733),
    [sym_word] = ACTIONS(733),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [705] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2236),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(2236),
    [anon_sym_LF] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2236),
  },
  [706] = {
    [anon_sym_in] = ACTIONS(2238),
    [sym_comment] = ACTIONS(115),
  },
  [707] = {
    [sym__heredoc_middle] = ACTIONS(2240),
    [sym__heredoc_end] = ACTIONS(2240),
    [sym_file_descriptor] = ACTIONS(2240),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_RPAREN] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(2243),
    [anon_sym_RBRACE] = ACTIONS(2243),
    [anon_sym_PIPE] = ACTIONS(2243),
    [anon_sym_PIPE_AMP] = ACTIONS(2243),
    [anon_sym_AMP_AMP] = ACTIONS(2243),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_RBRACK] = ACTIONS(2243),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2243),
    [anon_sym_COLON] = ACTIONS(2243),
    [anon_sym_LT] = ACTIONS(2243),
    [anon_sym_GT] = ACTIONS(2243),
    [anon_sym_GT_GT] = ACTIONS(2243),
    [anon_sym_AMP_GT] = ACTIONS(2243),
    [anon_sym_AMP_GT_GT] = ACTIONS(2243),
    [anon_sym_LT_AMP] = ACTIONS(2243),
    [anon_sym_GT_AMP] = ACTIONS(2243),
    [anon_sym_LT_LT] = ACTIONS(2243),
    [anon_sym_LT_LT_DASH] = ACTIONS(2243),
    [anon_sym_DQUOTE] = ACTIONS(2243),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2243),
    [sym_raw_string] = ACTIONS(2243),
    [anon_sym_DOLLAR] = ACTIONS(2243),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2243),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2243),
    [anon_sym_BQUOTE] = ACTIONS(2243),
    [sym_leading_word] = ACTIONS(2243),
    [sym_word] = ACTIONS(2243),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(2243),
    [anon_sym_LF] = ACTIONS(2243),
    [anon_sym_AMP] = ACTIONS(2243),
  },
  [708] = {
    [sym__heredoc_middle] = ACTIONS(861),
    [sym__heredoc_end] = ACTIONS(861),
    [sym_file_descriptor] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(843),
    [anon_sym_RPAREN] = ACTIONS(843),
    [anon_sym_SEMI_SEMI] = ACTIONS(843),
    [anon_sym_RBRACE] = ACTIONS(843),
    [anon_sym_PIPE] = ACTIONS(843),
    [anon_sym_PIPE_AMP] = ACTIONS(843),
    [anon_sym_AMP_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(843),
    [anon_sym_RBRACK] = ACTIONS(843),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_GT] = ACTIONS(843),
    [anon_sym_AMP_GT] = ACTIONS(843),
    [anon_sym_AMP_GT_GT] = ACTIONS(843),
    [anon_sym_LT_AMP] = ACTIONS(843),
    [anon_sym_GT_AMP] = ACTIONS(843),
    [anon_sym_LT_LT] = ACTIONS(843),
    [anon_sym_LT_LT_DASH] = ACTIONS(843),
    [anon_sym_DQUOTE] = ACTIONS(843),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(843),
    [sym_raw_string] = ACTIONS(843),
    [anon_sym_DOLLAR] = ACTIONS(843),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(843),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(843),
    [sym_leading_word] = ACTIONS(843),
    [sym_word] = ACTIONS(843),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(843),
    [anon_sym_LF] = ACTIONS(843),
    [anon_sym_AMP] = ACTIONS(843),
  },
  [709] = {
    [sym_string] = STATE(800),
    [sym_simple_expansion] = STATE(800),
    [sym_expansion] = STATE(800),
    [sym_command_substitution] = STATE(800),
    [sym_process_substitution] = STATE(800),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(2246),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(2248),
    [sym_comment] = ACTIONS(115),
  },
  [710] = {
    [anon_sym_RPAREN] = ACTIONS(1015),
    [anon_sym_SEMI_SEMI] = ACTIONS(1015),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_PIPE_AMP] = ACTIONS(1015),
    [anon_sym_AMP_AMP] = ACTIONS(1015),
    [anon_sym_PIPE_PIPE] = ACTIONS(1015),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1015),
    [anon_sym_LF] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1015),
  },
  [711] = {
    [anon_sym_RPAREN] = ACTIONS(1021),
    [anon_sym_SEMI_SEMI] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1021),
    [anon_sym_PIPE_AMP] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(1021),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1021),
    [anon_sym_LF] = ACTIONS(1021),
    [anon_sym_AMP] = ACTIONS(1021),
  },
  [712] = {
    [anon_sym_RPAREN] = ACTIONS(545),
    [anon_sym_SEMI_SEMI] = ACTIONS(545),
    [anon_sym_PIPE] = ACTIONS(545),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(545),
    [anon_sym_LF] = ACTIONS(545),
    [anon_sym_AMP] = ACTIONS(545),
  },
  [713] = {
    [anon_sym_RPAREN] = ACTIONS(1327),
    [anon_sym_SEMI_SEMI] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_PIPE_AMP] = ACTIONS(1327),
    [anon_sym_AMP_AMP] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1327),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1327),
    [anon_sym_LF] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
  },
  [714] = {
    [anon_sym_fi] = ACTIONS(2250),
    [sym_comment] = ACTIONS(115),
  },
  [715] = {
    [sym_elif_clause] = STATE(333),
    [sym_else_clause] = STATE(802),
    [anon_sym_fi] = ACTIONS(2250),
    [anon_sym_elif] = ACTIONS(787),
    [anon_sym_else] = ACTIONS(789),
    [sym_comment] = ACTIONS(115),
  },
  [716] = {
    [anon_sym_RPAREN] = ACTIONS(2252),
    [anon_sym_SEMI_SEMI] = ACTIONS(2252),
    [anon_sym_PIPE] = ACTIONS(2252),
    [anon_sym_PIPE_AMP] = ACTIONS(2252),
    [anon_sym_AMP_AMP] = ACTIONS(2252),
    [anon_sym_PIPE_PIPE] = ACTIONS(2252),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(2252),
    [anon_sym_LF] = ACTIONS(2252),
    [anon_sym_AMP] = ACTIONS(2252),
  },
  [717] = {
    [anon_sym_fi] = ACTIONS(2255),
    [sym_comment] = ACTIONS(115),
  },
  [718] = {
    [anon_sym_RPAREN] = ACTIONS(2257),
    [anon_sym_SEMI_SEMI] = ACTIONS(2257),
    [anon_sym_PIPE] = ACTIONS(2257),
    [anon_sym_PIPE_AMP] = ACTIONS(2257),
    [anon_sym_AMP_AMP] = ACTIONS(2257),
    [anon_sym_PIPE_PIPE] = ACTIONS(2257),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(2257),
    [anon_sym_LF] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
  },
  [719] = {
    [sym_string] = STATE(770),
    [sym_simple_expansion] = STATE(770),
    [sym_expansion] = STATE(770),
    [sym_command_substitution] = STATE(770),
    [sym_process_substitution] = STATE(770),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_LT] = ACTIONS(2163),
    [anon_sym_GT] = ACTIONS(2163),
    [anon_sym_DQUOTE] = ACTIONS(2165),
    [sym_raw_string] = ACTIONS(2167),
    [anon_sym_DOLLAR] = ACTIONS(2169),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2171),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2173),
    [anon_sym_BQUOTE] = ACTIONS(2175),
    [sym_word] = ACTIONS(2177),
    [sym_comment] = ACTIONS(115),
  },
  [720] = {
    [sym_simple_expansion] = STATE(63),
    [sym_expansion] = STATE(63),
    [sym_command_substitution] = STATE(63),
    [aux_sym_string_repeat1] = STATE(806),
    [anon_sym_DQUOTE] = ACTIONS(2262),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [721] = {
    [sym_file_descriptor] = ACTIONS(577),
    [anon_sym_RPAREN] = ACTIONS(579),
    [anon_sym_SEMI_SEMI] = ACTIONS(579),
    [anon_sym_PIPE] = ACTIONS(579),
    [anon_sym_PIPE_AMP] = ACTIONS(579),
    [anon_sym_AMP_AMP] = ACTIONS(579),
    [anon_sym_PIPE_PIPE] = ACTIONS(579),
    [anon_sym_RBRACK] = ACTIONS(579),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(579),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_AMP_GT] = ACTIONS(579),
    [anon_sym_AMP_GT_GT] = ACTIONS(579),
    [anon_sym_LT_AMP] = ACTIONS(579),
    [anon_sym_GT_AMP] = ACTIONS(579),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_DASH] = ACTIONS(579),
    [anon_sym_DQUOTE] = ACTIONS(579),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_DOLLAR] = ACTIONS(579),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(579),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(579),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_word] = ACTIONS(579),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(579),
    [anon_sym_LF] = ACTIONS(579),
    [anon_sym_AMP] = ACTIONS(579),
  },
  [722] = {
    [sym_special_variable_name] = STATE(809),
    [anon_sym_DOLLAR] = ACTIONS(2264),
    [sym_comment] = ACTIONS(73),
    [sym_simple_variable_name] = ACTIONS(2266),
    [anon_sym_STAR] = ACTIONS(2264),
    [anon_sym_AT] = ACTIONS(2264),
    [anon_sym_POUND] = ACTIONS(2268),
    [anon_sym_QMARK] = ACTIONS(2264),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_BANG] = ACTIONS(2264),
    [anon_sym_0] = ACTIONS(2268),
    [anon_sym__] = ACTIONS(2268),
  },
  [723] = {
    [sym_special_variable_name] = STATE(811),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_leading_word] = ACTIONS(2270),
    [sym_comment] = ACTIONS(73),
    [anon_sym_STAR] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_POUND] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(277),
    [anon_sym_0] = ACTIONS(277),
    [anon_sym__] = ACTIONS(277),
  },
  [724] = {
    [sym_command] = STATE(812),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(75),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(207),
    [sym_comment] = ACTIONS(115),
  },
  [725] = {
    [sym_command] = STATE(813),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_command_repeat1] = STATE(79),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(213),
    [sym_comment] = ACTIONS(115),
  },
  [726] = {
    [sym_file_redirect] = STATE(732),
    [sym_heredoc_redirect] = STATE(732),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(2272),
    [anon_sym_SEMI_SEMI] = ACTIONS(2272),
    [anon_sym_PIPE] = ACTIONS(2272),
    [anon_sym_PIPE_AMP] = ACTIONS(2272),
    [anon_sym_AMP_AMP] = ACTIONS(2272),
    [anon_sym_PIPE_PIPE] = ACTIONS(2272),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1646),
    [anon_sym_BQUOTE] = ACTIONS(2272),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(2272),
    [anon_sym_LF] = ACTIONS(2272),
    [anon_sym_AMP] = ACTIONS(2272),
  },
  [727] = {
    [sym_file_redirect] = STATE(675),
    [sym_heredoc_redirect] = STATE(675),
    [aux_sym_command_repeat2] = STATE(815),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_PIPE_AMP] = ACTIONS(355),
    [anon_sym_AMP_AMP] = ACTIONS(355),
    [anon_sym_PIPE_PIPE] = ACTIONS(355),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2277),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1646),
    [anon_sym_BQUOTE] = ACTIONS(355),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(355),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [728] = {
    [sym_simple_expansion] = STATE(63),
    [sym_expansion] = STATE(63),
    [sym_command_substitution] = STATE(63),
    [aux_sym_string_repeat1] = STATE(817),
    [anon_sym_DQUOTE] = ACTIONS(2279),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [729] = {
    [sym_command] = STATE(818),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(75),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(207),
    [sym_comment] = ACTIONS(115),
  },
  [730] = {
    [sym_command] = STATE(819),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_command_repeat1] = STATE(79),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(213),
    [sym_comment] = ACTIONS(115),
  },
  [731] = {
    [sym_file_redirect] = STATE(675),
    [sym_heredoc_redirect] = STATE(675),
    [aux_sym_command_repeat2] = STATE(821),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_SEMI_SEMI] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_PIPE_AMP] = ACTIONS(465),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE_PIPE] = ACTIONS(465),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2281),
    [anon_sym_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1646),
    [anon_sym_BQUOTE] = ACTIONS(465),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(465),
    [anon_sym_LF] = ACTIONS(465),
    [anon_sym_AMP] = ACTIONS(465),
  },
  [732] = {
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_RPAREN] = ACTIONS(633),
    [anon_sym_SEMI_SEMI] = ACTIONS(633),
    [anon_sym_PIPE] = ACTIONS(633),
    [anon_sym_PIPE_AMP] = ACTIONS(633),
    [anon_sym_AMP_AMP] = ACTIONS(633),
    [anon_sym_PIPE_PIPE] = ACTIONS(633),
    [anon_sym_LT] = ACTIONS(633),
    [anon_sym_GT] = ACTIONS(633),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_AMP_GT] = ACTIONS(633),
    [anon_sym_AMP_GT_GT] = ACTIONS(633),
    [anon_sym_LT_AMP] = ACTIONS(633),
    [anon_sym_GT_AMP] = ACTIONS(633),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_DASH] = ACTIONS(633),
    [anon_sym_BQUOTE] = ACTIONS(633),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(633),
    [anon_sym_LF] = ACTIONS(633),
    [anon_sym_AMP] = ACTIONS(633),
  },
  [733] = {
    [sym_file_descriptor] = ACTIONS(1149),
    [anon_sym_RPAREN] = ACTIONS(1151),
    [anon_sym_SEMI_SEMI] = ACTIONS(1151),
    [anon_sym_PIPE] = ACTIONS(1151),
    [anon_sym_PIPE_AMP] = ACTIONS(1151),
    [anon_sym_AMP_AMP] = ACTIONS(1151),
    [anon_sym_PIPE_PIPE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(1151),
    [anon_sym_GT] = ACTIONS(1151),
    [anon_sym_GT_GT] = ACTIONS(1151),
    [anon_sym_AMP_GT] = ACTIONS(1151),
    [anon_sym_AMP_GT_GT] = ACTIONS(1151),
    [anon_sym_LT_AMP] = ACTIONS(1151),
    [anon_sym_GT_AMP] = ACTIONS(1151),
    [anon_sym_LT_LT] = ACTIONS(1151),
    [anon_sym_LT_LT_DASH] = ACTIONS(1151),
    [anon_sym_BQUOTE] = ACTIONS(1151),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1151),
    [anon_sym_LF] = ACTIONS(1151),
    [anon_sym_AMP] = ACTIONS(1151),
  },
  [734] = {
    [sym_file_descriptor] = ACTIONS(665),
    [anon_sym_in] = ACTIONS(667),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_SEMI_SEMI] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(667),
    [anon_sym_PIPE] = ACTIONS(667),
    [anon_sym_PIPE_AMP] = ACTIONS(667),
    [anon_sym_AMP_AMP] = ACTIONS(667),
    [anon_sym_PIPE_PIPE] = ACTIONS(667),
    [anon_sym_RBRACK] = ACTIONS(667),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(667),
    [anon_sym_COLON] = ACTIONS(667),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(667),
    [anon_sym_GT] = ACTIONS(667),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(667),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_LT_LT] = ACTIONS(667),
    [anon_sym_LT_LT_DASH] = ACTIONS(667),
    [anon_sym_DQUOTE] = ACTIONS(667),
    [sym_raw_string] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(667),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(667),
    [anon_sym_BQUOTE] = ACTIONS(667),
    [sym_leading_word] = ACTIONS(667),
    [sym_word] = ACTIONS(667),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_LF] = ACTIONS(667),
    [anon_sym_AMP] = ACTIONS(667),
  },
  [735] = {
    [sym__terminated_statement] = STATE(639),
    [sym_for_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_function_definition] = STATE(27),
    [sym_subshell] = STATE(27),
    [sym_pipeline] = STATE(27),
    [sym_list] = STATE(27),
    [sym_bracket_command] = STATE(27),
    [sym_command] = STATE(27),
    [sym_environment_variable_assignment] = STATE(28),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [736] = {
    [anon_sym_RPAREN] = ACTIONS(1013),
    [anon_sym_SEMI_SEMI] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_PIPE_AMP] = ACTIONS(1013),
    [anon_sym_AMP_AMP] = ACTIONS(1013),
    [anon_sym_PIPE_PIPE] = ACTIONS(1013),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_LF] = ACTIONS(1013),
    [anon_sym_AMP] = ACTIONS(1013),
  },
  [737] = {
    [anon_sym_RPAREN] = ACTIONS(483),
    [anon_sym_SEMI_SEMI] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(483),
    [anon_sym_PIPE_AMP] = ACTIONS(483),
    [anon_sym_AMP_AMP] = ACTIONS(483),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(483),
    [anon_sym_LF] = ACTIONS(483),
    [anon_sym_AMP] = ACTIONS(483),
  },
  [738] = {
    [sym__terminated_statement] = STATE(18),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_elif_clause] = STATE(207),
    [sym_else_clause] = STATE(645),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_program_repeat1] = STATE(822),
    [aux_sym_if_statement_repeat1] = STATE(647),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_fi] = ACTIONS(2283),
    [anon_sym_elif] = ACTIONS(487),
    [anon_sym_else] = ACTIONS(489),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [739] = {
    [anon_sym_RPAREN] = ACTIONS(2285),
    [sym_comment] = ACTIONS(115),
  },
  [740] = {
    [anon_sym_RPAREN] = ACTIONS(283),
    [anon_sym_SEMI_SEMI] = ACTIONS(283),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_PIPE_AMP] = ACTIONS(283),
    [anon_sym_AMP_AMP] = ACTIONS(283),
    [anon_sym_PIPE_PIPE] = ACTIONS(283),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(283),
    [anon_sym_LF] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(283),
  },
  [741] = {
    [sym_string] = STATE(123),
    [sym_simple_expansion] = STATE(123),
    [sym_expansion] = STATE(123),
    [sym_command_substitution] = STATE(123),
    [sym_process_substitution] = STATE(123),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2138),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(309),
    [sym_comment] = ACTIONS(115),
  },
  [742] = {
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_GT_GT] = ACTIONS(2289),
    [anon_sym_AMP_GT] = ACTIONS(2287),
    [anon_sym_AMP_GT_GT] = ACTIONS(2289),
    [anon_sym_LT_AMP] = ACTIONS(2289),
    [anon_sym_GT_AMP] = ACTIONS(2289),
    [sym_comment] = ACTIONS(115),
  },
  [743] = {
    [sym_file_redirect] = STATE(746),
    [sym_heredoc_redirect] = STATE(746),
    [sym_string] = STATE(761),
    [sym_simple_expansion] = STATE(761),
    [sym_expansion] = STATE(761),
    [sym_command_substitution] = STATE(761),
    [sym_process_substitution] = STATE(761),
    [aux_sym_bracket_command_repeat1] = STATE(826),
    [aux_sym_command_repeat2] = STATE(827),
    [sym_file_descriptor] = ACTIONS(2098),
    [anon_sym_RPAREN] = ACTIONS(315),
    [anon_sym_SEMI_SEMI] = ACTIONS(315),
    [anon_sym_PIPE] = ACTIONS(315),
    [anon_sym_PIPE_AMP] = ACTIONS(315),
    [anon_sym_AMP_AMP] = ACTIONS(315),
    [anon_sym_PIPE_PIPE] = ACTIONS(315),
    [anon_sym_LT] = ACTIONS(2291),
    [anon_sym_GT] = ACTIONS(2291),
    [anon_sym_GT_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT_GT] = ACTIONS(2102),
    [anon_sym_LT_AMP] = ACTIONS(2102),
    [anon_sym_GT_AMP] = ACTIONS(2102),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2104),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [sym_raw_string] = ACTIONS(2151),
    [anon_sym_DOLLAR] = ACTIONS(2153),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2155),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2157),
    [anon_sym_BQUOTE] = ACTIONS(2293),
    [sym_word] = ACTIONS(2151),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(315),
    [anon_sym_LF] = ACTIONS(315),
    [anon_sym_AMP] = ACTIONS(315),
  },
  [744] = {
    [sym_string] = STATE(830),
    [sym_simple_expansion] = STATE(830),
    [sym_expansion] = STATE(830),
    [sym_command_substitution] = STATE(830),
    [sym_process_substitution] = STATE(830),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_DQUOTE] = ACTIONS(2297),
    [sym_raw_string] = ACTIONS(2299),
    [anon_sym_DOLLAR] = ACTIONS(2301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2303),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2305),
    [anon_sym_BQUOTE] = ACTIONS(2307),
    [sym_word] = ACTIONS(2309),
    [sym_comment] = ACTIONS(115),
  },
  [745] = {
    [sym_heredoc] = STATE(837),
    [sym__simple_heredoc] = ACTIONS(2311),
    [sym__heredoc_beginning] = ACTIONS(2313),
    [sym_comment] = ACTIONS(115),
  },
  [746] = {
    [sym_file_descriptor] = ACTIONS(351),
    [anon_sym_RPAREN] = ACTIONS(353),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_LT] = ACTIONS(353),
    [anon_sym_GT] = ACTIONS(353),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(353),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(353),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(353),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(353),
  },
  [747] = {
    [sym_file_redirect] = STATE(838),
    [sym_heredoc_redirect] = STATE(838),
    [sym_file_descriptor] = ACTIONS(2098),
    [anon_sym_RPAREN] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_PIPE_AMP] = ACTIONS(355),
    [anon_sym_AMP_AMP] = ACTIONS(355),
    [anon_sym_PIPE_PIPE] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(2102),
    [anon_sym_GT] = ACTIONS(2102),
    [anon_sym_GT_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT_GT] = ACTIONS(2102),
    [anon_sym_LT_AMP] = ACTIONS(2102),
    [anon_sym_GT_AMP] = ACTIONS(2102),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2104),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(355),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [748] = {
    [sym_file_descriptor] = ACTIONS(375),
    [anon_sym_RPAREN] = ACTIONS(377),
    [anon_sym_SEMI_SEMI] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_PIPE_AMP] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_AMP_GT] = ACTIONS(377),
    [anon_sym_AMP_GT_GT] = ACTIONS(377),
    [anon_sym_LT_AMP] = ACTIONS(377),
    [anon_sym_GT_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(377),
    [anon_sym_LF] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
  },
  [749] = {
    [sym_simple_expansion] = STATE(163),
    [sym_expansion] = STATE(163),
    [sym_command_substitution] = STATE(163),
    [anon_sym_DQUOTE] = ACTIONS(2315),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [750] = {
    [anon_sym_RPAREN] = ACTIONS(2317),
    [sym_comment] = ACTIONS(115),
  },
  [751] = {
    [anon_sym_BQUOTE] = ACTIONS(2317),
    [sym_comment] = ACTIONS(115),
  },
  [752] = {
    [anon_sym_RPAREN] = ACTIONS(2319),
    [sym_comment] = ACTIONS(115),
  },
  [753] = {
    [sym_file_redirect] = STATE(746),
    [sym_heredoc_redirect] = STATE(746),
    [sym_string] = STATE(761),
    [sym_simple_expansion] = STATE(761),
    [sym_expansion] = STATE(761),
    [sym_command_substitution] = STATE(761),
    [sym_process_substitution] = STATE(761),
    [aux_sym_bracket_command_repeat1] = STATE(842),
    [aux_sym_command_repeat2] = STATE(843),
    [sym_file_descriptor] = ACTIONS(2098),
    [anon_sym_RPAREN] = ACTIONS(429),
    [anon_sym_SEMI_SEMI] = ACTIONS(429),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_PIPE_AMP] = ACTIONS(429),
    [anon_sym_AMP_AMP] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(2291),
    [anon_sym_GT] = ACTIONS(2291),
    [anon_sym_GT_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT_GT] = ACTIONS(2102),
    [anon_sym_LT_AMP] = ACTIONS(2102),
    [anon_sym_GT_AMP] = ACTIONS(2102),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2104),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [sym_raw_string] = ACTIONS(2151),
    [anon_sym_DOLLAR] = ACTIONS(2153),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2155),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2157),
    [anon_sym_BQUOTE] = ACTIONS(2293),
    [sym_word] = ACTIONS(2151),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(429),
    [anon_sym_LF] = ACTIONS(429),
    [anon_sym_AMP] = ACTIONS(429),
  },
  [754] = {
    [sym_string] = STATE(611),
    [sym_simple_expansion] = STATE(611),
    [sym_expansion] = STATE(611),
    [sym_command_substitution] = STATE(611),
    [sym_process_substitution] = STATE(611),
    [sym__empty_value] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(2321),
    [anon_sym_GT] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [sym_raw_string] = ACTIONS(2325),
    [anon_sym_DOLLAR] = ACTIONS(2327),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2329),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2331),
    [anon_sym_BQUOTE] = ACTIONS(2333),
    [sym_word] = ACTIONS(2335),
    [sym_comment] = ACTIONS(115),
  },
  [755] = {
    [sym_file_redirect] = STATE(838),
    [sym_heredoc_redirect] = STATE(838),
    [sym_file_descriptor] = ACTIONS(2098),
    [anon_sym_RPAREN] = ACTIONS(449),
    [anon_sym_SEMI_SEMI] = ACTIONS(449),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_PIPE_AMP] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(449),
    [anon_sym_PIPE_PIPE] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(2102),
    [anon_sym_GT] = ACTIONS(2102),
    [anon_sym_GT_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT_GT] = ACTIONS(2102),
    [anon_sym_LT_AMP] = ACTIONS(2102),
    [anon_sym_GT_AMP] = ACTIONS(2102),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2104),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_LF] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
  },
  [756] = {
    [sym_file_redirect] = STATE(746),
    [sym_heredoc_redirect] = STATE(746),
    [aux_sym_command_repeat2] = STATE(827),
    [sym_file_descriptor] = ACTIONS(2098),
    [anon_sym_RPAREN] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_PIPE_AMP] = ACTIONS(355),
    [anon_sym_AMP_AMP] = ACTIONS(355),
    [anon_sym_PIPE_PIPE] = ACTIONS(355),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2337),
    [anon_sym_LT] = ACTIONS(2102),
    [anon_sym_GT] = ACTIONS(2102),
    [anon_sym_GT_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT_GT] = ACTIONS(2102),
    [anon_sym_LT_AMP] = ACTIONS(2102),
    [anon_sym_GT_AMP] = ACTIONS(2102),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2104),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(355),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [757] = {
    [sym_file_redirect] = STATE(746),
    [sym_heredoc_redirect] = STATE(746),
    [aux_sym_command_repeat2] = STATE(852),
    [sym_file_descriptor] = ACTIONS(2098),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_SEMI_SEMI] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_PIPE_AMP] = ACTIONS(465),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE_PIPE] = ACTIONS(465),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2339),
    [anon_sym_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(2102),
    [anon_sym_GT] = ACTIONS(2102),
    [anon_sym_GT_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT_GT] = ACTIONS(2102),
    [anon_sym_LT_AMP] = ACTIONS(2102),
    [anon_sym_GT_AMP] = ACTIONS(2102),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2104),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(465),
    [anon_sym_LF] = ACTIONS(465),
    [anon_sym_AMP] = ACTIONS(465),
  },
  [758] = {
    [sym_string] = STATE(853),
    [sym_simple_expansion] = STATE(853),
    [sym_expansion] = STATE(853),
    [sym_command_substitution] = STATE(853),
    [sym_process_substitution] = STATE(853),
    [anon_sym_LT] = ACTIONS(2163),
    [anon_sym_GT] = ACTIONS(2163),
    [anon_sym_DQUOTE] = ACTIONS(2165),
    [sym_raw_string] = ACTIONS(2341),
    [anon_sym_DOLLAR] = ACTIONS(2169),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2171),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2173),
    [anon_sym_BQUOTE] = ACTIONS(2175),
    [sym_word] = ACTIONS(2343),
    [sym_comment] = ACTIONS(115),
  },
  [759] = {
    [sym_string] = STATE(770),
    [sym_simple_expansion] = STATE(770),
    [sym_expansion] = STATE(770),
    [sym_command_substitution] = STATE(770),
    [sym_process_substitution] = STATE(770),
    [anon_sym_LPAREN] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2163),
    [anon_sym_GT] = ACTIONS(2163),
    [anon_sym_DQUOTE] = ACTIONS(2165),
    [sym_raw_string] = ACTIONS(2167),
    [anon_sym_DOLLAR] = ACTIONS(2169),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2171),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2173),
    [anon_sym_BQUOTE] = ACTIONS(2175),
    [sym_word] = ACTIONS(2177),
    [sym_comment] = ACTIONS(115),
  },
  [760] = {
    [sym_simple_expansion] = STATE(63),
    [sym_expansion] = STATE(63),
    [sym_command_substitution] = STATE(63),
    [aux_sym_string_repeat1] = STATE(856),
    [anon_sym_DQUOTE] = ACTIONS(2347),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [761] = {
    [sym_file_descriptor] = ACTIONS(293),
    [anon_sym_RPAREN] = ACTIONS(295),
    [anon_sym_SEMI_SEMI] = ACTIONS(295),
    [anon_sym_PIPE] = ACTIONS(295),
    [anon_sym_PIPE_AMP] = ACTIONS(295),
    [anon_sym_AMP_AMP] = ACTIONS(295),
    [anon_sym_PIPE_PIPE] = ACTIONS(295),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_GT] = ACTIONS(295),
    [anon_sym_AMP_GT] = ACTIONS(295),
    [anon_sym_AMP_GT_GT] = ACTIONS(295),
    [anon_sym_LT_AMP] = ACTIONS(295),
    [anon_sym_GT_AMP] = ACTIONS(295),
    [anon_sym_LT_LT] = ACTIONS(295),
    [anon_sym_LT_LT_DASH] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(295),
    [sym_raw_string] = ACTIONS(295),
    [anon_sym_DOLLAR] = ACTIONS(295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(295),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [sym_word] = ACTIONS(295),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(295),
    [anon_sym_LF] = ACTIONS(295),
    [anon_sym_AMP] = ACTIONS(295),
  },
  [762] = {
    [sym_special_variable_name] = STATE(859),
    [anon_sym_DOLLAR] = ACTIONS(2349),
    [sym_comment] = ACTIONS(73),
    [sym_simple_variable_name] = ACTIONS(2351),
    [anon_sym_STAR] = ACTIONS(2349),
    [anon_sym_AT] = ACTIONS(2349),
    [anon_sym_POUND] = ACTIONS(2353),
    [anon_sym_QMARK] = ACTIONS(2349),
    [anon_sym_DASH] = ACTIONS(2349),
    [anon_sym_BANG] = ACTIONS(2349),
    [anon_sym_0] = ACTIONS(2353),
    [anon_sym__] = ACTIONS(2353),
  },
  [763] = {
    [sym_special_variable_name] = STATE(861),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_leading_word] = ACTIONS(2355),
    [sym_comment] = ACTIONS(73),
    [anon_sym_STAR] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_POUND] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(277),
    [anon_sym_0] = ACTIONS(277),
    [anon_sym__] = ACTIONS(277),
  },
  [764] = {
    [sym_command] = STATE(862),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(75),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(207),
    [sym_comment] = ACTIONS(115),
  },
  [765] = {
    [sym_command] = STATE(863),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_command_repeat1] = STATE(79),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(213),
    [sym_comment] = ACTIONS(115),
  },
  [766] = {
    [sym_file_redirect] = STATE(675),
    [sym_heredoc_redirect] = STATE(675),
    [sym_string] = STATE(864),
    [sym_simple_expansion] = STATE(864),
    [sym_expansion] = STATE(864),
    [sym_command_substitution] = STATE(864),
    [sym_process_substitution] = STATE(864),
    [aux_sym_command_repeat2] = STATE(865),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(2357),
    [anon_sym_SEMI_SEMI] = ACTIONS(2357),
    [anon_sym_PIPE] = ACTIONS(2357),
    [anon_sym_PIPE_AMP] = ACTIONS(2357),
    [anon_sym_AMP_AMP] = ACTIONS(2357),
    [anon_sym_PIPE_PIPE] = ACTIONS(2357),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1646),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [sym_raw_string] = ACTIONS(2360),
    [anon_sym_DOLLAR] = ACTIONS(2153),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2155),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2157),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [sym_word] = ACTIONS(2360),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(2357),
    [anon_sym_LF] = ACTIONS(2357),
    [anon_sym_AMP] = ACTIONS(2357),
  },
  [767] = {
    [sym_file_redirect] = STATE(732),
    [sym_heredoc_redirect] = STATE(732),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(2366),
    [anon_sym_SEMI_SEMI] = ACTIONS(2366),
    [anon_sym_PIPE] = ACTIONS(2366),
    [anon_sym_PIPE_AMP] = ACTIONS(2366),
    [anon_sym_AMP_AMP] = ACTIONS(2366),
    [anon_sym_PIPE_PIPE] = ACTIONS(2366),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1646),
    [anon_sym_BQUOTE] = ACTIONS(2366),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(2366),
    [anon_sym_LF] = ACTIONS(2366),
    [anon_sym_AMP] = ACTIONS(2366),
  },
  [768] = {
    [anon_sym_LPAREN] = ACTIONS(2369),
    [sym_comment] = ACTIONS(115),
  },
  [769] = {
    [sym_simple_expansion] = STATE(63),
    [sym_expansion] = STATE(63),
    [sym_command_substitution] = STATE(63),
    [aux_sym_string_repeat1] = STATE(868),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [770] = {
    [sym_file_descriptor] = ACTIONS(361),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_SEMI_SEMI] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(365),
    [anon_sym_PIPE_AMP] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_LT] = ACTIONS(365),
    [anon_sym_GT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_AMP_GT] = ACTIONS(365),
    [anon_sym_AMP_GT_GT] = ACTIONS(365),
    [anon_sym_LT_AMP] = ACTIONS(365),
    [anon_sym_GT_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_LT_LT_DASH] = ACTIONS(365),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_LF] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(365),
  },
  [771] = {
    [sym_special_variable_name] = STATE(871),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym_comment] = ACTIONS(73),
    [sym_simple_variable_name] = ACTIONS(2375),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_AT] = ACTIONS(2373),
    [anon_sym_POUND] = ACTIONS(2377),
    [anon_sym_QMARK] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_BANG] = ACTIONS(2373),
    [anon_sym_0] = ACTIONS(2377),
    [anon_sym__] = ACTIONS(2377),
  },
  [772] = {
    [sym_special_variable_name] = STATE(873),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_leading_word] = ACTIONS(2379),
    [sym_comment] = ACTIONS(73),
    [anon_sym_STAR] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_POUND] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(277),
    [anon_sym_0] = ACTIONS(277),
    [anon_sym__] = ACTIONS(277),
  },
  [773] = {
    [sym_command] = STATE(874),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(75),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(207),
    [sym_comment] = ACTIONS(115),
  },
  [774] = {
    [sym_command] = STATE(875),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_command_repeat1] = STATE(79),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(213),
    [sym_comment] = ACTIONS(115),
  },
  [775] = {
    [sym_for_statement] = STATE(876),
    [sym_while_statement] = STATE(876),
    [sym_if_statement] = STATE(876),
    [sym_case_statement] = STATE(876),
    [sym_function_definition] = STATE(876),
    [sym_subshell] = STATE(876),
    [sym_pipeline] = STATE(876),
    [sym_list] = STATE(876),
    [sym_bracket_command] = STATE(876),
    [sym_command] = STATE(876),
    [sym_environment_variable_assignment] = STATE(877),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(219),
    [sym_command_substitution] = STATE(219),
    [aux_sym_command_repeat1] = STATE(223),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_if] = ACTIONS(495),
    [anon_sym_case] = ACTIONS(497),
    [anon_sym_function] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(505),
    [anon_sym_COLON] = ACTIONS(507),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(511),
    [sym_comment] = ACTIONS(115),
  },
  [776] = {
    [sym_file_descriptor] = ACTIONS(375),
    [anon_sym_RPAREN] = ACTIONS(377),
    [anon_sym_SEMI_SEMI] = ACTIONS(377),
    [anon_sym_RBRACE] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_PIPE_AMP] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_AMP_GT] = ACTIONS(377),
    [anon_sym_AMP_GT_GT] = ACTIONS(377),
    [anon_sym_LT_AMP] = ACTIONS(377),
    [anon_sym_GT_AMP] = ACTIONS(377),
    [anon_sym_DQUOTE] = ACTIONS(377),
    [sym_raw_string] = ACTIONS(377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(377),
    [sym_leading_word] = ACTIONS(377),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(377),
    [anon_sym_LF] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
  },
  [777] = {
    [sym_simple_expansion] = STATE(163),
    [sym_expansion] = STATE(163),
    [sym_command_substitution] = STATE(163),
    [anon_sym_DQUOTE] = ACTIONS(2381),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [778] = {
    [sym_file_descriptor] = ACTIONS(525),
    [anon_sym_RPAREN] = ACTIONS(519),
    [anon_sym_SEMI_SEMI] = ACTIONS(519),
    [anon_sym_RBRACE] = ACTIONS(519),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_PIPE_AMP] = ACTIONS(519),
    [anon_sym_AMP_AMP] = ACTIONS(519),
    [anon_sym_PIPE_PIPE] = ACTIONS(519),
    [anon_sym_COLON] = ACTIONS(519),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_GT] = ACTIONS(519),
    [anon_sym_AMP_GT] = ACTIONS(519),
    [anon_sym_AMP_GT_GT] = ACTIONS(519),
    [anon_sym_LT_AMP] = ACTIONS(519),
    [anon_sym_GT_AMP] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(519),
    [sym_raw_string] = ACTIONS(519),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(519),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [sym_leading_word] = ACTIONS(519),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(519),
    [anon_sym_LF] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(519),
  },
  [779] = {
    [sym_file_descriptor] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(521),
    [anon_sym_SEMI_SEMI] = ACTIONS(521),
    [anon_sym_RBRACE] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PIPE_AMP] = ACTIONS(521),
    [anon_sym_AMP_AMP] = ACTIONS(521),
    [anon_sym_PIPE_PIPE] = ACTIONS(521),
    [anon_sym_COLON] = ACTIONS(521),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_AMP_GT] = ACTIONS(521),
    [anon_sym_AMP_GT_GT] = ACTIONS(521),
    [anon_sym_LT_AMP] = ACTIONS(521),
    [anon_sym_GT_AMP] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(521),
    [sym_raw_string] = ACTIONS(521),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(521),
    [anon_sym_BQUOTE] = ACTIONS(521),
    [sym_leading_word] = ACTIONS(521),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(521),
    [anon_sym_LF] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
  },
  [780] = {
    [sym_file_descriptor] = ACTIONS(555),
    [anon_sym_RPAREN] = ACTIONS(523),
    [anon_sym_SEMI_SEMI] = ACTIONS(523),
    [anon_sym_RBRACE] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(523),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(523),
    [anon_sym_PIPE_PIPE] = ACTIONS(523),
    [anon_sym_COLON] = ACTIONS(523),
    [anon_sym_LT] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(523),
    [anon_sym_GT_GT] = ACTIONS(523),
    [anon_sym_AMP_GT] = ACTIONS(523),
    [anon_sym_AMP_GT_GT] = ACTIONS(523),
    [anon_sym_LT_AMP] = ACTIONS(523),
    [anon_sym_GT_AMP] = ACTIONS(523),
    [anon_sym_DQUOTE] = ACTIONS(523),
    [sym_raw_string] = ACTIONS(523),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(523),
    [anon_sym_BQUOTE] = ACTIONS(523),
    [sym_leading_word] = ACTIONS(523),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(523),
    [anon_sym_LF] = ACTIONS(523),
    [anon_sym_AMP] = ACTIONS(523),
  },
  [781] = {
    [anon_sym_RBRACE] = ACTIONS(2383),
    [anon_sym_COLON] = ACTIONS(2385),
    [anon_sym_EQ] = ACTIONS(2387),
    [anon_sym_COLON_QMARK] = ACTIONS(2387),
    [anon_sym_COLON_DASH] = ACTIONS(2387),
    [sym_comment] = ACTIONS(115),
  },
  [782] = {
    [anon_sym_RBRACE] = ACTIONS(2389),
    [anon_sym_COLON] = ACTIONS(2391),
    [anon_sym_EQ] = ACTIONS(2393),
    [anon_sym_COLON_QMARK] = ACTIONS(2393),
    [anon_sym_COLON_DASH] = ACTIONS(2393),
    [sym_comment] = ACTIONS(115),
  },
  [783] = {
    [anon_sym_RPAREN] = ACTIONS(2395),
    [sym_comment] = ACTIONS(115),
  },
  [784] = {
    [anon_sym_BQUOTE] = ACTIONS(2395),
    [sym_comment] = ACTIONS(115),
  },
  [785] = {
    [anon_sym_RPAREN] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [sym_comment] = ACTIONS(115),
  },
  [786] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(819),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(241),
    [anon_sym_GT] = ACTIONS(241),
    [anon_sym_GT_GT] = ACTIONS(241),
    [anon_sym_AMP_GT] = ACTIONS(241),
    [anon_sym_AMP_GT_GT] = ACTIONS(241),
    [anon_sym_LT_AMP] = ACTIONS(241),
    [anon_sym_GT_AMP] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_raw_string] = ACTIONS(241),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(115),
  },
  [787] = {
    [sym_for_statement] = STATE(884),
    [sym_while_statement] = STATE(884),
    [sym_if_statement] = STATE(884),
    [sym_case_statement] = STATE(884),
    [sym_function_definition] = STATE(884),
    [sym_subshell] = STATE(884),
    [sym_pipeline] = STATE(884),
    [sym_list] = STATE(884),
    [sym_bracket_command] = STATE(884),
    [sym_command] = STATE(884),
    [sym_environment_variable_assignment] = STATE(885),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(219),
    [sym_command_substitution] = STATE(219),
    [aux_sym_command_repeat1] = STATE(223),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_if] = ACTIONS(495),
    [anon_sym_case] = ACTIONS(497),
    [anon_sym_function] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(505),
    [anon_sym_COLON] = ACTIONS(507),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(511),
    [sym_comment] = ACTIONS(115),
  },
  [788] = {
    [sym_file_descriptor] = ACTIONS(375),
    [anon_sym_RPAREN] = ACTIONS(377),
    [anon_sym_SEMI_SEMI] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_PIPE_AMP] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_AMP_GT] = ACTIONS(377),
    [anon_sym_AMP_GT_GT] = ACTIONS(377),
    [anon_sym_LT_AMP] = ACTIONS(377),
    [anon_sym_GT_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_DQUOTE] = ACTIONS(377),
    [sym_raw_string] = ACTIONS(377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(377),
    [sym_leading_word] = ACTIONS(377),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(377),
    [anon_sym_LF] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
  },
  [789] = {
    [sym_simple_expansion] = STATE(163),
    [sym_expansion] = STATE(163),
    [sym_command_substitution] = STATE(163),
    [anon_sym_DQUOTE] = ACTIONS(2399),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [790] = {
    [sym_file_descriptor] = ACTIONS(525),
    [anon_sym_RPAREN] = ACTIONS(519),
    [anon_sym_SEMI_SEMI] = ACTIONS(519),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_PIPE_AMP] = ACTIONS(519),
    [anon_sym_AMP_AMP] = ACTIONS(519),
    [anon_sym_PIPE_PIPE] = ACTIONS(519),
    [anon_sym_COLON] = ACTIONS(519),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_GT] = ACTIONS(519),
    [anon_sym_AMP_GT] = ACTIONS(519),
    [anon_sym_AMP_GT_GT] = ACTIONS(519),
    [anon_sym_LT_AMP] = ACTIONS(519),
    [anon_sym_GT_AMP] = ACTIONS(519),
    [anon_sym_LT_LT] = ACTIONS(519),
    [anon_sym_LT_LT_DASH] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(519),
    [sym_raw_string] = ACTIONS(519),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(519),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [sym_leading_word] = ACTIONS(519),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(519),
    [anon_sym_LF] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(519),
  },
  [791] = {
    [sym_file_descriptor] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(521),
    [anon_sym_SEMI_SEMI] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PIPE_AMP] = ACTIONS(521),
    [anon_sym_AMP_AMP] = ACTIONS(521),
    [anon_sym_PIPE_PIPE] = ACTIONS(521),
    [anon_sym_COLON] = ACTIONS(521),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_AMP_GT] = ACTIONS(521),
    [anon_sym_AMP_GT_GT] = ACTIONS(521),
    [anon_sym_LT_AMP] = ACTIONS(521),
    [anon_sym_GT_AMP] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_LT_LT_DASH] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(521),
    [sym_raw_string] = ACTIONS(521),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(521),
    [anon_sym_BQUOTE] = ACTIONS(521),
    [sym_leading_word] = ACTIONS(521),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(521),
    [anon_sym_LF] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
  },
  [792] = {
    [sym_file_descriptor] = ACTIONS(555),
    [anon_sym_RPAREN] = ACTIONS(523),
    [anon_sym_SEMI_SEMI] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(523),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(523),
    [anon_sym_PIPE_PIPE] = ACTIONS(523),
    [anon_sym_COLON] = ACTIONS(523),
    [anon_sym_LT] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(523),
    [anon_sym_GT_GT] = ACTIONS(523),
    [anon_sym_AMP_GT] = ACTIONS(523),
    [anon_sym_AMP_GT_GT] = ACTIONS(523),
    [anon_sym_LT_AMP] = ACTIONS(523),
    [anon_sym_GT_AMP] = ACTIONS(523),
    [anon_sym_LT_LT] = ACTIONS(523),
    [anon_sym_LT_LT_DASH] = ACTIONS(523),
    [anon_sym_DQUOTE] = ACTIONS(523),
    [sym_raw_string] = ACTIONS(523),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(523),
    [anon_sym_BQUOTE] = ACTIONS(523),
    [sym_leading_word] = ACTIONS(523),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(523),
    [anon_sym_LF] = ACTIONS(523),
    [anon_sym_AMP] = ACTIONS(523),
  },
  [793] = {
    [anon_sym_RBRACE] = ACTIONS(2401),
    [anon_sym_COLON] = ACTIONS(2403),
    [anon_sym_EQ] = ACTIONS(2405),
    [anon_sym_COLON_QMARK] = ACTIONS(2405),
    [anon_sym_COLON_DASH] = ACTIONS(2405),
    [sym_comment] = ACTIONS(115),
  },
  [794] = {
    [anon_sym_RBRACE] = ACTIONS(2407),
    [anon_sym_COLON] = ACTIONS(2409),
    [anon_sym_EQ] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_DASH] = ACTIONS(2411),
    [sym_comment] = ACTIONS(115),
  },
  [795] = {
    [anon_sym_RPAREN] = ACTIONS(2413),
    [sym_comment] = ACTIONS(115),
  },
  [796] = {
    [anon_sym_BQUOTE] = ACTIONS(2413),
    [sym_comment] = ACTIONS(115),
  },
  [797] = {
    [sym_case_item] = STATE(358),
    [sym_string] = STATE(356),
    [sym_simple_expansion] = STATE(356),
    [sym_expansion] = STATE(356),
    [sym_command_substitution] = STATE(356),
    [sym_process_substitution] = STATE(356),
    [aux_sym_case_statement_repeat1] = STATE(893),
    [anon_sym_esac] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(829),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(833),
    [sym_comment] = ACTIONS(115),
  },
  [798] = {
    [sym_file_descriptor] = ACTIONS(475),
    [anon_sym_RPAREN] = ACTIONS(479),
    [anon_sym_SEMI_SEMI] = ACTIONS(479),
    [anon_sym_PIPE] = ACTIONS(479),
    [anon_sym_PIPE_AMP] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(479),
    [anon_sym_AMP_GT] = ACTIONS(479),
    [anon_sym_AMP_GT_GT] = ACTIONS(479),
    [anon_sym_LT_AMP] = ACTIONS(479),
    [anon_sym_GT_AMP] = ACTIONS(479),
    [anon_sym_LT_LT] = ACTIONS(479),
    [anon_sym_LT_LT_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(479),
    [sym_raw_string] = ACTIONS(479),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(479),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_leading_word] = ACTIONS(479),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_LF] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(479),
  },
  [799] = {
    [sym_case_item] = STATE(358),
    [sym_string] = STATE(356),
    [sym_simple_expansion] = STATE(356),
    [sym_expansion] = STATE(356),
    [sym_command_substitution] = STATE(356),
    [sym_process_substitution] = STATE(356),
    [aux_sym_case_statement_repeat1] = STATE(895),
    [anon_sym_esac] = ACTIONS(2417),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(829),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(833),
    [sym_comment] = ACTIONS(115),
  },
  [800] = {
    [anon_sym_RBRACE] = ACTIONS(2419),
    [sym_comment] = ACTIONS(115),
  },
  [801] = {
    [anon_sym_RPAREN] = ACTIONS(1211),
    [anon_sym_SEMI_SEMI] = ACTIONS(1211),
    [anon_sym_PIPE] = ACTIONS(1211),
    [anon_sym_PIPE_AMP] = ACTIONS(1211),
    [anon_sym_AMP_AMP] = ACTIONS(1211),
    [anon_sym_PIPE_PIPE] = ACTIONS(1211),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym_LF] = ACTIONS(1211),
    [anon_sym_AMP] = ACTIONS(1211),
  },
  [802] = {
    [anon_sym_fi] = ACTIONS(2421),
    [sym_comment] = ACTIONS(115),
  },
  [803] = {
    [anon_sym_RPAREN] = ACTIONS(2423),
    [anon_sym_SEMI_SEMI] = ACTIONS(2423),
    [anon_sym_PIPE] = ACTIONS(2423),
    [anon_sym_PIPE_AMP] = ACTIONS(2423),
    [anon_sym_AMP_AMP] = ACTIONS(2423),
    [anon_sym_PIPE_PIPE] = ACTIONS(2423),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(2423),
    [anon_sym_LF] = ACTIONS(2423),
    [anon_sym_AMP] = ACTIONS(2423),
  },
  [804] = {
    [sym_for_statement] = STATE(898),
    [sym_while_statement] = STATE(898),
    [sym_if_statement] = STATE(898),
    [sym_case_statement] = STATE(898),
    [sym_function_definition] = STATE(898),
    [sym_subshell] = STATE(898),
    [sym_pipeline] = STATE(898),
    [sym_list] = STATE(898),
    [sym_bracket_command] = STATE(898),
    [sym_command] = STATE(898),
    [sym_environment_variable_assignment] = STATE(899),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(219),
    [sym_command_substitution] = STATE(219),
    [aux_sym_command_repeat1] = STATE(223),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_if] = ACTIONS(495),
    [anon_sym_case] = ACTIONS(497),
    [anon_sym_function] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(505),
    [anon_sym_COLON] = ACTIONS(507),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(511),
    [sym_comment] = ACTIONS(115),
  },
  [805] = {
    [sym_file_descriptor] = ACTIONS(375),
    [anon_sym_RPAREN] = ACTIONS(377),
    [anon_sym_SEMI_SEMI] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_PIPE_AMP] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_RBRACK] = ACTIONS(377),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_AMP_GT] = ACTIONS(377),
    [anon_sym_AMP_GT_GT] = ACTIONS(377),
    [anon_sym_LT_AMP] = ACTIONS(377),
    [anon_sym_GT_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_DQUOTE] = ACTIONS(377),
    [sym_raw_string] = ACTIONS(377),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(377),
    [sym_word] = ACTIONS(377),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(377),
    [anon_sym_LF] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
  },
  [806] = {
    [sym_simple_expansion] = STATE(163),
    [sym_expansion] = STATE(163),
    [sym_command_substitution] = STATE(163),
    [anon_sym_DQUOTE] = ACTIONS(2426),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [807] = {
    [sym_file_descriptor] = ACTIONS(525),
    [anon_sym_RPAREN] = ACTIONS(519),
    [anon_sym_SEMI_SEMI] = ACTIONS(519),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_PIPE_AMP] = ACTIONS(519),
    [anon_sym_AMP_AMP] = ACTIONS(519),
    [anon_sym_PIPE_PIPE] = ACTIONS(519),
    [anon_sym_RBRACK] = ACTIONS(519),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(519),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_GT] = ACTIONS(519),
    [anon_sym_AMP_GT] = ACTIONS(519),
    [anon_sym_AMP_GT_GT] = ACTIONS(519),
    [anon_sym_LT_AMP] = ACTIONS(519),
    [anon_sym_GT_AMP] = ACTIONS(519),
    [anon_sym_LT_LT] = ACTIONS(519),
    [anon_sym_LT_LT_DASH] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(519),
    [sym_raw_string] = ACTIONS(519),
    [anon_sym_DOLLAR] = ACTIONS(519),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(519),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(519),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [sym_word] = ACTIONS(519),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(519),
    [anon_sym_LF] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(519),
  },
  [808] = {
    [sym_file_descriptor] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(521),
    [anon_sym_SEMI_SEMI] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PIPE_AMP] = ACTIONS(521),
    [anon_sym_AMP_AMP] = ACTIONS(521),
    [anon_sym_PIPE_PIPE] = ACTIONS(521),
    [anon_sym_RBRACK] = ACTIONS(521),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(521),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_AMP_GT] = ACTIONS(521),
    [anon_sym_AMP_GT_GT] = ACTIONS(521),
    [anon_sym_LT_AMP] = ACTIONS(521),
    [anon_sym_GT_AMP] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_LT_LT_DASH] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(521),
    [sym_raw_string] = ACTIONS(521),
    [anon_sym_DOLLAR] = ACTIONS(521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(521),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(521),
    [anon_sym_BQUOTE] = ACTIONS(521),
    [sym_word] = ACTIONS(521),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(521),
    [anon_sym_LF] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
  },
  [809] = {
    [sym_file_descriptor] = ACTIONS(555),
    [anon_sym_RPAREN] = ACTIONS(523),
    [anon_sym_SEMI_SEMI] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(523),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(523),
    [anon_sym_PIPE_PIPE] = ACTIONS(523),
    [anon_sym_RBRACK] = ACTIONS(523),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(523),
    [anon_sym_LT] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(523),
    [anon_sym_GT_GT] = ACTIONS(523),
    [anon_sym_AMP_GT] = ACTIONS(523),
    [anon_sym_AMP_GT_GT] = ACTIONS(523),
    [anon_sym_LT_AMP] = ACTIONS(523),
    [anon_sym_GT_AMP] = ACTIONS(523),
    [anon_sym_LT_LT] = ACTIONS(523),
    [anon_sym_LT_LT_DASH] = ACTIONS(523),
    [anon_sym_DQUOTE] = ACTIONS(523),
    [sym_raw_string] = ACTIONS(523),
    [anon_sym_DOLLAR] = ACTIONS(523),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(523),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(523),
    [anon_sym_BQUOTE] = ACTIONS(523),
    [sym_word] = ACTIONS(523),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(523),
    [anon_sym_LF] = ACTIONS(523),
    [anon_sym_AMP] = ACTIONS(523),
  },
  [810] = {
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_COLON] = ACTIONS(2430),
    [anon_sym_EQ] = ACTIONS(2432),
    [anon_sym_COLON_QMARK] = ACTIONS(2432),
    [anon_sym_COLON_DASH] = ACTIONS(2432),
    [sym_comment] = ACTIONS(115),
  },
  [811] = {
    [anon_sym_RBRACE] = ACTIONS(2434),
    [anon_sym_COLON] = ACTIONS(2436),
    [anon_sym_EQ] = ACTIONS(2438),
    [anon_sym_COLON_QMARK] = ACTIONS(2438),
    [anon_sym_COLON_DASH] = ACTIONS(2438),
    [sym_comment] = ACTIONS(115),
  },
  [812] = {
    [anon_sym_RPAREN] = ACTIONS(2440),
    [sym_comment] = ACTIONS(115),
  },
  [813] = {
    [anon_sym_BQUOTE] = ACTIONS(2440),
    [sym_comment] = ACTIONS(115),
  },
  [814] = {
    [sym_file_redirect] = STATE(675),
    [sym_heredoc_redirect] = STATE(675),
    [sym_string] = STATE(761),
    [sym_simple_expansion] = STATE(761),
    [sym_expansion] = STATE(761),
    [sym_command_substitution] = STATE(761),
    [sym_process_substitution] = STATE(761),
    [aux_sym_bracket_command_repeat1] = STATE(906),
    [aux_sym_command_repeat2] = STATE(907),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(597),
    [anon_sym_SEMI_SEMI] = ACTIONS(597),
    [anon_sym_PIPE] = ACTIONS(597),
    [anon_sym_PIPE_AMP] = ACTIONS(597),
    [anon_sym_AMP_AMP] = ACTIONS(597),
    [anon_sym_PIPE_PIPE] = ACTIONS(597),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1646),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [sym_raw_string] = ACTIONS(2151),
    [anon_sym_DOLLAR] = ACTIONS(2153),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2155),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2157),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [sym_word] = ACTIONS(2151),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(597),
    [anon_sym_LF] = ACTIONS(597),
    [anon_sym_AMP] = ACTIONS(597),
  },
  [815] = {
    [sym_file_redirect] = STATE(732),
    [sym_heredoc_redirect] = STATE(732),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(601),
    [anon_sym_SEMI_SEMI] = ACTIONS(601),
    [anon_sym_PIPE] = ACTIONS(601),
    [anon_sym_PIPE_AMP] = ACTIONS(601),
    [anon_sym_AMP_AMP] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(601),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1646),
    [anon_sym_BQUOTE] = ACTIONS(601),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(601),
    [anon_sym_LF] = ACTIONS(601),
    [anon_sym_AMP] = ACTIONS(601),
  },
  [816] = {
    [sym_file_descriptor] = ACTIONS(375),
    [anon_sym_RPAREN] = ACTIONS(377),
    [anon_sym_SEMI_SEMI] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_PIPE_AMP] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_AMP_GT] = ACTIONS(377),
    [anon_sym_AMP_GT_GT] = ACTIONS(377),
    [anon_sym_LT_AMP] = ACTIONS(377),
    [anon_sym_GT_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(377),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(377),
    [anon_sym_LF] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
  },
  [817] = {
    [sym_simple_expansion] = STATE(163),
    [sym_expansion] = STATE(163),
    [sym_command_substitution] = STATE(163),
    [anon_sym_DQUOTE] = ACTIONS(2445),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [818] = {
    [anon_sym_RPAREN] = ACTIONS(2447),
    [sym_comment] = ACTIONS(115),
  },
  [819] = {
    [anon_sym_BQUOTE] = ACTIONS(2447),
    [sym_comment] = ACTIONS(115),
  },
  [820] = {
    [sym_file_redirect] = STATE(675),
    [sym_heredoc_redirect] = STATE(675),
    [sym_string] = STATE(761),
    [sym_simple_expansion] = STATE(761),
    [sym_expansion] = STATE(761),
    [sym_command_substitution] = STATE(761),
    [sym_process_substitution] = STATE(761),
    [aux_sym_bracket_command_repeat1] = STATE(910),
    [aux_sym_command_repeat2] = STATE(911),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(769),
    [anon_sym_SEMI_SEMI] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_PIPE_AMP] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1646),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [sym_raw_string] = ACTIONS(2151),
    [anon_sym_DOLLAR] = ACTIONS(2153),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2155),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2157),
    [anon_sym_BQUOTE] = ACTIONS(2449),
    [sym_word] = ACTIONS(2151),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(769),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
  },
  [821] = {
    [sym_file_redirect] = STATE(732),
    [sym_heredoc_redirect] = STATE(732),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(771),
    [anon_sym_SEMI_SEMI] = ACTIONS(771),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_PIPE_AMP] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1646),
    [anon_sym_BQUOTE] = ACTIONS(771),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(771),
    [anon_sym_LF] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
  },
  [822] = {
    [sym__terminated_statement] = STATE(87),
    [sym_for_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_elif_clause] = STATE(207),
    [sym_else_clause] = STATE(714),
    [sym_case_statement] = STATE(19),
    [sym_function_definition] = STATE(19),
    [sym_subshell] = STATE(19),
    [sym_pipeline] = STATE(19),
    [sym_list] = STATE(19),
    [sym_bracket_command] = STATE(19),
    [sym_command] = STATE(19),
    [sym_environment_variable_assignment] = STATE(20),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(11),
    [sym_command_substitution] = STATE(11),
    [aux_sym_if_statement_repeat1] = STATE(715),
    [aux_sym_command_repeat1] = STATE(23),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(89),
    [anon_sym_fi] = ACTIONS(2452),
    [anon_sym_elif] = ACTIONS(487),
    [anon_sym_else] = ACTIONS(489),
    [anon_sym_case] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [sym_raw_string] = ACTIONS(107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym_leading_word] = ACTIONS(113),
    [sym_comment] = ACTIONS(115),
  },
  [823] = {
    [sym_compound_statement] = STATE(912),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [sym_comment] = ACTIONS(115),
  },
  [824] = {
    [sym_string] = STATE(913),
    [sym_simple_expansion] = STATE(913),
    [sym_expansion] = STATE(913),
    [sym_command_substitution] = STATE(913),
    [sym_process_substitution] = STATE(913),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_DQUOTE] = ACTIONS(2297),
    [sym_raw_string] = ACTIONS(2456),
    [anon_sym_DOLLAR] = ACTIONS(2301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2303),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2305),
    [anon_sym_BQUOTE] = ACTIONS(2307),
    [sym_word] = ACTIONS(2458),
    [sym_comment] = ACTIONS(115),
  },
  [825] = {
    [sym_string] = STATE(830),
    [sym_simple_expansion] = STATE(830),
    [sym_expansion] = STATE(830),
    [sym_command_substitution] = STATE(830),
    [sym_process_substitution] = STATE(830),
    [anon_sym_LPAREN] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_DQUOTE] = ACTIONS(2297),
    [sym_raw_string] = ACTIONS(2299),
    [anon_sym_DOLLAR] = ACTIONS(2301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2303),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2305),
    [anon_sym_BQUOTE] = ACTIONS(2307),
    [sym_word] = ACTIONS(2309),
    [sym_comment] = ACTIONS(115),
  },
  [826] = {
    [sym_file_redirect] = STATE(746),
    [sym_heredoc_redirect] = STATE(746),
    [sym_string] = STATE(864),
    [sym_simple_expansion] = STATE(864),
    [sym_expansion] = STATE(864),
    [sym_command_substitution] = STATE(864),
    [sym_process_substitution] = STATE(864),
    [aux_sym_command_repeat2] = STATE(914),
    [sym_file_descriptor] = ACTIONS(2098),
    [anon_sym_RPAREN] = ACTIONS(597),
    [anon_sym_SEMI_SEMI] = ACTIONS(597),
    [anon_sym_PIPE] = ACTIONS(597),
    [anon_sym_PIPE_AMP] = ACTIONS(597),
    [anon_sym_AMP_AMP] = ACTIONS(597),
    [anon_sym_PIPE_PIPE] = ACTIONS(597),
    [anon_sym_LT] = ACTIONS(2291),
    [anon_sym_GT] = ACTIONS(2291),
    [anon_sym_GT_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT_GT] = ACTIONS(2102),
    [anon_sym_LT_AMP] = ACTIONS(2102),
    [anon_sym_GT_AMP] = ACTIONS(2102),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2104),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [sym_raw_string] = ACTIONS(2360),
    [anon_sym_DOLLAR] = ACTIONS(2153),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2155),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2157),
    [anon_sym_BQUOTE] = ACTIONS(2293),
    [sym_word] = ACTIONS(2360),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(597),
    [anon_sym_LF] = ACTIONS(597),
    [anon_sym_AMP] = ACTIONS(597),
  },
  [827] = {
    [sym_file_redirect] = STATE(838),
    [sym_heredoc_redirect] = STATE(838),
    [sym_file_descriptor] = ACTIONS(2098),
    [anon_sym_RPAREN] = ACTIONS(601),
    [anon_sym_SEMI_SEMI] = ACTIONS(601),
    [anon_sym_PIPE] = ACTIONS(601),
    [anon_sym_PIPE_AMP] = ACTIONS(601),
    [anon_sym_AMP_AMP] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(601),
    [anon_sym_LT] = ACTIONS(2102),
    [anon_sym_GT] = ACTIONS(2102),
    [anon_sym_GT_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT_GT] = ACTIONS(2102),
    [anon_sym_LT_AMP] = ACTIONS(2102),
    [anon_sym_GT_AMP] = ACTIONS(2102),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2104),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(601),
    [anon_sym_LF] = ACTIONS(601),
    [anon_sym_AMP] = ACTIONS(601),
  },
  [828] = {
    [anon_sym_LPAREN] = ACTIONS(2460),
    [sym_comment] = ACTIONS(115),
  },
  [829] = {
    [sym_simple_expansion] = STATE(63),
    [sym_expansion] = STATE(63),
    [sym_command_substitution] = STATE(63),
    [aux_sym_string_repeat1] = STATE(917),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [830] = {
    [sym_file_descriptor] = ACTIONS(361),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_SEMI_SEMI] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(365),
    [anon_sym_PIPE_AMP] = ACTIONS(365),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [anon_sym_LT] = ACTIONS(365),
    [anon_sym_GT] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_AMP_GT] = ACTIONS(365),
    [anon_sym_AMP_GT_GT] = ACTIONS(365),
    [anon_sym_LT_AMP] = ACTIONS(365),
    [anon_sym_GT_AMP] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_LT_LT_DASH] = ACTIONS(365),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_LF] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(365),
  },
  [831] = {
    [sym_special_variable_name] = STATE(920),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym_comment] = ACTIONS(73),
    [sym_simple_variable_name] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_AT] = ACTIONS(2464),
    [anon_sym_POUND] = ACTIONS(2468),
    [anon_sym_QMARK] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2464),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_0] = ACTIONS(2468),
    [anon_sym__] = ACTIONS(2468),
  },
  [832] = {
    [sym_special_variable_name] = STATE(922),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_leading_word] = ACTIONS(2470),
    [sym_comment] = ACTIONS(73),
    [anon_sym_STAR] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_POUND] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(277),
    [anon_sym_0] = ACTIONS(277),
    [anon_sym__] = ACTIONS(277),
  },
  [833] = {
    [sym_command] = STATE(923),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(75),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(207),
    [sym_comment] = ACTIONS(115),
  },
  [834] = {
    [sym_command] = STATE(924),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_command_repeat1] = STATE(79),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(213),
    [sym_comment] = ACTIONS(115),
  },
  [835] = {
    [sym_file_descriptor] = ACTIONS(615),
    [anon_sym_RPAREN] = ACTIONS(617),
    [anon_sym_SEMI_SEMI] = ACTIONS(617),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_PIPE_AMP] = ACTIONS(617),
    [anon_sym_AMP_AMP] = ACTIONS(617),
    [anon_sym_PIPE_PIPE] = ACTIONS(617),
    [anon_sym_LT] = ACTIONS(617),
    [anon_sym_GT] = ACTIONS(617),
    [anon_sym_GT_GT] = ACTIONS(617),
    [anon_sym_AMP_GT] = ACTIONS(617),
    [anon_sym_AMP_GT_GT] = ACTIONS(617),
    [anon_sym_LT_AMP] = ACTIONS(617),
    [anon_sym_GT_AMP] = ACTIONS(617),
    [anon_sym_LT_LT] = ACTIONS(617),
    [anon_sym_LT_LT_DASH] = ACTIONS(617),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_LF] = ACTIONS(617),
    [anon_sym_AMP] = ACTIONS(617),
  },
  [836] = {
    [sym_simple_expansion] = STATE(264),
    [sym_expansion] = STATE(264),
    [aux_sym_heredoc_repeat1] = STATE(926),
    [sym__heredoc_middle] = ACTIONS(619),
    [sym__heredoc_end] = ACTIONS(2472),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(625),
    [sym_comment] = ACTIONS(115),
  },
  [837] = {
    [sym_file_descriptor] = ACTIONS(627),
    [anon_sym_RPAREN] = ACTIONS(629),
    [anon_sym_SEMI_SEMI] = ACTIONS(629),
    [anon_sym_PIPE] = ACTIONS(629),
    [anon_sym_PIPE_AMP] = ACTIONS(629),
    [anon_sym_AMP_AMP] = ACTIONS(629),
    [anon_sym_PIPE_PIPE] = ACTIONS(629),
    [anon_sym_LT] = ACTIONS(629),
    [anon_sym_GT] = ACTIONS(629),
    [anon_sym_GT_GT] = ACTIONS(629),
    [anon_sym_AMP_GT] = ACTIONS(629),
    [anon_sym_AMP_GT_GT] = ACTIONS(629),
    [anon_sym_LT_AMP] = ACTIONS(629),
    [anon_sym_GT_AMP] = ACTIONS(629),
    [anon_sym_LT_LT] = ACTIONS(629),
    [anon_sym_LT_LT_DASH] = ACTIONS(629),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym_LF] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
  },
  [838] = {
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_RPAREN] = ACTIONS(633),
    [anon_sym_SEMI_SEMI] = ACTIONS(633),
    [anon_sym_PIPE] = ACTIONS(633),
    [anon_sym_PIPE_AMP] = ACTIONS(633),
    [anon_sym_AMP_AMP] = ACTIONS(633),
    [anon_sym_PIPE_PIPE] = ACTIONS(633),
    [anon_sym_LT] = ACTIONS(633),
    [anon_sym_GT] = ACTIONS(633),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_AMP_GT] = ACTIONS(633),
    [anon_sym_AMP_GT_GT] = ACTIONS(633),
    [anon_sym_LT_AMP] = ACTIONS(633),
    [anon_sym_GT_AMP] = ACTIONS(633),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_DASH] = ACTIONS(633),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(633),
    [anon_sym_LF] = ACTIONS(633),
    [anon_sym_AMP] = ACTIONS(633),
  },
  [839] = {
    [sym_file_descriptor] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_SEMI_SEMI] = ACTIONS(667),
    [anon_sym_PIPE] = ACTIONS(667),
    [anon_sym_PIPE_AMP] = ACTIONS(667),
    [anon_sym_AMP_AMP] = ACTIONS(667),
    [anon_sym_PIPE_PIPE] = ACTIONS(667),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(667),
    [anon_sym_GT] = ACTIONS(667),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(667),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_LT_LT] = ACTIONS(667),
    [anon_sym_LT_LT_DASH] = ACTIONS(667),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_LF] = ACTIONS(667),
    [anon_sym_AMP] = ACTIONS(667),
  },
  [840] = {
    [sym_file_descriptor] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(733),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [841] = {
    [sym_compound_statement] = STATE(927),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [sym_comment] = ACTIONS(115),
  },
  [842] = {
    [sym_file_redirect] = STATE(746),
    [sym_heredoc_redirect] = STATE(746),
    [sym_string] = STATE(864),
    [sym_simple_expansion] = STATE(864),
    [sym_expansion] = STATE(864),
    [sym_command_substitution] = STATE(864),
    [sym_process_substitution] = STATE(864),
    [aux_sym_command_repeat2] = STATE(928),
    [sym_file_descriptor] = ACTIONS(2098),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_SEMI_SEMI] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(745),
    [anon_sym_PIPE_AMP] = ACTIONS(745),
    [anon_sym_AMP_AMP] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(745),
    [anon_sym_LT] = ACTIONS(2291),
    [anon_sym_GT] = ACTIONS(2291),
    [anon_sym_GT_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT_GT] = ACTIONS(2102),
    [anon_sym_LT_AMP] = ACTIONS(2102),
    [anon_sym_GT_AMP] = ACTIONS(2102),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2104),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [sym_raw_string] = ACTIONS(2360),
    [anon_sym_DOLLAR] = ACTIONS(2153),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2155),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2157),
    [anon_sym_BQUOTE] = ACTIONS(2293),
    [sym_word] = ACTIONS(2360),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_LF] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(745),
  },
  [843] = {
    [sym_file_redirect] = STATE(838),
    [sym_heredoc_redirect] = STATE(838),
    [sym_file_descriptor] = ACTIONS(2098),
    [anon_sym_RPAREN] = ACTIONS(747),
    [anon_sym_SEMI_SEMI] = ACTIONS(747),
    [anon_sym_PIPE] = ACTIONS(747),
    [anon_sym_PIPE_AMP] = ACTIONS(747),
    [anon_sym_AMP_AMP] = ACTIONS(747),
    [anon_sym_PIPE_PIPE] = ACTIONS(747),
    [anon_sym_LT] = ACTIONS(2102),
    [anon_sym_GT] = ACTIONS(2102),
    [anon_sym_GT_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT_GT] = ACTIONS(2102),
    [anon_sym_LT_AMP] = ACTIONS(2102),
    [anon_sym_GT_AMP] = ACTIONS(2102),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2104),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(747),
    [anon_sym_LF] = ACTIONS(747),
    [anon_sym_AMP] = ACTIONS(747),
  },
  [844] = {
    [anon_sym_LPAREN] = ACTIONS(2474),
    [sym_comment] = ACTIONS(115),
  },
  [845] = {
    [sym_simple_expansion] = STATE(63),
    [sym_expansion] = STATE(63),
    [sym_command_substitution] = STATE(63),
    [aux_sym_string_repeat1] = STATE(931),
    [anon_sym_DQUOTE] = ACTIONS(2476),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [846] = {
    [sym_special_variable_name] = STATE(934),
    [anon_sym_DOLLAR] = ACTIONS(2478),
    [sym_comment] = ACTIONS(73),
    [sym_simple_variable_name] = ACTIONS(2480),
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_AT] = ACTIONS(2478),
    [anon_sym_POUND] = ACTIONS(2482),
    [anon_sym_QMARK] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2478),
    [anon_sym_0] = ACTIONS(2482),
    [anon_sym__] = ACTIONS(2482),
  },
  [847] = {
    [sym_special_variable_name] = STATE(936),
    [anon_sym_DOLLAR] = ACTIONS(277),
    [sym_leading_word] = ACTIONS(2484),
    [sym_comment] = ACTIONS(73),
    [anon_sym_STAR] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_POUND] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(277),
    [anon_sym_0] = ACTIONS(277),
    [anon_sym__] = ACTIONS(277),
  },
  [848] = {
    [sym_command] = STATE(937),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(69),
    [sym_command_substitution] = STATE(69),
    [aux_sym_command_repeat1] = STATE(75),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(207),
    [sym_comment] = ACTIONS(115),
  },
  [849] = {
    [sym_command] = STATE(938),
    [sym_environment_variable_assignment] = STATE(21),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_command_repeat1] = STATE(79),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_COLON] = ACTIONS(209),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(213),
    [sym_comment] = ACTIONS(115),
  },
  [850] = {
    [sym_file_redirect] = STATE(746),
    [sym_heredoc_redirect] = STATE(746),
    [sym_string] = STATE(761),
    [sym_simple_expansion] = STATE(761),
    [sym_expansion] = STATE(761),
    [sym_command_substitution] = STATE(761),
    [sym_process_substitution] = STATE(761),
    [aux_sym_bracket_command_repeat1] = STATE(939),
    [aux_sym_command_repeat2] = STATE(914),
    [sym_file_descriptor] = ACTIONS(2098),
    [anon_sym_RPAREN] = ACTIONS(597),
    [anon_sym_SEMI_SEMI] = ACTIONS(597),
    [anon_sym_PIPE] = ACTIONS(597),
    [anon_sym_PIPE_AMP] = ACTIONS(597),
    [anon_sym_AMP_AMP] = ACTIONS(597),
    [anon_sym_PIPE_PIPE] = ACTIONS(597),
    [anon_sym_LT] = ACTIONS(2291),
    [anon_sym_GT] = ACTIONS(2291),
    [anon_sym_GT_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT_GT] = ACTIONS(2102),
    [anon_sym_LT_AMP] = ACTIONS(2102),
    [anon_sym_GT_AMP] = ACTIONS(2102),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2104),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [sym_raw_string] = ACTIONS(2151),
    [anon_sym_DOLLAR] = ACTIONS(2153),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2155),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2157),
    [anon_sym_BQUOTE] = ACTIONS(2293),
    [sym_word] = ACTIONS(2151),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(597),
    [anon_sym_LF] = ACTIONS(597),
    [anon_sym_AMP] = ACTIONS(597),
  },
  [851] = {
    [sym_file_redirect] = STATE(746),
    [sym_heredoc_redirect] = STATE(746),
    [sym_string] = STATE(761),
    [sym_simple_expansion] = STATE(761),
    [sym_expansion] = STATE(761),
    [sym_command_substitution] = STATE(761),
    [sym_process_substitution] = STATE(761),
    [aux_sym_bracket_command_repeat1] = STATE(940),
    [aux_sym_command_repeat2] = STATE(941),
    [sym_file_descriptor] = ACTIONS(2098),
    [anon_sym_RPAREN] = ACTIONS(769),
    [anon_sym_SEMI_SEMI] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_PIPE_AMP] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_LT] = ACTIONS(2291),
    [anon_sym_GT] = ACTIONS(2291),
    [anon_sym_GT_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT_GT] = ACTIONS(2102),
    [anon_sym_LT_AMP] = ACTIONS(2102),
    [anon_sym_GT_AMP] = ACTIONS(2102),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2104),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [sym_raw_string] = ACTIONS(2151),
    [anon_sym_DOLLAR] = ACTIONS(2153),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2155),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2157),
    [anon_sym_BQUOTE] = ACTIONS(2293),
    [sym_word] = ACTIONS(2151),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(769),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
  },
  [852] = {
    [sym_file_redirect] = STATE(838),
    [sym_heredoc_redirect] = STATE(838),
    [sym_file_descriptor] = ACTIONS(2098),
    [anon_sym_RPAREN] = ACTIONS(771),
    [anon_sym_SEMI_SEMI] = ACTIONS(771),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_PIPE_AMP] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_LT] = ACTIONS(2102),
    [anon_sym_GT] = ACTIONS(2102),
    [anon_sym_GT_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT_GT] = ACTIONS(2102),
    [anon_sym_LT_AMP] = ACTIONS(2102),
    [anon_sym_GT_AMP] = ACTIONS(2102),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2104),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(771),
    [anon_sym_LF] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
  },
  [853] = {
    [sym_file_descriptor] = ACTIONS(475),
    [anon_sym_RPAREN] = ACTIONS(479),
    [anon_sym_SEMI_SEMI] = ACTIONS(479),
    [anon_sym_PIPE] = ACTIONS(479),
    [anon_sym_PIPE_AMP] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(479),
    [anon_sym_AMP_GT] = ACTIONS(479),
    [anon_sym_AMP_GT_GT] = ACTIONS(479),
    [anon_sym_LT_AMP] = ACTIONS(479),
    [anon_sym_GT_AMP] = ACTIONS(479),
    [anon_sym_LT_LT] = ACTIONS(479),
    [anon_sym_LT_LT_DASH] = ACTIONS(479),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_LF] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(479),
  },
  [854] = {
    [sym_for_statement] = STATE(942),
    [sym_while_statement] = STATE(942),
    [sym_if_statement] = STATE(942),
    [sym_case_statement] = STATE(942),
    [sym_function_definition] = STATE(942),
    [sym_subshell] = STATE(942),
    [sym_pipeline] = STATE(942),
    [sym_list] = STATE(942),
    [sym_bracket_command] = STATE(942),
    [sym_command] = STATE(942),
    [sym_environment_variable_assignment] = STATE(943),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(219),
    [sym_command_substitution] = STATE(219),
    [aux_sym_command_repeat1] = STATE(223),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_if] = ACTIONS(495),
    [anon_sym_case] = ACTIONS(497),
    [anon_sym_function] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(505),
    [anon_sym_COLON] = ACTIONS(507),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(511),
    [sym_comment] = ACTIONS(115),
  },
  [855] = {
    [sym_file_descriptor] = ACTIONS(375),
    [anon_sym_RPAREN] = ACTIONS(377),
    [anon_sym_SEMI_SEMI] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_PIPE_AMP] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_AMP_GT] = ACTIONS(377),
    [anon_sym_AMP_GT_GT] = ACTIONS(377),
    [anon_sym_LT_AMP] = ACTIONS(377),
    [anon_sym_GT_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_DQUOTE] = ACTIONS(377),
    [sym_raw_string] = ACTIONS(377),
    [anon_sym_DOLLAR] = ACTIONS(377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(377),
    [sym_word] = ACTIONS(377),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(377),
    [anon_sym_LF] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
  },
  [856] = {
    [sym_simple_expansion] = STATE(163),
    [sym_expansion] = STATE(163),
    [sym_command_substitution] = STATE(163),
    [anon_sym_DQUOTE] = ACTIONS(2486),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [857] = {
    [sym_file_descriptor] = ACTIONS(525),
    [anon_sym_RPAREN] = ACTIONS(519),
    [anon_sym_SEMI_SEMI] = ACTIONS(519),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_PIPE_AMP] = ACTIONS(519),
    [anon_sym_AMP_AMP] = ACTIONS(519),
    [anon_sym_PIPE_PIPE] = ACTIONS(519),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_GT] = ACTIONS(519),
    [anon_sym_AMP_GT] = ACTIONS(519),
    [anon_sym_AMP_GT_GT] = ACTIONS(519),
    [anon_sym_LT_AMP] = ACTIONS(519),
    [anon_sym_GT_AMP] = ACTIONS(519),
    [anon_sym_LT_LT] = ACTIONS(519),
    [anon_sym_LT_LT_DASH] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(519),
    [sym_raw_string] = ACTIONS(519),
    [anon_sym_DOLLAR] = ACTIONS(519),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(519),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(519),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [sym_word] = ACTIONS(519),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(519),
    [anon_sym_LF] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(519),
  },
  [858] = {
    [sym_file_descriptor] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(521),
    [anon_sym_SEMI_SEMI] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PIPE_AMP] = ACTIONS(521),
    [anon_sym_AMP_AMP] = ACTIONS(521),
    [anon_sym_PIPE_PIPE] = ACTIONS(521),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_AMP_GT] = ACTIONS(521),
    [anon_sym_AMP_GT_GT] = ACTIONS(521),
    [anon_sym_LT_AMP] = ACTIONS(521),
    [anon_sym_GT_AMP] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_LT_LT_DASH] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(521),
    [sym_raw_string] = ACTIONS(521),
    [anon_sym_DOLLAR] = ACTIONS(521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(521),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(521),
    [anon_sym_BQUOTE] = ACTIONS(521),
    [sym_word] = ACTIONS(521),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(521),
    [anon_sym_LF] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
  },
  [859] = {
    [sym_file_descriptor] = ACTIONS(555),
    [anon_sym_RPAREN] = ACTIONS(523),
    [anon_sym_SEMI_SEMI] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(523),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(523),
    [anon_sym_PIPE_PIPE] = ACTIONS(523),
    [anon_sym_LT] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(523),
    [anon_sym_GT_GT] = ACTIONS(523),
    [anon_sym_AMP_GT] = ACTIONS(523),
    [anon_sym_AMP_GT_GT] = ACTIONS(523),
    [anon_sym_LT_AMP] = ACTIONS(523),
    [anon_sym_GT_AMP] = ACTIONS(523),
    [anon_sym_LT_LT] = ACTIONS(523),
    [anon_sym_LT_LT_DASH] = ACTIONS(523),
    [anon_sym_DQUOTE] = ACTIONS(523),
    [sym_raw_string] = ACTIONS(523),
    [anon_sym_DOLLAR] = ACTIONS(523),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(523),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(523),
    [anon_sym_BQUOTE] = ACTIONS(523),
    [sym_word] = ACTIONS(523),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(523),
    [anon_sym_LF] = ACTIONS(523),
    [anon_sym_AMP] = ACTIONS(523),
  },
  [860] = {
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_COLON] = ACTIONS(2490),
    [anon_sym_EQ] = ACTIONS(2492),
    [anon_sym_COLON_QMARK] = ACTIONS(2492),
    [anon_sym_COLON_DASH] = ACTIONS(2492),
    [sym_comment] = ACTIONS(115),
  },
  [861] = {
    [anon_sym_RBRACE] = ACTIONS(2494),
    [anon_sym_COLON] = ACTIONS(2496),
    [anon_sym_EQ] = ACTIONS(2498),
    [anon_sym_COLON_QMARK] = ACTIONS(2498),
    [anon_sym_COLON_DASH] = ACTIONS(2498),
    [sym_comment] = ACTIONS(115),
  },
  [862] = {
    [anon_sym_RPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(115),
  },
  [863] = {
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [sym_comment] = ACTIONS(115),
  },
  [864] = {
    [sym_file_descriptor] = ACTIONS(577),
    [anon_sym_RPAREN] = ACTIONS(579),
    [anon_sym_SEMI_SEMI] = ACTIONS(579),
    [anon_sym_PIPE] = ACTIONS(579),
    [anon_sym_PIPE_AMP] = ACTIONS(579),
    [anon_sym_AMP_AMP] = ACTIONS(579),
    [anon_sym_PIPE_PIPE] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(579),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_AMP_GT] = ACTIONS(579),
    [anon_sym_AMP_GT_GT] = ACTIONS(579),
    [anon_sym_LT_AMP] = ACTIONS(579),
    [anon_sym_GT_AMP] = ACTIONS(579),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_DASH] = ACTIONS(579),
    [anon_sym_DQUOTE] = ACTIONS(579),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_DOLLAR] = ACTIONS(579),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(579),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(579),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_word] = ACTIONS(579),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(579),
    [anon_sym_LF] = ACTIONS(579),
    [anon_sym_AMP] = ACTIONS(579),
  },
  [865] = {
    [sym_file_redirect] = STATE(732),
    [sym_heredoc_redirect] = STATE(732),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_PIPE_AMP] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1646),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [866] = {
    [sym_for_statement] = STATE(950),
    [sym_while_statement] = STATE(950),
    [sym_if_statement] = STATE(950),
    [sym_case_statement] = STATE(950),
    [sym_function_definition] = STATE(950),
    [sym_subshell] = STATE(950),
    [sym_pipeline] = STATE(950),
    [sym_list] = STATE(950),
    [sym_bracket_command] = STATE(950),
    [sym_command] = STATE(950),
    [sym_environment_variable_assignment] = STATE(951),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(219),
    [sym_command_substitution] = STATE(219),
    [aux_sym_command_repeat1] = STATE(223),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_if] = ACTIONS(495),
    [anon_sym_case] = ACTIONS(497),
    [anon_sym_function] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(505),
    [anon_sym_COLON] = ACTIONS(507),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(511),
    [sym_comment] = ACTIONS(115),
  },
  [867] = {
    [sym_file_descriptor] = ACTIONS(375),
    [anon_sym_RPAREN] = ACTIONS(377),
    [anon_sym_SEMI_SEMI] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_PIPE_AMP] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_AMP_GT] = ACTIONS(377),
    [anon_sym_AMP_GT_GT] = ACTIONS(377),
    [anon_sym_LT_AMP] = ACTIONS(377),
    [anon_sym_GT_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(377),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(377),
    [anon_sym_LF] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
  },
  [868] = {
    [sym_simple_expansion] = STATE(163),
    [sym_expansion] = STATE(163),
    [sym_command_substitution] = STATE(163),
    [anon_sym_DQUOTE] = ACTIONS(2505),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [869] = {
    [sym_file_descriptor] = ACTIONS(525),
    [anon_sym_RPAREN] = ACTIONS(519),
    [anon_sym_SEMI_SEMI] = ACTIONS(519),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_PIPE_AMP] = ACTIONS(519),
    [anon_sym_AMP_AMP] = ACTIONS(519),
    [anon_sym_PIPE_PIPE] = ACTIONS(519),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_GT] = ACTIONS(519),
    [anon_sym_AMP_GT] = ACTIONS(519),
    [anon_sym_AMP_GT_GT] = ACTIONS(519),
    [anon_sym_LT_AMP] = ACTIONS(519),
    [anon_sym_GT_AMP] = ACTIONS(519),
    [anon_sym_LT_LT] = ACTIONS(519),
    [anon_sym_LT_LT_DASH] = ACTIONS(519),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(519),
    [anon_sym_LF] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(519),
  },
  [870] = {
    [sym_file_descriptor] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(521),
    [anon_sym_SEMI_SEMI] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PIPE_AMP] = ACTIONS(521),
    [anon_sym_AMP_AMP] = ACTIONS(521),
    [anon_sym_PIPE_PIPE] = ACTIONS(521),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_AMP_GT] = ACTIONS(521),
    [anon_sym_AMP_GT_GT] = ACTIONS(521),
    [anon_sym_LT_AMP] = ACTIONS(521),
    [anon_sym_GT_AMP] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_LT_LT_DASH] = ACTIONS(521),
    [anon_sym_BQUOTE] = ACTIONS(521),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(521),
    [anon_sym_LF] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
  },
  [871] = {
    [sym_file_descriptor] = ACTIONS(555),
    [anon_sym_RPAREN] = ACTIONS(523),
    [anon_sym_SEMI_SEMI] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(523),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(523),
    [anon_sym_PIPE_PIPE] = ACTIONS(523),
    [anon_sym_LT] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(523),
    [anon_sym_GT_GT] = ACTIONS(523),
    [anon_sym_AMP_GT] = ACTIONS(523),
    [anon_sym_AMP_GT_GT] = ACTIONS(523),
    [anon_sym_LT_AMP] = ACTIONS(523),
    [anon_sym_GT_AMP] = ACTIONS(523),
    [anon_sym_LT_LT] = ACTIONS(523),
    [anon_sym_LT_LT_DASH] = ACTIONS(523),
    [anon_sym_BQUOTE] = ACTIONS(523),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(523),
    [anon_sym_LF] = ACTIONS(523),
    [anon_sym_AMP] = ACTIONS(523),
  },
  [872] = {
    [anon_sym_RBRACE] = ACTIONS(2507),
    [anon_sym_COLON] = ACTIONS(2509),
    [anon_sym_EQ] = ACTIONS(2511),
    [anon_sym_COLON_QMARK] = ACTIONS(2511),
    [anon_sym_COLON_DASH] = ACTIONS(2511),
    [sym_comment] = ACTIONS(115),
  },
  [873] = {
    [anon_sym_RBRACE] = ACTIONS(2513),
    [anon_sym_COLON] = ACTIONS(2515),
    [anon_sym_EQ] = ACTIONS(2517),
    [anon_sym_COLON_QMARK] = ACTIONS(2517),
    [anon_sym_COLON_DASH] = ACTIONS(2517),
    [sym_comment] = ACTIONS(115),
  },
  [874] = {
    [anon_sym_RPAREN] = ACTIONS(2519),
    [sym_comment] = ACTIONS(115),
  },
  [875] = {
    [anon_sym_BQUOTE] = ACTIONS(2519),
    [sym_comment] = ACTIONS(115),
  },
  [876] = {
    [anon_sym_RPAREN] = ACTIONS(2521),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [sym_comment] = ACTIONS(115),
  },
  [877] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(2521),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(819),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(241),
    [anon_sym_GT] = ACTIONS(241),
    [anon_sym_GT_GT] = ACTIONS(241),
    [anon_sym_AMP_GT] = ACTIONS(241),
    [anon_sym_AMP_GT_GT] = ACTIONS(241),
    [anon_sym_LT_AMP] = ACTIONS(241),
    [anon_sym_GT_AMP] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_raw_string] = ACTIONS(241),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(115),
  },
  [878] = {
    [sym_file_descriptor] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_SEMI_SEMI] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(667),
    [anon_sym_PIPE] = ACTIONS(667),
    [anon_sym_PIPE_AMP] = ACTIONS(667),
    [anon_sym_AMP_AMP] = ACTIONS(667),
    [anon_sym_PIPE_PIPE] = ACTIONS(667),
    [anon_sym_COLON] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(667),
    [anon_sym_GT] = ACTIONS(667),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(667),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_DQUOTE] = ACTIONS(667),
    [sym_raw_string] = ACTIONS(667),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(667),
    [anon_sym_BQUOTE] = ACTIONS(667),
    [sym_leading_word] = ACTIONS(667),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_LF] = ACTIONS(667),
    [anon_sym_AMP] = ACTIONS(667),
  },
  [879] = {
    [sym_file_descriptor] = ACTIONS(853),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_SEMI_SEMI] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_PIPE_AMP] = ACTIONS(837),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_COLON] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_AMP_GT] = ACTIONS(837),
    [anon_sym_AMP_GT_GT] = ACTIONS(837),
    [anon_sym_LT_AMP] = ACTIONS(837),
    [anon_sym_GT_AMP] = ACTIONS(837),
    [anon_sym_DQUOTE] = ACTIONS(837),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(837),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [sym_leading_word] = ACTIONS(837),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_LF] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(837),
  },
  [880] = {
    [sym_string] = STATE(959),
    [sym_simple_expansion] = STATE(959),
    [sym_expansion] = STATE(959),
    [sym_command_substitution] = STATE(959),
    [sym_process_substitution] = STATE(959),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(2523),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(2525),
    [sym_comment] = ACTIONS(115),
  },
  [881] = {
    [sym_file_descriptor] = ACTIONS(861),
    [anon_sym_RPAREN] = ACTIONS(843),
    [anon_sym_SEMI_SEMI] = ACTIONS(843),
    [anon_sym_RBRACE] = ACTIONS(843),
    [anon_sym_PIPE] = ACTIONS(843),
    [anon_sym_PIPE_AMP] = ACTIONS(843),
    [anon_sym_AMP_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_GT] = ACTIONS(843),
    [anon_sym_AMP_GT] = ACTIONS(843),
    [anon_sym_AMP_GT_GT] = ACTIONS(843),
    [anon_sym_LT_AMP] = ACTIONS(843),
    [anon_sym_GT_AMP] = ACTIONS(843),
    [anon_sym_DQUOTE] = ACTIONS(843),
    [sym_raw_string] = ACTIONS(843),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(843),
    [sym_leading_word] = ACTIONS(843),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(843),
    [anon_sym_LF] = ACTIONS(843),
    [anon_sym_AMP] = ACTIONS(843),
  },
  [882] = {
    [sym_string] = STATE(960),
    [sym_simple_expansion] = STATE(960),
    [sym_expansion] = STATE(960),
    [sym_command_substitution] = STATE(960),
    [sym_process_substitution] = STATE(960),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(2527),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(2529),
    [sym_comment] = ACTIONS(115),
  },
  [883] = {
    [sym_file_descriptor] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [sym_leading_word] = ACTIONS(733),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [884] = {
    [anon_sym_RPAREN] = ACTIONS(2531),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [sym_comment] = ACTIONS(115),
  },
  [885] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(2531),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(819),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(241),
    [anon_sym_GT] = ACTIONS(241),
    [anon_sym_GT_GT] = ACTIONS(241),
    [anon_sym_AMP_GT] = ACTIONS(241),
    [anon_sym_AMP_GT_GT] = ACTIONS(241),
    [anon_sym_LT_AMP] = ACTIONS(241),
    [anon_sym_GT_AMP] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_raw_string] = ACTIONS(241),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(115),
  },
  [886] = {
    [sym_file_descriptor] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_SEMI_SEMI] = ACTIONS(667),
    [anon_sym_PIPE] = ACTIONS(667),
    [anon_sym_PIPE_AMP] = ACTIONS(667),
    [anon_sym_AMP_AMP] = ACTIONS(667),
    [anon_sym_PIPE_PIPE] = ACTIONS(667),
    [anon_sym_COLON] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(667),
    [anon_sym_GT] = ACTIONS(667),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(667),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_LT_LT] = ACTIONS(667),
    [anon_sym_LT_LT_DASH] = ACTIONS(667),
    [anon_sym_DQUOTE] = ACTIONS(667),
    [sym_raw_string] = ACTIONS(667),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(667),
    [anon_sym_BQUOTE] = ACTIONS(667),
    [sym_leading_word] = ACTIONS(667),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_LF] = ACTIONS(667),
    [anon_sym_AMP] = ACTIONS(667),
  },
  [887] = {
    [sym_file_descriptor] = ACTIONS(853),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_SEMI_SEMI] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_PIPE_AMP] = ACTIONS(837),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_COLON] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_AMP_GT] = ACTIONS(837),
    [anon_sym_AMP_GT_GT] = ACTIONS(837),
    [anon_sym_LT_AMP] = ACTIONS(837),
    [anon_sym_GT_AMP] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_LT_LT_DASH] = ACTIONS(837),
    [anon_sym_DQUOTE] = ACTIONS(837),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(837),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [sym_leading_word] = ACTIONS(837),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_LF] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(837),
  },
  [888] = {
    [sym_string] = STATE(962),
    [sym_simple_expansion] = STATE(962),
    [sym_expansion] = STATE(962),
    [sym_command_substitution] = STATE(962),
    [sym_process_substitution] = STATE(962),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(2533),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(2535),
    [sym_comment] = ACTIONS(115),
  },
  [889] = {
    [sym_file_descriptor] = ACTIONS(861),
    [anon_sym_RPAREN] = ACTIONS(843),
    [anon_sym_SEMI_SEMI] = ACTIONS(843),
    [anon_sym_PIPE] = ACTIONS(843),
    [anon_sym_PIPE_AMP] = ACTIONS(843),
    [anon_sym_AMP_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_GT] = ACTIONS(843),
    [anon_sym_AMP_GT] = ACTIONS(843),
    [anon_sym_AMP_GT_GT] = ACTIONS(843),
    [anon_sym_LT_AMP] = ACTIONS(843),
    [anon_sym_GT_AMP] = ACTIONS(843),
    [anon_sym_LT_LT] = ACTIONS(843),
    [anon_sym_LT_LT_DASH] = ACTIONS(843),
    [anon_sym_DQUOTE] = ACTIONS(843),
    [sym_raw_string] = ACTIONS(843),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(843),
    [sym_leading_word] = ACTIONS(843),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(843),
    [anon_sym_LF] = ACTIONS(843),
    [anon_sym_AMP] = ACTIONS(843),
  },
  [890] = {
    [sym_string] = STATE(963),
    [sym_simple_expansion] = STATE(963),
    [sym_expansion] = STATE(963),
    [sym_command_substitution] = STATE(963),
    [sym_process_substitution] = STATE(963),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(2537),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(2539),
    [sym_comment] = ACTIONS(115),
  },
  [891] = {
    [sym_file_descriptor] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [sym_leading_word] = ACTIONS(733),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [892] = {
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_SEMI_SEMI] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1273),
    [anon_sym_PIPE_AMP] = ACTIONS(1273),
    [anon_sym_AMP_AMP] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE] = ACTIONS(1273),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(1273),
  },
  [893] = {
    [sym_case_item] = STATE(462),
    [sym_string] = STATE(356),
    [sym_simple_expansion] = STATE(356),
    [sym_expansion] = STATE(356),
    [sym_command_substitution] = STATE(356),
    [sym_process_substitution] = STATE(356),
    [anon_sym_esac] = ACTIONS(2541),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(829),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(833),
    [sym_comment] = ACTIONS(115),
  },
  [894] = {
    [anon_sym_RPAREN] = ACTIONS(1085),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_PIPE_AMP] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1085),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1085),
    [anon_sym_LF] = ACTIONS(1085),
    [anon_sym_AMP] = ACTIONS(1085),
  },
  [895] = {
    [sym_case_item] = STATE(462),
    [sym_string] = STATE(356),
    [sym_simple_expansion] = STATE(356),
    [sym_expansion] = STATE(356),
    [sym_command_substitution] = STATE(356),
    [sym_process_substitution] = STATE(356),
    [anon_sym_esac] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(829),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(833),
    [sym_comment] = ACTIONS(115),
  },
  [896] = {
    [sym__heredoc_middle] = ACTIONS(1291),
    [sym__heredoc_end] = ACTIONS(1291),
    [sym_file_descriptor] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(1285),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_RBRACE] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_RBRACK] = ACTIONS(1285),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1285),
    [anon_sym_COLON] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1285),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(1285),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [sym_leading_word] = ACTIONS(1285),
    [sym_word] = ACTIONS(1285),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [897] = {
    [anon_sym_RPAREN] = ACTIONS(1335),
    [anon_sym_SEMI_SEMI] = ACTIONS(1335),
    [anon_sym_PIPE] = ACTIONS(1335),
    [anon_sym_PIPE_AMP] = ACTIONS(1335),
    [anon_sym_AMP_AMP] = ACTIONS(1335),
    [anon_sym_PIPE_PIPE] = ACTIONS(1335),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym_LF] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1335),
  },
  [898] = {
    [anon_sym_RPAREN] = ACTIONS(2543),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [sym_comment] = ACTIONS(115),
  },
  [899] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(2543),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(819),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(241),
    [anon_sym_GT] = ACTIONS(241),
    [anon_sym_GT_GT] = ACTIONS(241),
    [anon_sym_AMP_GT] = ACTIONS(241),
    [anon_sym_AMP_GT_GT] = ACTIONS(241),
    [anon_sym_LT_AMP] = ACTIONS(241),
    [anon_sym_GT_AMP] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_raw_string] = ACTIONS(241),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(115),
  },
  [900] = {
    [sym_file_descriptor] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_SEMI_SEMI] = ACTIONS(667),
    [anon_sym_PIPE] = ACTIONS(667),
    [anon_sym_PIPE_AMP] = ACTIONS(667),
    [anon_sym_AMP_AMP] = ACTIONS(667),
    [anon_sym_PIPE_PIPE] = ACTIONS(667),
    [anon_sym_RBRACK] = ACTIONS(667),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(667),
    [anon_sym_GT] = ACTIONS(667),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(667),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_LT_LT] = ACTIONS(667),
    [anon_sym_LT_LT_DASH] = ACTIONS(667),
    [anon_sym_DQUOTE] = ACTIONS(667),
    [sym_raw_string] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(667),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(667),
    [anon_sym_BQUOTE] = ACTIONS(667),
    [sym_word] = ACTIONS(667),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_LF] = ACTIONS(667),
    [anon_sym_AMP] = ACTIONS(667),
  },
  [901] = {
    [sym_file_descriptor] = ACTIONS(853),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_SEMI_SEMI] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_PIPE_AMP] = ACTIONS(837),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_RBRACK] = ACTIONS(837),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_AMP_GT] = ACTIONS(837),
    [anon_sym_AMP_GT_GT] = ACTIONS(837),
    [anon_sym_LT_AMP] = ACTIONS(837),
    [anon_sym_GT_AMP] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_LT_LT_DASH] = ACTIONS(837),
    [anon_sym_DQUOTE] = ACTIONS(837),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_DOLLAR] = ACTIONS(837),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(837),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [sym_word] = ACTIONS(837),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_LF] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(837),
  },
  [902] = {
    [sym_string] = STATE(966),
    [sym_simple_expansion] = STATE(966),
    [sym_expansion] = STATE(966),
    [sym_command_substitution] = STATE(966),
    [sym_process_substitution] = STATE(966),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(2545),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(2547),
    [sym_comment] = ACTIONS(115),
  },
  [903] = {
    [sym_file_descriptor] = ACTIONS(861),
    [anon_sym_RPAREN] = ACTIONS(843),
    [anon_sym_SEMI_SEMI] = ACTIONS(843),
    [anon_sym_PIPE] = ACTIONS(843),
    [anon_sym_PIPE_AMP] = ACTIONS(843),
    [anon_sym_AMP_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(843),
    [anon_sym_RBRACK] = ACTIONS(843),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_GT] = ACTIONS(843),
    [anon_sym_AMP_GT] = ACTIONS(843),
    [anon_sym_AMP_GT_GT] = ACTIONS(843),
    [anon_sym_LT_AMP] = ACTIONS(843),
    [anon_sym_GT_AMP] = ACTIONS(843),
    [anon_sym_LT_LT] = ACTIONS(843),
    [anon_sym_LT_LT_DASH] = ACTIONS(843),
    [anon_sym_DQUOTE] = ACTIONS(843),
    [sym_raw_string] = ACTIONS(843),
    [anon_sym_DOLLAR] = ACTIONS(843),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(843),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(843),
    [sym_word] = ACTIONS(843),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(843),
    [anon_sym_LF] = ACTIONS(843),
    [anon_sym_AMP] = ACTIONS(843),
  },
  [904] = {
    [sym_string] = STATE(967),
    [sym_simple_expansion] = STATE(967),
    [sym_expansion] = STATE(967),
    [sym_command_substitution] = STATE(967),
    [sym_process_substitution] = STATE(967),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(2549),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(2551),
    [sym_comment] = ACTIONS(115),
  },
  [905] = {
    [sym_file_descriptor] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_RBRACK] = ACTIONS(733),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [sym_word] = ACTIONS(733),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [906] = {
    [sym_file_redirect] = STATE(675),
    [sym_heredoc_redirect] = STATE(675),
    [sym_string] = STATE(864),
    [sym_simple_expansion] = STATE(864),
    [sym_expansion] = STATE(864),
    [sym_command_substitution] = STATE(864),
    [sym_process_substitution] = STATE(864),
    [aux_sym_command_repeat2] = STATE(968),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(1007),
    [anon_sym_SEMI_SEMI] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_PIPE_AMP] = ACTIONS(1007),
    [anon_sym_AMP_AMP] = ACTIONS(1007),
    [anon_sym_PIPE_PIPE] = ACTIONS(1007),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1646),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [sym_raw_string] = ACTIONS(2360),
    [anon_sym_DOLLAR] = ACTIONS(2153),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2155),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2157),
    [anon_sym_BQUOTE] = ACTIONS(2553),
    [sym_word] = ACTIONS(2360),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1007),
    [anon_sym_LF] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
  },
  [907] = {
    [sym_file_redirect] = STATE(732),
    [sym_heredoc_redirect] = STATE(732),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_SEMI_SEMI] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(887),
    [anon_sym_PIPE_AMP] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1646),
    [anon_sym_BQUOTE] = ACTIONS(887),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_LF] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(887),
  },
  [908] = {
    [sym_file_descriptor] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_SEMI_SEMI] = ACTIONS(667),
    [anon_sym_PIPE] = ACTIONS(667),
    [anon_sym_PIPE_AMP] = ACTIONS(667),
    [anon_sym_AMP_AMP] = ACTIONS(667),
    [anon_sym_PIPE_PIPE] = ACTIONS(667),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(667),
    [anon_sym_GT] = ACTIONS(667),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(667),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_LT_LT] = ACTIONS(667),
    [anon_sym_LT_LT_DASH] = ACTIONS(667),
    [anon_sym_BQUOTE] = ACTIONS(667),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_LF] = ACTIONS(667),
    [anon_sym_AMP] = ACTIONS(667),
  },
  [909] = {
    [sym_file_descriptor] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [910] = {
    [sym_file_redirect] = STATE(675),
    [sym_heredoc_redirect] = STATE(675),
    [sym_string] = STATE(864),
    [sym_simple_expansion] = STATE(864),
    [sym_expansion] = STATE(864),
    [sym_command_substitution] = STATE(864),
    [sym_process_substitution] = STATE(864),
    [aux_sym_command_repeat2] = STATE(969),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(1009),
    [anon_sym_SEMI_SEMI] = ACTIONS(1009),
    [anon_sym_PIPE] = ACTIONS(1009),
    [anon_sym_PIPE_AMP] = ACTIONS(1009),
    [anon_sym_AMP_AMP] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE] = ACTIONS(1009),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1646),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [sym_raw_string] = ACTIONS(2360),
    [anon_sym_DOLLAR] = ACTIONS(2153),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2155),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2157),
    [anon_sym_BQUOTE] = ACTIONS(2556),
    [sym_word] = ACTIONS(2360),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1009),
    [anon_sym_LF] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1009),
  },
  [911] = {
    [sym_file_redirect] = STATE(732),
    [sym_heredoc_redirect] = STATE(732),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(1011),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1646),
    [anon_sym_BQUOTE] = ACTIONS(1011),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1011),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1011),
  },
  [912] = {
    [anon_sym_RPAREN] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_PIPE_AMP] = ACTIONS(1103),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [913] = {
    [sym_file_descriptor] = ACTIONS(475),
    [anon_sym_RPAREN] = ACTIONS(479),
    [anon_sym_SEMI_SEMI] = ACTIONS(479),
    [anon_sym_PIPE] = ACTIONS(479),
    [anon_sym_PIPE_AMP] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_GT] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(479),
    [anon_sym_AMP_GT] = ACTIONS(479),
    [anon_sym_AMP_GT_GT] = ACTIONS(479),
    [anon_sym_LT_AMP] = ACTIONS(479),
    [anon_sym_GT_AMP] = ACTIONS(479),
    [anon_sym_LT_LT] = ACTIONS(479),
    [anon_sym_LT_LT_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_LF] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(479),
  },
  [914] = {
    [sym_file_redirect] = STATE(838),
    [sym_heredoc_redirect] = STATE(838),
    [sym_file_descriptor] = ACTIONS(2098),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_SEMI_SEMI] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(887),
    [anon_sym_PIPE_AMP] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_LT] = ACTIONS(2102),
    [anon_sym_GT] = ACTIONS(2102),
    [anon_sym_GT_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT_GT] = ACTIONS(2102),
    [anon_sym_LT_AMP] = ACTIONS(2102),
    [anon_sym_GT_AMP] = ACTIONS(2102),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2104),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_LF] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(887),
  },
  [915] = {
    [sym_for_statement] = STATE(970),
    [sym_while_statement] = STATE(970),
    [sym_if_statement] = STATE(970),
    [sym_case_statement] = STATE(970),
    [sym_function_definition] = STATE(970),
    [sym_subshell] = STATE(970),
    [sym_pipeline] = STATE(970),
    [sym_list] = STATE(970),
    [sym_bracket_command] = STATE(970),
    [sym_command] = STATE(970),
    [sym_environment_variable_assignment] = STATE(971),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(219),
    [sym_command_substitution] = STATE(219),
    [aux_sym_command_repeat1] = STATE(223),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_if] = ACTIONS(495),
    [anon_sym_case] = ACTIONS(497),
    [anon_sym_function] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(505),
    [anon_sym_COLON] = ACTIONS(507),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(511),
    [sym_comment] = ACTIONS(115),
  },
  [916] = {
    [sym_file_descriptor] = ACTIONS(375),
    [anon_sym_RPAREN] = ACTIONS(377),
    [anon_sym_SEMI_SEMI] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_PIPE_AMP] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_AMP_GT] = ACTIONS(377),
    [anon_sym_AMP_GT_GT] = ACTIONS(377),
    [anon_sym_LT_AMP] = ACTIONS(377),
    [anon_sym_GT_AMP] = ACTIONS(377),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(377),
    [anon_sym_LF] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
  },
  [917] = {
    [sym_simple_expansion] = STATE(163),
    [sym_expansion] = STATE(163),
    [sym_command_substitution] = STATE(163),
    [anon_sym_DQUOTE] = ACTIONS(2559),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [918] = {
    [sym_file_descriptor] = ACTIONS(525),
    [anon_sym_RPAREN] = ACTIONS(519),
    [anon_sym_SEMI_SEMI] = ACTIONS(519),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_PIPE_AMP] = ACTIONS(519),
    [anon_sym_AMP_AMP] = ACTIONS(519),
    [anon_sym_PIPE_PIPE] = ACTIONS(519),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_GT] = ACTIONS(519),
    [anon_sym_AMP_GT] = ACTIONS(519),
    [anon_sym_AMP_GT_GT] = ACTIONS(519),
    [anon_sym_LT_AMP] = ACTIONS(519),
    [anon_sym_GT_AMP] = ACTIONS(519),
    [anon_sym_LT_LT] = ACTIONS(519),
    [anon_sym_LT_LT_DASH] = ACTIONS(519),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(519),
    [anon_sym_LF] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(519),
  },
  [919] = {
    [sym_file_descriptor] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(521),
    [anon_sym_SEMI_SEMI] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PIPE_AMP] = ACTIONS(521),
    [anon_sym_AMP_AMP] = ACTIONS(521),
    [anon_sym_PIPE_PIPE] = ACTIONS(521),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_AMP_GT] = ACTIONS(521),
    [anon_sym_AMP_GT_GT] = ACTIONS(521),
    [anon_sym_LT_AMP] = ACTIONS(521),
    [anon_sym_GT_AMP] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_LT_LT_DASH] = ACTIONS(521),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(521),
    [anon_sym_LF] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
  },
  [920] = {
    [sym_file_descriptor] = ACTIONS(555),
    [anon_sym_RPAREN] = ACTIONS(523),
    [anon_sym_SEMI_SEMI] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(523),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(523),
    [anon_sym_PIPE_PIPE] = ACTIONS(523),
    [anon_sym_LT] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(523),
    [anon_sym_GT_GT] = ACTIONS(523),
    [anon_sym_AMP_GT] = ACTIONS(523),
    [anon_sym_AMP_GT_GT] = ACTIONS(523),
    [anon_sym_LT_AMP] = ACTIONS(523),
    [anon_sym_GT_AMP] = ACTIONS(523),
    [anon_sym_LT_LT] = ACTIONS(523),
    [anon_sym_LT_LT_DASH] = ACTIONS(523),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(523),
    [anon_sym_LF] = ACTIONS(523),
    [anon_sym_AMP] = ACTIONS(523),
  },
  [921] = {
    [anon_sym_RBRACE] = ACTIONS(2561),
    [anon_sym_COLON] = ACTIONS(2563),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_COLON_QMARK] = ACTIONS(2565),
    [anon_sym_COLON_DASH] = ACTIONS(2565),
    [sym_comment] = ACTIONS(115),
  },
  [922] = {
    [anon_sym_RBRACE] = ACTIONS(2567),
    [anon_sym_COLON] = ACTIONS(2569),
    [anon_sym_EQ] = ACTIONS(2571),
    [anon_sym_COLON_QMARK] = ACTIONS(2571),
    [anon_sym_COLON_DASH] = ACTIONS(2571),
    [sym_comment] = ACTIONS(115),
  },
  [923] = {
    [anon_sym_RPAREN] = ACTIONS(2573),
    [sym_comment] = ACTIONS(115),
  },
  [924] = {
    [anon_sym_BQUOTE] = ACTIONS(2573),
    [sym_comment] = ACTIONS(115),
  },
  [925] = {
    [sym_file_descriptor] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(911),
    [anon_sym_SEMI_SEMI] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_PIPE_AMP] = ACTIONS(911),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(911),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_GT] = ACTIONS(911),
    [anon_sym_AMP_GT] = ACTIONS(911),
    [anon_sym_AMP_GT_GT] = ACTIONS(911),
    [anon_sym_LT_AMP] = ACTIONS(911),
    [anon_sym_GT_AMP] = ACTIONS(911),
    [anon_sym_LT_LT] = ACTIONS(911),
    [anon_sym_LT_LT_DASH] = ACTIONS(911),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_LF] = ACTIONS(911),
    [anon_sym_AMP] = ACTIONS(911),
  },
  [926] = {
    [sym_simple_expansion] = STATE(388),
    [sym_expansion] = STATE(388),
    [sym__heredoc_middle] = ACTIONS(921),
    [sym__heredoc_end] = ACTIONS(2575),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(625),
    [sym_comment] = ACTIONS(115),
  },
  [927] = {
    [anon_sym_RPAREN] = ACTIONS(987),
    [anon_sym_SEMI_SEMI] = ACTIONS(987),
    [anon_sym_PIPE] = ACTIONS(987),
    [anon_sym_PIPE_AMP] = ACTIONS(987),
    [anon_sym_AMP_AMP] = ACTIONS(987),
    [anon_sym_PIPE_PIPE] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_LF] = ACTIONS(987),
    [anon_sym_AMP] = ACTIONS(987),
  },
  [928] = {
    [sym_file_redirect] = STATE(838),
    [sym_heredoc_redirect] = STATE(838),
    [sym_file_descriptor] = ACTIONS(2098),
    [anon_sym_RPAREN] = ACTIONS(989),
    [anon_sym_SEMI_SEMI] = ACTIONS(989),
    [anon_sym_PIPE] = ACTIONS(989),
    [anon_sym_PIPE_AMP] = ACTIONS(989),
    [anon_sym_AMP_AMP] = ACTIONS(989),
    [anon_sym_PIPE_PIPE] = ACTIONS(989),
    [anon_sym_LT] = ACTIONS(2102),
    [anon_sym_GT] = ACTIONS(2102),
    [anon_sym_GT_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT_GT] = ACTIONS(2102),
    [anon_sym_LT_AMP] = ACTIONS(2102),
    [anon_sym_GT_AMP] = ACTIONS(2102),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2104),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(989),
    [anon_sym_LF] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(989),
  },
  [929] = {
    [sym_for_statement] = STATE(979),
    [sym_while_statement] = STATE(979),
    [sym_if_statement] = STATE(979),
    [sym_case_statement] = STATE(979),
    [sym_function_definition] = STATE(979),
    [sym_subshell] = STATE(979),
    [sym_pipeline] = STATE(979),
    [sym_list] = STATE(979),
    [sym_bracket_command] = STATE(979),
    [sym_command] = STATE(979),
    [sym_environment_variable_assignment] = STATE(980),
    [sym_file_redirect] = STATE(21),
    [sym_string] = STATE(219),
    [sym_command_substitution] = STATE(219),
    [aux_sym_command_repeat1] = STATE(223),
    [sym_file_descriptor] = ACTIONS(81),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_if] = ACTIONS(495),
    [anon_sym_case] = ACTIONS(497),
    [anon_sym_function] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(505),
    [anon_sym_COLON] = ACTIONS(507),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_AMP_GT] = ACTIONS(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(103),
    [anon_sym_LT_AMP] = ACTIONS(103),
    [anon_sym_GT_AMP] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_leading_word] = ACTIONS(511),
    [sym_comment] = ACTIONS(115),
  },
  [930] = {
    [sym_file_descriptor] = ACTIONS(375),
    [anon_sym_RPAREN] = ACTIONS(377),
    [anon_sym_SEMI_SEMI] = ACTIONS(377),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_PIPE_AMP] = ACTIONS(377),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [anon_sym_COLON] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [anon_sym_AMP_GT] = ACTIONS(377),
    [anon_sym_AMP_GT_GT] = ACTIONS(377),
    [anon_sym_LT_AMP] = ACTIONS(377),
    [anon_sym_GT_AMP] = ACTIONS(377),
    [anon_sym_DQUOTE] = ACTIONS(377),
    [sym_raw_string] = ACTIONS(377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(377),
    [sym_leading_word] = ACTIONS(377),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(377),
    [anon_sym_LF] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
  },
  [931] = {
    [sym_simple_expansion] = STATE(163),
    [sym_expansion] = STATE(163),
    [sym_command_substitution] = STATE(163),
    [anon_sym_DQUOTE] = ACTIONS(2577),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(193),
    [anon_sym_BQUOTE] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [932] = {
    [sym_file_descriptor] = ACTIONS(525),
    [anon_sym_RPAREN] = ACTIONS(519),
    [anon_sym_SEMI_SEMI] = ACTIONS(519),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_PIPE_AMP] = ACTIONS(519),
    [anon_sym_AMP_AMP] = ACTIONS(519),
    [anon_sym_PIPE_PIPE] = ACTIONS(519),
    [anon_sym_COLON] = ACTIONS(519),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_GT] = ACTIONS(519),
    [anon_sym_AMP_GT] = ACTIONS(519),
    [anon_sym_AMP_GT_GT] = ACTIONS(519),
    [anon_sym_LT_AMP] = ACTIONS(519),
    [anon_sym_GT_AMP] = ACTIONS(519),
    [anon_sym_DQUOTE] = ACTIONS(519),
    [sym_raw_string] = ACTIONS(519),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(519),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [sym_leading_word] = ACTIONS(519),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(519),
    [anon_sym_LF] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(519),
  },
  [933] = {
    [sym_file_descriptor] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(521),
    [anon_sym_SEMI_SEMI] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PIPE_AMP] = ACTIONS(521),
    [anon_sym_AMP_AMP] = ACTIONS(521),
    [anon_sym_PIPE_PIPE] = ACTIONS(521),
    [anon_sym_COLON] = ACTIONS(521),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_AMP_GT] = ACTIONS(521),
    [anon_sym_AMP_GT_GT] = ACTIONS(521),
    [anon_sym_LT_AMP] = ACTIONS(521),
    [anon_sym_GT_AMP] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(521),
    [sym_raw_string] = ACTIONS(521),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(521),
    [anon_sym_BQUOTE] = ACTIONS(521),
    [sym_leading_word] = ACTIONS(521),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(521),
    [anon_sym_LF] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
  },
  [934] = {
    [sym_file_descriptor] = ACTIONS(555),
    [anon_sym_RPAREN] = ACTIONS(523),
    [anon_sym_SEMI_SEMI] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(523),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(523),
    [anon_sym_PIPE_PIPE] = ACTIONS(523),
    [anon_sym_COLON] = ACTIONS(523),
    [anon_sym_LT] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(523),
    [anon_sym_GT_GT] = ACTIONS(523),
    [anon_sym_AMP_GT] = ACTIONS(523),
    [anon_sym_AMP_GT_GT] = ACTIONS(523),
    [anon_sym_LT_AMP] = ACTIONS(523),
    [anon_sym_GT_AMP] = ACTIONS(523),
    [anon_sym_DQUOTE] = ACTIONS(523),
    [sym_raw_string] = ACTIONS(523),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(523),
    [anon_sym_BQUOTE] = ACTIONS(523),
    [sym_leading_word] = ACTIONS(523),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(523),
    [anon_sym_LF] = ACTIONS(523),
    [anon_sym_AMP] = ACTIONS(523),
  },
  [935] = {
    [anon_sym_RBRACE] = ACTIONS(2579),
    [anon_sym_COLON] = ACTIONS(2581),
    [anon_sym_EQ] = ACTIONS(2583),
    [anon_sym_COLON_QMARK] = ACTIONS(2583),
    [anon_sym_COLON_DASH] = ACTIONS(2583),
    [sym_comment] = ACTIONS(115),
  },
  [936] = {
    [anon_sym_RBRACE] = ACTIONS(2585),
    [anon_sym_COLON] = ACTIONS(2587),
    [anon_sym_EQ] = ACTIONS(2589),
    [anon_sym_COLON_QMARK] = ACTIONS(2589),
    [anon_sym_COLON_DASH] = ACTIONS(2589),
    [sym_comment] = ACTIONS(115),
  },
  [937] = {
    [anon_sym_RPAREN] = ACTIONS(2591),
    [sym_comment] = ACTIONS(115),
  },
  [938] = {
    [anon_sym_BQUOTE] = ACTIONS(2591),
    [sym_comment] = ACTIONS(115),
  },
  [939] = {
    [sym_file_redirect] = STATE(746),
    [sym_heredoc_redirect] = STATE(746),
    [sym_string] = STATE(864),
    [sym_simple_expansion] = STATE(864),
    [sym_expansion] = STATE(864),
    [sym_command_substitution] = STATE(864),
    [sym_process_substitution] = STATE(864),
    [aux_sym_command_repeat2] = STATE(987),
    [sym_file_descriptor] = ACTIONS(2098),
    [anon_sym_RPAREN] = ACTIONS(1007),
    [anon_sym_SEMI_SEMI] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_PIPE_AMP] = ACTIONS(1007),
    [anon_sym_AMP_AMP] = ACTIONS(1007),
    [anon_sym_PIPE_PIPE] = ACTIONS(1007),
    [anon_sym_LT] = ACTIONS(2291),
    [anon_sym_GT] = ACTIONS(2291),
    [anon_sym_GT_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT_GT] = ACTIONS(2102),
    [anon_sym_LT_AMP] = ACTIONS(2102),
    [anon_sym_GT_AMP] = ACTIONS(2102),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2104),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [sym_raw_string] = ACTIONS(2360),
    [anon_sym_DOLLAR] = ACTIONS(2153),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2155),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2157),
    [anon_sym_BQUOTE] = ACTIONS(2293),
    [sym_word] = ACTIONS(2360),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1007),
    [anon_sym_LF] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
  },
  [940] = {
    [sym_file_redirect] = STATE(746),
    [sym_heredoc_redirect] = STATE(746),
    [sym_string] = STATE(864),
    [sym_simple_expansion] = STATE(864),
    [sym_expansion] = STATE(864),
    [sym_command_substitution] = STATE(864),
    [sym_process_substitution] = STATE(864),
    [aux_sym_command_repeat2] = STATE(988),
    [sym_file_descriptor] = ACTIONS(2098),
    [anon_sym_RPAREN] = ACTIONS(1009),
    [anon_sym_SEMI_SEMI] = ACTIONS(1009),
    [anon_sym_PIPE] = ACTIONS(1009),
    [anon_sym_PIPE_AMP] = ACTIONS(1009),
    [anon_sym_AMP_AMP] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE] = ACTIONS(1009),
    [anon_sym_LT] = ACTIONS(2291),
    [anon_sym_GT] = ACTIONS(2291),
    [anon_sym_GT_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT_GT] = ACTIONS(2102),
    [anon_sym_LT_AMP] = ACTIONS(2102),
    [anon_sym_GT_AMP] = ACTIONS(2102),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2104),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [sym_raw_string] = ACTIONS(2360),
    [anon_sym_DOLLAR] = ACTIONS(2153),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2155),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2157),
    [anon_sym_BQUOTE] = ACTIONS(2293),
    [sym_word] = ACTIONS(2360),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1009),
    [anon_sym_LF] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1009),
  },
  [941] = {
    [sym_file_redirect] = STATE(838),
    [sym_heredoc_redirect] = STATE(838),
    [sym_file_descriptor] = ACTIONS(2098),
    [anon_sym_RPAREN] = ACTIONS(1011),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(2102),
    [anon_sym_GT] = ACTIONS(2102),
    [anon_sym_GT_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT_GT] = ACTIONS(2102),
    [anon_sym_LT_AMP] = ACTIONS(2102),
    [anon_sym_GT_AMP] = ACTIONS(2102),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2104),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1011),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1011),
  },
  [942] = {
    [anon_sym_RPAREN] = ACTIONS(2593),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [sym_comment] = ACTIONS(115),
  },
  [943] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(2593),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(819),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(241),
    [anon_sym_GT] = ACTIONS(241),
    [anon_sym_GT_GT] = ACTIONS(241),
    [anon_sym_AMP_GT] = ACTIONS(241),
    [anon_sym_AMP_GT_GT] = ACTIONS(241),
    [anon_sym_LT_AMP] = ACTIONS(241),
    [anon_sym_GT_AMP] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_raw_string] = ACTIONS(241),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(115),
  },
  [944] = {
    [sym_file_descriptor] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_SEMI_SEMI] = ACTIONS(667),
    [anon_sym_PIPE] = ACTIONS(667),
    [anon_sym_PIPE_AMP] = ACTIONS(667),
    [anon_sym_AMP_AMP] = ACTIONS(667),
    [anon_sym_PIPE_PIPE] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(667),
    [anon_sym_GT] = ACTIONS(667),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(667),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_LT_LT] = ACTIONS(667),
    [anon_sym_LT_LT_DASH] = ACTIONS(667),
    [anon_sym_DQUOTE] = ACTIONS(667),
    [sym_raw_string] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(667),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(667),
    [anon_sym_BQUOTE] = ACTIONS(667),
    [sym_word] = ACTIONS(667),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_LF] = ACTIONS(667),
    [anon_sym_AMP] = ACTIONS(667),
  },
  [945] = {
    [sym_file_descriptor] = ACTIONS(853),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_SEMI_SEMI] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_PIPE_AMP] = ACTIONS(837),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_AMP_GT] = ACTIONS(837),
    [anon_sym_AMP_GT_GT] = ACTIONS(837),
    [anon_sym_LT_AMP] = ACTIONS(837),
    [anon_sym_GT_AMP] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_LT_LT_DASH] = ACTIONS(837),
    [anon_sym_DQUOTE] = ACTIONS(837),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_DOLLAR] = ACTIONS(837),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(837),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [sym_word] = ACTIONS(837),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_LF] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(837),
  },
  [946] = {
    [sym_string] = STATE(990),
    [sym_simple_expansion] = STATE(990),
    [sym_expansion] = STATE(990),
    [sym_command_substitution] = STATE(990),
    [sym_process_substitution] = STATE(990),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(2595),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(2597),
    [sym_comment] = ACTIONS(115),
  },
  [947] = {
    [sym_file_descriptor] = ACTIONS(861),
    [anon_sym_RPAREN] = ACTIONS(843),
    [anon_sym_SEMI_SEMI] = ACTIONS(843),
    [anon_sym_PIPE] = ACTIONS(843),
    [anon_sym_PIPE_AMP] = ACTIONS(843),
    [anon_sym_AMP_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_GT] = ACTIONS(843),
    [anon_sym_AMP_GT] = ACTIONS(843),
    [anon_sym_AMP_GT_GT] = ACTIONS(843),
    [anon_sym_LT_AMP] = ACTIONS(843),
    [anon_sym_GT_AMP] = ACTIONS(843),
    [anon_sym_LT_LT] = ACTIONS(843),
    [anon_sym_LT_LT_DASH] = ACTIONS(843),
    [anon_sym_DQUOTE] = ACTIONS(843),
    [sym_raw_string] = ACTIONS(843),
    [anon_sym_DOLLAR] = ACTIONS(843),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(843),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(843),
    [sym_word] = ACTIONS(843),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(843),
    [anon_sym_LF] = ACTIONS(843),
    [anon_sym_AMP] = ACTIONS(843),
  },
  [948] = {
    [sym_string] = STATE(991),
    [sym_simple_expansion] = STATE(991),
    [sym_expansion] = STATE(991),
    [sym_command_substitution] = STATE(991),
    [sym_process_substitution] = STATE(991),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(2599),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(2601),
    [sym_comment] = ACTIONS(115),
  },
  [949] = {
    [sym_file_descriptor] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [sym_word] = ACTIONS(733),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [950] = {
    [anon_sym_RPAREN] = ACTIONS(2603),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [sym_comment] = ACTIONS(115),
  },
  [951] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(2603),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(819),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(241),
    [anon_sym_GT] = ACTIONS(241),
    [anon_sym_GT_GT] = ACTIONS(241),
    [anon_sym_AMP_GT] = ACTIONS(241),
    [anon_sym_AMP_GT_GT] = ACTIONS(241),
    [anon_sym_LT_AMP] = ACTIONS(241),
    [anon_sym_GT_AMP] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_raw_string] = ACTIONS(241),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(115),
  },
  [952] = {
    [sym_file_descriptor] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_SEMI_SEMI] = ACTIONS(667),
    [anon_sym_PIPE] = ACTIONS(667),
    [anon_sym_PIPE_AMP] = ACTIONS(667),
    [anon_sym_AMP_AMP] = ACTIONS(667),
    [anon_sym_PIPE_PIPE] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(667),
    [anon_sym_GT] = ACTIONS(667),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(667),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_LT_LT] = ACTIONS(667),
    [anon_sym_LT_LT_DASH] = ACTIONS(667),
    [anon_sym_BQUOTE] = ACTIONS(667),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_LF] = ACTIONS(667),
    [anon_sym_AMP] = ACTIONS(667),
  },
  [953] = {
    [sym_file_descriptor] = ACTIONS(853),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_SEMI_SEMI] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_PIPE_AMP] = ACTIONS(837),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_AMP_GT] = ACTIONS(837),
    [anon_sym_AMP_GT_GT] = ACTIONS(837),
    [anon_sym_LT_AMP] = ACTIONS(837),
    [anon_sym_GT_AMP] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_LT_LT_DASH] = ACTIONS(837),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_LF] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(837),
  },
  [954] = {
    [sym_string] = STATE(993),
    [sym_simple_expansion] = STATE(993),
    [sym_expansion] = STATE(993),
    [sym_command_substitution] = STATE(993),
    [sym_process_substitution] = STATE(993),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(2605),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(2607),
    [sym_comment] = ACTIONS(115),
  },
  [955] = {
    [sym_file_descriptor] = ACTIONS(861),
    [anon_sym_RPAREN] = ACTIONS(843),
    [anon_sym_SEMI_SEMI] = ACTIONS(843),
    [anon_sym_PIPE] = ACTIONS(843),
    [anon_sym_PIPE_AMP] = ACTIONS(843),
    [anon_sym_AMP_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_GT] = ACTIONS(843),
    [anon_sym_AMP_GT] = ACTIONS(843),
    [anon_sym_AMP_GT_GT] = ACTIONS(843),
    [anon_sym_LT_AMP] = ACTIONS(843),
    [anon_sym_GT_AMP] = ACTIONS(843),
    [anon_sym_LT_LT] = ACTIONS(843),
    [anon_sym_LT_LT_DASH] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(843),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(843),
    [anon_sym_LF] = ACTIONS(843),
    [anon_sym_AMP] = ACTIONS(843),
  },
  [956] = {
    [sym_string] = STATE(994),
    [sym_simple_expansion] = STATE(994),
    [sym_expansion] = STATE(994),
    [sym_command_substitution] = STATE(994),
    [sym_process_substitution] = STATE(994),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(2609),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(2611),
    [sym_comment] = ACTIONS(115),
  },
  [957] = {
    [sym_file_descriptor] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [958] = {
    [sym_file_descriptor] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1079),
    [anon_sym_SEMI_SEMI] = ACTIONS(1079),
    [anon_sym_RBRACE] = ACTIONS(1079),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PIPE_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1079),
    [anon_sym_COLON] = ACTIONS(1079),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT_GT] = ACTIONS(1079),
    [anon_sym_LT_AMP] = ACTIONS(1079),
    [anon_sym_GT_AMP] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(1079),
    [sym_raw_string] = ACTIONS(1079),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1079),
    [anon_sym_BQUOTE] = ACTIONS(1079),
    [sym_leading_word] = ACTIONS(1079),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1079),
    [anon_sym_LF] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
  },
  [959] = {
    [anon_sym_RBRACE] = ACTIONS(2613),
    [sym_comment] = ACTIONS(115),
  },
  [960] = {
    [anon_sym_RBRACE] = ACTIONS(2615),
    [sym_comment] = ACTIONS(115),
  },
  [961] = {
    [sym_file_descriptor] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1079),
    [anon_sym_SEMI_SEMI] = ACTIONS(1079),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PIPE_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1079),
    [anon_sym_COLON] = ACTIONS(1079),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT_GT] = ACTIONS(1079),
    [anon_sym_LT_AMP] = ACTIONS(1079),
    [anon_sym_GT_AMP] = ACTIONS(1079),
    [anon_sym_LT_LT] = ACTIONS(1079),
    [anon_sym_LT_LT_DASH] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(1079),
    [sym_raw_string] = ACTIONS(1079),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1079),
    [anon_sym_BQUOTE] = ACTIONS(1079),
    [sym_leading_word] = ACTIONS(1079),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1079),
    [anon_sym_LF] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
  },
  [962] = {
    [anon_sym_RBRACE] = ACTIONS(2617),
    [sym_comment] = ACTIONS(115),
  },
  [963] = {
    [anon_sym_RBRACE] = ACTIONS(2619),
    [sym_comment] = ACTIONS(115),
  },
  [964] = {
    [anon_sym_RPAREN] = ACTIONS(1395),
    [anon_sym_SEMI_SEMI] = ACTIONS(1395),
    [anon_sym_PIPE] = ACTIONS(1395),
    [anon_sym_PIPE_AMP] = ACTIONS(1395),
    [anon_sym_AMP_AMP] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1395),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1395),
    [anon_sym_LF] = ACTIONS(1395),
    [anon_sym_AMP] = ACTIONS(1395),
  },
  [965] = {
    [sym_file_descriptor] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1079),
    [anon_sym_SEMI_SEMI] = ACTIONS(1079),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PIPE_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1079),
    [anon_sym_RBRACK] = ACTIONS(1079),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1079),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT_GT] = ACTIONS(1079),
    [anon_sym_LT_AMP] = ACTIONS(1079),
    [anon_sym_GT_AMP] = ACTIONS(1079),
    [anon_sym_LT_LT] = ACTIONS(1079),
    [anon_sym_LT_LT_DASH] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(1079),
    [sym_raw_string] = ACTIONS(1079),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1079),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1079),
    [anon_sym_BQUOTE] = ACTIONS(1079),
    [sym_word] = ACTIONS(1079),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1079),
    [anon_sym_LF] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
  },
  [966] = {
    [anon_sym_RBRACE] = ACTIONS(2621),
    [sym_comment] = ACTIONS(115),
  },
  [967] = {
    [anon_sym_RBRACE] = ACTIONS(2623),
    [sym_comment] = ACTIONS(115),
  },
  [968] = {
    [sym_file_redirect] = STATE(732),
    [sym_heredoc_redirect] = STATE(732),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(1205),
    [anon_sym_SEMI_SEMI] = ACTIONS(1205),
    [anon_sym_PIPE] = ACTIONS(1205),
    [anon_sym_PIPE_AMP] = ACTIONS(1205),
    [anon_sym_AMP_AMP] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1646),
    [anon_sym_BQUOTE] = ACTIONS(1205),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1205),
    [anon_sym_LF] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1205),
  },
  [969] = {
    [sym_file_redirect] = STATE(732),
    [sym_heredoc_redirect] = STATE(732),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_SEMI_SEMI] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PIPE_AMP] = ACTIONS(1207),
    [anon_sym_AMP_AMP] = ACTIONS(1207),
    [anon_sym_PIPE_PIPE] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1644),
    [anon_sym_GT_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT] = ACTIONS(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1644),
    [anon_sym_LT_AMP] = ACTIONS(1644),
    [anon_sym_GT_AMP] = ACTIONS(1644),
    [anon_sym_LT_LT] = ACTIONS(1646),
    [anon_sym_LT_LT_DASH] = ACTIONS(1646),
    [anon_sym_BQUOTE] = ACTIONS(1207),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LF] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
  },
  [970] = {
    [anon_sym_RPAREN] = ACTIONS(2625),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [sym_comment] = ACTIONS(115),
  },
  [971] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(2625),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(819),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(241),
    [anon_sym_GT] = ACTIONS(241),
    [anon_sym_GT_GT] = ACTIONS(241),
    [anon_sym_AMP_GT] = ACTIONS(241),
    [anon_sym_AMP_GT_GT] = ACTIONS(241),
    [anon_sym_LT_AMP] = ACTIONS(241),
    [anon_sym_GT_AMP] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_raw_string] = ACTIONS(241),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(115),
  },
  [972] = {
    [sym_file_descriptor] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_SEMI_SEMI] = ACTIONS(667),
    [anon_sym_PIPE] = ACTIONS(667),
    [anon_sym_PIPE_AMP] = ACTIONS(667),
    [anon_sym_AMP_AMP] = ACTIONS(667),
    [anon_sym_PIPE_PIPE] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(667),
    [anon_sym_GT] = ACTIONS(667),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(667),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_LT_LT] = ACTIONS(667),
    [anon_sym_LT_LT_DASH] = ACTIONS(667),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_LF] = ACTIONS(667),
    [anon_sym_AMP] = ACTIONS(667),
  },
  [973] = {
    [sym_file_descriptor] = ACTIONS(853),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_SEMI_SEMI] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_PIPE_AMP] = ACTIONS(837),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_AMP_GT] = ACTIONS(837),
    [anon_sym_AMP_GT_GT] = ACTIONS(837),
    [anon_sym_LT_AMP] = ACTIONS(837),
    [anon_sym_GT_AMP] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_LT_LT_DASH] = ACTIONS(837),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_LF] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(837),
  },
  [974] = {
    [sym_string] = STATE(1002),
    [sym_simple_expansion] = STATE(1002),
    [sym_expansion] = STATE(1002),
    [sym_command_substitution] = STATE(1002),
    [sym_process_substitution] = STATE(1002),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(2627),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(2629),
    [sym_comment] = ACTIONS(115),
  },
  [975] = {
    [sym_file_descriptor] = ACTIONS(861),
    [anon_sym_RPAREN] = ACTIONS(843),
    [anon_sym_SEMI_SEMI] = ACTIONS(843),
    [anon_sym_PIPE] = ACTIONS(843),
    [anon_sym_PIPE_AMP] = ACTIONS(843),
    [anon_sym_AMP_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_GT] = ACTIONS(843),
    [anon_sym_AMP_GT] = ACTIONS(843),
    [anon_sym_AMP_GT_GT] = ACTIONS(843),
    [anon_sym_LT_AMP] = ACTIONS(843),
    [anon_sym_GT_AMP] = ACTIONS(843),
    [anon_sym_LT_LT] = ACTIONS(843),
    [anon_sym_LT_LT_DASH] = ACTIONS(843),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(843),
    [anon_sym_LF] = ACTIONS(843),
    [anon_sym_AMP] = ACTIONS(843),
  },
  [976] = {
    [sym_string] = STATE(1003),
    [sym_simple_expansion] = STATE(1003),
    [sym_expansion] = STATE(1003),
    [sym_command_substitution] = STATE(1003),
    [sym_process_substitution] = STATE(1003),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(2631),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(2633),
    [sym_comment] = ACTIONS(115),
  },
  [977] = {
    [sym_file_descriptor] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_LT_LT_DASH] = ACTIONS(733),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [978] = {
    [sym_file_descriptor] = ACTIONS(1149),
    [anon_sym_RPAREN] = ACTIONS(1151),
    [anon_sym_SEMI_SEMI] = ACTIONS(1151),
    [anon_sym_PIPE] = ACTIONS(1151),
    [anon_sym_PIPE_AMP] = ACTIONS(1151),
    [anon_sym_AMP_AMP] = ACTIONS(1151),
    [anon_sym_PIPE_PIPE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(1151),
    [anon_sym_GT] = ACTIONS(1151),
    [anon_sym_GT_GT] = ACTIONS(1151),
    [anon_sym_AMP_GT] = ACTIONS(1151),
    [anon_sym_AMP_GT_GT] = ACTIONS(1151),
    [anon_sym_LT_AMP] = ACTIONS(1151),
    [anon_sym_GT_AMP] = ACTIONS(1151),
    [anon_sym_LT_LT] = ACTIONS(1151),
    [anon_sym_LT_LT_DASH] = ACTIONS(1151),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1151),
    [anon_sym_LF] = ACTIONS(1151),
    [anon_sym_AMP] = ACTIONS(1151),
  },
  [979] = {
    [anon_sym_RPAREN] = ACTIONS(2635),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(817),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [sym_comment] = ACTIONS(115),
  },
  [980] = {
    [sym_file_descriptor] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(2635),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PIPE_AMP] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(819),
    [anon_sym_PIPE_PIPE] = ACTIONS(817),
    [anon_sym_COLON] = ACTIONS(237),
    [anon_sym_LT] = ACTIONS(241),
    [anon_sym_GT] = ACTIONS(241),
    [anon_sym_GT_GT] = ACTIONS(241),
    [anon_sym_AMP_GT] = ACTIONS(241),
    [anon_sym_AMP_GT_GT] = ACTIONS(241),
    [anon_sym_LT_AMP] = ACTIONS(241),
    [anon_sym_GT_AMP] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(237),
    [sym_raw_string] = ACTIONS(241),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [sym_leading_word] = ACTIONS(239),
    [sym_comment] = ACTIONS(115),
  },
  [981] = {
    [sym_file_descriptor] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_SEMI_SEMI] = ACTIONS(667),
    [anon_sym_PIPE] = ACTIONS(667),
    [anon_sym_PIPE_AMP] = ACTIONS(667),
    [anon_sym_AMP_AMP] = ACTIONS(667),
    [anon_sym_PIPE_PIPE] = ACTIONS(667),
    [anon_sym_COLON] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(667),
    [anon_sym_GT] = ACTIONS(667),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(667),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_DQUOTE] = ACTIONS(667),
    [sym_raw_string] = ACTIONS(667),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(667),
    [anon_sym_BQUOTE] = ACTIONS(667),
    [sym_leading_word] = ACTIONS(667),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_LF] = ACTIONS(667),
    [anon_sym_AMP] = ACTIONS(667),
  },
  [982] = {
    [sym_file_descriptor] = ACTIONS(853),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_SEMI_SEMI] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_PIPE_AMP] = ACTIONS(837),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_COLON] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_AMP_GT] = ACTIONS(837),
    [anon_sym_AMP_GT_GT] = ACTIONS(837),
    [anon_sym_LT_AMP] = ACTIONS(837),
    [anon_sym_GT_AMP] = ACTIONS(837),
    [anon_sym_DQUOTE] = ACTIONS(837),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(837),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [sym_leading_word] = ACTIONS(837),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_LF] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(837),
  },
  [983] = {
    [sym_string] = STATE(1005),
    [sym_simple_expansion] = STATE(1005),
    [sym_expansion] = STATE(1005),
    [sym_command_substitution] = STATE(1005),
    [sym_process_substitution] = STATE(1005),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(2637),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(2639),
    [sym_comment] = ACTIONS(115),
  },
  [984] = {
    [sym_file_descriptor] = ACTIONS(861),
    [anon_sym_RPAREN] = ACTIONS(843),
    [anon_sym_SEMI_SEMI] = ACTIONS(843),
    [anon_sym_PIPE] = ACTIONS(843),
    [anon_sym_PIPE_AMP] = ACTIONS(843),
    [anon_sym_AMP_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_GT] = ACTIONS(843),
    [anon_sym_AMP_GT] = ACTIONS(843),
    [anon_sym_AMP_GT_GT] = ACTIONS(843),
    [anon_sym_LT_AMP] = ACTIONS(843),
    [anon_sym_GT_AMP] = ACTIONS(843),
    [anon_sym_DQUOTE] = ACTIONS(843),
    [sym_raw_string] = ACTIONS(843),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(843),
    [sym_leading_word] = ACTIONS(843),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(843),
    [anon_sym_LF] = ACTIONS(843),
    [anon_sym_AMP] = ACTIONS(843),
  },
  [985] = {
    [sym_string] = STATE(1006),
    [sym_simple_expansion] = STATE(1006),
    [sym_expansion] = STATE(1006),
    [sym_command_substitution] = STATE(1006),
    [sym_process_substitution] = STATE(1006),
    [anon_sym_LT] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(2641),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym_word] = ACTIONS(2643),
    [sym_comment] = ACTIONS(115),
  },
  [986] = {
    [sym_file_descriptor] = ACTIONS(731),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_SEMI_SEMI] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_PIPE_AMP] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_DQUOTE] = ACTIONS(733),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(733),
    [anon_sym_BQUOTE] = ACTIONS(733),
    [sym_leading_word] = ACTIONS(733),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
  },
  [987] = {
    [sym_file_redirect] = STATE(838),
    [sym_heredoc_redirect] = STATE(838),
    [sym_file_descriptor] = ACTIONS(2098),
    [anon_sym_RPAREN] = ACTIONS(1205),
    [anon_sym_SEMI_SEMI] = ACTIONS(1205),
    [anon_sym_PIPE] = ACTIONS(1205),
    [anon_sym_PIPE_AMP] = ACTIONS(1205),
    [anon_sym_AMP_AMP] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(2102),
    [anon_sym_GT] = ACTIONS(2102),
    [anon_sym_GT_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT_GT] = ACTIONS(2102),
    [anon_sym_LT_AMP] = ACTIONS(2102),
    [anon_sym_GT_AMP] = ACTIONS(2102),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2104),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1205),
    [anon_sym_LF] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1205),
  },
  [988] = {
    [sym_file_redirect] = STATE(838),
    [sym_heredoc_redirect] = STATE(838),
    [sym_file_descriptor] = ACTIONS(2098),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_SEMI_SEMI] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PIPE_AMP] = ACTIONS(1207),
    [anon_sym_AMP_AMP] = ACTIONS(1207),
    [anon_sym_PIPE_PIPE] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(2102),
    [anon_sym_GT] = ACTIONS(2102),
    [anon_sym_GT_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT] = ACTIONS(2102),
    [anon_sym_AMP_GT_GT] = ACTIONS(2102),
    [anon_sym_LT_AMP] = ACTIONS(2102),
    [anon_sym_GT_AMP] = ACTIONS(2102),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(2104),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_LF] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
  },
  [989] = {
    [sym_file_descriptor] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1079),
    [anon_sym_SEMI_SEMI] = ACTIONS(1079),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PIPE_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1079),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT_GT] = ACTIONS(1079),
    [anon_sym_LT_AMP] = ACTIONS(1079),
    [anon_sym_GT_AMP] = ACTIONS(1079),
    [anon_sym_LT_LT] = ACTIONS(1079),
    [anon_sym_LT_LT_DASH] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(1079),
    [sym_raw_string] = ACTIONS(1079),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1079),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1079),
    [anon_sym_BQUOTE] = ACTIONS(1079),
    [sym_word] = ACTIONS(1079),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1079),
    [anon_sym_LF] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
  },
  [990] = {
    [anon_sym_RBRACE] = ACTIONS(2645),
    [sym_comment] = ACTIONS(115),
  },
  [991] = {
    [anon_sym_RBRACE] = ACTIONS(2647),
    [sym_comment] = ACTIONS(115),
  },
  [992] = {
    [sym_file_descriptor] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1079),
    [anon_sym_SEMI_SEMI] = ACTIONS(1079),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PIPE_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1079),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT_GT] = ACTIONS(1079),
    [anon_sym_LT_AMP] = ACTIONS(1079),
    [anon_sym_GT_AMP] = ACTIONS(1079),
    [anon_sym_LT_LT] = ACTIONS(1079),
    [anon_sym_LT_LT_DASH] = ACTIONS(1079),
    [anon_sym_BQUOTE] = ACTIONS(1079),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1079),
    [anon_sym_LF] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
  },
  [993] = {
    [anon_sym_RBRACE] = ACTIONS(2649),
    [sym_comment] = ACTIONS(115),
  },
  [994] = {
    [anon_sym_RBRACE] = ACTIONS(2651),
    [sym_comment] = ACTIONS(115),
  },
  [995] = {
    [sym_file_descriptor] = ACTIONS(1287),
    [anon_sym_RPAREN] = ACTIONS(1283),
    [anon_sym_SEMI_SEMI] = ACTIONS(1283),
    [anon_sym_RBRACE] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1283),
    [anon_sym_PIPE_AMP] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE] = ACTIONS(1283),
    [anon_sym_COLON] = ACTIONS(1283),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(1283),
    [anon_sym_GT_GT] = ACTIONS(1283),
    [anon_sym_AMP_GT] = ACTIONS(1283),
    [anon_sym_AMP_GT_GT] = ACTIONS(1283),
    [anon_sym_LT_AMP] = ACTIONS(1283),
    [anon_sym_GT_AMP] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(1283),
    [sym_raw_string] = ACTIONS(1283),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_BQUOTE] = ACTIONS(1283),
    [sym_leading_word] = ACTIONS(1283),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_LF] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1283),
  },
  [996] = {
    [sym_file_descriptor] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_RBRACE] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_COLON] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [sym_leading_word] = ACTIONS(1285),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [997] = {
    [sym_file_descriptor] = ACTIONS(1287),
    [anon_sym_RPAREN] = ACTIONS(1283),
    [anon_sym_SEMI_SEMI] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1283),
    [anon_sym_PIPE_AMP] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE] = ACTIONS(1283),
    [anon_sym_COLON] = ACTIONS(1283),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(1283),
    [anon_sym_GT_GT] = ACTIONS(1283),
    [anon_sym_AMP_GT] = ACTIONS(1283),
    [anon_sym_AMP_GT_GT] = ACTIONS(1283),
    [anon_sym_LT_AMP] = ACTIONS(1283),
    [anon_sym_GT_AMP] = ACTIONS(1283),
    [anon_sym_LT_LT] = ACTIONS(1283),
    [anon_sym_LT_LT_DASH] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(1283),
    [sym_raw_string] = ACTIONS(1283),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_BQUOTE] = ACTIONS(1283),
    [sym_leading_word] = ACTIONS(1283),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_LF] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1283),
  },
  [998] = {
    [sym_file_descriptor] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_COLON] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [sym_leading_word] = ACTIONS(1285),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [999] = {
    [sym_file_descriptor] = ACTIONS(1287),
    [anon_sym_RPAREN] = ACTIONS(1283),
    [anon_sym_SEMI_SEMI] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1283),
    [anon_sym_PIPE_AMP] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE] = ACTIONS(1283),
    [anon_sym_RBRACK] = ACTIONS(1283),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1283),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(1283),
    [anon_sym_GT_GT] = ACTIONS(1283),
    [anon_sym_AMP_GT] = ACTIONS(1283),
    [anon_sym_AMP_GT_GT] = ACTIONS(1283),
    [anon_sym_LT_AMP] = ACTIONS(1283),
    [anon_sym_GT_AMP] = ACTIONS(1283),
    [anon_sym_LT_LT] = ACTIONS(1283),
    [anon_sym_LT_LT_DASH] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(1283),
    [sym_raw_string] = ACTIONS(1283),
    [anon_sym_DOLLAR] = ACTIONS(1283),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1283),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_BQUOTE] = ACTIONS(1283),
    [sym_word] = ACTIONS(1283),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_LF] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1283),
  },
  [1000] = {
    [sym_file_descriptor] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_RBRACK] = ACTIONS(1285),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(1285),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [sym_word] = ACTIONS(1285),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [1001] = {
    [sym_file_descriptor] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1079),
    [anon_sym_SEMI_SEMI] = ACTIONS(1079),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PIPE_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1079),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT_GT] = ACTIONS(1079),
    [anon_sym_LT_AMP] = ACTIONS(1079),
    [anon_sym_GT_AMP] = ACTIONS(1079),
    [anon_sym_LT_LT] = ACTIONS(1079),
    [anon_sym_LT_LT_DASH] = ACTIONS(1079),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1079),
    [anon_sym_LF] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
  },
  [1002] = {
    [anon_sym_RBRACE] = ACTIONS(2653),
    [sym_comment] = ACTIONS(115),
  },
  [1003] = {
    [anon_sym_RBRACE] = ACTIONS(2655),
    [sym_comment] = ACTIONS(115),
  },
  [1004] = {
    [sym_file_descriptor] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1079),
    [anon_sym_SEMI_SEMI] = ACTIONS(1079),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PIPE_AMP] = ACTIONS(1079),
    [anon_sym_AMP_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1079),
    [anon_sym_COLON] = ACTIONS(1079),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1079),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT] = ACTIONS(1079),
    [anon_sym_AMP_GT_GT] = ACTIONS(1079),
    [anon_sym_LT_AMP] = ACTIONS(1079),
    [anon_sym_GT_AMP] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(1079),
    [sym_raw_string] = ACTIONS(1079),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1079),
    [anon_sym_BQUOTE] = ACTIONS(1079),
    [sym_leading_word] = ACTIONS(1079),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1079),
    [anon_sym_LF] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
  },
  [1005] = {
    [anon_sym_RBRACE] = ACTIONS(2657),
    [sym_comment] = ACTIONS(115),
  },
  [1006] = {
    [anon_sym_RBRACE] = ACTIONS(2659),
    [sym_comment] = ACTIONS(115),
  },
  [1007] = {
    [sym_file_descriptor] = ACTIONS(1287),
    [anon_sym_RPAREN] = ACTIONS(1283),
    [anon_sym_SEMI_SEMI] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1283),
    [anon_sym_PIPE_AMP] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE] = ACTIONS(1283),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(1283),
    [anon_sym_GT_GT] = ACTIONS(1283),
    [anon_sym_AMP_GT] = ACTIONS(1283),
    [anon_sym_AMP_GT_GT] = ACTIONS(1283),
    [anon_sym_LT_AMP] = ACTIONS(1283),
    [anon_sym_GT_AMP] = ACTIONS(1283),
    [anon_sym_LT_LT] = ACTIONS(1283),
    [anon_sym_LT_LT_DASH] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(1283),
    [sym_raw_string] = ACTIONS(1283),
    [anon_sym_DOLLAR] = ACTIONS(1283),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1283),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_BQUOTE] = ACTIONS(1283),
    [sym_word] = ACTIONS(1283),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_LF] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1283),
  },
  [1008] = {
    [sym_file_descriptor] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(1285),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [sym_word] = ACTIONS(1285),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [1009] = {
    [sym_file_descriptor] = ACTIONS(1287),
    [anon_sym_RPAREN] = ACTIONS(1283),
    [anon_sym_SEMI_SEMI] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1283),
    [anon_sym_PIPE_AMP] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE] = ACTIONS(1283),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(1283),
    [anon_sym_GT_GT] = ACTIONS(1283),
    [anon_sym_AMP_GT] = ACTIONS(1283),
    [anon_sym_AMP_GT_GT] = ACTIONS(1283),
    [anon_sym_LT_AMP] = ACTIONS(1283),
    [anon_sym_GT_AMP] = ACTIONS(1283),
    [anon_sym_LT_LT] = ACTIONS(1283),
    [anon_sym_LT_LT_DASH] = ACTIONS(1283),
    [anon_sym_BQUOTE] = ACTIONS(1283),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_LF] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1283),
  },
  [1010] = {
    [sym_file_descriptor] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [1011] = {
    [sym_file_descriptor] = ACTIONS(1287),
    [anon_sym_RPAREN] = ACTIONS(1283),
    [anon_sym_SEMI_SEMI] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1283),
    [anon_sym_PIPE_AMP] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE] = ACTIONS(1283),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(1283),
    [anon_sym_GT_GT] = ACTIONS(1283),
    [anon_sym_AMP_GT] = ACTIONS(1283),
    [anon_sym_AMP_GT_GT] = ACTIONS(1283),
    [anon_sym_LT_AMP] = ACTIONS(1283),
    [anon_sym_GT_AMP] = ACTIONS(1283),
    [anon_sym_LT_LT] = ACTIONS(1283),
    [anon_sym_LT_LT_DASH] = ACTIONS(1283),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_LF] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1283),
  },
  [1012] = {
    [sym_file_descriptor] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
  },
  [1013] = {
    [sym_file_descriptor] = ACTIONS(1287),
    [anon_sym_RPAREN] = ACTIONS(1283),
    [anon_sym_SEMI_SEMI] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1283),
    [anon_sym_PIPE_AMP] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE] = ACTIONS(1283),
    [anon_sym_COLON] = ACTIONS(1283),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(1283),
    [anon_sym_GT_GT] = ACTIONS(1283),
    [anon_sym_AMP_GT] = ACTIONS(1283),
    [anon_sym_AMP_GT_GT] = ACTIONS(1283),
    [anon_sym_LT_AMP] = ACTIONS(1283),
    [anon_sym_GT_AMP] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(1283),
    [sym_raw_string] = ACTIONS(1283),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_BQUOTE] = ACTIONS(1283),
    [sym_leading_word] = ACTIONS(1283),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_LF] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1283),
  },
  [1014] = {
    [sym_file_descriptor] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_COLON] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [sym_leading_word] = ACTIONS(1285),
    [sym_comment] = ACTIONS(73),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false, .depends_on_lookahead = false},
  [1] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(606),
  [3] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(607),
  [5] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(608),
  [7] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(609),
  [9] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(610),
  [11] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(611),
  [13] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(0),
  [15] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(578),
  [17] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(579),
  [19] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(580),
  [21] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, RECOVER(581),
  [23] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(582),
  [25] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(583),
  [27] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(584),
  [29] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(585),
  [31] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(205),
  [33] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(206),
  [35] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(586),
  [37] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(587),
  [39] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(588),
  [41] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(589),
  [43] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(590),
  [45] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(591),
  [47] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(592),
  [49] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, RECOVER(593),
  [51] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(594),
  [53] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(595),
  [55] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, RECOVER(596),
  [57] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(596),
  [59] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(597),
  [61] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(598),
  [63] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, RECOVER(599),
  [65] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(600),
  [67] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(601),
  [69] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(602),
  [71] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(603),
  [73] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT_EXTRA(),
  [75] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(604),
  [77] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, RECOVER(604),
  [79] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(605),
  [81] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2),
  [83] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_program, 0),
  [85] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(3),
  [87] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(4),
  [89] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(5),
  [91] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(6),
  [93] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(7),
  [95] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(8),
  [97] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(9),
  [99] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(10),
  [101] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(11),
  [103] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(12),
  [105] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(13),
  [107] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(11),
  [109] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(14),
  [111] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(15),
  [113] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(16),
  [115] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT_EXTRA(),
  [117] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(24),
  [119] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(24),
  [121] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(25),
  [123] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(30),
  [125] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(31),
  [127] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(32),
  [129] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(33),
  [131] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(34),
  [133] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(35),
  [135] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(36),
  [137] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(32),
  [139] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(37),
  [141] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(38),
  [143] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(40),
  [145] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(41),
  [147] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(42),
  [149] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(43),
  [151] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(44),
  [153] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(45),
  [155] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(46),
  [157] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(42),
  [159] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(49),
  [161] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 1),
  [163] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(50),
  [165] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(51),
  [167] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(52),
  [169] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(55),
  [171] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(56),
  [173] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(57),
  [175] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(58),
  [177] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(59),
  [179] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(60),
  [181] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(61),
  [183] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(57),
  [185] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(62),
  [187] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(63),
  [189] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(64),
  [191] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(65),
  [193] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(66),
  [195] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(67),
  [197] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(69),
  [199] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(70),
  [201] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(69),
  [203] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(71),
  [205] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(72),
  [207] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(73),
  [209] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(76),
  [211] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(76),
  [213] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(77),
  [215] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 1, .rename_sequence_id = 1),
  [217] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(80),
  [219] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(81),
  [221] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(82),
  [223] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, ACCEPT_INPUT(),
  [225] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 1),
  [227] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 1),
  [229] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 1),
  [231] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(84),
  [233] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(85),
  [235] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(86),
  [237] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1),
  [239] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1),
  [241] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat1, 1),
  [243] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_program, 1),
  [245] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(88),
  [247] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(88),
  [249] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(89),
  [251] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(91),
  [253] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(91),
  [255] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(92),
  [257] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(93),
  [259] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(95),
  [261] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(96),
  [263] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(97),
  [265] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(98),
  [267] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(100),
  [269] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(101),
  [271] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(102),
  [273] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(103),
  [275] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(102),
  [277] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(105),
  [279] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(106),
  [281] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(110),
  [283] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 2),
  [285] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(111),
  [287] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(112),
  [289] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(113),
  [291] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_bracket_command_repeat1, 1),
  [293] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_bracket_command_repeat1, 1),
  [295] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_bracket_command_repeat1, 1),
  [297] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(115),
  [299] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(116),
  [301] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(115),
  [303] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(118),
  [305] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(122),
  [307] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(123),
  [309] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(123),
  [311] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(124),
  [313] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(124),
  [315] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 2, .fragile = true),
  [317] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(125),
  [319] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(126),
  [321] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(127),
  [323] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(128),
  [325] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(129),
  [327] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(130),
  [329] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(131),
  [331] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(134),
  [333] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(135),
  [335] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(136),
  [337] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(137),
  [339] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(138),
  [341] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(139),
  [343] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(140),
  [345] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(136),
  [347] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(141),
  [349] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(142),
  [351] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 1),
  [353] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 1),
  [355] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 2),
  [357] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(145),
  [359] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(146),
  [361] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2),
  [363] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_file_redirect, 2),
  [365] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2),
  [367] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(148),
  [369] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(149),
  [371] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(148),
  [373] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(151),
  [375] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_string, 2),
  [377] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 2),
  [379] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 1),
  [381] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_string_repeat1, 1),
  [383] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(155),
  [385] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(156),
  [387] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(155),
  [389] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(158),
  [391] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(162),
  [393] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(163),
  [395] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(164),
  [397] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(165),
  [399] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(166),
  [401] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(167),
  [403] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(170),
  [405] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(174),
  [407] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(175),
  [409] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(177),
  [411] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(178),
  [413] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(178),
  [415] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(179),
  [417] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(180),
  [419] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(181),
  [421] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(182),
  [423] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(182),
  [425] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(183),
  [427] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(184),
  [429] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 2, .fragile = true, .rename_sequence_id = 2),
  [431] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(187),
  [433] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(188),
  [435] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(189),
  [437] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(187),
  [439] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(190),
  [441] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(191),
  [443] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(192),
  [445] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(193),
  [447] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(187),
  [449] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 2, .rename_sequence_id = 2),
  [451] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2),
  [453] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym__terminated_statement, 2),
  [455] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2),
  [457] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2),
  [459] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2),
  [461] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2),
  [463] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(198),
  [465] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 2, .rename_sequence_id = 3),
  [467] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(199),
  [469] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 2),
  [471] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat1, 2),
  [473] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 2),
  [475] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 3),
  [477] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_file_redirect, 3),
  [479] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 3),
  [481] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(202),
  [483] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_while_statement, 3),
  [485] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(204),
  [487] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(205),
  [489] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(206),
  [491] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(211),
  [493] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(212),
  [495] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(213),
  [497] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(214),
  [499] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(215),
  [501] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(216),
  [503] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(217),
  [505] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(218),
  [507] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(219),
  [509] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(219),
  [511] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(220),
  [513] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(224),
  [515] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(225),
  [517] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(226),
  [519] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_special_variable_name, 1),
  [521] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2, .rename_sequence_id = 4),
  [523] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2),
  [525] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_special_variable_name, 1),
  [527] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_special_variable_name, 1),
  [529] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(227),
  [531] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(228),
  [533] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(228),
  [535] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(229),
  [537] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(230),
  [539] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(230),
  [541] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(231),
  [543] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(232),
  [545] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 3),
  [547] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_string, 2),
  [549] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(235),
  [551] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2, .rename_sequence_id = 4),
  [553] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_simple_expansion, 2, .rename_sequence_id = 4),
  [555] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2),
  [557] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_simple_expansion, 2),
  [559] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(236),
  [561] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(237),
  [563] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(237),
  [565] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(238),
  [567] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(239),
  [569] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(239),
  [571] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(240),
  [573] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_bracket_command, 3),
  [575] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_bracket_command_repeat1, 2),
  [577] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_bracket_command_repeat1, 2),
  [579] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_bracket_command_repeat1, 2),
  [581] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(241),
  [583] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(241),
  [585] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(242),
  [587] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(243),
  [589] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(245),
  [591] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(246),
  [593] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(245),
  [595] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(248),
  [597] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 3, .fragile = true),
  [599] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(252),
  [601] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 3),
  [603] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(254),
  [605] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(255),
  [607] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(257),
  [609] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(258),
  [611] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(257),
  [613] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(260),
  [615] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 1),
  [617] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 1),
  [619] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(264),
  [621] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(265),
  [623] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(266),
  [625] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(267),
  [627] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc_redirect, 2),
  [629] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc_redirect, 2),
  [631] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2),
  [633] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2),
  [635] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(271),
  [637] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(272),
  [639] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(273),
  [641] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(273),
  [643] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(274),
  [645] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(275),
  [647] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(275),
  [649] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(276),
  [651] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(277),
  [653] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(278),
  [655] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(278),
  [657] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(279),
  [659] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(280),
  [661] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(280),
  [663] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(281),
  [665] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_string, 3),
  [667] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 3),
  [669] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2),
  [671] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_string_repeat1, 2),
  [673] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(282),
  [675] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(282),
  [677] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 2, .fragile = true),
  [679] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(283),
  [681] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(166),
  [683] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(166),
  [685] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(167),
  [687] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(167),
  [689] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(284),
  [691] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(285),
  [693] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(286),
  [695] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(287),
  [697] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(288),
  [699] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(289),
  [701] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(285),
  [703] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(292),
  [705] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(293),
  [707] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(293),
  [709] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(294),
  [711] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(295),
  [713] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat2, 1),
  [715] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 2),
  [717] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(298),
  [719] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(299),
  [721] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 2, .fragile = true, .rename_sequence_id = 2),
  [723] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(302),
  [725] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(302),
  [727] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(302),
  [729] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 2, .rename_sequence_id = 2),
  [731] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3),
  [733] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3),
  [735] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(303),
  [737] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(304),
  [739] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(308),
  [741] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(309),
  [743] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(310),
  [745] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 3, .fragile = true, .rename_sequence_id = 5),
  [747] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 3, .rename_sequence_id = 5),
  [749] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_environment_variable_assignment, 3, .rename_sequence_id = 6),
  [751] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_environment_variable_assignment, 3, .rename_sequence_id = 6),
  [753] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(313),
  [755] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(314),
  [757] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(316),
  [759] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(317),
  [761] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(316),
  [763] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(319),
  [765] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3, .fragile = true),
  [767] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_list, 3, .fragile = true),
  [769] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 3, .fragile = true, .rename_sequence_id = 7),
  [771] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 3, .rename_sequence_id = 7),
  [773] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_do_group, 2),
  [775] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(327),
  [777] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 4),
  [779] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_else_clause, 1),
  [781] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_if_statement_repeat1, 1),
  [783] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(330),
  [785] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(330),
  [787] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(205),
  [789] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(206),
  [791] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(334),
  [793] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(337),
  [795] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(337),
  [797] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(338),
  [799] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(339),
  [801] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(343),
  [803] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(344),
  [805] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(345),
  [807] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(347),
  [809] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(348),
  [811] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(350),
  [813] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(351),
  [815] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(351),
  [817] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(352),
  [819] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(352),
  [821] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(353),
  [823] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(353),
  [825] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(354),
  [827] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(355),
  [829] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(356),
  [831] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(357),
  [833] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(356),
  [835] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(360),
  [837] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3, .rename_sequence_id = 8),
  [839] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(361),
  [841] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(361),
  [843] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3),
  [845] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(362),
  [847] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(362),
  [849] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(364),
  [851] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_string, 3),
  [853] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3, .rename_sequence_id = 8),
  [855] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 3, .rename_sequence_id = 8),
  [857] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(365),
  [859] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(365),
  [861] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3),
  [863] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 3),
  [865] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(366),
  [867] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(366),
  [869] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command_substitution, 3),
  [871] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(369),
  [873] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(370),
  [875] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(371),
  [877] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(371),
  [879] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(372),
  [881] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(373),
  [883] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(373),
  [885] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(374),
  [887] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 4),
  [889] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(377),
  [891] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(378),
  [893] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(379),
  [895] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(379),
  [897] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(380),
  [899] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(381),
  [901] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(381),
  [903] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(382),
  [905] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 1),
  [907] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_heredoc_repeat1, 1),
  [909] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 2),
  [911] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 2),
  [913] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(383),
  [915] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(384),
  [917] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(383),
  [919] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(386),
  [921] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(388),
  [923] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(389),
  [925] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(390),
  [927] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(391),
  [929] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(391),
  [931] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(392),
  [933] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(392),
  [935] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(393),
  [937] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(393),
  [939] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(394),
  [941] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(394),
  [943] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(395),
  [945] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(395),
  [947] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(396),
  [949] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(397),
  [951] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(399),
  [953] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(400),
  [955] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(399),
  [957] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(402),
  [959] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 3, .fragile = true),
  [961] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(406),
  [963] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(406),
  [965] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 3),
  [967] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc, 1),
  [969] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(408),
  [971] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc_redirect, 2),
  [973] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat2, 2),
  [975] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 3, .fragile = true, .rename_sequence_id = 5),
  [977] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 3, .rename_sequence_id = 5),
  [979] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_environment_variable_assignment, 3, .rename_sequence_id = 6),
  [981] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 3, .fragile = true, .rename_sequence_id = 7),
  [983] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 3, .rename_sequence_id = 7),
  [985] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(416),
  [987] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 4, .rename_sequence_id = 9),
  [989] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 4, .rename_sequence_id = 9),
  [991] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(420),
  [993] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(421),
  [995] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(422),
  [997] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(422),
  [999] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(423),
  [1001] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(424),
  [1003] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(424),
  [1005] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(425),
  [1007] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 4, .fragile = true),
  [1009] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 4, .fragile = true, .rename_sequence_id = 10),
  [1011] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 4, .rename_sequence_id = 10),
  [1013] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_for_statement, 5),
  [1015] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_do_group, 3),
  [1017] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(428),
  [1019] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_else_clause, 2),
  [1021] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 5),
  [1023] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(429),
  [1025] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [1027] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(431),
  [1029] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(432),
  [1031] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(434),
  [1033] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(435),
  [1035] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(436),
  [1037] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(437),
  [1039] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subshell, 2),
  [1041] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subshell, 2),
  [1043] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(438),
  [1045] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(439),
  [1047] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(440),
  [1049] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(440),
  [1051] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 2, .fragile = true),
  [1053] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(441),
  [1055] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(345),
  [1057] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(345),
  [1059] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(444),
  [1061] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(445),
  [1063] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(446),
  [1065] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(447),
  [1067] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(448),
  [1069] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(449),
  [1071] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 2),
  [1073] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(450),
  [1075] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 2, .fragile = true, .rename_sequence_id = 2),
  [1077] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 2, .rename_sequence_id = 2),
  [1079] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_process_substitution, 4),
  [1081] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(457),
  [1083] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(458),
  [1085] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5),
  [1087] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(460),
  [1089] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(105),
  [1091] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_case_statement_repeat1, 1),
  [1093] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 1),
  [1095] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 1),
  [1097] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(461),
  [1099] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(464),
  [1101] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(465),
  [1103] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 5, .rename_sequence_id = 11),
  [1105] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_process_substitution, 4),
  [1107] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_process_substitution, 4),
  [1109] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(466),
  [1111] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(467),
  [1113] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(468),
  [1115] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(469),
  [1117] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(469),
  [1119] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(470),
  [1121] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(470),
  [1123] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(471),
  [1125] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(472),
  [1127] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(472),
  [1129] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(473),
  [1131] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(473),
  [1133] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(474),
  [1135] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(475),
  [1137] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(475),
  [1139] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(476),
  [1141] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(477),
  [1143] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(477),
  [1145] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 2),
  [1147] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_heredoc_repeat1, 2),
  [1149] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 3),
  [1151] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 3),
  [1153] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(478),
  [1155] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(479),
  [1157] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(480),
  [1159] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(481),
  [1161] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(484),
  [1163] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(485),
  [1165] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(486),
  [1167] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(486),
  [1169] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(487),
  [1171] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(488),
  [1173] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(488),
  [1175] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(489),
  [1177] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 4),
  [1179] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc, 2),
  [1181] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(490),
  [1183] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 4, .rename_sequence_id = 9),
  [1185] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 4, .fragile = true),
  [1187] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 4, .fragile = true, .rename_sequence_id = 10),
  [1189] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 4, .rename_sequence_id = 10),
  [1191] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 2),
  [1193] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(493),
  [1195] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(494),
  [1197] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(495),
  [1199] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(495),
  [1201] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(496),
  [1203] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(496),
  [1205] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 5),
  [1207] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 5, .rename_sequence_id = 11),
  [1209] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 3),
  [1211] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 6),
  [1213] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(498),
  [1215] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(500),
  [1217] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_while_statement, 3),
  [1219] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_while_statement, 3),
  [1221] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(502),
  [1223] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(506),
  [1225] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(507),
  [1227] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(508),
  [1229] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subshell, 3),
  [1231] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subshell, 3),
  [1233] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_bracket_command, 3),
  [1235] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_bracket_command, 3),
  [1237] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 3, .fragile = true),
  [1239] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 3),
  [1241] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(510),
  [1243] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(511),
  [1245] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(513),
  [1247] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(514),
  [1249] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(513),
  [1251] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(516),
  [1253] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(520),
  [1255] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 3, .fragile = true, .rename_sequence_id = 5),
  [1257] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 3, .rename_sequence_id = 5),
  [1259] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3, .fragile = true),
  [1261] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_pipeline, 3, .fragile = true),
  [1263] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_list, 3, .fragile = true),
  [1265] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_list, 3, .fragile = true),
  [1267] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 3, .fragile = true, .rename_sequence_id = 7),
  [1269] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 3, .rename_sequence_id = 7),
  [1271] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(526),
  [1273] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6),
  [1275] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_case_statement_repeat1, 2),
  [1277] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2),
  [1279] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2),
  [1281] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(528),
  [1283] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .rename_sequence_id = 12),
  [1285] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5),
  [1287] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .rename_sequence_id = 12),
  [1289] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 5, .rename_sequence_id = 12),
  [1291] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5),
  [1293] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 5),
  [1295] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(529),
  [1297] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(530),
  [1299] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(531),
  [1301] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(532),
  [1303] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(533),
  [1305] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(533),
  [1307] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(534),
  [1309] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(534),
  [1311] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(535),
  [1313] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(536),
  [1315] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(536),
  [1317] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(537),
  [1319] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(537),
  [1321] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc, 3),
  [1323] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 5),
  [1325] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 5, .rename_sequence_id = 11),
  [1327] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 3),
  [1329] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(538),
  [1331] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(539),
  [1333] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 4),
  [1335] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 7),
  [1337] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_do_group, 2),
  [1339] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_do_group, 2),
  [1341] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(541),
  [1343] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 4),
  [1345] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 4),
  [1347] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(542),
  [1349] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(542),
  [1351] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(545),
  [1353] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(547),
  [1355] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 4),
  [1357] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(551),
  [1359] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(552),
  [1361] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(553),
  [1363] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(553),
  [1365] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(554),
  [1367] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(555),
  [1369] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(555),
  [1371] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(556),
  [1373] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(557),
  [1375] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 4, .rename_sequence_id = 9),
  [1377] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 4, .rename_sequence_id = 9),
  [1379] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 4, .rename_sequence_id = 9),
  [1381] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 4, .fragile = true),
  [1383] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 4, .fragile = true, .rename_sequence_id = 10),
  [1385] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 4, .rename_sequence_id = 10),
  [1387] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 3),
  [1389] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 3),
  [1391] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 3),
  [1393] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(561),
  [1395] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 7),
  [1397] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(562),
  [1399] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(563),
  [1401] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(564),
  [1403] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(565),
  [1405] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_for_statement, 5),
  [1407] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_for_statement, 5),
  [1409] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_do_group, 3),
  [1411] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_do_group, 3),
  [1413] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 5),
  [1415] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 5),
  [1417] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(566),
  [1419] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5),
  [1421] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 5),
  [1423] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(568),
  [1425] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 5, .rename_sequence_id = 11),
  [1427] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 5, .rename_sequence_id = 11),
  [1429] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(570),
  [1431] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(571),
  [1433] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(571),
  [1435] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(572),
  [1437] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(572),
  [1439] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 2),
  [1441] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_compound_statement, 2),
  [1443] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(573),
  [1445] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 5),
  [1447] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 5, .rename_sequence_id = 11),
  [1449] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 4),
  [1451] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 4),
  [1453] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 4),
  [1455] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 6),
  [1457] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 6),
  [1459] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(574),
  [1461] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6),
  [1463] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 6),
  [1465] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(575),
  [1467] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(576),
  [1469] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(577),
  [1471] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 3),
  [1473] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_compound_statement, 3),
  [1475] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 7),
  [1477] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 7),
  [1479] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 7),
  [1481] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 7),
  [1483] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(637),
  [1485] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(3),
  [1487] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(4),
  [1489] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(5),
  [1491] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(6),
  [1493] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(638),
  [1495] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(7),
  [1497] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(8),
  [1499] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(9),
  [1501] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(10),
  [1503] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(11),
  [1505] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(12),
  [1507] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(13),
  [1509] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(14),
  [1511] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(15),
  [1513] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(641),
  [1515] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_do_group, 2), REDUCE(sym_do_group, 3),
  [1518] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 3), SHIFT(644),
  [1521] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 3), SHIFT(205),
  [1524] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 3), SHIFT(206),
  [1527] = {.count = 4, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 4), REDUCE(sym_if_statement, 5), REDUCE(sym_if_statement, 6), REDUCE(sym_if_statement, 7),
  [1532] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(648),
  [1534] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(648),
  [1536] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5), REDUCE(sym_case_statement, 6), REDUCE(sym_case_statement, 7),
  [1540] = {.count = 3, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 4), SHIFT(2),
  [1544] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 4),
  [1547] = {.count = 4, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 2), REDUCE(sym_subshell, 3), REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 4),
  [1552] = {.count = 5, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 2), REDUCE(sym_subshell, 3), REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 4), SHIFT(526),
  [1558] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(591),
  [1560] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 4), SHIFT(11),
  [1564] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 4), SHIFT(12),
  [1568] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 4), SHIFT(13),
  [1572] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 4), SHIFT(14),
  [1576] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 4), SHIFT(15),
  [1580] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 4), SHIFT(16),
  [1584] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(649),
  [1586] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(578),
  [1588] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(580),
  [1590] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(583),
  [1592] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(586),
  [1594] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(650),
  [1596] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(589),
  [1598] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(651),
  [1600] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(595),
  [1602] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(652),
  [1604] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(653),
  [1606] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(654),
  [1608] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(653),
  [1610] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(655),
  [1612] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(656),
  [1614] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(657),
  [1616] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(662),
  [1618] = {.count = 4, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3), REDUCE(sym_expansion, 3, .rename_sequence_id = 8), REDUCE(sym_expansion, 5), REDUCE(sym_expansion, 5, .rename_sequence_id = 12),
  [1623] = {.count = 4, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3), REDUCE(sym_expansion, 3, .rename_sequence_id = 8), REDUCE(sym_expansion, 5), REDUCE(sym_expansion, 5, .rename_sequence_id = 12),
  [1628] = {.count = 6, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 2), REDUCE(sym_compound_statement, 3), REDUCE(sym_expansion, 3), REDUCE(sym_expansion, 3, .rename_sequence_id = 8), REDUCE(sym_expansion, 5), REDUCE(sym_expansion, 5, .rename_sequence_id = 12),
  [1635] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(669),
  [1637] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 1), REDUCE(sym_command, 2),
  [1640] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(670),
  [1642] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(671),
  [1644] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(672),
  [1646] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(673),
  [1648] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(41),
  [1650] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(674),
  [1652] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(357),
  [1654] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(44),
  [1656] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(45),
  [1658] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 1), REDUCE(sym_command, 2), SHIFT(46),
  [1662] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(611),
  [1664] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(677),
  [1666] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(678),
  [1668] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(679),
  [1670] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(680),
  [1672] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(681),
  [1674] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(682),
  [1676] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(683),
  [1678] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(679),
  [1680] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(684),
  [1682] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(685),
  [1684] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(686),
  [1686] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(687),
  [1688] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(688),
  [1690] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(689),
  [1692] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(690),
  [1694] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(691),
  [1696] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(687),
  [1698] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_string, 2), REDUCE(sym_string, 3),
  [1701] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 2), REDUCE(sym_string, 3),
  [1704] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 2), REDUCE(sym_string, 3), SHIFT(692),
  [1708] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 2), REDUCE(sym_string, 3), SHIFT(64),
  [1712] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 2), REDUCE(sym_string, 3), SHIFT(65),
  [1716] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 2), REDUCE(sym_string, 3), SHIFT(66),
  [1720] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 2), REDUCE(sym_string, 3), SHIFT(67),
  [1724] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_special_variable_name, 1), SHIFT(693),
  [1727] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(694),
  [1729] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(693),
  [1731] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), SHIFT(2),
  [1734] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), SHIFT(76),
  [1737] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), SHIFT(12),
  [1740] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), SHIFT(70),
  [1743] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), SHIFT(71),
  [1746] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), SHIFT(72),
  [1749] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), SHIFT(77),
  [1752] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(697),
  [1754] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(698),
  [1756] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym__terminated_statement, 2), SHIFT(40),
  [1759] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2), SHIFT(41),
  [1762] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym__terminated_statement, 2), SHIFT(356),
  [1765] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2), SHIFT(45),
  [1768] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2), SHIFT(46),
  [1771] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(699),
  [1773] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 1), REDUCE(aux_sym_heredoc_repeat1, 2),
  [1776] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_heredoc_repeat1, 1), REDUCE(aux_sym_heredoc_repeat1, 2),
  [1779] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 2), REDUCE(sym_heredoc, 3),
  [1782] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 2), REDUCE(sym_heredoc, 3),
  [1785] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(700),
  [1787] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(700),
  [1789] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 1), REDUCE(aux_sym_program_repeat1, 2),
  [1792] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 1), REDUCE(aux_sym_program_repeat1, 2),
  [1795] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(581),
  [1797] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(584),
  [1799] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 1), REDUCE(aux_sym_program_repeat1, 2),
  [1802] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3, .fragile = true), REDUCE(sym_list, 3, .fragile = true), SHIFT(701),
  [1806] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3, .fragile = true), REDUCE(sym_list, 3, .fragile = true), SHIFT(84),
  [1810] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3, .fragile = true), REDUCE(sym_list, 3, .fragile = true), SHIFT(593),
  [1814] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3, .fragile = true), REDUCE(sym_list, 3, .fragile = true), SHIFT(594),
  [1818] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_while_statement, 3), REDUCE(sym_for_statement, 5),
  [1821] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_if_statement_repeat1, 1), REDUCE(aux_sym_if_statement_repeat1, 2),
  [1824] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(702),
  [1826] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_case_statement_repeat1, 1), REDUCE(aux_sym_case_statement_repeat1, 2),
  [1829] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 1), REDUCE(aux_sym_case_statement_repeat1, 2),
  [1832] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 1), REDUCE(aux_sym_case_statement_repeat1, 2),
  [1835] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 4, .rename_sequence_id = 9), REDUCE(sym_function_definition, 5, .rename_sequence_id = 11),
  [1838] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3), REDUCE(sym_list, 3), SHIFT(703),
  [1842] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3), REDUCE(sym_list, 3), SHIFT(84),
  [1846] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3), REDUCE(sym_list, 3), SHIFT(593),
  [1850] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3), REDUCE(sym_list, 3), SHIFT(594),
  [1854] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(704),
  [1856] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1), REDUCE(aux_sym_command_repeat1, 2),
  [1859] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1), REDUCE(aux_sym_command_repeat1, 2),
  [1862] = {.count = 4, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1), REDUCE(aux_sym_command_repeat2, 1), REDUCE(aux_sym_command_repeat1, 2), REDUCE(aux_sym_command_repeat2, 2),
  [1867] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 1), REDUCE(aux_sym_command_repeat2, 2),
  [1870] = {.count = 4, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1), REDUCE(aux_sym_command_repeat2, 1), REDUCE(aux_sym_command_repeat1, 2), REDUCE(aux_sym_command_repeat2, 2),
  [1875] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 1), REDUCE(aux_sym_command_repeat2, 2),
  [1878] = {.count = 6, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_bracket_command_repeat1, 1), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_bracket_command_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3, .rename_sequence_id = 6), REDUCE(sym_file_redirect, 3), SHIFT(669),
  [1885] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(705),
  [1887] = {.count = 8, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 1), REDUCE(aux_sym_bracket_command_repeat1, 1), REDUCE(sym_command, 2), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_bracket_command_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3, .rename_sequence_id = 6), REDUCE(sym_file_redirect, 3), SHIFT(460),
  [1896] = {.count = 8, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 1), REDUCE(aux_sym_bracket_command_repeat1, 1), REDUCE(sym_command, 2), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_bracket_command_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3, .rename_sequence_id = 6), REDUCE(sym_file_redirect, 3), SHIFT(706),
  [1905] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(707),
  [1907] = {.count = 7, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 1), REDUCE(aux_sym_bracket_command_repeat1, 1), REDUCE(sym_command, 2), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_bracket_command_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3, .rename_sequence_id = 6), REDUCE(sym_file_redirect, 3),
  [1915] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_bracket_command_repeat1, 1), REDUCE(aux_sym_bracket_command_repeat1, 2),
  [1918] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2), REDUCE(sym_environment_variable_assignment, 3, .rename_sequence_id = 6), REDUCE(sym_file_redirect, 3),
  [1922] = {.count = 6, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_bracket_command_repeat1, 1), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_bracket_command_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3, .rename_sequence_id = 6), REDUCE(sym_file_redirect, 3), SHIFT(672),
  [1929] = {.count = 5, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_bracket_command_repeat1, 1), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_bracket_command_repeat1, 2), REDUCE(sym_file_redirect, 3), SHIFT(673),
  [1935] = {.count = 5, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_bracket_command_repeat1, 1), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_bracket_command_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3, .rename_sequence_id = 6), REDUCE(sym_file_redirect, 3),
  [1941] = {.count = 5, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_bracket_command_repeat1, 1), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_bracket_command_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3, .rename_sequence_id = 6), REDUCE(sym_file_redirect, 3),
  [1947] = {.count = 6, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_bracket_command_repeat1, 1), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_bracket_command_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3, .rename_sequence_id = 6), REDUCE(sym_file_redirect, 3), SHIFT(460),
  [1954] = {.count = 6, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_bracket_command_repeat1, 1), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_bracket_command_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3, .rename_sequence_id = 6), REDUCE(sym_file_redirect, 3), SHIFT(706),
  [1961] = {.count = 4, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_bracket_command_repeat1, 1), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_bracket_command_repeat1, 2), REDUCE(sym_file_redirect, 3),
  [1966] = {.count = 7, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_bracket_command_repeat1, 1), REDUCE(aux_sym_string_repeat1, 1), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_bracket_command_repeat1, 2), REDUCE(aux_sym_string_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3, .rename_sequence_id = 6), REDUCE(sym_file_redirect, 3),
  [1974] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 1), REDUCE(aux_sym_string_repeat1, 2),
  [1977] = {.count = 6, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_bracket_command_repeat1, 1), REDUCE(aux_sym_heredoc_repeat1, 1), REDUCE(aux_sym_string_repeat1, 1), REDUCE(aux_sym_bracket_command_repeat1, 2), REDUCE(aux_sym_heredoc_repeat1, 2), REDUCE(aux_sym_string_repeat1, 2),
  [1984] = {.count = 4, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_bracket_command_repeat1, 1), REDUCE(aux_sym_string_repeat1, 1), REDUCE(aux_sym_bracket_command_repeat1, 2), REDUCE(aux_sym_string_repeat1, 2),
  [1989] = {.count = 9, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 1), REDUCE(aux_sym_bracket_command_repeat1, 1), REDUCE(aux_sym_string_repeat1, 1), REDUCE(sym_command, 2), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_bracket_command_repeat1, 2), REDUCE(aux_sym_string_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3, .rename_sequence_id = 6), REDUCE(sym_file_redirect, 3),
  [1999] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2), SHIFT(708),
  [2002] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2), SHIFT(709),
  [2005] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(709),
  [2007] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(709),
  [2009] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(710),
  [2011] = {.count = 3, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_else_clause, 2), REDUCE(sym_elif_clause, 4), SHIFT(711),
  [2015] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 4), SHIFT(205),
  [2018] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 4), SHIFT(206),
  [2021] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(712),
  [2023] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(713),
  [2025] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(716),
  [2027] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(718),
  [2029] = {.count = 4, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 3, .fragile = true), REDUCE(sym_command, 3, .fragile = true, .rename_sequence_id = 5), REDUCE(sym_command, 4, .fragile = true), REDUCE(sym_command, 4, .fragile = true, .rename_sequence_id = 10),
  [2034] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(596),
  [2036] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(719),
  [2038] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(720),
  [2040] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(721),
  [2042] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(722),
  [2044] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(723),
  [2046] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(724),
  [2048] = {.count = 5, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 3, .fragile = true), REDUCE(sym_command, 3, .fragile = true, .rename_sequence_id = 5), REDUCE(sym_command, 4, .fragile = true), REDUCE(sym_command, 4, .fragile = true, .rename_sequence_id = 10), SHIFT(725),
  [2054] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(727),
  [2056] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(728),
  [2058] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(727),
  [2060] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(729),
  [2062] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(730),
  [2064] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(731),
  [2066] = {.count = 10, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 2), REDUCE(sym_command, 2, .rename_sequence_id = 2), REDUCE(sym_command, 3), REDUCE(sym_command, 3, .rename_sequence_id = 7), REDUCE(sym_command, 3, .rename_sequence_id = 5), REDUCE(sym_command, 4), REDUCE(sym_command, 4, .rename_sequence_id = 10), REDUCE(sym_command, 4, .rename_sequence_id = 9), REDUCE(sym_command, 5), REDUCE(sym_command, 5, .rename_sequence_id = 11),
  [2077] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(733),
  [2079] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(734),
  [2081] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(735),
  [2083] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(581),
  [2085] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(738),
  [2087] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(711),
  [2089] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 4), SHIFT(711),
  [2092] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(706),
  [2094] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(739),
  [2096] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(740),
  [2098] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(742),
  [2100] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(743),
  [2102] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(744),
  [2104] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(745),
  [2106] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(748),
  [2108] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(752),
  [2110] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(753),
  [2112] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(754),
  [2114] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(701),
  [2116] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(593),
  [2118] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(594),
  [2120] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(756),
  [2122] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(756),
  [2124] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(757),
  [2126] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3, .fragile = true), SHIFT(593),
  [2129] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3, .fragile = true), SHIFT(594),
  [2132] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_list, 3, .fragile = true), SHIFT(593),
  [2135] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_list, 3, .fragile = true), SHIFT(594),
  [2138] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(596),
  [2140] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(758),
  [2142] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(758),
  [2144] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 2, .fragile = true), REDUCE(sym_command, 3, .fragile = true),
  [2147] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(759),
  [2149] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(760),
  [2151] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(761),
  [2153] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(762),
  [2155] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(763),
  [2157] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(764),
  [2159] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 2, .fragile = true), REDUCE(sym_command, 3, .fragile = true), SHIFT(765),
  [2163] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(768),
  [2165] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(769),
  [2167] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(770),
  [2169] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(771),
  [2171] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(772),
  [2173] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(773),
  [2175] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(774),
  [2177] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(770),
  [2179] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(606),
  [2181] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(607),
  [2183] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(707),
  [2185] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 2), REDUCE(sym_command, 3),
  [2188] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(775),
  [2190] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(776),
  [2192] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(778),
  [2194] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(779),
  [2196] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(778),
  [2198] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(781),
  [2200] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(787),
  [2202] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(788),
  [2204] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2), REDUCE(sym_file_redirect, 3),
  [2207] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2), REDUCE(sym_file_redirect, 3),
  [2210] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(790),
  [2212] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(791),
  [2214] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(790),
  [2216] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(793),
  [2218] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(704),
  [2220] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(797),
  [2222] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5), REDUCE(sym_case_statement, 6),
  [2225] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(798),
  [2227] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(798),
  [2229] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 5), REDUCE(sym_if_statement, 6), REDUCE(sym_if_statement, 7),
  [2233] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 4),
  [2236] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(799),
  [2238] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(697),
  [2240] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5), REDUCE(sym_expansion, 5, .rename_sequence_id = 12),
  [2243] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5), REDUCE(sym_expansion, 5, .rename_sequence_id = 12),
  [2246] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(800),
  [2248] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(800),
  [2250] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(801),
  [2252] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 5), REDUCE(sym_if_statement, 6),
  [2255] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(803),
  [2257] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6), REDUCE(sym_case_statement, 7),
  [2260] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(804),
  [2262] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(805),
  [2264] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(807),
  [2266] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(808),
  [2268] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(807),
  [2270] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(810),
  [2272] = {.count = 4, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 4), REDUCE(sym_command, 4, .rename_sequence_id = 9), REDUCE(sym_command, 5), REDUCE(sym_command, 5, .rename_sequence_id = 11),
  [2277] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(814),
  [2279] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(816),
  [2281] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(820),
  [2283] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(644),
  [2285] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(823),
  [2287] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(824),
  [2289] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(824),
  [2291] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(825),
  [2293] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(765),
  [2295] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(828),
  [2297] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(829),
  [2299] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(830),
  [2301] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(831),
  [2303] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(832),
  [2305] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(833),
  [2307] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(834),
  [2309] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(830),
  [2311] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(835),
  [2313] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(836),
  [2315] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(839),
  [2317] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(840),
  [2319] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(841),
  [2321] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(844),
  [2323] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(845),
  [2325] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(611),
  [2327] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(846),
  [2329] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(847),
  [2331] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(848),
  [2333] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(849),
  [2335] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(611),
  [2337] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(850),
  [2339] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(851),
  [2341] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(853),
  [2343] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(853),
  [2345] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(854),
  [2347] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(855),
  [2349] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(857),
  [2351] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(858),
  [2353] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(857),
  [2355] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(860),
  [2357] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 3, .fragile = true), REDUCE(sym_command, 4, .fragile = true),
  [2360] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(864),
  [2362] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 3, .fragile = true), REDUCE(sym_command, 4, .fragile = true), SHIFT(765),
  [2366] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 3), REDUCE(sym_command, 4),
  [2369] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(866),
  [2371] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(867),
  [2373] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(869),
  [2375] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(870),
  [2377] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(869),
  [2379] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(872),
  [2381] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(878),
  [2383] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(879),
  [2385] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(880),
  [2387] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(880),
  [2389] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(881),
  [2391] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(882),
  [2393] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(882),
  [2395] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(883),
  [2397] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(701),
  [2399] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(886),
  [2401] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(887),
  [2403] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(888),
  [2405] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(888),
  [2407] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(889),
  [2409] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(890),
  [2411] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(890),
  [2413] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(891),
  [2415] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(892),
  [2417] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(894),
  [2419] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(896),
  [2421] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(897),
  [2423] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 6), REDUCE(sym_if_statement, 7),
  [2426] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(900),
  [2428] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(901),
  [2430] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(902),
  [2432] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(902),
  [2434] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(903),
  [2436] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(904),
  [2438] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(904),
  [2440] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(905),
  [2442] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 3, .fragile = true), SHIFT(765),
  [2445] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(908),
  [2447] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(909),
  [2449] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 3, .fragile = true, .rename_sequence_id = 7), SHIFT(765),
  [2452] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(711),
  [2454] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(591),
  [2456] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(913),
  [2458] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(913),
  [2460] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(915),
  [2462] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(916),
  [2464] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(918),
  [2466] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(919),
  [2468] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(918),
  [2470] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(921),
  [2472] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(925),
  [2474] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(929),
  [2476] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(930),
  [2478] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(932),
  [2480] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(933),
  [2482] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(932),
  [2484] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(935),
  [2486] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(944),
  [2488] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(945),
  [2490] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(946),
  [2492] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(946),
  [2494] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(947),
  [2496] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(948),
  [2498] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(948),
  [2500] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(949),
  [2502] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 4), REDUCE(sym_command, 5),
  [2505] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(952),
  [2507] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(953),
  [2509] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(954),
  [2511] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(954),
  [2513] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(955),
  [2515] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(956),
  [2517] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(956),
  [2519] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(957),
  [2521] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(958),
  [2523] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(959),
  [2525] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(959),
  [2527] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(960),
  [2529] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(960),
  [2531] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(961),
  [2533] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(962),
  [2535] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(962),
  [2537] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(963),
  [2539] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(963),
  [2541] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(964),
  [2543] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(965),
  [2545] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(966),
  [2547] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(966),
  [2549] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(967),
  [2551] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(967),
  [2553] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 4, .fragile = true), SHIFT(765),
  [2556] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 4, .fragile = true, .rename_sequence_id = 10), SHIFT(765),
  [2559] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(972),
  [2561] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(973),
  [2563] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(974),
  [2565] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(974),
  [2567] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(975),
  [2569] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(976),
  [2571] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(976),
  [2573] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(977),
  [2575] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(978),
  [2577] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(981),
  [2579] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(982),
  [2581] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(983),
  [2583] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(983),
  [2585] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(984),
  [2587] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(985),
  [2589] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(985),
  [2591] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(986),
  [2593] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(989),
  [2595] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(990),
  [2597] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(990),
  [2599] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(991),
  [2601] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(991),
  [2603] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(992),
  [2605] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(993),
  [2607] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(993),
  [2609] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(994),
  [2611] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(994),
  [2613] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(995),
  [2615] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(996),
  [2617] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(997),
  [2619] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(998),
  [2621] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(999),
  [2623] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1000),
  [2625] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1001),
  [2627] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1002),
  [2629] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1002),
  [2631] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1003),
  [2633] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1003),
  [2635] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1004),
  [2637] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1005),
  [2639] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1005),
  [2641] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1006),
  [2643] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1006),
  [2645] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1007),
  [2647] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1008),
  [2649] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1009),
  [2651] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1010),
  [2653] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1011),
  [2655] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1012),
  [2657] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1013),
  [2659] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1014),
};

void *tree_sitter_bash_external_scanner_create();
void tree_sitter_bash_external_scanner_destroy();
void tree_sitter_bash_external_scanner_reset(void *);
bool tree_sitter_bash_external_scanner_scan(void *, TSLexer *, const bool *);
bool tree_sitter_bash_external_scanner_serialize(void *, TSExternalTokenState);
void tree_sitter_bash_external_scanner_deserialize(void *, const TSExternalTokenState);

const TSLanguage *tree_sitter_bash() {
  GET_LANGUAGE(
    (const bool *)ts_external_scanner_states,
    ts_external_scanner_symbol_map,
    tree_sitter_bash_external_scanner_create,
    tree_sitter_bash_external_scanner_destroy,
    tree_sitter_bash_external_scanner_reset,
    tree_sitter_bash_external_scanner_scan,
    tree_sitter_bash_external_scanner_serialize,
    tree_sitter_bash_external_scanner_deserialize,
  );
}
